#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "math";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "// C calling conventions:",
  "// - the method's arguments are in args[0], args[1], ...",
  "// - the insatnce variables of an object o are in o->data, but exactly where depends",
  "//     on whether it is built-in or defined in Grace.",
  "// - ‹return› returns from the method",
  "// - the native code insertions can be treated as an expression answering a value;",
  "//     that value should be assigend to ‹result›",
  "",
  "// JS conventions:",
  "// - Access ‹param› by writing var_‹param›",
  "// - Access ‹field› by writing this.data.‹field›",
  "// - set result by assigning to ‹result›",
  "// - ‹return› returns from the method",
  "",
  "",
  "method sin(a:Number) -> Number {",
  "    // sine of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(sin(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.sin(var_a._value));›",
  "}",
  "",
  "method cos(a:Number) -> Number {",
  "    // cosine of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(cos(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.cos(var_a._value));›",
  "}",
  "",
  "method tan(a:Number) -> Number {",
  "    // tangent of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(tan(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.tan(var_a._value));;›",
  "}",
  "",
  "method asin(a:Number) -> Number {",
  "    // arcsin of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(asin(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.asin(var_a._value));›",
  "}",
  "",
  "method acos(a:Number) -> Number {",
  "    // arccos of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(acos(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.acos(var_a._value));›",
  "}",
  "",
  "method atan(a:Number) -> Number {",
  "    // arctan of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(atan(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.atan(var_a._value));›",
  "}",
  "",
  "method random -> Number {",
  "    // a pseudo-random number",
  "    native \"c\" code ‹    return alloc_Float64((double)rand() / RAND_MAX);›",
  "    native \"js\" code ‹    return new GraceNum(Math.random());›",
  "}",
  "",
  "method π -> Number {",
  "    // an approximation of the constant π",
  "    native \"c\" code ‹    return alloc_Float64((double)3.141592653589793);›",
  "    native \"js\" code ‹    return new GraceNum(3.141592653589793);›",
  "}",
  "",
  "method pi -> Number {",
  "    // same as π — for those who don't know Greek",
  "    native \"c\" code ‹    return alloc_Float64((double)3.141592653589793);›",
  "    native \"js\" code ‹    return new GraceNum(3.141592653589793);›",
  "}",
  "",
  "method sqrt(a:Number) -> Number {",
  "    // square root of a",
  "    native \"c\" code ‹    return alloc_Float64(sqrt(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.sqrt(var_a._value));›",
  "}",
  "",
  "method abs(a:Number) -> Number {",
  "    // absolute value of a",
  "    native \"c\" code ‹    return alloc_Float64(fabs(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.abs(var_a._value));›",
  "}",
  "",
  "method lg(a:Number) -> Number {",
  "    // logarithm to base 2 of a",
  "    native \"c\" code ‹    double log2 = log(2.0);",
  "    double logA = log(*(double*) args[0]->data);",
  "    return alloc_Float64(logA/log2);›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value) / Math.LN2);›",
  "}",
  "",
  "method ln(a:Number) -> Number {",
  "    // natural logarithm (base e) of a",
  "    native \"c\" code ‹    return alloc_Float64(log(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value));›",
  "}",
  "",
  "method exp(a:Number) -> Number {",
  "    // e to the power a",
  "    native \"c\" code ‹    return alloc_Float64(exp(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.exp(var_a._value));›",
  "}",
  "",
  "method log10(a:Number) -> Number {",
  "    // logarithm to base 10 of a",
  "    native \"c\" code ‹    return alloc_Float64(log10(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value) / Math.LN10);›",
  "}",
  NULL
};
Object meth_math_sin0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sin");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sin");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sin (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sin");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 18
  Object nat1;
  { Object result = done;
    return alloc_Float64(sin(*(double*) args[0]->data));
  nat1 = result;
  }
// compiled call node returning nat1 (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_cos2(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method cos");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for cos (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for cos");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 24
  Object nat3;
  { Object result = done;
    return alloc_Float64(cos(*(double*) args[0]->data));
  nat3 = result;
  }
// compiled call node returning nat3 (depth = 2)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_tan4(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "tan");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method tan");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tan (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for tan");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 30
  Object nat5;
  { Object result = done;
    return alloc_Float64(tan(*(double*) args[0]->data));
  nat5 = result;
  }
// compiled call node returning nat5 (depth = 2)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_asin6(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asin");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method asin");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asin (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for asin");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 36
  Object nat7;
  { Object result = done;
    return alloc_Float64(asin(*(double*) args[0]->data));
  nat7 = result;
  }
// compiled call node returning nat7 (depth = 2)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_acos8(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "acos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method acos");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for acos (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for acos");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 42
  Object nat9;
  { Object result = done;
    return alloc_Float64(acos(*(double*) args[0]->data));
  nat9 = result;
  }
// compiled call node returning nat9 (depth = 2)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_atan10(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "atan");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method atan");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for atan (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for atan");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 48
  Object nat11;
  { Object result = done;
    return alloc_Float64(atan(*(double*) args[0]->data));
  nat11 = result;
  }
// compiled call node returning nat11 (depth = 2)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_random12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "random");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for random (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for random");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 54
  Object nat13;
  { Object result = done;
    return alloc_Float64((double)rand() / RAND_MAX);
  nat13 = result;
  }
// compiled call node returning nat13 (depth = 2)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, """\xcf""""\x80""");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for π (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for π");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 60
  Object nat15;
  { Object result = done;
    return alloc_Float64((double)3.141592653589793);
  nat15 = result;
  }
// compiled call node returning nat15 (depth = 2)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_pi16(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pi");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pi (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pi");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 66
  Object nat17;
  { Object result = done;
    return alloc_Float64((double)3.141592653589793);
  nat17 = result;
  }
// compiled call node returning nat17 (depth = 2)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_sqrt18(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sqrt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sqrt");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sqrt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for sqrt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 72
  Object nat19;
  { Object result = done;
    return alloc_Float64(sqrt(*(double*) args[0]->data));
  nat19 = result;
  }
// compiled call node returning nat19 (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_abs20(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "abs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method abs");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for abs (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for abs");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 78
  Object nat21;
  { Object result = done;
    return alloc_Float64(fabs(*(double*) args[0]->data));
  nat21 = result;
  }
// compiled call node returning nat21 (depth = 2)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_lg22(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lg");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lg (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lg");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 84
  Object nat23;
  { Object result = done;
    double log2 = log(2.0);
    double logA = log(*(double*) args[0]->data);
    return alloc_Float64(logA/log2);
  nat23 = result;
  }
// compiled call node returning nat23 (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_ln24(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "ln");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ln");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ln (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ln");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 92
  Object nat25;
  { Object result = done;
    return alloc_Float64(log(*(double*) args[0]->data));
  nat25 = result;
  }
// compiled call node returning nat25 (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_exp26(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "exp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method exp");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for exp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for exp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 98
  Object nat27;
  { Object result = done;
    return alloc_Float64(exp(*(double*) args[0]->data));
  nat27 = result;
  }
// compiled call node returning nat27 (depth = 2)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_log1028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "log10");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method log10");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for log10 (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for log10");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 104
  Object nat29;
  { Object result = done;
    return alloc_Float64(log10(*(double*) args[0]->data));
  nat29 = result;
  }
// compiled call node returning nat29 (depth = 2)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object module_math_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(17, 17);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<math>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method sin
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = emptyclosure;
  Method *meth_meth_math_sin0 = addmethod2pos(self, "sin", &meth_math_sin0, 1);
  int argcv_meth_math_sin0[] = {1};
  meth_meth_math_sin0->type = alloc_MethodType(1, argcv_meth_math_sin0);
meth_meth_math_sin0->type->types[0] = type_Number;
meth_meth_math_sin0->type->names[0] = "a";
  meth_meth_math_sin0->definitionModule = modulename;
  meth_meth_math_sin0->definitionLine = 16;
// compiled method node returning  (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method cos
  struct UserObject *uo2 = (struct UserObject*)self;
  uo2->data[2] = emptyclosure;
  Method *meth_meth_math_cos2 = addmethod2pos(self, "cos", &meth_math_cos2, 2);
  int argcv_meth_math_cos2[] = {1};
  meth_meth_math_cos2->type = alloc_MethodType(1, argcv_meth_math_cos2);
meth_meth_math_cos2->type->types[0] = type_Number;
meth_meth_math_cos2->type->names[0] = "a";
  meth_meth_math_cos2->definitionModule = modulename;
  meth_meth_math_cos2->definitionLine = 22;
// compiled method node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method tan
  struct UserObject *uo4 = (struct UserObject*)self;
  uo4->data[3] = emptyclosure;
  Method *meth_meth_math_tan4 = addmethod2pos(self, "tan", &meth_math_tan4, 3);
  int argcv_meth_math_tan4[] = {1};
  meth_meth_math_tan4->type = alloc_MethodType(1, argcv_meth_math_tan4);
meth_meth_math_tan4->type->types[0] = type_Number;
meth_meth_math_tan4->type->names[0] = "a";
  meth_meth_math_tan4->definitionModule = modulename;
  meth_meth_math_tan4->definitionLine = 28;
// compiled method node returning  (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method asin
  struct UserObject *uo6 = (struct UserObject*)self;
  uo6->data[4] = emptyclosure;
  Method *meth_meth_math_asin6 = addmethod2pos(self, "asin", &meth_math_asin6, 4);
  int argcv_meth_math_asin6[] = {1};
  meth_meth_math_asin6->type = alloc_MethodType(1, argcv_meth_math_asin6);
meth_meth_math_asin6->type->types[0] = type_Number;
meth_meth_math_asin6->type->names[0] = "a";
  meth_meth_math_asin6->definitionModule = modulename;
  meth_meth_math_asin6->definitionLine = 34;
// compiled method node returning  (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method acos
  struct UserObject *uo8 = (struct UserObject*)self;
  uo8->data[5] = emptyclosure;
  Method *meth_meth_math_acos8 = addmethod2pos(self, "acos", &meth_math_acos8, 5);
  int argcv_meth_math_acos8[] = {1};
  meth_meth_math_acos8->type = alloc_MethodType(1, argcv_meth_math_acos8);
meth_meth_math_acos8->type->types[0] = type_Number;
meth_meth_math_acos8->type->names[0] = "a";
  meth_meth_math_acos8->definitionModule = modulename;
  meth_meth_math_acos8->definitionLine = 40;
// compiled method node returning  (depth = 1)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method atan
  struct UserObject *uo10 = (struct UserObject*)self;
  uo10->data[6] = emptyclosure;
  Method *meth_meth_math_atan10 = addmethod2pos(self, "atan", &meth_math_atan10, 6);
  int argcv_meth_math_atan10[] = {1};
  meth_meth_math_atan10->type = alloc_MethodType(1, argcv_meth_math_atan10);
meth_meth_math_atan10->type->types[0] = type_Number;
meth_meth_math_atan10->type->names[0] = "a";
  meth_meth_math_atan10->definitionModule = modulename;
  meth_meth_math_atan10->definitionLine = 46;
// compiled method node returning  (depth = 1)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method random
  struct UserObject *uo12 = (struct UserObject*)self;
  uo12->data[7] = emptyclosure;
  Method *meth_meth_math_random12 = addmethod2pos(self, "random", &meth_math_random12, 7);
  int argcv_meth_math_random12[] = {0};
  meth_meth_math_random12->type = alloc_MethodType(1, argcv_meth_math_random12);
  meth_meth_math_random12->definitionModule = modulename;
  meth_meth_math_random12->definitionLine = 52;
// compiled method node returning  (depth = 1)
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method π
  struct UserObject *uo14 = (struct UserObject*)self;
  uo14->data[8] = emptyclosure;
  Method *meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14 = addmethod2pos(self, """\xcf""""\x80""", &meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14, 8);
  int argcv_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14[] = {0};
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14->type = alloc_MethodType(1, argcv_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14);
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14->definitionModule = modulename;
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_14->definitionLine = 58;
// compiled method node returning  (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pi
  struct UserObject *uo16 = (struct UserObject*)self;
  uo16->data[9] = emptyclosure;
  Method *meth_meth_math_pi16 = addmethod2pos(self, "pi", &meth_math_pi16, 9);
  int argcv_meth_math_pi16[] = {0};
  meth_meth_math_pi16->type = alloc_MethodType(1, argcv_meth_math_pi16);
  meth_meth_math_pi16->definitionModule = modulename;
  meth_meth_math_pi16->definitionLine = 64;
// compiled method node returning  (depth = 1)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method sqrt
  struct UserObject *uo18 = (struct UserObject*)self;
  uo18->data[10] = emptyclosure;
  Method *meth_meth_math_sqrt18 = addmethod2pos(self, "sqrt", &meth_math_sqrt18, 10);
  int argcv_meth_math_sqrt18[] = {1};
  meth_meth_math_sqrt18->type = alloc_MethodType(1, argcv_meth_math_sqrt18);
meth_meth_math_sqrt18->type->types[0] = type_Number;
meth_meth_math_sqrt18->type->names[0] = "a";
  meth_meth_math_sqrt18->definitionModule = modulename;
  meth_meth_math_sqrt18->definitionLine = 70;
// compiled method node returning  (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method abs
  struct UserObject *uo20 = (struct UserObject*)self;
  uo20->data[11] = emptyclosure;
  Method *meth_meth_math_abs20 = addmethod2pos(self, "abs", &meth_math_abs20, 11);
  int argcv_meth_math_abs20[] = {1};
  meth_meth_math_abs20->type = alloc_MethodType(1, argcv_meth_math_abs20);
meth_meth_math_abs20->type->types[0] = type_Number;
meth_meth_math_abs20->type->names[0] = "a";
  meth_meth_math_abs20->definitionModule = modulename;
  meth_meth_math_abs20->definitionLine = 76;
// compiled method node returning  (depth = 1)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method lg
  struct UserObject *uo22 = (struct UserObject*)self;
  uo22->data[12] = emptyclosure;
  Method *meth_meth_math_lg22 = addmethod2pos(self, "lg", &meth_math_lg22, 12);
  int argcv_meth_math_lg22[] = {1};
  meth_meth_math_lg22->type = alloc_MethodType(1, argcv_meth_math_lg22);
meth_meth_math_lg22->type->types[0] = type_Number;
meth_meth_math_lg22->type->names[0] = "a";
  meth_meth_math_lg22->definitionModule = modulename;
  meth_meth_math_lg22->definitionLine = 82;
// compiled method node returning  (depth = 1)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method ln
  struct UserObject *uo24 = (struct UserObject*)self;
  uo24->data[13] = emptyclosure;
  Method *meth_meth_math_ln24 = addmethod2pos(self, "ln", &meth_math_ln24, 13);
  int argcv_meth_math_ln24[] = {1};
  meth_meth_math_ln24->type = alloc_MethodType(1, argcv_meth_math_ln24);
meth_meth_math_ln24->type->types[0] = type_Number;
meth_meth_math_ln24->type->names[0] = "a";
  meth_meth_math_ln24->definitionModule = modulename;
  meth_meth_math_ln24->definitionLine = 90;
// compiled method node returning  (depth = 1)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method exp
  struct UserObject *uo26 = (struct UserObject*)self;
  uo26->data[14] = emptyclosure;
  Method *meth_meth_math_exp26 = addmethod2pos(self, "exp", &meth_math_exp26, 14);
  int argcv_meth_math_exp26[] = {1};
  meth_meth_math_exp26->type = alloc_MethodType(1, argcv_meth_math_exp26);
meth_meth_math_exp26->type->types[0] = type_Number;
meth_meth_math_exp26->type->names[0] = "a";
  meth_meth_math_exp26->definitionModule = modulename;
  meth_meth_math_exp26->definitionLine = 96;
// compiled method node returning  (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method log10
  struct UserObject *uo28 = (struct UserObject*)self;
  uo28->data[15] = emptyclosure;
  Method *meth_meth_math_log1028 = addmethod2pos(self, "log10", &meth_math_log1028, 15);
  int argcv_meth_math_log1028[] = {1};
  meth_meth_math_log1028->type = alloc_MethodType(1, argcv_meth_math_log1028);
meth_meth_math_log1028->type->types[0] = type_Number;
meth_meth_math_log1028->type->names[0] = "a";
  meth_meth_math_log1028->definitionModule = modulename;
  meth_meth_math_log1028->definitionLine = 102;
// compiled method node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
