#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "unixFilePath";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "import \"io\" as io",
  "",
  "factory method null {",
  "    // creates a unixFilePath with empty components",
  "",
  "    var dir is readable := \"\"",
  "    // the directory part; \"\" if in current directory",
  "",
  "    var base is public := \"\"",
  "    // the base part of the file name (without an extension)",
  "",
  "    var extension is public := \"\"",
  "    // the extension (like `.grace`) , including the `.`",
  "",
  "    method asString { dir ++ base ++ extension }",
  "    // the whole file name as a string",
  "",
  "    method shortName { base ++ extension }",
  "    // the file name without the directory part",
  "",
  "    method asDebugString { \"unixFilePath[{dir}|{base}|{extension}]\" }",
  "    // for debugging; shows the division into parts",
  "",
  "    method directory {",
  "    // the directory part; \"./\" if in current directory",
  "        if (dir == \"\") then { \"./\" } else { dir }",
  "    }",
  "    ",
  "    method directory:=(d) {",
  "    // set the directory part",
  "        var newDir := d",
  "        if (newDir == \"\") then {",
  "            dir := \"\"",
  "            return",
  "        }",
  "        if (newDir.at(newDir.size) != \"/\") then {",
  "            newDir := newDir ++ \"/\"",
  "        }",
  "        if (newDir == \"./\") then { newDir := \"\" }",
  "        dir := newDir",
  "    }",
  "    method setDirectory(d) {",
  "    // set the directory part; answers self for chaining",
  "        directory := d",
  "        self",
  "    }",
  "    method setBase(b) {",
  "    // set the base part; answers self for chaining",
  "        base := b",
  "        self",
  "    }",
  "    method setExtension(e) {",
  "    // set the extension; answers self for chaining",
  "        if (e.first == \".\") then {",
  "            extension := e",
  "        } else {",
  "            extension := \".\" ++ e",
  "        }",
  "        self",
  "    }",
  "    method exists -> Boolean {",
  "    // true if his file exists",
  "        io.exists(self.asString)",
  "    }",
  "    method newer(other) -> Boolean {",
  "    // true if this file is newer than other",
  "        io.newer(self.asString, other.asString)",
  "    }",
  "",
  "    method copy {",
  "    // a copy of this filePath",
  "        def p = null",
  "        p.directory := directory",
  "        p.base := base",
  "        p.extension := extension",
  "        p",
  "    }",
  "}",
  "",
  "method withDirectory(d) {",
  "    null.setDirectory(d)",
  "}",
  "",
  "method withBase(b) {",
  "    null.setBase(b)",
  "}",
  "",
  "method withExtension(e) {",
  "    null.setExtension(e)",
  "}",
  "",
  "method withDirectory(d) base(b) extension(e) {",
  "    // creates a unixFilePath with directory d, base b and extension e",
  "    null.setDirectory(d).setBase(b).setExtension(e)",
  "}",
  "",
  "method fromString(s) {",
  "    // parses the filename s into components and answers the approriate unixFilePath",
  "    def p = null",
  "    var slashPosn := 0",
  "    def sSize = s.size",
  "    var ix := sSize",
  "    while { (slashPosn == 0) && (ix > 0) } do {",
  "        if (s.at(ix) == \"/\") then {",
  "            slashPosn := ix",
  "        } else { ",
  "            ix := ix - 1 ",
  "        }",
  "    }",
  "    p.directory := s.substringFrom 1 to (slashPosn)",
  "    var dotPosn := sSize + 1",
  "    ix := sSize",
  "    while { (dotPosn > sSize) && (ix > slashPosn) } do {",
  "        if (s.at(ix) == \".\") then {",
  "            dotPosn := ix",
  "        } else {",
  "            ix := ix - 1",
  "        }",
  "    }",
  "    if (dotPosn <= sSize) then {",
  "        p.extension := s.substringFrom (dotPosn) to (sSize)",
  "    }",
  "    p.base := s.substringFrom (slashPosn + 1) to (dotPosn - 1)",
  "    p",
  "}",
  "",
  "method split(pathString) -> List<String> {",
  "    // splits pathString, assumed to be a Unix PATH containing items separated",
  "    // by colons, into a List of items.  Ensures that each item ends with /",
  "    def locations = list.empty",
  "    var ix := 1",
  "    var ox := 1",
  "    def pss = pathString.size",
  "    while { ox <= pss } do {",
  "        while { (ox <= pss).andAlso{pathString.at(ox) != \":\"} } do {",
  "            ox := ox + 1 ",
  "        }",
  "        var item := pathString.substringFrom(ix) to(ox-1)",
  "        if (item.at(item.size) != \"/\") then { item := item ++ \"/\" }",
  "        locations.addLast (item)",
  "        ix := ox + 1",
  "        ox := ix",
  "    }",
  "    return locations",
  "}",
  "",
  "method file(name) onPath(pathString) otherwise(action) {",
  "    def locations = split(pathString)",
  "    locations.addFirst \"./\"",
  "    def candidate = name.copy",
  "    def originalDir = name.dir",
  "    if (originalDir.first == \"/\") then {",
  "        if (candidate.exists) then {",
  "            return candidate",
  "        } else {",
  "            return action.apply \"\"",
  "        }",
  "    }",
  "    locations.do { each ->",
  "        candidate.setDirectory(each ++ originalDir)",
  "        if ( candidate.exists ) then {",
  "            return candidate",
  "        }",
  "    }",
  "    action.apply(locations)",
  "}",
  NULL
};
Object reader_unixFilePath_outer_2(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_unixFilePath_dir_3(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_unixFilePath_dir_3(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_unixFilePath_base_4(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_unixFilePath_base_4(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_unixFilePath_extension_5(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_unixFilePath_extension_5(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
static ClassData objclass1;
static Object strlit29;
static Object strlit36;
static Object strlit43;
static Object strlit49;
static Object strlit59;
static Object strlit64;
static Object strlit70;
static Object strlit74;
static Object strlit78;
static Object strlit86;
static Object strlit92;
static Object strlit95;
static Object strlit108;
static Object strlit118;
static Object strlit150;
static Object strlit151;
static Object strlit152;
static Object strlit203;
static Object strlit243;
static Object strlit301;
static Object strlit329;
static Object strlit337;
static Object strlit355;
static Object strlit363;
static Object strlit372;
Object module_io;
Object module_io_init();
Object meth_unixFilePath_asString6(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9 = callmethodflags(self, "extension", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8);
// compiled call node returning call9 (depth = 4)
// compiled member node returning call9 (depth = 3)
  int op_slot_right_7 = gc_frame_newslot(call9);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call13 = callmethodflags(self, "base", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12);
// compiled call node returning call13 (depth = 5)
// compiled member node returning call13 (depth = 4)
  int op_slot_right_11 = gc_frame_newslot(call13);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe15 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call16 = callmethodflags(self, "dir", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe15);
// compiled call node returning call16 (depth = 5)
// compiled member node returning call16 (depth = 4)
  int op_slot_left_11 = gc_frame_newslot(call16);
  params[0] = call13;
  partcv[0] = 1;
  Object opresult17 = callmethod(call16, "++", 1, partcv, params);
// compiled op node returning opresult17 (depth = 3)
  int op_slot_left_7 = gc_frame_newslot(opresult17);
  params[0] = call9;
  partcv[0] = 1;
  Object opresult18 = callmethod(opresult17, "++", 1, partcv, params);
// compiled op node returning opresult18 (depth = 2)
  gc_frame_end(frame);
  return opresult18;
}
Object meth_unixFilePath_shortName19(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shortName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shortName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for shortName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe21 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call22 = callmethodflags(self, "extension", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe21);
// compiled call node returning call22 (depth = 4)
// compiled member node returning call22 (depth = 3)
  int op_slot_right_20 = gc_frame_newslot(call22);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe24 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call25 = callmethodflags(self, "base", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe24);
// compiled call node returning call25 (depth = 4)
// compiled member node returning call25 (depth = 3)
  int op_slot_left_20 = gc_frame_newslot(call25);
  params[0] = call22;
  partcv[0] = 1;
  Object opresult26 = callmethod(call25, "++", 1, partcv, params);
// compiled op node returning opresult26 (depth = 2)
  gc_frame_end(frame);
  return opresult26;
}
Object meth_unixFilePath_asDebugString27(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit29 == NULL) {
    strlit29 = alloc_String("]");
    gc_root(strlit29);
  }
// compiled string node returning strlit29 (depth = 3)
  int op_slot_right_28 = gc_frame_newslot(strlit29);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe32 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call33 = callmethodflags(self, "extension", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe32);
// compiled call node returning call33 (depth = 5)
// compiled member node returning call33 (depth = 4)
  int op_slot_right_31 = gc_frame_newslot(call33);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit36 == NULL) {
    strlit36 = alloc_String("|");
    gc_root(strlit36);
  }
// compiled string node returning strlit36 (depth = 5)
  int op_slot_right_35 = gc_frame_newslot(strlit36);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe39 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call40 = callmethodflags(self, "base", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 7)
// compiled member node returning call40 (depth = 6)
  int op_slot_right_38 = gc_frame_newslot(call40);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit43 == NULL) {
    strlit43 = alloc_String("|");
    gc_root(strlit43);
  }
// compiled string node returning strlit43 (depth = 7)
  int op_slot_right_42 = gc_frame_newslot(strlit43);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe46 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call47 = callmethodflags(self, "dir", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compiled call node returning call47 (depth = 9)
// compiled member node returning call47 (depth = 8)
  int op_slot_right_45 = gc_frame_newslot(call47);
// starting to compile string node (depth = 8)
  if (strlit49 == NULL) {
    strlit49 = alloc_String("unixFilePath[");
    gc_root(strlit49);
  }
// compiled string node returning strlit49 (depth = 8)
  int op_slot_left_45 = gc_frame_newslot(strlit49);
  params[0] = call47;
  partcv[0] = 1;
  Object opresult50 = callmethod(strlit49, "++", 1, partcv, params);
// compiled op node returning opresult50 (depth = 7)
  int op_slot_left_42 = gc_frame_newslot(opresult50);
  params[0] = strlit43;
  partcv[0] = 1;
  Object opresult51 = callmethod(opresult50, "++", 1, partcv, params);
// compiled op node returning opresult51 (depth = 6)
  int op_slot_left_38 = gc_frame_newslot(opresult51);
  params[0] = call40;
  partcv[0] = 1;
  Object opresult52 = callmethod(opresult51, "++", 1, partcv, params);
// compiled op node returning opresult52 (depth = 5)
  int op_slot_left_35 = gc_frame_newslot(opresult52);
  params[0] = strlit36;
  partcv[0] = 1;
  Object opresult53 = callmethod(opresult52, "++", 1, partcv, params);
// compiled op node returning opresult53 (depth = 4)
  int op_slot_left_31 = gc_frame_newslot(opresult53);
  params[0] = call33;
  partcv[0] = 1;
  Object opresult54 = callmethod(opresult53, "++", 1, partcv, params);
// compiled op node returning opresult54 (depth = 3)
  int op_slot_left_28 = gc_frame_newslot(opresult54);
  params[0] = strlit29;
  partcv[0] = 1;
  Object opresult55 = callmethod(opresult54, "++", 1, partcv, params);
// compiled op node returning opresult55 (depth = 2)
  gc_frame_end(frame);
  return opresult55;
}
Object meth_unixFilePath_directory56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "directory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for directory (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for directory");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit59 == NULL) {
    strlit59 = alloc_String("");
    gc_root(strlit59);
  }
// compiled string node returning strlit59 (depth = 4)
  int op_slot_right_58 = gc_frame_newslot(strlit59);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe61 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call62 = callmethodflags(self, "dir", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe61);
// compiled call node returning call62 (depth = 5)
// compiled member node returning call62 (depth = 4)
  int op_slot_left_58 = gc_frame_newslot(call62);
  params[0] = strlit59;
  partcv[0] = 1;
  Object opresult63 = callmethod(call62, "==", 1, partcv, params);
// compiled op node returning opresult63 (depth = 3)
  Object if57 = done;
  if (istrue(opresult63)) {
// starting to compile string node (depth = 3)
  if (strlit64 == NULL) {
    strlit64 = alloc_String("./");
    gc_root(strlit64);
  }
// compiled string node returning strlit64 (depth = 3)
    gc_frame_newslot(strlit64);
    if57 = strlit64;
  } else {
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe65 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call66 = callmethodflags(self, "dir", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe65);
// compiled call node returning call66 (depth = 4)
// compiled member node returning call66 (depth = 3)
    gc_frame_newslot(call66);
    if57 = call66;
  }
// compiled if node returning if57 (depth = 2)
  gc_frame_end(frame);
  return if57;
}
Object meth_unixFilePath_directory_58__61_67(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "directory:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method directory:=");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for directory:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_d = &(stackframe->slots[0]);
  *var_d = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for directory:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDir = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDir");
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_d (depth = 3)
  *var_newDir = *var_d;
  if (*var_d == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit70 == NULL) {
    strlit70 = alloc_String("");
    gc_root(strlit70);
  }
// compiled string node returning strlit70 (depth = 4)
  int op_slot_right_69 = gc_frame_newslot(strlit70);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newDir (depth = 4)
  int op_slot_left_69 = gc_frame_newslot(*var_newDir);
  params[0] = strlit70;
  partcv[0] = 1;
  Object opresult72 = callmethod(*var_newDir, "==", 1, partcv, params);
// compiled op node returning opresult72 (depth = 3)
  Object if68 = done;
  if (istrue(opresult72)) {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe73 = gc_frame_new();
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit74 == NULL) {
    strlit74 = alloc_String("");
    gc_root(strlit74);
  }
// compiled string node returning strlit74 (depth = 5)
  gc_frame_newslot(strlit74);
// call case 4: self request
  params[0] = strlit74;
  partcv[0] = 1;
  Object call75 = callmethodflags(self, "dir:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe73);
// compiled call node returning call75 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if68 = undefined;
  } else {
  }
// compiled if node returning if68 (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit78 == NULL) {
    strlit78 = alloc_String("/");
    gc_root(strlit78);
  }
// compiled string node returning strlit78 (depth = 4)
  int op_slot_right_77 = gc_frame_newslot(strlit78);
// starting to compile call node (depth = 4)
  int callframe80 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe81 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newDir (depth = 7)
  partcv[0] = 0;
  Object call82 = callmethod(*var_newDir, "size",
    1, partcv, params);
  gc_frame_end(callframe81);
// compiled call node returning call82 (depth = 6)
// compiled member node returning call82 (depth = 5)
  gc_frame_newslot(call82);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDir (depth = 5)
  params[0] = call82;
  partcv[0] = 1;
  Object call83 = callmethod(*var_newDir, "at",
    1, partcv, params);
  gc_frame_end(callframe80);
// compiled call node returning call83 (depth = 4)
  int op_slot_left_77 = gc_frame_newslot(call83);
  params[0] = strlit78;
  partcv[0] = 1;
  Object opresult84 = callmethod(call83, "!=", 1, partcv, params);
// compiled op node returning opresult84 (depth = 3)
  Object if76 = done;
  if (istrue(opresult84)) {
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit86 == NULL) {
    strlit86 = alloc_String("/");
    gc_root(strlit86);
  }
// compiled string node returning strlit86 (depth = 5)
  int op_slot_right_85 = gc_frame_newslot(strlit86);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDir (depth = 5)
  int op_slot_left_85 = gc_frame_newslot(*var_newDir);
  params[0] = strlit86;
  partcv[0] = 1;
  Object opresult88 = callmethod(*var_newDir, "++", 1, partcv, params);
// compiled op node returning opresult88 (depth = 4)
  *var_newDir = opresult88;
  if (opresult88 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if76 = done;
  } else {
  }
// compiled if node returning if76 (depth = 2)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit92 == NULL) {
    strlit92 = alloc_String("./");
    gc_root(strlit92);
  }
// compiled string node returning strlit92 (depth = 4)
  int op_slot_right_91 = gc_frame_newslot(strlit92);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newDir (depth = 4)
  int op_slot_left_91 = gc_frame_newslot(*var_newDir);
  params[0] = strlit92;
  partcv[0] = 1;
  Object opresult94 = callmethod(*var_newDir, "==", 1, partcv, params);
// compiled op node returning opresult94 (depth = 3)
  Object if90 = done;
  if (istrue(opresult94)) {
// starting to compile bind node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit95 == NULL) {
    strlit95 = alloc_String("");
    gc_root(strlit95);
  }
// compiled string node returning strlit95 (depth = 4)
  *var_newDir = strlit95;
  if (strlit95 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if90 = done;
  } else {
  }
// compiled if node returning if90 (depth = 2)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe97 = gc_frame_new();
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newDir (depth = 4)
  gc_frame_newslot(*var_newDir);
// call case 4: self request
  params[0] = *var_newDir;
  partcv[0] = 1;
  Object call98 = callmethodflags(self, "dir:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe97);
// compiled call node returning call98 (depth = 3)
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_unixFilePath_setDirectory99(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setDirectory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method setDirectory");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for setDirectory (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_d = &(stackframe->slots[0]);
  *var_d = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for setDirectory");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe100 = gc_frame_new();
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_d (depth = 4)
  gc_frame_newslot(*var_d);
// call case 4: self request
  params[0] = *var_d;
  partcv[0] = 1;
  Object call101 = callmethodflags(self, "directory:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call101 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_unixFilePath_setBase102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setBase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method setBase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for setBase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for setBase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe103 = gc_frame_new();
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call104 = callmethodflags(self, "base:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe103);
// compiled call node returning call104 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_unixFilePath_setExtension105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setExtension");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method setExtension");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for setExtension (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for setExtension");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit108 == NULL) {
    strlit108 = alloc_String(".");
    gc_root(strlit108);
  }
// compiled string node returning strlit108 (depth = 4)
  int op_slot_right_107 = gc_frame_newslot(strlit108);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_e (depth = 6)
  partcv[0] = 0;
  Object call111 = callmethod(*var_e, "first",
    1, partcv, params);
  gc_frame_end(callframe110);
// compiled call node returning call111 (depth = 5)
// compiled member node returning call111 (depth = 4)
  int op_slot_left_107 = gc_frame_newslot(call111);
  params[0] = strlit108;
  partcv[0] = 1;
  Object opresult112 = callmethod(call111, "==", 1, partcv, params);
// compiled op node returning opresult112 (depth = 3)
  Object if106 = done;
  if (istrue(opresult112)) {
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe113 = gc_frame_new();
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_e (depth = 5)
  gc_frame_newslot(*var_e);
// call case 4: self request
  params[0] = *var_e;
  partcv[0] = 1;
  Object call114 = callmethodflags(self, "extension:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe113);
// compiled call node returning call114 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if106 = done;
  } else {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe115 = gc_frame_new();
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_e (depth = 6)
  int op_slot_right_116 = gc_frame_newslot(*var_e);
// starting to compile string node (depth = 6)
  if (strlit118 == NULL) {
    strlit118 = alloc_String(".");
    gc_root(strlit118);
  }
// compiled string node returning strlit118 (depth = 6)
  int op_slot_left_116 = gc_frame_newslot(strlit118);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult119 = callmethod(strlit118, "++", 1, partcv, params);
// compiled op node returning opresult119 (depth = 5)
  gc_frame_newslot(opresult119);
// call case 4: self request
  params[0] = opresult119;
  partcv[0] = 1;
  Object call120 = callmethodflags(self, "extension:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled call node returning call120 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if106 = done;
  }
// compiled if node returning if106 (depth = 2)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_unixFilePath_exists121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "exists");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_io = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for exists (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for exists");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe122 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call124 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe123);
// compiled call node returning call124 (depth = 4)
// compiled member node returning call124 (depth = 3)
  gc_frame_newslot(call124);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_io (depth = 3)
  params[0] = call124;
  partcv[0] = 1;
  Object call125 = callmethod(*var_io, "exists",
    1, partcv, params);
  gc_frame_end(callframe122);
// compiled call node returning call125 (depth = 2)
  gc_frame_end(frame);
  return call125;
}
Object meth_unixFilePath_newer126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newer");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method newer");
  Object params[2];
  int partcv[1];
  Object *var_io = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for newer (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for newer");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe127 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call129 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 4)
// compiled member node returning call129 (depth = 3)
  gc_frame_newslot(call129);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call131 = callmethod(*var_other, "asString",
    1, partcv, params);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 4)
// compiled member node returning call131 (depth = 3)
  gc_frame_newslot(call131);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_io (depth = 3)
  params[0] = call129;
  params[1] = call131;
  partcv[0] = 2;
  Object call132 = callmethod(*var_io, "newer",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call132 (depth = 2)
  gc_frame_end(frame);
  return call132;
}
Object meth_unixFilePath_copy133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "p");
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe134 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe135 = gc_frame_new();
// call case 3: self.outer request
  Object call136 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe135);
// compiled call node returning call136 (depth = 6)
// compiled member node returning call136 (depth = 5)
  partcv[0] = 0;
  Object call137 = callmethodflags(call136, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe134);
// compiled call node returning call137 (depth = 4)
// compiled member node returning call137 (depth = 3)
  *var_p = call137;
  if (call137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe138 = gc_frame_new();
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call140 = callmethodflags(self, "directory", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe139);
// compiled call node returning call140 (depth = 5)
// compiled member node returning call140 (depth = 4)
  gc_frame_newslot(call140);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = call140;
  partcv[0] = 1;
  Object call141 = callmethod(*var_p, "directory:=",
    1, partcv, params);
  gc_frame_end(callframe138);
// compiled call node returning call141 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe142 = gc_frame_new();
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe143 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call144 = callmethodflags(self, "base", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe143);
// compiled call node returning call144 (depth = 5)
// compiled member node returning call144 (depth = 4)
  gc_frame_newslot(call144);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = call144;
  partcv[0] = 1;
  Object call145 = callmethod(*var_p, "base:=",
    1, partcv, params);
  gc_frame_end(callframe142);
// compiled call node returning call145 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe146 = gc_frame_new();
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call148 = callmethodflags(self, "extension", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe147);
// compiled call node returning call148 (depth = 5)
// compiled member node returning call148 (depth = 4)
  gc_frame_newslot(call148);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = call148;
  partcv[0] = 1;
  Object call149 = callmethod(*var_p, "extension:=",
    1, partcv, params);
  gc_frame_end(callframe146);
// compiled call node returning call149 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_p (depth = 2)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_unixFilePath_null0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "null");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for null (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for null");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1 = alloc_userobj2(17,15, objclass1);
  gc_frame_newslot(obj1);
if (objclass1 == NULL) {
  glfree(obj1->class->name);
  obj1->class->name = "self.null";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1, self, 0);
  addmethodreal(obj1,"outer", &reader_unixFilePath_outer_2);
  Object oldself1 = self;
  struct StackFrameObject *oldstackframe1 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1);
  gc_frame_newslot((Object)stackframe);
  self = obj1;
  Object *oldselfslot1 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1 = (*(struct UserObject *)self).data[0], lowerouter1 = thisouter1;
  if (inheritingObject1) {
    struct UserObject *inho1 = (struct UserObject *)inheritingObject1;
    while (inho1->super != GraceDefaultObject) inho1 = (struct UserObject *)inho1->super;
    inho1->super = obj1;
    self = inheritingObject1;
    *selfslot = self;
    lowerouter1 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1;
  }
if (objclass1 == NULL) {
  Method *reader3 = addmethodrealflags(obj1, "dir",&reader_unixFilePath_dir_3, 0);
  Method *writer3 = addmethodrealflags(obj1, "dir:=",&writer_unixFilePath_dir_3, MFLAG_CONFIDENTIAL);
  reader3->definitionModule = modulename;
  writer3->definitionModule = modulename;
  reader3->definitionLine = 6;
  writer3->definitionLine = 6;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 1);
if (objclass1 == NULL) {
  Method *reader4 = addmethodrealflags(obj1, "base",&reader_unixFilePath_base_4, 0);
  Method *writer4 = addmethodrealflags(obj1, "base:=",&writer_unixFilePath_base_4, 0);
  reader4->definitionModule = modulename;
  writer4->definitionModule = modulename;
  reader4->definitionLine = 9;
  writer4->definitionLine = 9;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 2);
if (objclass1 == NULL) {
  Method *reader5 = addmethodrealflags(obj1, "extension",&reader_unixFilePath_extension_5, 0);
  Method *writer5 = addmethodrealflags(obj1, "extension:=",&writer_unixFilePath_extension_5, 0);
  reader5->definitionModule = modulename;
  writer5->definitionModule = modulename;
  reader5->definitionLine = 12;
  writer5->definitionLine = 12;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo6 = (struct UserObject*)obj1;
  uo6->data[4] = emptyclosure;
  Method *meth_meth_unixFilePath_asString6 = addmethod2pos(obj1, "asString", &meth_unixFilePath_asString6, 4);
  int argcv_meth_unixFilePath_asString6[] = {0};
  meth_meth_unixFilePath_asString6->type = alloc_MethodType(1, argcv_meth_unixFilePath_asString6);
  meth_meth_unixFilePath_asString6->definitionModule = modulename;
  meth_meth_unixFilePath_asString6->definitionLine = 15;
// method shortName
  struct UserObject *uo19 = (struct UserObject*)obj1;
  uo19->data[5] = emptyclosure;
  Method *meth_meth_unixFilePath_shortName19 = addmethod2pos(obj1, "shortName", &meth_unixFilePath_shortName19, 5);
  int argcv_meth_unixFilePath_shortName19[] = {0};
  meth_meth_unixFilePath_shortName19->type = alloc_MethodType(1, argcv_meth_unixFilePath_shortName19);
  meth_meth_unixFilePath_shortName19->definitionModule = modulename;
  meth_meth_unixFilePath_shortName19->definitionLine = 18;
// method asDebugString
  struct UserObject *uo27 = (struct UserObject*)obj1;
  uo27->data[6] = emptyclosure;
  Method *meth_meth_unixFilePath_asDebugString27 = addmethod2pos(obj1, "asDebugString", &meth_unixFilePath_asDebugString27, 6);
  int argcv_meth_unixFilePath_asDebugString27[] = {0};
  meth_meth_unixFilePath_asDebugString27->type = alloc_MethodType(1, argcv_meth_unixFilePath_asDebugString27);
  meth_meth_unixFilePath_asDebugString27->definitionModule = modulename;
  meth_meth_unixFilePath_asDebugString27->definitionLine = 21;
// method directory
  struct UserObject *uo56 = (struct UserObject*)obj1;
  uo56->data[7] = emptyclosure;
  Method *meth_meth_unixFilePath_directory56 = addmethod2pos(obj1, "directory", &meth_unixFilePath_directory56, 7);
  int argcv_meth_unixFilePath_directory56[] = {0};
  meth_meth_unixFilePath_directory56->type = alloc_MethodType(1, argcv_meth_unixFilePath_directory56);
  meth_meth_unixFilePath_directory56->definitionModule = modulename;
  meth_meth_unixFilePath_directory56->definitionLine = 24;
// method directory:=
  block_savedest(obj1);
  Object closure67 = createclosure(1, "directory:=");
  setclosureframe(closure67, stackframe);
  addtoclosure(closure67, var_done);
  struct UserObject *uo67 = (struct UserObject*)obj1;
  uo67->data[8] = (Object)closure67;
  Method *meth_meth_unixFilePath_directory_58__61_67 = addmethod2pos(obj1, "directory:=", &meth_unixFilePath_directory_58__61_67, 8);
  int argcv_meth_unixFilePath_directory_58__61_67[] = {1};
  meth_meth_unixFilePath_directory_58__61_67->type = alloc_MethodType(1, argcv_meth_unixFilePath_directory_58__61_67);
  meth_meth_unixFilePath_directory_58__61_67->definitionModule = modulename;
  meth_meth_unixFilePath_directory_58__61_67->definitionLine = 29;
// method setDirectory
  struct UserObject *uo99 = (struct UserObject*)obj1;
  uo99->data[9] = emptyclosure;
  Method *meth_meth_unixFilePath_setDirectory99 = addmethod2pos(obj1, "setDirectory", &meth_unixFilePath_setDirectory99, 9);
  int argcv_meth_unixFilePath_setDirectory99[] = {1};
  meth_meth_unixFilePath_setDirectory99->type = alloc_MethodType(1, argcv_meth_unixFilePath_setDirectory99);
  meth_meth_unixFilePath_setDirectory99->definitionModule = modulename;
  meth_meth_unixFilePath_setDirectory99->definitionLine = 42;
// method setBase
  struct UserObject *uo102 = (struct UserObject*)obj1;
  uo102->data[10] = emptyclosure;
  Method *meth_meth_unixFilePath_setBase102 = addmethod2pos(obj1, "setBase", &meth_unixFilePath_setBase102, 10);
  int argcv_meth_unixFilePath_setBase102[] = {1};
  meth_meth_unixFilePath_setBase102->type = alloc_MethodType(1, argcv_meth_unixFilePath_setBase102);
  meth_meth_unixFilePath_setBase102->definitionModule = modulename;
  meth_meth_unixFilePath_setBase102->definitionLine = 47;
// method setExtension
  struct UserObject *uo105 = (struct UserObject*)obj1;
  uo105->data[11] = emptyclosure;
  Method *meth_meth_unixFilePath_setExtension105 = addmethod2pos(obj1, "setExtension", &meth_unixFilePath_setExtension105, 11);
  int argcv_meth_unixFilePath_setExtension105[] = {1};
  meth_meth_unixFilePath_setExtension105->type = alloc_MethodType(1, argcv_meth_unixFilePath_setExtension105);
  meth_meth_unixFilePath_setExtension105->definitionModule = modulename;
  meth_meth_unixFilePath_setExtension105->definitionLine = 52;
// method exists
  block_savedest(obj1);
  Object closure121 = createclosure(1, "exists");
  setclosureframe(closure121, stackframe);
  addtoclosure(closure121, var_io);
  struct UserObject *uo121 = (struct UserObject*)obj1;
  uo121->data[12] = (Object)closure121;
  Method *meth_meth_unixFilePath_exists121 = addmethod2pos(obj1, "exists", &meth_unixFilePath_exists121, 12);
  int argcv_meth_unixFilePath_exists121[] = {0};
  meth_meth_unixFilePath_exists121->type = alloc_MethodType(1, argcv_meth_unixFilePath_exists121);
  meth_meth_unixFilePath_exists121->definitionModule = modulename;
  meth_meth_unixFilePath_exists121->definitionLine = 61;
// method newer
  block_savedest(obj1);
  Object closure126 = createclosure(1, "newer");
  setclosureframe(closure126, stackframe);
  addtoclosure(closure126, var_io);
  struct UserObject *uo126 = (struct UserObject*)obj1;
  uo126->data[13] = (Object)closure126;
  Method *meth_meth_unixFilePath_newer126 = addmethod2pos(obj1, "newer", &meth_unixFilePath_newer126, 13);
  int argcv_meth_unixFilePath_newer126[] = {1};
  meth_meth_unixFilePath_newer126->type = alloc_MethodType(1, argcv_meth_unixFilePath_newer126);
  meth_meth_unixFilePath_newer126->definitionModule = modulename;
  meth_meth_unixFilePath_newer126->definitionLine = 65;
// method copy
  struct UserObject *uo133 = (struct UserObject*)obj1;
  uo133->data[14] = emptyclosure;
  Method *meth_meth_unixFilePath_copy133 = addmethod2pos(obj1, "copy", &meth_unixFilePath_copy133, 14);
  int argcv_meth_unixFilePath_copy133[] = {0};
  meth_meth_unixFilePath_copy133->type = alloc_MethodType(1, argcv_meth_unixFilePath_copy133);
  meth_meth_unixFilePath_copy133->definitionModule = modulename;
  meth_meth_unixFilePath_copy133->definitionLine = 70;
  sourceObject = obj1;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit150 == NULL) {
    strlit150 = alloc_String("");
    gc_root(strlit150);
  }
// compiled string node returning strlit150 (depth = 2)
  adddatum2(obj1, strlit150, 1);
  sourceObject = obj1;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit151 == NULL) {
    strlit151 = alloc_String("");
    gc_root(strlit151);
  }
// compiled string node returning strlit151 (depth = 2)
  adddatum2(obj1, strlit151, 2);
  sourceObject = obj1;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit152 == NULL) {
    strlit152 = alloc_String("");
    gc_root(strlit152);
  }
// compiled string node returning strlit152 (depth = 2)
  adddatum2(obj1, strlit152, 3);
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  objclass1 = obj1->class;
  objclass1->definitionModule = modulename;
  objclass1->definitionLine = 3;
  (*(struct UserObject *)self).data[0] = lowerouter1;
  self = oldself1;
  selfslot = oldselfslot1;
  stackframe = oldstackframe1;
  gc_frame_end(frame);
  return obj1;
}
Object meth_unixFilePath_null0_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "null()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for null (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for null");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1 = alloc_userobj2(17,15, objclass1);
  gc_frame_newslot(obj1);
if (objclass1 == NULL) {
  glfree(obj1->class->name);
  obj1->class->name = "self.null";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1, self, 0);
  addmethodreal(obj1,"outer", &reader_unixFilePath_outer_2);
  Object oldself1 = self;
  struct StackFrameObject *oldstackframe1 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1);
  gc_frame_newslot((Object)stackframe);
  self = obj1;
  Object *oldselfslot1 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1 = (*(struct UserObject *)self).data[0], lowerouter1 = thisouter1;
  if (inheritingObject1) {
    struct UserObject *inho1 = (struct UserObject *)inheritingObject1;
    while (inho1->super != GraceDefaultObject) inho1 = (struct UserObject *)inho1->super;
    inho1->super = obj1;
    self = inheritingObject1;
    *selfslot = self;
    lowerouter1 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1;
  }
if (objclass1 == NULL) {
  Method *reader3 = addmethodrealflags(obj1, "dir",&reader_unixFilePath_dir_3, 0);
  Method *writer3 = addmethodrealflags(obj1, "dir:=",&writer_unixFilePath_dir_3, MFLAG_CONFIDENTIAL);
  reader3->definitionModule = modulename;
  writer3->definitionModule = modulename;
  reader3->definitionLine = 6;
  writer3->definitionLine = 6;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 1);
if (objclass1 == NULL) {
  Method *reader4 = addmethodrealflags(obj1, "base",&reader_unixFilePath_base_4, 0);
  Method *writer4 = addmethodrealflags(obj1, "base:=",&writer_unixFilePath_base_4, 0);
  reader4->definitionModule = modulename;
  writer4->definitionModule = modulename;
  reader4->definitionLine = 9;
  writer4->definitionLine = 9;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 2);
if (objclass1 == NULL) {
  Method *reader5 = addmethodrealflags(obj1, "extension",&reader_unixFilePath_extension_5, 0);
  Method *writer5 = addmethodrealflags(obj1, "extension:=",&writer_unixFilePath_extension_5, 0);
  reader5->definitionModule = modulename;
  writer5->definitionModule = modulename;
  reader5->definitionLine = 12;
  writer5->definitionLine = 12;
}
obj1->flags |= OFLAG_MUTABLE;
adddatum2(obj1, alloc_Undefined(), 3);
// method asString
  struct UserObject *uo6 = (struct UserObject*)obj1;
  uo6->data[4] = emptyclosure;
  Method *meth_meth_unixFilePath_asString6 = addmethod2pos(obj1, "asString", &meth_unixFilePath_asString6, 4);
  int argcv_meth_unixFilePath_asString6[] = {0};
  meth_meth_unixFilePath_asString6->type = alloc_MethodType(1, argcv_meth_unixFilePath_asString6);
  meth_meth_unixFilePath_asString6->definitionModule = modulename;
  meth_meth_unixFilePath_asString6->definitionLine = 15;
// method shortName
  struct UserObject *uo19 = (struct UserObject*)obj1;
  uo19->data[5] = emptyclosure;
  Method *meth_meth_unixFilePath_shortName19 = addmethod2pos(obj1, "shortName", &meth_unixFilePath_shortName19, 5);
  int argcv_meth_unixFilePath_shortName19[] = {0};
  meth_meth_unixFilePath_shortName19->type = alloc_MethodType(1, argcv_meth_unixFilePath_shortName19);
  meth_meth_unixFilePath_shortName19->definitionModule = modulename;
  meth_meth_unixFilePath_shortName19->definitionLine = 18;
// method asDebugString
  struct UserObject *uo27 = (struct UserObject*)obj1;
  uo27->data[6] = emptyclosure;
  Method *meth_meth_unixFilePath_asDebugString27 = addmethod2pos(obj1, "asDebugString", &meth_unixFilePath_asDebugString27, 6);
  int argcv_meth_unixFilePath_asDebugString27[] = {0};
  meth_meth_unixFilePath_asDebugString27->type = alloc_MethodType(1, argcv_meth_unixFilePath_asDebugString27);
  meth_meth_unixFilePath_asDebugString27->definitionModule = modulename;
  meth_meth_unixFilePath_asDebugString27->definitionLine = 21;
// method directory
  struct UserObject *uo56 = (struct UserObject*)obj1;
  uo56->data[7] = emptyclosure;
  Method *meth_meth_unixFilePath_directory56 = addmethod2pos(obj1, "directory", &meth_unixFilePath_directory56, 7);
  int argcv_meth_unixFilePath_directory56[] = {0};
  meth_meth_unixFilePath_directory56->type = alloc_MethodType(1, argcv_meth_unixFilePath_directory56);
  meth_meth_unixFilePath_directory56->definitionModule = modulename;
  meth_meth_unixFilePath_directory56->definitionLine = 24;
// method directory:=
  block_savedest(obj1);
  Object closure67 = createclosure(1, "directory:=");
  setclosureframe(closure67, stackframe);
  addtoclosure(closure67, var_done);
  struct UserObject *uo67 = (struct UserObject*)obj1;
  uo67->data[8] = (Object)closure67;
  Method *meth_meth_unixFilePath_directory_58__61_67 = addmethod2pos(obj1, "directory:=", &meth_unixFilePath_directory_58__61_67, 8);
  int argcv_meth_unixFilePath_directory_58__61_67[] = {1};
  meth_meth_unixFilePath_directory_58__61_67->type = alloc_MethodType(1, argcv_meth_unixFilePath_directory_58__61_67);
  meth_meth_unixFilePath_directory_58__61_67->definitionModule = modulename;
  meth_meth_unixFilePath_directory_58__61_67->definitionLine = 29;
// method setDirectory
  struct UserObject *uo99 = (struct UserObject*)obj1;
  uo99->data[9] = emptyclosure;
  Method *meth_meth_unixFilePath_setDirectory99 = addmethod2pos(obj1, "setDirectory", &meth_unixFilePath_setDirectory99, 9);
  int argcv_meth_unixFilePath_setDirectory99[] = {1};
  meth_meth_unixFilePath_setDirectory99->type = alloc_MethodType(1, argcv_meth_unixFilePath_setDirectory99);
  meth_meth_unixFilePath_setDirectory99->definitionModule = modulename;
  meth_meth_unixFilePath_setDirectory99->definitionLine = 42;
// method setBase
  struct UserObject *uo102 = (struct UserObject*)obj1;
  uo102->data[10] = emptyclosure;
  Method *meth_meth_unixFilePath_setBase102 = addmethod2pos(obj1, "setBase", &meth_unixFilePath_setBase102, 10);
  int argcv_meth_unixFilePath_setBase102[] = {1};
  meth_meth_unixFilePath_setBase102->type = alloc_MethodType(1, argcv_meth_unixFilePath_setBase102);
  meth_meth_unixFilePath_setBase102->definitionModule = modulename;
  meth_meth_unixFilePath_setBase102->definitionLine = 47;
// method setExtension
  struct UserObject *uo105 = (struct UserObject*)obj1;
  uo105->data[11] = emptyclosure;
  Method *meth_meth_unixFilePath_setExtension105 = addmethod2pos(obj1, "setExtension", &meth_unixFilePath_setExtension105, 11);
  int argcv_meth_unixFilePath_setExtension105[] = {1};
  meth_meth_unixFilePath_setExtension105->type = alloc_MethodType(1, argcv_meth_unixFilePath_setExtension105);
  meth_meth_unixFilePath_setExtension105->definitionModule = modulename;
  meth_meth_unixFilePath_setExtension105->definitionLine = 52;
// method exists
  block_savedest(obj1);
  Object closure121 = createclosure(1, "exists");
  setclosureframe(closure121, stackframe);
  addtoclosure(closure121, var_io);
  struct UserObject *uo121 = (struct UserObject*)obj1;
  uo121->data[12] = (Object)closure121;
  Method *meth_meth_unixFilePath_exists121 = addmethod2pos(obj1, "exists", &meth_unixFilePath_exists121, 12);
  int argcv_meth_unixFilePath_exists121[] = {0};
  meth_meth_unixFilePath_exists121->type = alloc_MethodType(1, argcv_meth_unixFilePath_exists121);
  meth_meth_unixFilePath_exists121->definitionModule = modulename;
  meth_meth_unixFilePath_exists121->definitionLine = 61;
// method newer
  block_savedest(obj1);
  Object closure126 = createclosure(1, "newer");
  setclosureframe(closure126, stackframe);
  addtoclosure(closure126, var_io);
  struct UserObject *uo126 = (struct UserObject*)obj1;
  uo126->data[13] = (Object)closure126;
  Method *meth_meth_unixFilePath_newer126 = addmethod2pos(obj1, "newer", &meth_unixFilePath_newer126, 13);
  int argcv_meth_unixFilePath_newer126[] = {1};
  meth_meth_unixFilePath_newer126->type = alloc_MethodType(1, argcv_meth_unixFilePath_newer126);
  meth_meth_unixFilePath_newer126->definitionModule = modulename;
  meth_meth_unixFilePath_newer126->definitionLine = 65;
// method copy
  struct UserObject *uo133 = (struct UserObject*)obj1;
  uo133->data[14] = emptyclosure;
  Method *meth_meth_unixFilePath_copy133 = addmethod2pos(obj1, "copy", &meth_unixFilePath_copy133, 14);
  int argcv_meth_unixFilePath_copy133[] = {0};
  meth_meth_unixFilePath_copy133->type = alloc_MethodType(1, argcv_meth_unixFilePath_copy133);
  meth_meth_unixFilePath_copy133->definitionModule = modulename;
  meth_meth_unixFilePath_copy133->definitionLine = 70;
  sourceObject = obj1;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit150 == NULL) {
    strlit150 = alloc_String("");
    gc_root(strlit150);
  }
// compiled string node returning strlit150 (depth = 2)
  adddatum2(obj1, strlit150, 1);
  sourceObject = obj1;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit151 == NULL) {
    strlit151 = alloc_String("");
    gc_root(strlit151);
  }
// compiled string node returning strlit151 (depth = 2)
  adddatum2(obj1, strlit151, 2);
  sourceObject = obj1;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit152 == NULL) {
    strlit152 = alloc_String("");
    gc_root(strlit152);
  }
// compiled string node returning strlit152 (depth = 2)
  adddatum2(obj1, strlit152, 3);
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  sourceObject = obj1;
  objclass1 = obj1->class;
  objclass1->definitionModule = modulename;
  objclass1->definitionLine = 3;
  (*(struct UserObject *)self).data[0] = lowerouter1;
  self = oldself1;
  selfslot = oldselfslot1;
  stackframe = oldstackframe1;
  gc_frame_end(frame);
  return obj1;
}
Object meth_unixFilePath_withDirectory154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withDirectory");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withDirectory");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withDirectory (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_d = &(stackframe->slots[0]);
  *var_d = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withDirectory");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe155 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_d (depth = 3)
  gc_frame_newslot(*var_d);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call157 = callmethodflags(self, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe156);
// compiled call node returning call157 (depth = 4)
// compiled member node returning call157 (depth = 3)
  params[0] = *var_d;
  partcv[0] = 1;
  Object call158 = callmethod(call157, "setDirectory",
    1, partcv, params);
  gc_frame_end(callframe155);
// compiled call node returning call158 (depth = 2)
  gc_frame_end(frame);
  return call158;
}
Object meth_unixFilePath_withBase159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withBase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withBase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withBase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withBase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe160 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call162 = callmethodflags(self, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe161);
// compiled call node returning call162 (depth = 4)
// compiled member node returning call162 (depth = 3)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call163 = callmethod(call162, "setBase",
    1, partcv, params);
  gc_frame_end(callframe160);
// compiled call node returning call163 (depth = 2)
  gc_frame_end(frame);
  return call163;
}
Object meth_unixFilePath_withExtension164(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withExtension");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withExtension");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withExtension (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withExtension");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe165 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_e (depth = 3)
  gc_frame_newslot(*var_e);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call167 = callmethodflags(self, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe166);
// compiled call node returning call167 (depth = 4)
// compiled member node returning call167 (depth = 3)
  params[0] = *var_e;
  partcv[0] = 1;
  Object call168 = callmethod(call167, "setExtension",
    1, partcv, params);
  gc_frame_end(callframe165);
// compiled call node returning call168 (depth = 2)
  gc_frame_end(frame);
  return call168;
}
Object meth_unixFilePath_withDirectory_40__41_base_40__41_extension169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withDirectory()base()extension");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method withDirectory()base()extension");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method withDirectory()base()extension");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method withDirectory()base()extension");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for withDirectory()base()extension (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_d = &(stackframe->slots[0]);
  *var_d = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for withDirectory");
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for base");
  Object *var_e = &(stackframe->slots[2]);
  *var_e = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for extension");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe170 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_e (depth = 3)
  gc_frame_newslot(*var_e);
// call case 6: other member request
// starting to compile call node (depth = 3)
  int callframe171 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe172 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_d (depth = 5)
  gc_frame_newslot(*var_d);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call174 = callmethodflags(self, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe173);
// compiled call node returning call174 (depth = 6)
// compiled member node returning call174 (depth = 5)
  params[0] = *var_d;
  partcv[0] = 1;
  Object call175 = callmethod(call174, "setDirectory",
    1, partcv, params);
  gc_frame_end(callframe172);
// compiled call node returning call175 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call176 = callmethod(call175, "setBase",
    1, partcv, params);
  gc_frame_end(callframe171);
// compiled call node returning call176 (depth = 3)
  params[0] = *var_e;
  partcv[0] = 1;
  Object call177 = callmethod(call176, "setExtension",
    1, partcv, params);
  gc_frame_end(callframe170);
// compiled call node returning call177 (depth = 2)
  gc_frame_end(frame);
  return call177;
}
Object meth_unixFilePath__apply186(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_slashPosn = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num189 = alloc_Float64(0);
// compiled num node returning num189 (depth = 6)
  int op_slot_right_188 = gc_frame_newslot(num189);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_188 = gc_frame_newslot(*var_ix);
  params[0] = num189;
  partcv[0] = 1;
  Object opresult191 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult191 (depth = 5)
  int op_slot_right_187 = gc_frame_newslot(opresult191);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num194 = alloc_Float64(0);
// compiled num node returning num194 (depth = 6)
  int op_slot_right_193 = gc_frame_newslot(num194);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_slashPosn (depth = 6)
  int op_slot_left_193 = gc_frame_newslot(*var_slashPosn);
  params[0] = num194;
  partcv[0] = 1;
  Object opresult196 = callmethod(*var_slashPosn, "==", 1, partcv, params);
// compiled op node returning opresult196 (depth = 5)
  int op_slot_left_187 = gc_frame_newslot(opresult196);
  params[0] = opresult191;
  partcv[0] = 1;
  Object opresult197 = callmethod(opresult196, "&&", 1, partcv, params);
// compiled op node returning opresult197 (depth = 4)
  gc_frame_end(frame);
  return opresult197;
}
Object meth_unixFilePath__apply200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_slashPosn = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit203 == NULL) {
    strlit203 = alloc_String("/");
    gc_root(strlit203);
  }
// compiled string node returning strlit203 (depth = 6)
  int op_slot_right_202 = gc_frame_newslot(strlit203);
// starting to compile call node (depth = 6)
  int callframe205 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call206 = callmethod(*var_s, "at",
    1, partcv, params);
  gc_frame_end(callframe205);
// compiled call node returning call206 (depth = 6)
  int op_slot_left_202 = gc_frame_newslot(call206);
  params[0] = strlit203;
  partcv[0] = 1;
  Object opresult207 = callmethod(call206, "==", 1, partcv, params);
// compiled op node returning opresult207 (depth = 5)
  Object if201 = done;
  if (istrue(opresult207)) {
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  *var_slashPosn = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if201 = done;
  } else {
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num210 = alloc_Float64(1);
// compiled num node returning num210 (depth = 7)
  int op_slot_right_209 = gc_frame_newslot(num210);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_209 = gc_frame_newslot(*var_ix);
  params[0] = num210;
  partcv[0] = 1;
  Object diff212 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff212 (depth = 6)
  *var_ix = diff212;
  if (diff212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if201 = done;
  }
// compiled if node returning if201 (depth = 4)
  gc_frame_end(frame);
  return if201;
}
Object meth_unixFilePath__apply228(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_slashPosn = getfromclosure(closure, 0);
  Object *var_ix = getfromclosure(closure, 1);
  Object *var_sSize = getfromclosure(closure, 2);
  Object *var_dotPosn = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_slashPosn (depth = 6)
  int op_slot_right_230 = gc_frame_newslot(*var_slashPosn);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_230 = gc_frame_newslot(*var_ix);
  params[0] = *var_slashPosn;
  partcv[0] = 1;
  Object opresult232 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult232 (depth = 5)
  int op_slot_right_229 = gc_frame_newslot(opresult232);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sSize (depth = 6)
  int op_slot_right_234 = gc_frame_newslot(*var_sSize);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dotPosn (depth = 6)
  int op_slot_left_234 = gc_frame_newslot(*var_dotPosn);
  params[0] = *var_sSize;
  partcv[0] = 1;
  Object opresult236 = callmethod(*var_dotPosn, ">", 1, partcv, params);
// compiled op node returning opresult236 (depth = 5)
  int op_slot_left_229 = gc_frame_newslot(opresult236);
  params[0] = opresult232;
  partcv[0] = 1;
  Object opresult237 = callmethod(opresult236, "&&", 1, partcv, params);
// compiled op node returning opresult237 (depth = 4)
  gc_frame_end(frame);
  return opresult237;
}
Object meth_unixFilePath__apply240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_dotPosn = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit243 == NULL) {
    strlit243 = alloc_String(".");
    gc_root(strlit243);
  }
// compiled string node returning strlit243 (depth = 6)
  int op_slot_right_242 = gc_frame_newslot(strlit243);
// starting to compile call node (depth = 6)
  int callframe245 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call246 = callmethod(*var_s, "at",
    1, partcv, params);
  gc_frame_end(callframe245);
// compiled call node returning call246 (depth = 6)
  int op_slot_left_242 = gc_frame_newslot(call246);
  params[0] = strlit243;
  partcv[0] = 1;
  Object opresult247 = callmethod(call246, "==", 1, partcv, params);
// compiled op node returning opresult247 (depth = 5)
  Object if241 = done;
  if (istrue(opresult247)) {
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  *var_dotPosn = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if241 = done;
  } else {
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num250 = alloc_Float64(1);
// compiled num node returning num250 (depth = 7)
  int op_slot_right_249 = gc_frame_newslot(num250);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_249 = gc_frame_newslot(*var_ix);
  params[0] = num250;
  partcv[0] = 1;
  Object diff252 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff252 (depth = 6)
  *var_ix = diff252;
  if (diff252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if241 = done;
  }
// compiled if node returning if241 (depth = 4)
  gc_frame_end(frame);
  return if241;
}
Object meth_unixFilePath_fromString178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fromString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method fromString");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for fromString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
  Object *var_slashPosn = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "slashPosn");
  Object *var_sSize = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sSize");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_dotPosn = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dotPosn");
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe179 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call180 = callmethodflags(self, "null", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe179);
// compiled call node returning call180 (depth = 4)
// compiled member node returning call180 (depth = 3)
  *var_p = call180;
  if (call180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num181 = alloc_Float64(0);
// compiled num node returning num181 (depth = 3)
  *var_slashPosn = num181;
  if (num181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call183 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe182);
// compiled call node returning call183 (depth = 4)
// compiled member node returning call183 (depth = 3)
  *var_sSize = call183;
  if (call183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sSize (depth = 3)
  *var_ix = *var_sSize;
  if (*var_sSize == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe184 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block185 = alloc_Block(NULL, NULL, "unixFilePath", 103);
  gc_frame_newslot(block185);
// method _apply
  block_savedest(block185);
  Object closure186 = createclosure(3, "_apply");
  setclosureframe(closure186, stackframe);
  addtoclosure(closure186, var_ix);
  addtoclosure(closure186, var_slashPosn);
  addtoclosure(closure186, selfslot);
  struct UserObject *uo186 = (struct UserObject*)block185;
  uo186->data[0] = (Object)closure186;
  Method *meth_meth_unixFilePath__apply186 = addmethod2pos(block185, "_apply", &meth_unixFilePath__apply186, 0);
  int argcv_meth_unixFilePath__apply186[] = {0};
  meth_meth_unixFilePath__apply186->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply186);
  meth_meth_unixFilePath__apply186->definitionModule = modulename;
  meth_meth_unixFilePath__apply186->definitionLine = 101;
// compiled block node returning block185 (depth = 3)
  gc_frame_newslot(block185);
// starting to compile block node (depth = 3)
  Object block199 = alloc_Block(NULL, NULL, "unixFilePath", 103);
  gc_frame_newslot(block199);
// method _apply
  block_savedest(block199);
  Object closure200 = createclosure(4, "_apply");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_ix);
  addtoclosure(closure200, var_s);
  addtoclosure(closure200, var_slashPosn);
  addtoclosure(closure200, selfslot);
  struct UserObject *uo200 = (struct UserObject*)block199;
  uo200->data[0] = (Object)closure200;
  Method *meth_meth_unixFilePath__apply200 = addmethod2pos(block199, "_apply", &meth_unixFilePath__apply200, 0);
  int argcv_meth_unixFilePath__apply200[] = {0};
  meth_meth_unixFilePath__apply200->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply200);
  meth_meth_unixFilePath__apply200->definitionModule = modulename;
  meth_meth_unixFilePath__apply200->definitionLine = 101;
// compiled block node returning block199 (depth = 3)
  gc_frame_newslot(block199);
// call case 5: prelude request
  params[0] = block185;
  params[1] = block199;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call215 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe184);
// compiled call node returning call215 (depth = 2)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe216 = gc_frame_new();
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe217 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num218 = alloc_Float64(1);
// compiled num node returning num218 (depth = 5)
  gc_frame_newslot(num218);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_slashPosn (depth = 5)
  gc_frame_newslot(*var_slashPosn);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  params[0] = num218;
  params[1] = *var_slashPosn;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call219 = callmethod(*var_s, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe217);
// compiled call node returning call219 (depth = 4)
  gc_frame_newslot(call219);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = call219;
  partcv[0] = 1;
  Object call220 = callmethod(*var_p, "directory:=",
    1, partcv, params);
  gc_frame_end(callframe216);
// compiled call node returning call220 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num222 = alloc_Float64(1);
// compiled num node returning num222 (depth = 4)
  int op_slot_right_221 = gc_frame_newslot(num222);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sSize (depth = 4)
  int op_slot_left_221 = gc_frame_newslot(*var_sSize);
  params[0] = num222;
  partcv[0] = 1;
  Object sum224 = callmethod(*var_sSize, "+", 1, partcv, params);
// compiled op node returning sum224 (depth = 3)
  *var_dotPosn = sum224;
  if (sum224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sSize (depth = 3)
  *var_ix = *var_sSize;
  if (*var_sSize == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe226 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block227 = alloc_Block(NULL, NULL, "unixFilePath", 113);
  gc_frame_newslot(block227);
// method _apply
  block_savedest(block227);
  Object closure228 = createclosure(5, "_apply");
  setclosureframe(closure228, stackframe);
  addtoclosure(closure228, var_slashPosn);
  addtoclosure(closure228, var_ix);
  addtoclosure(closure228, var_sSize);
  addtoclosure(closure228, var_dotPosn);
  addtoclosure(closure228, selfslot);
  struct UserObject *uo228 = (struct UserObject*)block227;
  uo228->data[0] = (Object)closure228;
  Method *meth_meth_unixFilePath__apply228 = addmethod2pos(block227, "_apply", &meth_unixFilePath__apply228, 0);
  int argcv_meth_unixFilePath__apply228[] = {0};
  meth_meth_unixFilePath__apply228->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply228);
  meth_meth_unixFilePath__apply228->definitionModule = modulename;
  meth_meth_unixFilePath__apply228->definitionLine = 101;
// compiled block node returning block227 (depth = 3)
  gc_frame_newslot(block227);
// starting to compile block node (depth = 3)
  Object block239 = alloc_Block(NULL, NULL, "unixFilePath", 113);
  gc_frame_newslot(block239);
// method _apply
  block_savedest(block239);
  Object closure240 = createclosure(4, "_apply");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_ix);
  addtoclosure(closure240, var_s);
  addtoclosure(closure240, var_dotPosn);
  addtoclosure(closure240, selfslot);
  struct UserObject *uo240 = (struct UserObject*)block239;
  uo240->data[0] = (Object)closure240;
  Method *meth_meth_unixFilePath__apply240 = addmethod2pos(block239, "_apply", &meth_unixFilePath__apply240, 0);
  int argcv_meth_unixFilePath__apply240[] = {0};
  meth_meth_unixFilePath__apply240->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply240);
  meth_meth_unixFilePath__apply240->definitionModule = modulename;
  meth_meth_unixFilePath__apply240->definitionLine = 101;
// compiled block node returning block239 (depth = 3)
  gc_frame_newslot(block239);
// call case 5: prelude request
  params[0] = block227;
  params[1] = block239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call255 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe226);
// compiled call node returning call255 (depth = 2)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sSize (depth = 4)
  int op_slot_right_257 = gc_frame_newslot(*var_sSize);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dotPosn (depth = 4)
  int op_slot_left_257 = gc_frame_newslot(*var_dotPosn);
  params[0] = *var_sSize;
  partcv[0] = 1;
  Object opresult259 = callmethod(*var_dotPosn, "<=", 1, partcv, params);
// compiled op node returning opresult259 (depth = 3)
  Object if256 = done;
  if (istrue(opresult259)) {
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe260 = gc_frame_new();
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe261 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dotPosn (depth = 6)
  gc_frame_newslot(*var_dotPosn);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sSize (depth = 6)
  gc_frame_newslot(*var_sSize);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  params[0] = *var_dotPosn;
  params[1] = *var_sSize;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call262 = callmethod(*var_s, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe261);
// compiled call node returning call262 (depth = 5)
  gc_frame_newslot(call262);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  params[0] = call262;
  partcv[0] = 1;
  Object call263 = callmethod(*var_p, "extension:=",
    1, partcv, params);
  gc_frame_end(callframe260);
// compiled call node returning call263 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if256 = done;
  } else {
  }
// compiled if node returning if256 (depth = 2)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe264 = gc_frame_new();
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe265 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num267 = alloc_Float64(1);
// compiled num node returning num267 (depth = 6)
  int op_slot_right_266 = gc_frame_newslot(num267);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_slashPosn (depth = 6)
  int op_slot_left_266 = gc_frame_newslot(*var_slashPosn);
  params[0] = num267;
  partcv[0] = 1;
  Object sum269 = callmethod(*var_slashPosn, "+", 1, partcv, params);
// compiled op node returning sum269 (depth = 5)
  gc_frame_newslot(sum269);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num271 = alloc_Float64(1);
// compiled num node returning num271 (depth = 6)
  int op_slot_right_270 = gc_frame_newslot(num271);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dotPosn (depth = 6)
  int op_slot_left_270 = gc_frame_newslot(*var_dotPosn);
  params[0] = num271;
  partcv[0] = 1;
  Object diff273 = callmethod(*var_dotPosn, "-", 1, partcv, params);
// compiled op node returning diff273 (depth = 5)
  gc_frame_newslot(diff273);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  params[0] = sum269;
  params[1] = diff273;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call274 = callmethod(*var_s, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe265);
// compiled call node returning call274 (depth = 4)
  gc_frame_newslot(call274);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = call274;
  partcv[0] = 1;
  Object call275 = callmethod(*var_p, "base:=",
    1, partcv, params);
  gc_frame_end(callframe264);
// compiled call node returning call275 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_p (depth = 2)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_unixFilePath__apply287(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_pss = getfromclosure(closure, 0);
  Object *var_ox = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pss (depth = 5)
  int op_slot_right_288 = gc_frame_newslot(*var_pss);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ox (depth = 5)
  int op_slot_left_288 = gc_frame_newslot(*var_ox);
  params[0] = *var_pss;
  partcv[0] = 1;
  Object opresult290 = callmethod(*var_ox, "<=", 1, partcv, params);
// compiled op node returning opresult290 (depth = 4)
  gc_frame_end(frame);
  return opresult290;
}
Object meth_unixFilePath__apply299(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ox = getfromclosure(closure, 0);
  Object *var_pathString = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit301 == NULL) {
    strlit301 = alloc_String(":");
    gc_root(strlit301);
  }
// compiled string node returning strlit301 (depth = 9)
  int op_slot_right_300 = gc_frame_newslot(strlit301);
// starting to compile call node (depth = 9)
  int callframe303 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ox (depth = 10)
  gc_frame_newslot(*var_ox);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pathString (depth = 10)
  params[0] = *var_ox;
  partcv[0] = 1;
  Object call304 = callmethod(*var_pathString, "at",
    1, partcv, params);
  gc_frame_end(callframe303);
// compiled call node returning call304 (depth = 9)
  int op_slot_left_300 = gc_frame_newslot(call304);
  params[0] = strlit301;
  partcv[0] = 1;
  Object opresult305 = callmethod(call304, "!=", 1, partcv, params);
// compiled op node returning opresult305 (depth = 8)
  gc_frame_end(frame);
  return opresult305;
}
Object meth_unixFilePath__apply296(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ox = getfromclosure(closure, 0);
  Object *var_pathString = getfromclosure(closure, 1);
  Object *var_pss = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe297 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block298 = alloc_Block(NULL, NULL, "unixFilePath", 135);
  gc_frame_newslot(block298);
// method _apply
  block_savedest(block298);
  Object closure299 = createclosure(3, "_apply");
  setclosureframe(closure299, stackframe);
  addtoclosure(closure299, var_ox);
  addtoclosure(closure299, var_pathString);
  addtoclosure(closure299, selfslot);
  struct UserObject *uo299 = (struct UserObject*)block298;
  uo299->data[0] = (Object)closure299;
  Method *meth_meth_unixFilePath__apply299 = addmethod2pos(block298, "_apply", &meth_unixFilePath__apply299, 0);
  int argcv_meth_unixFilePath__apply299[] = {0};
  meth_meth_unixFilePath__apply299->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply299);
  meth_meth_unixFilePath__apply299->definitionModule = modulename;
  meth_meth_unixFilePath__apply299->definitionLine = 133;
// compiled block node returning block298 (depth = 7)
  gc_frame_newslot(block298);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_pss (depth = 8)
  int op_slot_right_307 = gc_frame_newslot(*var_pss);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ox (depth = 8)
  int op_slot_left_307 = gc_frame_newslot(*var_ox);
  params[0] = *var_pss;
  partcv[0] = 1;
  Object opresult309 = callmethod(*var_ox, "<=", 1, partcv, params);
// compiled op node returning opresult309 (depth = 7)
  params[0] = block298;
  partcv[0] = 1;
  Object call310 = callmethod(opresult309, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe297);
// compiled call node returning call310 (depth = 6)
  gc_frame_end(frame);
  return call310;
}
Object meth_unixFilePath__apply313(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ox = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num315 = alloc_Float64(1);
// compiled num node returning num315 (depth = 8)
  int op_slot_right_314 = gc_frame_newslot(num315);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ox (depth = 8)
  int op_slot_left_314 = gc_frame_newslot(*var_ox);
  params[0] = num315;
  partcv[0] = 1;
  Object sum317 = callmethod(*var_ox, "+", 1, partcv, params);
// compiled op node returning sum317 (depth = 7)
  *var_ox = sum317;
  if (sum317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_unixFilePath__apply293(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ox = getfromclosure(closure, 0);
  Object *var_pathString = getfromclosure(closure, 1);
  Object *var_pss = getfromclosure(closure, 2);
  Object *var_ix = getfromclosure(closure, 3);
  Object *var_locations = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_item = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "item");
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe294 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block295 = alloc_Block(NULL, NULL, "unixFilePath", 135);
  gc_frame_newslot(block295);
// method _apply
  block_savedest(block295);
  Object closure296 = createclosure(4, "_apply");
  setclosureframe(closure296, stackframe);
  addtoclosure(closure296, var_ox);
  addtoclosure(closure296, var_pathString);
  addtoclosure(closure296, var_pss);
  addtoclosure(closure296, selfslot);
  struct UserObject *uo296 = (struct UserObject*)block295;
  uo296->data[0] = (Object)closure296;
  Method *meth_meth_unixFilePath__apply296 = addmethod2pos(block295, "_apply", &meth_unixFilePath__apply296, 0);
  int argcv_meth_unixFilePath__apply296[] = {0};
  meth_meth_unixFilePath__apply296->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply296);
  meth_meth_unixFilePath__apply296->definitionModule = modulename;
  meth_meth_unixFilePath__apply296->definitionLine = 133;
// compiled block node returning block295 (depth = 5)
  gc_frame_newslot(block295);
// starting to compile block node (depth = 5)
  Object block312 = alloc_Block(NULL, NULL, "unixFilePath", 135);
  gc_frame_newslot(block312);
// method _apply
  block_savedest(block312);
  Object closure313 = createclosure(2, "_apply");
  setclosureframe(closure313, stackframe);
  addtoclosure(closure313, var_ox);
  addtoclosure(closure313, selfslot);
  struct UserObject *uo313 = (struct UserObject*)block312;
  uo313->data[0] = (Object)closure313;
  Method *meth_meth_unixFilePath__apply313 = addmethod2pos(block312, "_apply", &meth_unixFilePath__apply313, 0);
  int argcv_meth_unixFilePath__apply313[] = {0};
  meth_meth_unixFilePath__apply313->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply313);
  meth_meth_unixFilePath__apply313->definitionModule = modulename;
  meth_meth_unixFilePath__apply313->definitionLine = 133;
// compiled block node returning block312 (depth = 5)
  gc_frame_newslot(block312);
// call case 5: prelude request
  params[0] = block295;
  params[1] = block312;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call320 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe294);
// compiled call node returning call320 (depth = 4)
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe321 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num323 = alloc_Float64(1);
// compiled num node returning num323 (depth = 7)
  int op_slot_right_322 = gc_frame_newslot(num323);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ox (depth = 7)
  int op_slot_left_322 = gc_frame_newslot(*var_ox);
  params[0] = num323;
  partcv[0] = 1;
  Object diff325 = callmethod(*var_ox, "-", 1, partcv, params);
// compiled op node returning diff325 (depth = 6)
  gc_frame_newslot(diff325);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pathString (depth = 6)
  params[0] = *var_ix;
  params[1] = diff325;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call326 = callmethod(*var_pathString, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe321);
// compiled call node returning call326 (depth = 5)
  *var_item = call326;
  if (call326 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit329 == NULL) {
    strlit329 = alloc_String("/");
    gc_root(strlit329);
  }
// compiled string node returning strlit329 (depth = 6)
  int op_slot_right_328 = gc_frame_newslot(strlit329);
// starting to compile call node (depth = 6)
  int callframe331 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_item (depth = 9)
  partcv[0] = 0;
  Object call333 = callmethod(*var_item, "size",
    1, partcv, params);
  gc_frame_end(callframe332);
// compiled call node returning call333 (depth = 8)
// compiled member node returning call333 (depth = 7)
  gc_frame_newslot(call333);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_item (depth = 7)
  params[0] = call333;
  partcv[0] = 1;
  Object call334 = callmethod(*var_item, "at",
    1, partcv, params);
  gc_frame_end(callframe331);
// compiled call node returning call334 (depth = 6)
  int op_slot_left_328 = gc_frame_newslot(call334);
  params[0] = strlit329;
  partcv[0] = 1;
  Object opresult335 = callmethod(call334, "!=", 1, partcv, params);
// compiled op node returning opresult335 (depth = 5)
  Object if327 = done;
  if (istrue(opresult335)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit337 == NULL) {
    strlit337 = alloc_String("/");
    gc_root(strlit337);
  }
// compiled string node returning strlit337 (depth = 7)
  int op_slot_right_336 = gc_frame_newslot(strlit337);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_item (depth = 7)
  int op_slot_left_336 = gc_frame_newslot(*var_item);
  params[0] = strlit337;
  partcv[0] = 1;
  Object opresult339 = callmethod(*var_item, "++", 1, partcv, params);
// compiled op node returning opresult339 (depth = 6)
  *var_item = opresult339;
  if (opresult339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if327 = done;
  } else {
  }
// compiled if node returning if327 (depth = 4)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_item (depth = 5)
  gc_frame_newslot(*var_item);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_locations (depth = 5)
  params[0] = *var_item;
  partcv[0] = 1;
  Object call342 = callmethod(*var_locations, "addLast",
    1, partcv, params);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 4)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num344 = alloc_Float64(1);
// compiled num node returning num344 (depth = 6)
  int op_slot_right_343 = gc_frame_newslot(num344);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ox (depth = 6)
  int op_slot_left_343 = gc_frame_newslot(*var_ox);
  params[0] = num344;
  partcv[0] = 1;
  Object sum346 = callmethod(*var_ox, "+", 1, partcv, params);
// compiled op node returning sum346 (depth = 5)
  *var_ix = sum346;
  if (sum346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  *var_ox = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_unixFilePath_split276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "split");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method split");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for split (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pathString = &(stackframe->slots[0]);
  *var_pathString = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for split");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_locations = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "locations");
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
  Object *var_ox = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ox");
  Object *var_pss = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "pss");
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe277 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe278 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call279 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe278);
// compiled call node returning call279 (depth = 6)
// compiled member node returning call279 (depth = 5)
  partcv[0] = 0;
  Object call280 = callmethod(call279, "empty",
    1, partcv, params);
  gc_frame_end(callframe277);
// compiled call node returning call280 (depth = 4)
// compiled member node returning call280 (depth = 3)
  *var_locations = call280;
  if (call280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num281 = alloc_Float64(1);
// compiled num node returning num281 (depth = 3)
  *var_ix = num281;
  if (num281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num282 = alloc_Float64(1);
// compiled num node returning num282 (depth = 3)
  *var_ox = num282;
  if (num282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pathString (depth = 5)
  partcv[0] = 0;
  Object call284 = callmethod(*var_pathString, "size",
    1, partcv, params);
  gc_frame_end(callframe283);
// compiled call node returning call284 (depth = 4)
// compiled member node returning call284 (depth = 3)
  *var_pss = call284;
  if (call284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe285 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block286 = alloc_Block(NULL, NULL, "unixFilePath", 134);
  gc_frame_newslot(block286);
// method _apply
  block_savedest(block286);
  Object closure287 = createclosure(3, "_apply");
  setclosureframe(closure287, stackframe);
  addtoclosure(closure287, var_pss);
  addtoclosure(closure287, var_ox);
  addtoclosure(closure287, selfslot);
  struct UserObject *uo287 = (struct UserObject*)block286;
  uo287->data[0] = (Object)closure287;
  Method *meth_meth_unixFilePath__apply287 = addmethod2pos(block286, "_apply", &meth_unixFilePath__apply287, 0);
  int argcv_meth_unixFilePath__apply287[] = {0};
  meth_meth_unixFilePath__apply287->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply287);
  meth_meth_unixFilePath__apply287->definitionModule = modulename;
  meth_meth_unixFilePath__apply287->definitionLine = 133;
// compiled block node returning block286 (depth = 3)
  gc_frame_newslot(block286);
// starting to compile block node (depth = 3)
  Object block292 = alloc_Block(NULL, NULL, "unixFilePath", 134);
  gc_frame_newslot(block292);
// method _apply
  block_savedest(block292);
  Object closure293 = createclosure(6, "_apply");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_ox);
  addtoclosure(closure293, var_pathString);
  addtoclosure(closure293, var_pss);
  addtoclosure(closure293, var_ix);
  addtoclosure(closure293, var_locations);
  addtoclosure(closure293, selfslot);
  struct UserObject *uo293 = (struct UserObject*)block292;
  uo293->data[0] = (Object)closure293;
  Method *meth_meth_unixFilePath__apply293 = addmethod2pos(block292, "_apply", &meth_unixFilePath__apply293, 0);
  int argcv_meth_unixFilePath__apply293[] = {0};
  meth_meth_unixFilePath__apply293->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply293);
  meth_meth_unixFilePath__apply293->definitionModule = modulename;
  meth_meth_unixFilePath__apply293->definitionLine = 133;
// compiled block node returning block292 (depth = 3)
  gc_frame_newslot(block292);
// call case 5: prelude request
  params[0] = block286;
  params[1] = block292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call350 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe285);
// compiled call node returning call350 (depth = 2)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_locations (depth = 3)
  return *var_locations;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_unixFilePath__apply376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_originalDir = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe377 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_originalDir (depth = 6)
  int op_slot_right_378 = gc_frame_newslot(*var_originalDir);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_378 = gc_frame_newslot(*var_each);
  params[0] = *var_originalDir;
  partcv[0] = 1;
  Object opresult380 = callmethod(*var_each, "++", 1, partcv, params);
// compiled op node returning opresult380 (depth = 5)
  gc_frame_newslot(opresult380);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  params[0] = opresult380;
  partcv[0] = 1;
  Object call381 = callmethod(*var_candidate, "setDirectory",
    1, partcv, params);
  gc_frame_end(callframe377);
// compiled call node returning call381 (depth = 4)
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  partcv[0] = 0;
  Object call384 = callmethod(*var_candidate, "exists",
    1, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 6)
// compiled member node returning call384 (depth = 5)
  Object if382 = done;
  if (istrue(call384)) {
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  block_return(realself, *var_candidate);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if382 = undefined;
  } else {
  }
// compiled if node returning if382 (depth = 4)
  gc_frame_end(frame);
  return if382;
}
Object meth_unixFilePath_file_40__41_onPath_40__41_otherwise351(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "file()onPath()otherwise");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method file()onPath()otherwise");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method file()onPath()otherwise");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method file()onPath()otherwise");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for file()onPath()otherwise (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for file");
  Object *var_pathString = &(stackframe->slots[1]);
  *var_pathString = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onPath");
  Object *var_action = &(stackframe->slots[2]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for otherwise");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_locations = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "locations");
  Object *var_candidate = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "candidate");
  Object *var_originalDir = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "originalDir");
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe352 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pathString (depth = 4)
  gc_frame_newslot(*var_pathString);
// call case 4: self request
  params[0] = *var_pathString;
  partcv[0] = 1;
  Object call353 = callmethodflags(self, "split", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe352);
// compiled call node returning call353 (depth = 3)
  *var_locations = call353;
  if (call353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe354 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit355 == NULL) {
    strlit355 = alloc_String("./");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 3)
  gc_frame_newslot(strlit355);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_locations (depth = 3)
  params[0] = strlit355;
  partcv[0] = 1;
  Object call356 = callmethod(*var_locations, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe354);
// compiled call node returning call356 (depth = 2)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  partcv[0] = 0;
  Object call358 = callmethod(*var_name, "copy",
    1, partcv, params);
  gc_frame_end(callframe357);
// compiled call node returning call358 (depth = 4)
// compiled member node returning call358 (depth = 3)
  *var_candidate = call358;
  if (call358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  partcv[0] = 0;
  Object call360 = callmethod(*var_name, "dir",
    1, partcv, params);
  gc_frame_end(callframe359);
// compiled call node returning call360 (depth = 4)
// compiled member node returning call360 (depth = 3)
  *var_originalDir = call360;
  if (call360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit363 == NULL) {
    strlit363 = alloc_String("/");
    gc_root(strlit363);
  }
// compiled string node returning strlit363 (depth = 4)
  int op_slot_right_362 = gc_frame_newslot(strlit363);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe365 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_originalDir (depth = 6)
  partcv[0] = 0;
  Object call366 = callmethod(*var_originalDir, "first",
    1, partcv, params);
  gc_frame_end(callframe365);
// compiled call node returning call366 (depth = 5)
// compiled member node returning call366 (depth = 4)
  int op_slot_left_362 = gc_frame_newslot(call366);
  params[0] = strlit363;
  partcv[0] = 1;
  Object opresult367 = callmethod(call366, "==", 1, partcv, params);
// compiled op node returning opresult367 (depth = 3)
  Object if361 = done;
  if (istrue(opresult367)) {
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  partcv[0] = 0;
  Object call370 = callmethod(*var_candidate, "exists",
    1, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 5)
// compiled member node returning call370 (depth = 4)
  Object if368 = done;
  if (istrue(call370)) {
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  return *var_candidate;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if368 = undefined;
  } else {
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe371 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit372 == NULL) {
    strlit372 = alloc_String("");
    gc_root(strlit372);
  }
// compiled string node returning strlit372 (depth = 6)
  gc_frame_newslot(strlit372);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = strlit372;
  partcv[0] = 1;
  Object call373 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe371);
// compiled call node returning call373 (depth = 5)
  return call373;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if368 = undefined;
  }
// compiled if node returning if368 (depth = 3)
    gc_frame_newslot(if368);
    if361 = if368;
  } else {
  }
// compiled if node returning if361 (depth = 2)
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe374 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block375 = alloc_Block(NULL, NULL, "unixFilePath", 159);
  gc_frame_newslot(block375);
// method _apply
  block_savedest(block375);
  Object closure376 = createclosure(3, "_apply");
  setclosureframe(closure376, stackframe);
  addtoclosure(closure376, var_originalDir);
  addtoclosure(closure376, var_candidate);
  addtoclosure(closure376, selfslot);
  struct UserObject *uo376 = (struct UserObject*)block375;
  uo376->data[0] = (Object)closure376;
  Method *meth_meth_unixFilePath__apply376 = addmethod2pos(block375, "_apply", &meth_unixFilePath__apply376, 0);
  int argcv_meth_unixFilePath__apply376[] = {1};
  meth_meth_unixFilePath__apply376->type = alloc_MethodType(1, argcv_meth_unixFilePath__apply376);
  meth_meth_unixFilePath__apply376->definitionModule = modulename;
  meth_meth_unixFilePath__apply376->definitionLine = 153;
// compiled block node returning block375 (depth = 3)
  gc_frame_newslot(block375);
// call case 6: other member request
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_locations (depth = 3)
  params[0] = block375;
  partcv[0] = 1;
  Object call386 = callmethod(*var_locations, "do",
    1, partcv, params);
  gc_frame_end(callframe374);
// compiled call node returning call386 (depth = 2)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_locations (depth = 3)
  gc_frame_newslot(*var_locations);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  params[0] = *var_locations;
  partcv[0] = 1;
  Object call388 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe387);
// compiled call node returning call388 (depth = 2)
  gc_frame_end(frame);
  return call388;
}
Object module_unixFilePath_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(11, 11);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<unixFilePath>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method null
  block_savedest(self);
  Object closure0 = createclosure(2, "null");
  setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_done);
  addtoclosure(closure0, var_io);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_unixFilePath_null0 = addmethod2pos(self, "null", &meth_unixFilePath_null0, 1);
  int argcv_meth_unixFilePath_null0[] = {0};
  meth_meth_unixFilePath_null0->type = alloc_MethodType(1, argcv_meth_unixFilePath_null0);
  meth_meth_unixFilePath_null0->definitionModule = modulename;
  meth_meth_unixFilePath_null0->definitionLine = 3;
  block_savedest(self);
  Object closure153 = createclosure(2, "null()object");
  setclosureframe(closure153, stackframe);
  addtoclosure(closure153, var_done);
  addtoclosure(closure153, var_io);
  Method *meth_meth_unixFilePath_null0_object = addmethod2pos(self, "null()object", &meth_unixFilePath_null0_object, 1);
  meth_meth_unixFilePath_null0_object->definitionModule = modulename;
  meth_meth_unixFilePath_null0_object->definitionLine = 3;
// compiled method node returning  (depth = 1)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method withDirectory
  struct UserObject *uo154 = (struct UserObject*)self;
  uo154->data[2] = emptyclosure;
  Method *meth_meth_unixFilePath_withDirectory154 = addmethod2pos(self, "withDirectory", &meth_unixFilePath_withDirectory154, 2);
  int argcv_meth_unixFilePath_withDirectory154[] = {1};
  meth_meth_unixFilePath_withDirectory154->type = alloc_MethodType(1, argcv_meth_unixFilePath_withDirectory154);
  meth_meth_unixFilePath_withDirectory154->definitionModule = modulename;
  meth_meth_unixFilePath_withDirectory154->definitionLine = 80;
// compiled method node returning  (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method withBase
  struct UserObject *uo159 = (struct UserObject*)self;
  uo159->data[3] = emptyclosure;
  Method *meth_meth_unixFilePath_withBase159 = addmethod2pos(self, "withBase", &meth_unixFilePath_withBase159, 3);
  int argcv_meth_unixFilePath_withBase159[] = {1};
  meth_meth_unixFilePath_withBase159->type = alloc_MethodType(1, argcv_meth_unixFilePath_withBase159);
  meth_meth_unixFilePath_withBase159->definitionModule = modulename;
  meth_meth_unixFilePath_withBase159->definitionLine = 84;
// compiled method node returning  (depth = 1)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method withExtension
  struct UserObject *uo164 = (struct UserObject*)self;
  uo164->data[4] = emptyclosure;
  Method *meth_meth_unixFilePath_withExtension164 = addmethod2pos(self, "withExtension", &meth_unixFilePath_withExtension164, 4);
  int argcv_meth_unixFilePath_withExtension164[] = {1};
  meth_meth_unixFilePath_withExtension164->type = alloc_MethodType(1, argcv_meth_unixFilePath_withExtension164);
  meth_meth_unixFilePath_withExtension164->definitionModule = modulename;
  meth_meth_unixFilePath_withExtension164->definitionLine = 88;
// compiled method node returning  (depth = 1)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method withDirectory()base()extension
  struct UserObject *uo169 = (struct UserObject*)self;
  uo169->data[5] = emptyclosure;
  Method *meth_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169 = addmethod2pos(self, "withDirectory()base()extension", &meth_unixFilePath_withDirectory_40__41_base_40__41_extension169, 5);
  int argcv_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169[] = {1, 1, 1};
  meth_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169->type = alloc_MethodType(3, argcv_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169);
  meth_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169->definitionModule = modulename;
  meth_meth_unixFilePath_withDirectory_40__41_base_40__41_extension169->definitionLine = 92;
// compiled method node returning  (depth = 1)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method fromString
  struct UserObject *uo178 = (struct UserObject*)self;
  uo178->data[6] = emptyclosure;
  Method *meth_meth_unixFilePath_fromString178 = addmethod2pos(self, "fromString", &meth_unixFilePath_fromString178, 6);
  int argcv_meth_unixFilePath_fromString178[] = {1};
  meth_meth_unixFilePath_fromString178->type = alloc_MethodType(1, argcv_meth_unixFilePath_fromString178);
  meth_meth_unixFilePath_fromString178->definitionModule = modulename;
  meth_meth_unixFilePath_fromString178->definitionLine = 97;
// compiled method node returning  (depth = 1)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method split
  struct UserObject *uo276 = (struct UserObject*)self;
  uo276->data[7] = emptyclosure;
  Method *meth_meth_unixFilePath_split276 = addmethod2pos(self, "split", &meth_unixFilePath_split276, 7);
  int argcv_meth_unixFilePath_split276[] = {1};
  meth_meth_unixFilePath_split276->type = alloc_MethodType(1, argcv_meth_unixFilePath_split276);
  meth_meth_unixFilePath_split276->definitionModule = modulename;
  meth_meth_unixFilePath_split276->definitionLine = 127;
// compiled method node returning  (depth = 1)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method file()onPath()otherwise
  struct UserObject *uo351 = (struct UserObject*)self;
  uo351->data[8] = emptyclosure;
  Method *meth_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351 = addmethod2pos(self, "file()onPath()otherwise", &meth_unixFilePath_file_40__41_onPath_40__41_otherwise351, 8);
  int argcv_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351[] = {1, 1, 1};
  meth_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351->type = alloc_MethodType(3, argcv_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351);
  meth_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351->definitionModule = modulename;
  meth_meth_unixFilePath_file_40__41_onPath_40__41_otherwise351->definitionLine = 147;
// compiled method node returning  (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
