#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "lexer";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "import \"util\" as util",
  "import \"unicode\" as unicode",
  "import \"errormessages\" as errormessages",
  "",
  "method padl(s, l, w) {",
  "    if (s.size >= l) then {",
  "        return s",
  "    }",
  "    var s' := s",
  "    while {s'.size < l} do {",
  "        s' := w ++ s'",
  "    }",
  "    return s'",
  "}",
  "",
  "",
  "method new {",
  "    var lineNumber := 1",
  "    var linePosition := 0",
  "    var startPosition := 1",
  "    var indentLevel := 0",
  "    var startLine := 1",
  "    var stringStart",
  "    ",
  "    class Token.new() {",
  "        def line is public = lineNumber",
  "        def indent is public = indentLevel",
  "        def linePos is public = startPosition",
  "",
  "        var next is public := false",
  "        var prev is public := false",
  "",
  "        method ==(other) {",
  "            if (other == false) then {",
  "                false",
  "            } else {",
  "                (other.line == line) && (other.linePos == linePos)",
  "            }",
  "        }",
  "        method asString { \"({line}:{linePos}){self.kind} {self.value}\" }",
  "    }",
  "",
  "",
  "    class IdentifierToken.new(s) {",
  "        inherits Token.new",
  "        def kind is public = \"identifier\"",
  "        def value is public = s",
  "        def size is public = s.size",
  "    }",
  "    class StringToken.new(s) {",
  "        inherits Token.new",
  "        def kind is public = \"string\"",
  "        def value is public = s",
  "        def size is public = linePosition - stringStart + 1",
  "    }",
  "    class MultiLineStringToken.new(s) {",
  "        inherits Token.new",
  "        def kind is public = \"string\"",
  "        def value is public = s",
  "        def size is public = s.size + 2",
  "        def line' = startLine",
  "        def linePos' = stringStart",
  "        method line is override { line' }",
  "        method linePos is override { linePos' }",
  "    }",
  "    class CommentToken.new(s) {",
  "        inherits Token.new",
  "        def kind is public = \"comment\"",
  "        def value is public = s",
  "        def size is public = s.size + 2",
  "    }",
  "    class LBraceToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"lbrace\"",
  "        def value is public = \"\\{\"",
  "        def size is public = 1",
  "    }",
  "    class RBraceToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"rbrace\"",
  "        def value is public = \"}\"",
  "        def size is public = 1",
  "    }",
  "    class LParenToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"lparen\"",
  "        def value is public = \"(\"",
  "        def size is public = 1",
  "    }",
  "    class RParenToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"rparen\"",
  "        def value is public = \")\"",
  "        def size is public = 1",
  "    }",
  "    class LSquareToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"lsquare\"",
  "        def value is public = \"[\"",
  "        def size is public = 1",
  "    }",
  "    class RSquareToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"rsquare\"",
  "        def value is public = \"]\"",
  "        def size is public = 1",
  "    }",
  "    class CommaToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"comma\"",
  "        def value is public = \",\"",
  "        def size is public = 1",
  "    }",
  "    class ColonToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"colon\"",
  "        def value is public = \":\"",
  "        def size is public = 1",
  "    }",
  "    class DotToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"dot\"",
  "        def value is public = \".\"",
  "        def size is public = 1",
  "    }",
  "    class NumToken.new(v, b) {",
  "        inherits Token.new",
  "        def kind is public = \"num\"",
  "        def value is public = v",
  "        def base is public = b",
  "        def size is public = linePosition - startPosition",
  "    }",
  "    class KeywordToken.new(v) {",
  "        inherits Token.new",
  "        def kind is public = \"keyword\"",
  "        def value is public = v",
  "        def size is public = v.size",
  "    }",
  "    class OpToken.new(v) {",
  "        inherits Token.new",
  "        def kind is public = \"op\"",
  "        def value is public = v",
  "        def size is public = v.size",
  "    }",
  "    class ArrowToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"arrow\"",
  "        def value is public = \"->\"",
  "        def size is public = 2",
  "    }",
  "    class BindToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"bind\"",
  "        def value is public = \":=\"",
  "        def size is public = 2",
  "    }",
  "    class SemicolonToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"semicolon\"",
  "        def value is public = \";\"",
  "        def size is public = 1",
  "    }",
  "    class LGenericToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"lgeneric\"",
  "        def value is public = \"<\"",
  "        def size is public = 1",
  "    }",
  "    class RGenericToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"rgeneric\"",
  "        def value is public = \">\"",
  "        def size is public = 1",
  "    }",
  "    class eofToken.new {",
  "        inherits Token.new",
  "        def kind is public = \"eof\"",
  "        def value is public = \"\"",
  "        def size is public = 0",
  "    }",
  "",
  "",
  "    object {",
  "        // When a new lexical class has begun, add to the tokens list",
  "        // the token corresponding to the previous accumulated data.",
  "        // mode is the previous lexical mode (a string), and accum the",
  "        // accumulated characters since that mode began. Modes are:",
  "",
  "        //   n           Whitespace       i   Identifier",
  "        //   \"           Quoted string    q   extended string",
  "        //   m           Number           o   Any operator",
  "        //   p           Pragma           d   Indentation",
  "        //   c           Comment",
  "        //   ,.{}()[]<>; The corresponding literal character",
  "        //",
  "        // There are three special cases for mode o. If accum is \"->\",",
  "        // \":=\", or \"=\", the corresponding special token is created.",
  "        // For mode i, a keyword token is created for an identifier",
  "        // whose name is a reserved keyword.",
  "        method modechange(tokens, mode, accum) {",
  "            var isDone := false",
  "            var tok := 0",
  "            if ((mode != \"n\") || (accum.size > 0)) then {",
  "                if (mode == \"i\") then {",
  "                    tok := IdentifierToken.new(accum)",
  "                    if ((accum == \"object\") || (accum == \"method\")",
  "                        || (accum == \"var\") || (accum == \"type\")",
  "                        || (accum == \"import\") || (accum == \"class\")",
  "                        || (accum == \"return\") || (accum == \"def\")",
  "                        || (accum == \"inherits\") || (accum == \"is\")",
  "                        || (accum == \"dialect\") || (accum == \"factory\")) then {",
  "                        tok := KeywordToken.new(accum)",
  "                    }",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                }",
  "                if (mode == \"I\") then {",
  "                    tok := IdentifierToken.new(accum)",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"\\\"\") then {",
  "                    tok := StringToken.new(accum)",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"q\") then {",
  "                    tok := MultiLineStringToken.new(accum)",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"x\") then {",
  "                    ProgrammingError.raise \"obsolete Octet-token mode in lexer\\n\"",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \",\") then {",
  "                    tok := CommaToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \".\") then {",
  "                    tok := DotToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"\\{\") then {",
  "                    tok := LBraceToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"}\") then {",
  "                    tok := RBraceToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"(\") then {",
  "                    tok := LParenToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \")\") then {",
  "                    tok := RParenToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"[\") then {",
  "                    tok := LSquareToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                }",
  "                if (mode == \"]\") then {",
  "                    tok := RSquareToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"<\") then {",
  "                    tok := LGenericToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \">\") then {",
  "                    tok := RGenericToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \";\") then {",
  "                    tok := SemicolonToken.new",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"m\") then {",
  "                    if ((tokens.size > 1).andAlso {tokens.last.kind == \"dot\"}) then {",
  "                        def dot = tokens.pop",
  "                        if (tokens.last.kind == \"num\") then {",
  "                            if (tokens.last.base == 10) then {",
  "                                tok := tokens.pop",
  "                                var decimal := makeNumToken(accum)",
  "                                if(decimal.base == 10) then {",
  "                                    tok := NumToken.new(tok.value ++ \".\" ++ accum, 10)",
  "                                } else {",
  "                                    def suggestions = []",
  "                                    var suggestion := errormessages.suggestion.new",
  "                                    suggestion.replaceRange(dot.linePos + 1, linePosition - 1)with(decimal.value)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.deleteRange(dot.linePos, linePosition - 1)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"The fractional part of a number must be in base 10.\")atRange(",
  "                                        lineNumber, dot.linePos + 1, linePosition - 1)withSuggestions(suggestions)",
  "                                }",
  "                            } else {",
  "                                def suggestions = []",
  "                                var suggestion := errormessages.suggestion.new",
  "                                suggestion.replaceRange(tokens.last.linePos, dot.linePos - 1)with(tokens.last.value)onLine(lineNumber)",
  "                                suggestions.push(suggestion)",
  "                                suggestion := errormessages.suggestion.new",
  "                                suggestion.deleteChar(dot.linePos)onLine(lineNumber)",
  "                                suggestions.push(suggestion)",
  "                                errormessages.syntaxError(\"A number in base {tokens.last.base} cannot have a fractional part.\")atRange(",
  "                                    lineNumber, dot.linePos, linePosition - 1)withSuggestions(suggestions)",
  "                            }",
  "                        } else {",
  "                            if(tokens.last.kind == \"string\") then {",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.replaceChar(dot.linePos)with(\"++\")onLine(dot.line)",
  "                                errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'. \"",
  "                                    ++ \"To join a number to a string, use '++'.\")atRange(",
  "                                    dot.line, dot.linePos, dot.linePos)withSuggestion(suggestion)",
  "                            } elseif((tokens.last.kind == \"op\") || (tokens.last.kind == \"bind\")) then {",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.insert(\"0\")atPosition(dot.linePos)onLine(dot.line)",
  "                                errormessages.syntaxError(\"A number must have a digit before the decimal point.\")atPosition(",
  "                                    dot.line, dot.linePos)withSuggestion(suggestion)",
  "                            } elseif(tokens.last.kind == \"identifier\") then {",
  "                                def suggestions = []",
  "                                if(tokens.last.value == \"o\") then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceChar(tokens.last.linePos)with(\"0\")onLine(tokens.last.line)",
  "                                    suggestions.push(suggestion)",
  "                                }",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.replaceRange(dot.linePos, linePosition - 1)with(\"({accum})\")onLine(tokens.last.line)",
  "                                suggestions.push(suggestion)",
  "                                errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                    dot.line, dot.linePos, dot.linePos)withSuggestions(suggestions)",
  "                            } else {",
  "                                errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                    dot.line, dot.linePos, dot.linePos)",
  "                            }",
  "                        }",
  "                    } else {",
  "                        tok := makeNumToken(accum)",
  "                    }",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"o\") then {",
  "                    tok := OpToken.new(accum)",
  "                    if (accum == \"->\") then {",
  "                        tok := ArrowToken.new",
  "                    } elseif (accum == \":=\") then {",
  "                        tok := BindToken.new",
  "                    } elseif (accum == \":\") then {",
  "                        tok := ColonToken.new",
  "                    }",
  "                    tokens.push(tok)",
  "                    isDone := true",
  "                } elseif (mode == \"d\") then {",
  "                    indentLevel := linePosition - 1",
  "                    isDone := true",
  "                } elseif (mode == \"n\") then {",
  "                    isDone := true",
  "                } elseif (mode == \"c\") then {",
  "                    var firstNonSpace := 3      // skip the leading \"//\"",
  "                    def accumSize = accum.size",
  "                    while { (firstNonSpace <= accum.size).andAlso {",
  "                            accum.at(firstNonSpace) == \" \" } } do {",
  "                        firstNonSpace := firstNonSpace + 1 ",
  "                    }",
  "                    def cmt = accum.substringFrom(firstNonSpace)to(accum.size)",
  "                    tokens.push(CommentToken.new(cmt))",
  "                    isDone := true",
  "                } elseif (mode == \"p\") then {",
  "                    if (accum.substringFrom(1)to(8) == \"#pragma \") then {",
  "                        util.processExtension(",
  "                            accum.substringFrom(9)to(accum.size))",
  "                    }",
  "                } elseif (isDone) then {",
  "                    //print(mode, accum, tokens)",
  "                } else {",
  "                    errormessages.syntaxError \"Lexing error: no handler for mode {mode} with accum ‹{accum}›\"",
  "                        atPosition(lineNumber, linePosition)",
  "                }",
  "            }",
  "            startPosition := linePosition",
  "        }",
  "",
  "        method fromBase(str, base) {",
  "            var val := 0",
  "            var i := 0",
  "            for (str) do {c->",
  "                def n = c.ord",
  "                val := val * base",
  "                var inc := 0",
  "                if ((n >= 48) && (n <= 57)) then {",
  "                    inc := n - 48 // 0",
  "                } elseif((n >= 65) && (n <= 90)) then {",
  "                    inc := n - 55 // 'A' - 10",
  "                } else {",
  "                    inc := n - 87 // 'a' - 10",
  "                }",
  "                if (inc >= base) then {",
  "                    if((str[1] == \"0\") && (inc < 16)) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        suggestion.insert(\"x\")atPosition(linePosition - str.size + 1)onLine(lineNumber)",
  "                        errormessages.syntaxError(\"A number in base 16 must start with '0x'.\")atPosition(",
  "                            lineNumber, linePosition - str.size + 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        if(str.size == 1) then {",
  "                            suggestion.deleteRange(linePosition - str.size - 1, linePosition - 1)onLine(lineNumber)",
  "                        } else {",
  "                            suggestion.deleteChar(linePosition - str.size + i)onLine(lineNumber)",
  "                        }",
  "                        def validDigits = if(base <= 10) then {",
  "                            \"'0' to '{base - 1}'\"",
  "                        } else {",
  "                            \"'0' to '9', 'a' to '{unicode.create(87 + base)}'\"",
  "                        }",
  "                        errormessages.syntaxError(\"'{c}' is not a valid digit in base {base}. Valid digits are {validDigits}.\")atRange(",
  "                            lineNumber, linePosition - str.size + i, linePosition - str.size + i)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                val := val + inc",
  "                i := i + 1",
  "            }",
  "            val",
  "        }",
  "                ",
  "        method hexdecchar(c) {",
  "        // Return the numeric value of the single hexadecimal digit c.",
  "            def AOrd = \"A\".ord",
  "            def aOrd = \"a\".ord",
  "            def zeroOrd = \"0\".ord",
  "            def cOrd = c.ord",
  "            if ( (cOrd >= AOrd) && (cOrd <= \"F\".ord) ) then {",
  "                cOrd - AOrd + 10",
  "            } elseif { (cOrd >= aOrd) && (cOrd <= \"f\".ord) } then {",
  "                cOrd - aOrd + 10",
  "            } elseif { (cOrd >= zeroOrd) && (cOrd <= \"9\".ord) } then {",
  "                cOrd - zeroOrd",
  "            } else {",
  "                errormessages.syntaxError(\"The character '{c}' must be a hexadecimal digit\")",
  "                    atRange(lineNumber, linePosition, linePosition)",
  "            }",
  "        }",
  "",
  "        method makeNumToken(accum) {",
  "            var base := 10",
  "            var baseSet := false",
  "            var sofar := \"\"",
  "            var i := 0",
  "            for (accum) do {c->",
  "                if ((c == \"x\") && (!baseSet)) then {",
  "                    base := sofar.asNumber",
  "                    baseSet := true",
  "                    if (base == 0) then {",
  "                        base := 16",
  "                    }",
  "                    if((base < 2) || (base > 36)) then {",
  "                        def suggestions = []",
  "                        var suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceChar(linePosition - accum.size + i)with(\"*\")onLine(lineNumber)",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteRange(linePosition - accum.size, linePosition - accum.size + i)onLine(lineNumber)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"Base {base} is not a valid numerical base.\")atRange(",
  "                            lineNumber, linePosition - accum.size, linePosition - accum.size + i - 1)withSuggestions(suggestions)",
  "                    }",
  "                    sofar := \"\"",
  "                } else {",
  "                    sofar := sofar ++ c",
  "                }",
  "                i := i + 1",
  "            }",
  "            if(sofar == \"\") then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteRange(linePosition - accum.size + i - 1, linePosition - 1)onLine(lineNumber)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\"0\")atPosition(linePosition)onLine(lineNumber)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"At least one digit must follow the 'x' in a number.\")atPosition(",
  "                    lineNumber, linePosition - accum.size + i)withSuggestions(suggestions)",
  "            }",
  "            NumToken.new(fromBase(sofar, base).asString, base)",
  "        }",
  "        // True if ov is a valid identifier character. Identifier",
  "        // characters are Unicode letters, Unicode numbers, apostrophe,",
  "        // and (currently) underscore.",
  "        method isidentifierchar(ov) {",
  "            if (unicode.isLetter(ov)) then {",
  "                return true",
  "            }",
  "            if (unicode.isNumber(ov)) then {",
  "                return true",
  "            }",
  "            if ((ov == 95) || (ov == 39)) then {",
  "                // 95 is _, 39 is '",
  "                true",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "",
  "        // True if c (with codepoint ordval) is a valid operator character.",
  "        method isoperatorchar(c, ordval) {",
  "            if ((c == \"-\") || (c == \"&\") || (c == \"|\") || (c == \":\")",
  "                || (c == \"%\") || (c == \"^\") || (c == \"@\") || (c == \"?\")",
  "                || (c == \"*\") || (c == \"/\") || (c == \"+\") || (c == \"!\")",
  "                ) then {",
  "                return true",
  "            }",
  "            if (unicode.isSymbolMathematical(ordval)) then {",
  "                return true",
  "            } elseif (unicode.iscategory(c, \"So\")) then {",
  "                return true",
  "            }",
  "            return false",
  "        }",
  "",
  "        // Read the program text from util.infile and return a list of",
  "        // tokens.",
  "        method lexfile(file) {",
  "            def lines = []",
  "            def cLines = []",
  "            var line := \"\"",
  "            var cLine := \"\"",
  "            var wasCR := false",
  "            for(file.read) do { c ->",
  "                if (c == \"\\r\") then {",
  "                    lines.push(line)",
  "                    cLines.push(cLine)",
  "                    line := \"\"",
  "                    cLine := \"\"",
  "                    wasCR := true",
  "                } elseif {c  == \"\\n\"} then {",
  "                    if (wasCR) then {",
  "                        // the spec says \"LINE FEED that immediately",
  "                        // follows a CARRIAGE RETURN is ignored\"",
  "                    } else {",
  "                        lines.push(line)",
  "                        cLines.push(cLine)",
  "                        line := \"\"",
  "                        cLine := \"\"",
  "                    }",
  "                    wasCR := false",
  "                } elseif {c == \"\\l\"} then {",
  "                    lines.push(line)",
  "                    cLines.push(cLine)",
  "                    line := \"\"",
  "                    cLine := \"\"",
  "                    wasCR := false",
  "                } elseif {c == \"\\\\\"} then {",
  "                    line := line ++ \"\\\\\"",
  "                    cLine := cLine ++ \"\\\\\\\\\"",
  "                    wasCR := false",
  "                } elseif {c == \"\\\"\"} then {",
  "                    line := line ++ \"\\\"\"",
  "                    cLine := cLine ++ \"\\\\\\\"\"",
  "                    wasCR := false",
  "                } else {",
  "                    line := line ++ c",
  "                    cLine := cLine ++ c",
  "                    wasCR := false",
  "                }",
  "            }",
  "            if (line != \"\") then {",
  "                // this deals with an un-terminated final line",
  "                lines.push(line)",
  "                cLines.push(cLine)",
  "            }",
  "            util.lines := lines",
  "            util.cLines := cLines",
  "            lexinput(lines)",
  "        }",
  "",
  "        method lexinput(inputLines) {",
  "            // tokens is a doubly-linked list of tokens.",
  "            var tokens := object {",
  "                var first is readable := false",
  "                var last is readable := false",
  "                var size' := 0",
  "",
  "                method push(t) {",
  "                    if(first == false) then {",
  "                        first := t",
  "                        last := t",
  "                    } else {",
  "                        last.next := t",
  "                        t.prev := last",
  "                        last := t",
  "                    }",
  "                    size' := size' + 1",
  "                }",
  "",
  "                method pop {",
  "                    if(last != false) then {",
  "                        def popped = last",
  "                        last := last.prev",
  "                        if(last == false) then {",
  "                            first := false",
  "                        }",
  "                        size' := size' - 1",
  "                        popped",
  "                    }",
  "                }",
  "",
  "                method poll {",
  "                    if(first != false) then {",
  "                        def polled = first",
  "                        first := first.next",
  "                        if(first == false) then {",
  "                            last := false",
  "                        }",
  "                        size' := size' - 1",
  "                        polled",
  "                    }",
  "                }",
  "",
  "                method size {",
  "                    size' + 0",
  "                }",
  "",
  "                method iter {",
  "                    object {",
  "                        var n := first",
  "                        method havemore {",
  "                            n != false",
  "                        }",
  "                        method hasNext {",
  "                            n != false",
  "                        }",
  "                        method next {",
  "                            def ret = n",
  "                            n := n.next",
  "                            ret",
  "                        }",
  "                    }",
  "                }",
  "",
  "                method iterator {",
  "                    iter",
  "                }",
  "            }",
  "",
  "            var mode := \"d\"",
  "            var newmode := mode",
  "            var inStr := false",
  "            var inBackticks := false",
  "            var backtickIdent := false",
  "            var accum := \"\"",
  "            var escaped := false",
  "            var unichars := 0",
  "            var codepoint := 0",
  "            var interpdepth := 0",
  "            var interpString := false",
  "            var atStart := true",
  "            var newlineFound := false",
  "            linePosition := 0",
  "            util.log_verbose \"lexing.\"",
  "            def badSeparator = unicode.pattern(\"Z\", 9)not(32, 160)",
  "                // 32 is SPACE, and 160 NO-BREAK SPACE",
  "            def badControl =  unicode.pattern(\"C\")not(10, 13)",
  "            def selfModes = unicode.pattern(\"(\".ord, \")\".ord, \",\".ord,",
  "                \".\".ord, \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord, \";\".ord)",
  "            def brackets = unicode.pattern(\"(\".ord, \")\".ord,",
  "                \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord)",
  "            def identifierChar = unicode.pattern(\"L\", \"N\", 95, 39) // 95 = _, 39 = '",
  "            def digit = unicode.pattern(\"0\".ord, \"1\".ord, \"2\".ord, \"3\".ord,",
  "                \"4\".ord, \"5\".ord, \"6\".ord, \"7\".ord, \"8\".ord, \"9\".ord)",
  "            def operatorChar = unicode.pattern(\"Sm\", \"So\",",
  "                \"-\".ord, \"&\".ord, \"|\".ord, \":\".ord,",
  "               \"%\".ord, \"^\".ord, \"@\".ord, \"?\".ord,",
  "               \"*\".ord, \"/\".ord, \"+\".ord, \"!\".ord",
  "                )",
  "            def iGTLT = unicode.pattern(\"i\".ord, \"<\".ord, \">\".ord)",
  "            def mainBlock = { c->",
  "                var ct := \"\"",
  "                var ordval := c.ord // String.ord gives the codepoint",
  "                if (badSeparator.match(ordval).andAlso { mode != \"q\" }) then {",
  "                    // Character is whitespace, but not an ASCII space or",
  "                    // Unicode NO-BREAK SPACE.  For example, a tab",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.replaceChar(linePosition)with(\" \")onLine(lineNumber)",
  "                    if (ordval == 9) then {",
  "                        if (inStr) then {",
  "                            suggestion.replaceRange(linePosition, linePosition)",
  "                                with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                onLine(lineNumber)",
  "                            errormessages.syntaxError(\"tabs cannot be \"",
  "                                ++ \"written in the source code; \"",
  "                                ++ \"use the Unicode escape \\\\u\"",
  "                                ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                ++ \" instead\")",
  "                                atRange(lineNumber, linePosition, linePosition)",
  "                                withSuggestion(suggestion)",
  "                        }",
  "                        errormessages.syntaxError(\"Tabs are not allowed; use spaces instead.\")atRange(lineNumber,",
  "                            linePosition, linePosition)withSuggestion(suggestion)",
  "                    } else {",
  "                        if (mode == \"\\\"\") then {",
  "                            suggestion.replaceRange(linePosition, linePosition)",
  "                                with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                onLine(lineNumber)",
  "                            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                ++ \"is not a valid whitespace character\"",
  "                                ++ \" and cannot be \"",
  "                                ++ \"written in the source code; \"",
  "                                ++ \"use the Unicode escape \\\\u\"",
  "                                ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                ++ \" instead\")",
  "                                atRange(lineNumber, linePosition, linePosition)",
  "                                withSuggestion(suggestion)",
  "                        }",
  "                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                            ++ \"is not a valid whitespace character; use spaces instead.\")atRange(lineNumber,",
  "                            linePosition, linePosition)withSuggestion(suggestion)",
  "                    }",
  "                } elseif {badControl.match(ordval).andAlso { mode != \"q\" }} then {",
  "                    // Character is a control character other than",
  "                    // carriage return or line feed.",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if (inStr) then {",
  "                        suggestion.replaceRange(linePosition, linePosition)",
  "                            with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                            onLine(lineNumber)",
  "                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                            ++ \"is a control character and cannot be \"",
  "                            ++ \"written in the source code; \"",
  "                            ++ \"use the Unicode escape \\\\u\"",
  "                            ++ padl(ordval.inBase 16, 4, \"0\")",
  "                            ++ \" instead\")",
  "                            atRange(lineNumber, linePosition, linePosition)",
  "                            withSuggestion(suggestion)",
  "                    }",
  "                    suggestion.deleteChar(linePosition)onLine(lineNumber)",
  "                    errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                        ++ \"is a control character and cannot be written in the source code; consider using spaces instead.\")atRange(lineNumber,",
  "                        linePosition, linePosition)withSuggestion(suggestion)",
  "                }",
  "                if (atStart) then {",
  "                    if (linePosition == 1) then {",
  "                        if (c == \"#\") then {",
  "                            mode := \"p\"",
  "                            newmode := mode",
  "                        } else {",
  "                            atStart := false",
  "                        }",
  "                    }",
  "                }",
  "                if (inStr) then {",
  "",
  "                } elseif ( (mode != \"c\") && (mode != \"p\") ) then {",
  "                    // Not in a comment or pragma, so look for a mode.",
  "                    if ((c == \" \") && (mode != \"d\")) then {",
  "                        newmode := \"n\"",
  "                    }",
  "                    if (c == \"\\\"\") then {",
  "                        // Beginning of a string",
  "                        newmode := \"\\\"\"",
  "                        inStr := true",
  "                        stringStart := linePosition",
  "                    } elseif { c == \"‹\" } then {",
  "                        // Beginning of a multi-line string",
  "                        newmode := \"q\"",
  "                        inStr := true",
  "                        startLine := lineNumber",
  "                        stringStart := linePosition",
  "                    } elseif { identifierChar.match(ordval) } then {",
  "                        newmode := \"i\"",
  "                    }",
  "                    if (digit.match(ordval)) then {",
  "                        // This may overwrite newmode := \"i\"",
  "                        // established 5 lines up",
  "                        if (mode != \"i\") then {",
  "                            newmode := \"m\"",
  "                        }",
  "                    }",
  "                    if (mode == \"m\") then {",
  "                        if ((ordval >= 97) && (ordval <=122)) then {",
  "                            newmode := \"m\"",
  "                        } else {",
  "                            if ((ordval >= 65) && (ordval <= 90)) then {",
  "                                newmode := \"m\"",
  "                            }",
  "                        }",
  "                    }",
  "                    if ((mode == \"i\") && (c == \"<\")) then {",
  "                        newmode := \"<\"",
  "                    } elseif (iGTLT.match(mode)",
  "                        && (c == \">\")) then {",
  "                        if (mode == \">\") then {",
  "                            modechange(tokens, mode, accum)",
  "                        }",
  "                        newmode := \">\"",
  "                    } elseif (operatorChar.match(ordval)) then {",
  "                        newmode := \"o\"",
  "                    }",
  "                    if (selfModes.match(ordval)) then {",
  "                        newmode := c",
  "                    }",
  "                    if (c == \"#\") then {",
  "                        if (mode != \"p\") then {",
  "                            if(util.lines.at(lineNumber).substringFrom(1)to(7) == \"#pragma\") then {",
  "                                if(tokens.size == 0) then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.addLine(1, util.lines.at(lineNumber))",
  "                                    suggestion.addLine(lineNumber, \"\")",
  "                                    errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                        lineNumber)withSuggestion(suggestion)",
  "                                } else {",
  "                                    errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                        lineNumber)",
  "                                }",
  "                            } else {",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.replaceChar(linePosition)with(\"//\")onLine(lineNumber)",
  "                                errormessages.syntaxError(\"'#' is not allowed here. For a comment use '//'.\")atRange(",
  "                                    lineNumber, linePosition, linePosition)withSuggestion(suggestion)",
  "                            }",
  "                        }",
  "                    }",
  "                    if (c == \".\") then {",
  "                        if (accum == \".\") then {",
  "                            // Special handler for .. operator",
  "                            mode := \"o\"",
  "                            newmode := mode",
  "                        }",
  "                        if (accum == \"..\") then {",
  "                            // Special handler for ... identifier",
  "                            mode := \"n\"",
  "                            newmode := mode",
  "                            modechange(tokens, \"i\", \"...\")",
  "                            accum := \"\"",
  "                        }",
  "                    }",
  "                    if (c == \"/\") then {",
  "                        if (accum == \"/\") then {",
  "                            // Start of comment",
  "                            mode := \"c\"",
  "                            newmode := mode",
  "                        }",
  "                    }",
  "                    if (mode == \"n\") then {",
  "                        if (mode == newmode) then {",
  "                            if (unicode.isSeparator(ordval).not) then {",
  "                                if (unicode.isControl(ordval).not) then {",
  "                                    if (ordval != 10) then {",
  "                                        if (ordval != 13) then {",
  "                                            if (ordval != 32) then {",
  "                                                if (c != \".\") then{",
  "                                                    errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                                        ++ \"is not a valid character; use spaces instead.\")atRange(",
  "                                                        lineNumber, linePosition, linePosition)",
  "                                                }",
  "                                            }",
  "                                        }",
  "                                    }",
  "                                }",
  "                            }",
  "                        }",
  "                    }",
  "                }",
  "                if (mode == \"\\\"\") then {",
  "                    if (c == \"\\\"\") then {",
  "                        if (escaped.not) then {",
  "                            // End of string literal",
  "                            newmode := \"n\"",
  "                            inStr := false",
  "                            if (interpString) then {",
  "                                modechange(tokens, mode, accum)",
  "                                modechange(tokens, \")\", \")\")",
  "                                mode := newmode",
  "                                interpString := false",
  "                            }",
  "                        }",
  "                    }",
  "                } elseif {mode == \"q\"} then {",
  "                    if (c == \"›\") then {",
  "                        //end of literal",
  "                        newmode := \"n\"",
  "                        inStr := false",
  "                    }",
  "                }",
  "                if (newmode != mode) then {",
  "                    // This character is the beginning of a different",
  "                    // lexical mode - process the old one now.",
  "                    modechange(tokens, mode, accum)",
  "                    if (interpdepth > 0) then {",
  "                        if (newmode == \"}\") then {",
  "                            // Find the position of the opening brace to ",
  "                            // check if the interpolation is empty.",
  "                            if (tokens.last.kind == \"lbrace\") then {",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.deleteRange(linePosition - 1, linePosition)onLine(lineNumber)",
  "                                errormessages.syntaxError(\"A string interpolation cannot be empty.\")atRange(",
  "                                    lineNumber, tokens.last.linePos, linePosition)withSuggestion(suggestion)",
  "                            }",
  "                            modechange(tokens, \")\", \")\")",
  "                            modechange(tokens, \"o\", \"++\")",
  "                            newmode := \"\\\"\"",
  "                            inStr := true",
  "                            interpdepth := interpdepth - 1",
  "                        }",
  "                    }",
  "                    mode := newmode",
  "                    if (inStr) then {",
  "                        // String accum should skip the opening quote, but",
  "                        // other modes' should include their first",
  "                        // character.",
  "                        accum := \"\"",
  "                    } else {",
  "                        accum := c",
  "                    }",
  "                    if (brackets.match(mode)) then {",
  "                        modechange(tokens, mode, accum)",
  "                        mode := \"n\"",
  "                        newmode := \"n\"",
  "                        accum := \"\"",
  "                    }",
  "                } elseif (mode == \"\\\"\") then {",
  "                    if (c == \"\\n\") then {",
  "                        if (interpdepth > 0) then {",
  "                            // Find closest {.",
  "                            var line := lineNumber",
  "                            var i := util.lines.at(line).size",
  "                            while { util.lines.at(line)[i] != \"\\{\" } do {",
  "                                i := i - 1",
  "                                if(i == 0) then {",
  "                                    lineNumber := line - 1",
  "                                    i := util.lines.at(line).size",
  "                                }",
  "                            }",
  "                            def suggestions = []",
  "                            var suggestion := errormessages.suggestion.new",
  "                            suggestion.insert(\"\\\\\")atPosition(i)onLine(line)",
  "                            suggestions.push(suggestion)",
  "                            if((line == lineNumber) && (i == (linePosition - 2))) then {",
  "                                errormessages.syntaxError(\"For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                    line, i)withSuggestions(suggestions)",
  "                            } else {",
  "                                suggestion := errormessages.suggestion.new",
  "                                suggestion.insert(\"}\")atPosition(linePosition - accum.size - 1)onLine(lineNumber)",
  "                                suggestions.push(suggestion)",
  "                                errormessages.syntaxError(\"A string interpolation must end with a '}'. For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                    lineNumber, linePosition - accum.size - 1)withSuggestions(suggestions)",
  "                            }",
  "                        } else {",
  "                            def errorLine = util.lines.at(lineNumber)",
  "                            def nextLine = if(util.lines.size >= (lineNumber + 1)) then {",
  "                                util.lines.at(lineNumber + 1)",
  "                            } else {",
  "                                \"\"",
  "                            }",
  "                            // Count the number of literal quotes in the next line.",
  "                            var i := 1",
  "                            var count := 0",
  "                            while { i <= nextLine.size } do {",
  "                                if(nextLine[i] == \"\\\"\") then { count := count + 1 }",
  "                                elseif(nextLine[i] == \"\\\\\") then { i := i + 1 }",
  "                                i := i + 1",
  "                            }",
  "                            if ((count % 2) == 1) then {",
  "                                def suggestions = []",
  "                                var suggestion := errormessages.suggestion.new",
  "                                suggestion.addLine(lineNumber, errorLine ++ nextLine)",
  "                                suggestion.addLine(lineNumber + 1, \"\")",
  "                                suggestions.push(suggestion)",
  "                                suggestion := errormessages.suggestion.new",
  "                                suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                suggestion.addLine(lineNumber + 1, \"    ++ \\\"\" ++ nextLine)",
  "                                suggestions.push(suggestion)",
  "                                suggestion := errormessages.suggestion.new",
  "                                suggestion.addLine(lineNumber, errorLine ++ \"\\\\n\" ++ nextLine)",
  "                                suggestion.addLine(lineNumber + 1, \"\")",
  "                                suggestions.push(suggestion)",
  "                                errormessages.syntaxError(\"A string must end with a '\\\"'. To insert a newline in a string use '\\\\n'. \"",
  "                                    ++ \"To split a string over multiple lines use '++' to join strings together.\")atRange(",
  "                                    lineNumber, linePosition, linePosition)withSuggestions(suggestions)",
  "                            } else {",
  "                                def suggestion = errormessages.suggestion.new",
  "                                suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                                    lineNumber, linePosition)withSuggestion(suggestion)",
  "                            }",
  "                        }",
  "                    }",
  "                    if (escaped) then {",
  "                        if (c == \"n\") then {",
  "                            // Newline escape",
  "                            accum := accum ++ \"\\u000a\"",
  "                        } elseif (c == \"u\") then {",
  "                            // Beginning of a four-digit Unicode escape",
  "                            // (for a BMP codepoint).",
  "                            unichars := 4",
  "                            codepoint := 0",
  "                        } elseif (c == \"U\") then {",
  "                            // Beginning of a six-digit Unicode escape",
  "                            // (for a general codepoint).",
  "                            unichars := 6",
  "                            codepoint := 0",
  "                        } elseif (c == \"t\") then {",
  "                            // Tab escape",
  "                            accum := accum ++ \"\\u0009\"",
  "                        } elseif (c == \"r\") then {",
  "                            // Carriage return escape",
  "                            accum := accum ++ \"\\u000d\"",
  "                        } elseif (c == \"b\") then {",
  "                            // Backspace escape",
  "                            accum := accum ++ \"\\u0008\"",
  "                        } elseif (c == \"l\") then {",
  "                            // LINE SEPARATOR escape",
  "                            accum := accum ++ \"\\u2028\"",
  "                        } elseif (c == \"f\") then {",
  "                            // Form feed/page down escape",
  "                            accum := accum ++ \"\\u000c\"",
  "                        } elseif (c == \"e\") then {",
  "                            // Escape escape",
  "                            accum := accum ++ \"\\u001b\"",
  "                        } elseif (c == \"_\") then {",
  "                            // non-breaking space",
  "                            accum := accum ++ \"\\u00a0\"",
  "                        } else {",
  "                            // For any other character preceded by \\,",
  "                            // insert it literally.",
  "                            accum := accum ++ c",
  "                        }",
  "                        escaped := false",
  "                    } elseif (c == \"\\\\\") then {",
  "                        // Begin an escape sequence",
  "                        escaped := true",
  "                    } elseif (unichars > 0) then {",
  "                        // There are still hex digits to read for a",
  "                        // Unicode escape. Use the current character",
  "                        // as a hex digit and update the codepoint",
  "                        // being calculated with its value.",
  "                        unichars := unichars - 1",
  "                        codepoint := codepoint * 16",
  "                        codepoint := codepoint + hexdecchar(c)",
  "                        if (unichars == 0) then {",
  "                            // At the end of the sequence construct",
  "                            // the character in the unicode library.",
  "                            accum := accum ++ unicode.create(codepoint)",
  "                        }",
  "                    } elseif (c == \"\\{\") then {",
  "                        if (interpString.not) then {",
  "                            modechange(tokens, \"(\", \"(\")",
  "                            interpString := true",
  "                        }",
  "                        modechange(tokens, mode, accum)",
  "                        modechange(tokens, \"o\", \"++\")",
  "                        modechange(tokens, \"(\", \"(\")",
  "                        mode := \"n\"",
  "                        newmode := \"n\"",
  "                        accum := \"\"",
  "                        inStr:= false",
  "                        interpdepth := interpdepth + 1",
  "                    } else {",
  "                        accum := accum ++ c",
  "                    }",
  "                } elseif (c == \"\\n\") then {",
  "                    newlineFound := true",
  "                    if (mode == \"q\") then {",
  "                        accum := accum ++ c",
  "                    } else {",
  "                        // Linebreaks terminate any open tokens",
  "                        modechange(tokens, mode, accum)",
  "                        mode := \"d\"",
  "                        newmode := \"d\"",
  "                        accum := \"\"",
  "                    }",
  "                } else {",
  "                    accum := accum ++ c",
  "                }",
  "                if (accum == \"...\") then {",
  "                    if (mode == \"o\") then {",
  "                        modechange(tokens, \"i\", \"...\")",
  "                        newmode := \"n\"",
  "                        mode := newmode",
  "                        accum := \"\"",
  "                    }",
  "                }",
  "                if (newlineFound) then {",
  "                    // Linebreaks increment the line counter and insert a",
  "                    // special \"line\" token, which the parser can use to",
  "                    // track the origin of AST nodes for later error",
  "                    // reporting.",
  "                    newlineFound := false",
  "                    lineNumber := lineNumber + 1",
  "                    linePosition := 0",
  "                    startPosition := 1",
  "                }",
  "            }",
  "            for (inputLines) do { eachLine ->",
  "                for (eachLine) do { ch ->",
  "                    linePosition := linePosition + 1",
  "                    if (ch == \" \") then {",
  "                        if (mode == \"d\") then {",
  "                        } else {",
  "                            if (mode != \"n\") then {",
  "                                mainBlock.apply(ch)",
  "                            }",
  "                        }",
  "                    } else {",
  "                        mainBlock.apply(ch)",
  "                    }",
  "                }",
  "                mainBlock.apply \"\\n\"",
  "            }",
  "            linePosition := linePosition + 1",
  "            if (inStr) then {",
  "                if (mode == \"\\\"\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.addLine(lineNumber, util.lines.at(lineNumber) ++ \"\\\"\")",
  "                    errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                        lineNumber, linePosition)withSuggestion(suggestion)",
  "                } elseif {mode == \"q\"} then {",
  "                    errormessages.syntaxError(\"A multi-line string must end with a '›'.\\n\" ++ ",
  "                        \"String opened on line {startLine} and unclosed at end of input.\")",
  "                        atRange(startLine, stringStart, util.lines.at(startLine).size)",
  "                }",
  "            }",
  "            modechange(tokens, mode, accum)",
  "            tokens.push(eofToken.new)",
  "            tokens",
  "        }",
  "    }",
  "}",
  "",
  NULL
};
Object reader_lexer_outer_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_line_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_indent_36(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_linePos_37(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_next_38(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_lexer_next_38(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_lexer_prev_39(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_lexer_prev_39(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_lexer_outer_106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_109(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_120(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_123(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_124(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_126(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_139(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_142(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_143(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_144(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_145(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_line_39__146(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_linePos_39__147(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_lexer_outer_165(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_168(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_183(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_186(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_187(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_188(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_189(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_197(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_211(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_214(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_215(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_216(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_217(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_225(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_242(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_243(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_244(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_245(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_281(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_284(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_286(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_287(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_299(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_300(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_312(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_313(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_314(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_base_315(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_size_316(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_outer_325(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_328(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_329(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_331(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_356(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_357(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_358(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_359(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_370(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_371(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_372(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_373(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_395(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_398(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_399(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_400(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_401(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_409(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_412(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_413(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_414(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_415(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_423(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_427(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_1917(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_first_1918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_first_1918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_last_1919(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_lexer_last_1919(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_lexer_size_39__1920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_lexer_size_39__1920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_lexer_outer_2028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_n_2029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_n_2029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
static ClassData objclass30;
static ClassData objclass33;
static Object strlit66;
static Object strlit73;
static Object strlit80;
static Object strlit87;
static Object strlit93;
static ClassData objclass105;
static ClassData objclass108;
static Object strlit115;
static ClassData objclass119;
static ClassData objclass122;
static Object strlit129;
static ClassData objclass138;
static ClassData objclass141;
static Object strlit156;
static ClassData objclass164;
static ClassData objclass167;
static Object strlit174;
static ClassData objclass182;
static ClassData objclass185;
static Object strlit192;
static Object strlit193;
static ClassData objclass196;
static ClassData objclass199;
static Object strlit206;
static Object strlit207;
static ClassData objclass210;
static ClassData objclass213;
static Object strlit220;
static Object strlit221;
static ClassData objclass224;
static ClassData objclass227;
static Object strlit234;
static Object strlit235;
static ClassData objclass238;
static ClassData objclass241;
static Object strlit248;
static Object strlit249;
static ClassData objclass252;
static ClassData objclass255;
static Object strlit262;
static Object strlit263;
static ClassData objclass266;
static ClassData objclass269;
static Object strlit276;
static Object strlit277;
static ClassData objclass280;
static ClassData objclass283;
static Object strlit290;
static Object strlit291;
static ClassData objclass294;
static ClassData objclass297;
static Object strlit304;
static Object strlit305;
static ClassData objclass308;
static ClassData objclass311;
static Object strlit319;
static ClassData objclass324;
static ClassData objclass327;
static Object strlit334;
static ClassData objclass338;
static ClassData objclass341;
static Object strlit348;
static ClassData objclass352;
static ClassData objclass355;
static Object strlit362;
static Object strlit363;
static ClassData objclass366;
static ClassData objclass369;
static Object strlit376;
static Object strlit377;
static ClassData objclass380;
static ClassData objclass383;
static Object strlit390;
static Object strlit391;
static ClassData objclass394;
static ClassData objclass397;
static Object strlit404;
static Object strlit405;
static ClassData objclass408;
static ClassData objclass411;
static Object strlit418;
static Object strlit419;
static ClassData objclass422;
static ClassData objclass425;
static Object strlit432;
static Object strlit433;
static ClassData objclass436;
static Object strlit451;
static Object strlit457;
static Object strlit466;
static Object strlit472;
static Object strlit478;
static Object strlit484;
static Object strlit490;
static Object strlit496;
static Object strlit502;
static Object strlit508;
static Object strlit514;
static Object strlit520;
static Object strlit526;
static Object strlit531;
static Object strlit554;
static Object strlit566;
static Object strlit578;
static Object strlit590;
static Object strlit594;
static Object strlit604;
static Object strlit616;
static Object strlit628;
static Object strlit640;
static Object strlit652;
static Object strlit664;
static Object strlit676;
static Object strlit688;
static Object strlit700;
static Object strlit712;
static Object strlit724;
static Object strlit736;
static Object strlit744;
static Object strlit763;
static Object strlit795;
static Object strlit841;
static Object strlit889;
static Object strlit897;
static Object strlit909;
static Object strlit923;
static Object strlit929;
static Object strlit931;
static Object strlit943;
static Object strlit952;
static Object strlit965;
static Object strlit972;
static Object strlit980;
static Object strlit990;
static Object strlit1006;
static Object strlit1026;
static Object strlit1030;
static Object strlit1041;
static Object strlit1050;
static Object strlit1067;
static Object strlit1075;
static Object strlit1083;
static Object strlit1091;
static Object strlit1103;
static Object strlit1115;
static Object strlit1122;
static Object strlit1135;
static Object strlit1169;
static Object strlit1174;
static Object strlit1191;
static Object strlit1196;
static Object strlit1200;
static Object strlit1271;
static Object strlit1282;
static Object strlit1294;
static Object strlit1347;
static Object strlit1355;
static Object strlit1359;
static Object strlit1369;
static Object strlit1374;
static Object strlit1379;
static Object strlit1384;
static Object strlit1388;
static Object strlit1425;
static Object strlit1428;
static Object strlit1431;
static Object strlit1439;
static Object strlit1459;
static Object strlit1479;
static Object strlit1493;
static Object strlit1497;
static Object strlit1504;
static Object strlit1515;
static Object strlit1557;
static Object strlit1585;
static Object strlit1589;
static Object strlit1610;
static Object strlit1625;
static Object strlit1659;
static Object strlit1664;
static Object strlit1707;
static Object strlit1713;
static Object strlit1719;
static Object strlit1725;
static Object strlit1731;
static Object strlit1737;
static Object strlit1743;
static Object strlit1749;
static Object strlit1755;
static Object strlit1761;
static Object strlit1767;
static Object strlit1772;
static Object strlit1793;
static Object strlit1800;
static Object strlit1801;
static Object strlit1810;
static Object strlit1817;
static Object strlit1819;
static Object strlit1825;
static Object strlit1833;
static Object strlit1835;
static Object strlit1841;
static Object strlit1848;
static Object strlit1850;
static Object strlit1856;
static Object strlit1860;
static Object strlit1865;
static Object strlit1873;
static Object strlit1877;
static Object strlit1882;
static Object strlit1902;
static ClassData objclass1916;
static ClassData objclass2027;
static Object strlit2064;
static Object strlit2068;
static Object strlit2079;
static Object strlit2082;
static Object strlit2088;
static Object strlit2094;
static Object strlit2097;
static Object strlit2100;
static Object strlit2103;
static Object strlit2106;
static Object strlit2109;
static Object strlit2112;
static Object strlit2115;
static Object strlit2118;
static Object strlit2123;
static Object strlit2126;
static Object strlit2129;
static Object strlit2132;
static Object strlit2135;
static Object strlit2138;
static Object strlit2142;
static Object strlit2143;
static Object strlit2149;
static Object strlit2152;
static Object strlit2155;
static Object strlit2158;
static Object strlit2161;
static Object strlit2164;
static Object strlit2167;
static Object strlit2170;
static Object strlit2173;
static Object strlit2176;
static Object strlit2180;
static Object strlit2181;
static Object strlit2183;
static Object strlit2186;
static Object strlit2189;
static Object strlit2192;
static Object strlit2195;
static Object strlit2198;
static Object strlit2201;
static Object strlit2204;
static Object strlit2207;
static Object strlit2210;
static Object strlit2213;
static Object strlit2216;
static Object strlit2221;
static Object strlit2224;
static Object strlit2227;
static Object strlit2232;
static Object strlit2240;
static Object strlit2252;
static Object strlit2262;
static Object strlit2270;
static Object strlit2275;
static Object strlit2281;
static Object strlit2289;
static Object strlit2295;
static Object strlit2298;
static Object strlit2300;
static Object strlit2307;
static Object strlit2311;
static Object strlit2316;
static Object strlit2324;
static Object strlit2329;
static Object strlit2335;
static Object strlit2343;
static Object strlit2349;
static Object strlit2352;
static Object strlit2355;
static Object strlit2358;
static Object strlit2361;
static Object strlit2369;
static Object strlit2375;
static Object strlit2381;
static Object strlit2395;
static Object strlit2398;
static Object strlit2406;
static Object strlit2412;
static Object strlit2418;
static Object strlit2430;
static Object strlit2444;
static Object strlit2452;
static Object strlit2457;
static Object strlit2463;
static Object strlit2471;
static Object strlit2477;
static Object strlit2480;
static Object strlit2483;
static Object strlit2486;
static Object strlit2494;
static Object strlit2500;
static Object strlit2506;
static Object strlit2521;
static Object strlit2524;
static Object strlit2532;
static Object strlit2538;
static Object strlit2544;
static Object strlit2559;
static Object strlit2562;
static Object strlit2571;
static Object strlit2576;
static Object strlit2583;
static Object strlit2588;
static Object strlit2592;
static Object strlit2596;
static Object strlit2599;
static Object strlit2606;
static Object strlit2609;
static Object strlit2618;
static Object strlit2625;
static Object strlit2628;
static Object strlit2632;
static Object strlit2647;
static Object strlit2661;
static Object strlit2666;
static Object strlit2671;
static Object strlit2675;
static Object strlit2680;
static Object strlit2689;
static Object strlit2694;
static Object strlit2699;
static Object strlit2707;
static Object strlit2712;
static Object strlit2717;
static Object strlit2747;
static Object strlit2750;
static Object strlit2753;
static Object strlit2760;
static Object strlit2763;
static Object strlit2767;
static Object strlit2772;
static Object strlit2775;
static Object strlit2780;
static Object strlit2783;
static Object strlit2787;
static Object strlit2788;
static Object strlit2790;
static Object strlit2794;
static Object strlit2799;
static Object strlit2802;
static Object strlit2807;
static Object strlit2841;
static Object strlit2846;
static Object strlit2849;
static Object strlit2857;
static Object strlit2863;
static Object strlit2869;
static Object strlit2878;
static Object strlit2883;
static Object strlit2889;
static Object strlit2897;
static Object strlit2898;
static Object strlit2905;
static Object strlit2910;
static Object strlit2913;
static Object strlit2930;
static Object strlit2935;
static Object strlit2953;
static Object strlit2960;
static Object strlit2961;
static Object strlit2964;
static Object strlit2965;
static Object strlit2967;
static Object strlit2978;
static Object strlit2986;
static Object strlit2988;
static Object strlit2990;
static Object strlit2994;
static Object strlit2999;
static Object strlit3017;
static Object strlit3058;
static Object strlit3077;
static Object strlit3085;
static Object strlit3099;
static Object strlit3134;
static Object strlit3150;
static Object strlit3161;
static Object strlit3201;
static Object strlit3212;
static Object strlit3223;
static Object strlit3237;
static Object strlit3247;
static Object strlit3253;
static Object strlit3255;
static Object strlit3264;
static Object strlit3269;
static Object strlit3274;
static Object strlit3278;
static Object strlit3284;
static Object strlit3293;
static Object strlit3302;
static Object strlit3306;
static Object strlit3312;
static Object strlit3316;
static Object strlit3322;
static Object strlit3326;
static Object strlit3332;
static Object strlit3336;
static Object strlit3342;
static Object strlit3346;
static Object strlit3352;
static Object strlit3356;
static Object strlit3362;
static Object strlit3366;
static Object strlit3378;
static Object strlit3417;
static Object strlit3424;
static Object strlit3425;
static Object strlit3432;
static Object strlit3433;
static Object strlit3436;
static Object strlit3437;
static Object strlit3439;
static Object strlit3441;
static Object strlit3443;
static Object strlit3458;
static Object strlit3465;
static Object strlit3474;
static Object strlit3476;
static Object strlit3478;
static Object strlit3486;
static Object strlit3491;
static Object strlit3495;
static Object strlit3496;
static Object strlit3498;
static Object strlit3501;
static Object strlit3529;
static Object strlit3534;
static Object strlit3539;
static Object strlit3549;
static Object strlit3561;
static Object strlit3570;
static Object strlit3579;
static Object strlit3583;
static Object strlit3589;
static Object strlit3593;
static Object strlit3597;
Object module_util;
Object module_util_init();
Object module_unicode;
Object module_unicode_init();
Object module_errormessages;
Object module_errormessages_init();
Object meth_lexer__apply9(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_l = getfromclosure(closure, 0);
  Object *var_s_39_ = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  int op_slot_right_10 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s_39_ (depth = 7)
  partcv[0] = 0;
  Object call13 = callmethod(*var_s_39_, "size",
    1, partcv, params);
  gc_frame_end(callframe12);
// compiled call node returning call13 (depth = 6)
// compiled member node returning call13 (depth = 5)
  int op_slot_left_10 = gc_frame_newslot(call13);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult14 = callmethod(call13, "<", 1, partcv, params);
// compiled op node returning opresult14 (depth = 4)
  gc_frame_end(frame);
  return opresult14;
}
Object meth_lexer__apply17(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s_39_ = getfromclosure(closure, 0);
  Object *var_w = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s_39_ (depth = 6)
  int op_slot_right_18 = gc_frame_newslot(*var_s_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_w (depth = 6)
  int op_slot_left_18 = gc_frame_newslot(*var_w);
  params[0] = *var_s_39_;
  partcv[0] = 1;
  Object opresult20 = callmethod(*var_w, "++", 1, partcv, params);
// compiled op node returning opresult20 (depth = 5)
  *var_s_39_ = opresult20;
  if (opresult20 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_padl0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "padl");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method padl");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for padl (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_w = &(stackframe->slots[2]);
  *var_w = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for padl");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s'");
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  int op_slot_right_2 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call5 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe4);
// compiled call node returning call5 (depth = 5)
// compiled member node returning call5 (depth = 4)
  int op_slot_left_2 = gc_frame_newslot(call5);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult6 = callmethod(call5, ">=", 1, partcv, params);
// compiled op node returning opresult6 (depth = 3)
  Object if1 = done;
  if (istrue(opresult6)) {
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  return *var_s;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1 = undefined;
  } else {
  }
// compiled if node returning if1 (depth = 2)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  *var_s_39_ = *var_s;
  if (*var_s == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8 = alloc_Block(NULL, NULL, "lexer", 10);
  gc_frame_newslot(block8);
// method _apply
  block_savedest(block8);
  Object closure9 = createclosure(3, "_apply");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_l);
  addtoclosure(closure9, var_s_39_);
  addtoclosure(closure9, selfslot);
  struct UserObject *uo9 = (struct UserObject*)block8;
  uo9->data[0] = (Object)closure9;
  Method *meth_meth_lexer__apply9 = addmethod2pos(block8, "_apply", &meth_lexer__apply9, 0);
  int argcv_meth_lexer__apply9[] = {0};
  meth_meth_lexer__apply9->type = alloc_MethodType(1, argcv_meth_lexer__apply9);
  meth_meth_lexer__apply9->definitionModule = modulename;
  meth_meth_lexer__apply9->definitionLine = 6;
// compiled block node returning block8 (depth = 3)
  gc_frame_newslot(block8);
// starting to compile block node (depth = 3)
  Object block16 = alloc_Block(NULL, NULL, "lexer", 10);
  gc_frame_newslot(block16);
// method _apply
  block_savedest(block16);
  Object closure17 = createclosure(3, "_apply");
  setclosureframe(closure17, stackframe);
  addtoclosure(closure17, var_s_39_);
  addtoclosure(closure17, var_w);
  addtoclosure(closure17, selfslot);
  struct UserObject *uo17 = (struct UserObject*)block16;
  uo17->data[0] = (Object)closure17;
  Method *meth_meth_lexer__apply17 = addmethod2pos(block16, "_apply", &meth_lexer__apply17, 0);
  int argcv_meth_lexer__apply17[] = {0};
  meth_meth_lexer__apply17->type = alloc_MethodType(1, argcv_meth_lexer__apply17);
  meth_meth_lexer__apply17->definitionModule = modulename;
  meth_meth_lexer__apply17->definitionLine = 10;
// compiled block node returning block16 (depth = 3)
  gc_frame_newslot(block16);
// call case 5: prelude request
  params[0] = block8;
  params[1] = block16;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call23 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7);
// compiled call node returning call23 (depth = 2)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s_39_ (depth = 3)
  return *var_s_39_;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer__61__61_40(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool43 = alloc_Boolean(0);
// compiled identifier node returning bool43 (depth = 7)
  int op_slot_right_42 = gc_frame_newslot(bool43);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  int op_slot_left_42 = gc_frame_newslot(*var_other);
  params[0] = bool43;
  partcv[0] = 1;
  Object opresult45 = callmethod(*var_other, "==", 1, partcv, params);
// compiled op node returning opresult45 (depth = 6)
  Object if41 = done;
  if (istrue(opresult45)) {
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool46 = alloc_Boolean(0);
// compiled identifier node returning bool46 (depth = 6)
    gc_frame_newslot(bool46);
    if41 = bool46;
  } else {
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe49 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call50 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe49);
// compiled call node returning call50 (depth = 9)
// compiled member node returning call50 (depth = 8)
  int op_slot_right_48 = gc_frame_newslot(call50);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe52 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_other (depth = 10)
  partcv[0] = 0;
  Object call53 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe52);
// compiled call node returning call53 (depth = 9)
// compiled member node returning call53 (depth = 8)
  int op_slot_left_48 = gc_frame_newslot(call53);
  params[0] = call50;
  partcv[0] = 1;
  Object opresult54 = callmethod(call53, "==", 1, partcv, params);
// compiled op node returning opresult54 (depth = 7)
  int op_slot_right_47 = gc_frame_newslot(opresult54);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe57 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call58 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe57);
// compiled call node returning call58 (depth = 9)
// compiled member node returning call58 (depth = 8)
  int op_slot_right_56 = gc_frame_newslot(call58);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe60 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_other (depth = 10)
  partcv[0] = 0;
  Object call61 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe60);
// compiled call node returning call61 (depth = 9)
// compiled member node returning call61 (depth = 8)
  int op_slot_left_56 = gc_frame_newslot(call61);
  params[0] = call58;
  partcv[0] = 1;
  Object opresult62 = callmethod(call61, "==", 1, partcv, params);
// compiled op node returning opresult62 (depth = 7)
  int op_slot_left_47 = gc_frame_newslot(opresult62);
  params[0] = opresult54;
  partcv[0] = 1;
  Object opresult63 = callmethod(opresult62, "&&", 1, partcv, params);
// compiled op node returning opresult63 (depth = 6)
    gc_frame_newslot(opresult63);
    if41 = opresult63;
  }
// compiled if node returning if41 (depth = 5)
  gc_frame_end(frame);
  return if41;
}
Object meth_lexer_asString64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit66 == NULL) {
    strlit66 = alloc_String("");
    gc_root(strlit66);
  }
// compiled string node returning strlit66 (depth = 6)
  int op_slot_right_65 = gc_frame_newslot(strlit66);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe69 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call70 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe69);
// compiled call node returning call70 (depth = 8)
// compiled member node returning call70 (depth = 7)
  int op_slot_right_68 = gc_frame_newslot(call70);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit73 == NULL) {
    strlit73 = alloc_String(" ");
    gc_root(strlit73);
  }
// compiled string node returning strlit73 (depth = 8)
  int op_slot_right_72 = gc_frame_newslot(strlit73);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe76 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call77 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe76);
// compiled call node returning call77 (depth = 10)
// compiled member node returning call77 (depth = 9)
  int op_slot_right_75 = gc_frame_newslot(call77);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit80 == NULL) {
    strlit80 = alloc_String(")");
    gc_root(strlit80);
  }
// compiled string node returning strlit80 (depth = 10)
  int op_slot_right_79 = gc_frame_newslot(strlit80);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe83 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call84 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe83);
// compiled call node returning call84 (depth = 12)
// compiled member node returning call84 (depth = 11)
  int op_slot_right_82 = gc_frame_newslot(call84);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit87 == NULL) {
    strlit87 = alloc_String(":");
    gc_root(strlit87);
  }
// compiled string node returning strlit87 (depth = 12)
  int op_slot_right_86 = gc_frame_newslot(strlit87);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe90 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call91 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe90);
// compiled call node returning call91 (depth = 14)
// compiled member node returning call91 (depth = 13)
  int op_slot_right_89 = gc_frame_newslot(call91);
// starting to compile string node (depth = 13)
  if (strlit93 == NULL) {
    strlit93 = alloc_String("(");
    gc_root(strlit93);
  }
// compiled string node returning strlit93 (depth = 13)
  int op_slot_left_89 = gc_frame_newslot(strlit93);
  params[0] = call91;
  partcv[0] = 1;
  Object opresult94 = callmethod(strlit93, "++", 1, partcv, params);
// compiled op node returning opresult94 (depth = 12)
  int op_slot_left_86 = gc_frame_newslot(opresult94);
  params[0] = strlit87;
  partcv[0] = 1;
  Object opresult95 = callmethod(opresult94, "++", 1, partcv, params);
// compiled op node returning opresult95 (depth = 11)
  int op_slot_left_82 = gc_frame_newslot(opresult95);
  params[0] = call84;
  partcv[0] = 1;
  Object opresult96 = callmethod(opresult95, "++", 1, partcv, params);
// compiled op node returning opresult96 (depth = 10)
  int op_slot_left_79 = gc_frame_newslot(opresult96);
  params[0] = strlit80;
  partcv[0] = 1;
  Object opresult97 = callmethod(opresult96, "++", 1, partcv, params);
// compiled op node returning opresult97 (depth = 9)
  int op_slot_left_75 = gc_frame_newslot(opresult97);
  params[0] = call77;
  partcv[0] = 1;
  Object opresult98 = callmethod(opresult97, "++", 1, partcv, params);
// compiled op node returning opresult98 (depth = 8)
  int op_slot_left_72 = gc_frame_newslot(opresult98);
  params[0] = strlit73;
  partcv[0] = 1;
  Object opresult99 = callmethod(opresult98, "++", 1, partcv, params);
// compiled op node returning opresult99 (depth = 7)
  int op_slot_left_68 = gc_frame_newslot(opresult99);
  params[0] = call70;
  partcv[0] = 1;
  Object opresult100 = callmethod(opresult99, "++", 1, partcv, params);
// compiled op node returning opresult100 (depth = 6)
  int op_slot_left_65 = gc_frame_newslot(opresult100);
  params[0] = strlit66;
  partcv[0] = 1;
  Object opresult101 = callmethod(opresult100, "++", 1, partcv, params);
// compiled op node returning opresult101 (depth = 5)
  gc_frame_end(frame);
  return opresult101;
}
Object meth_lexer_new32(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject33 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj33 = alloc_userobj2(9,8, objclass33);
  gc_frame_newslot(obj33);
if (objclass33 == NULL) {
  glfree(obj33->class->name);
  obj33->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj33, self, 0);
  addmethodreal(obj33,"outer", &reader_lexer_outer_34);
  Object oldself33 = self;
  struct StackFrameObject *oldstackframe33 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe33);
  gc_frame_newslot((Object)stackframe);
  self = obj33;
  Object *oldselfslot33 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter33 = (*(struct UserObject *)self).data[0], lowerouter33 = thisouter33;
  if (inheritingObject33) {
    struct UserObject *inho33 = (struct UserObject *)inheritingObject33;
    while (inho33->super != GraceDefaultObject) inho33 = (struct UserObject *)inho33->super;
    inho33->super = obj33;
    self = inheritingObject33;
    *selfslot = self;
    lowerouter33 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter33;
  }
if (objclass33 == NULL) {
  Method *reader35 = addmethodrealflags(obj33, "line",&reader_lexer_line_35, MFLAG_DEF);
  reader35->definitionModule = modulename;
  reader35->definitionLine = 26;
}
adddatum2(obj33, alloc_Undefined(), 1);
if (objclass33 == NULL) {
  Method *reader36 = addmethodrealflags(obj33, "indent",&reader_lexer_indent_36, MFLAG_DEF);
  reader36->definitionModule = modulename;
  reader36->definitionLine = 27;
}
adddatum2(obj33, alloc_Undefined(), 2);
if (objclass33 == NULL) {
  Method *reader37 = addmethodrealflags(obj33, "linePos",&reader_lexer_linePos_37, MFLAG_DEF);
  reader37->definitionModule = modulename;
  reader37->definitionLine = 28;
}
adddatum2(obj33, alloc_Undefined(), 3);
if (objclass33 == NULL) {
  Method *reader38 = addmethodrealflags(obj33, "next",&reader_lexer_next_38, 0);
  Method *writer38 = addmethodrealflags(obj33, "next:=",&writer_lexer_next_38, 0);
  reader38->definitionModule = modulename;
  writer38->definitionModule = modulename;
  reader38->definitionLine = 30;
  writer38->definitionLine = 30;
}
obj33->flags |= OFLAG_MUTABLE;
adddatum2(obj33, alloc_Undefined(), 4);
if (objclass33 == NULL) {
  Method *reader39 = addmethodrealflags(obj33, "prev",&reader_lexer_prev_39, 0);
  Method *writer39 = addmethodrealflags(obj33, "prev:=",&writer_lexer_prev_39, 0);
  reader39->definitionModule = modulename;
  writer39->definitionModule = modulename;
  reader39->definitionLine = 31;
  writer39->definitionLine = 31;
}
obj33->flags |= OFLAG_MUTABLE;
adddatum2(obj33, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo40 = (struct UserObject*)obj33;
  uo40->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_40 = addmethod2pos(obj33, "==", &meth_lexer__61__61_40, 6);
  int argcv_meth_lexer__61__61_40[] = {1};
  meth_meth_lexer__61__61_40->type = alloc_MethodType(1, argcv_meth_lexer__61__61_40);
  meth_meth_lexer__61__61_40->definitionModule = modulename;
  meth_meth_lexer__61__61_40->definitionLine = 33;
// method asString
  struct UserObject *uo64 = (struct UserObject*)obj33;
  uo64->data[7] = emptyclosure;
  Method *meth_meth_lexer_asString64 = addmethod2pos(obj33, "asString", &meth_lexer_asString64, 7);
  int argcv_meth_lexer_asString64[] = {0};
  meth_meth_lexer_asString64->type = alloc_MethodType(1, argcv_meth_lexer_asString64);
  meth_meth_lexer_asString64->definitionModule = modulename;
  meth_meth_lexer_asString64->definitionLine = 40;
  sourceObject = obj33;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  adddatum2(obj33, *var_lineNumber, 1);
  sourceObject = obj33;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_indentLevel (depth = 5)
  adddatum2(obj33, *var_indentLevel, 2);
  sourceObject = obj33;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startPosition (depth = 5)
  adddatum2(obj33, *var_startPosition, 3);
  sourceObject = obj33;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool102 = alloc_Boolean(0);
// compiled identifier node returning bool102 (depth = 5)
  adddatum2(obj33, bool102, 4);
  sourceObject = obj33;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 5)
  adddatum2(obj33, bool103, 5);
  sourceObject = obj33;
  sourceObject = obj33;
  objclass33 = obj33->class;
  objclass33->definitionModule = modulename;
  objclass33->definitionLine = 25;
  (*(struct UserObject *)self).data[0] = lowerouter33;
  self = oldself33;
  selfslot = oldselfslot33;
  stackframe = oldstackframe33;
  gc_frame_end(frame);
  return obj33;
}
Object meth_lexer_new32_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject33 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj33 = alloc_userobj2(9,8, objclass33);
  gc_frame_newslot(obj33);
if (objclass33 == NULL) {
  glfree(obj33->class->name);
  obj33->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj33, self, 0);
  addmethodreal(obj33,"outer", &reader_lexer_outer_34);
  Object oldself33 = self;
  struct StackFrameObject *oldstackframe33 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe33);
  gc_frame_newslot((Object)stackframe);
  self = obj33;
  Object *oldselfslot33 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter33 = (*(struct UserObject *)self).data[0], lowerouter33 = thisouter33;
  if (inheritingObject33) {
    struct UserObject *inho33 = (struct UserObject *)inheritingObject33;
    while (inho33->super != GraceDefaultObject) inho33 = (struct UserObject *)inho33->super;
    inho33->super = obj33;
    self = inheritingObject33;
    *selfslot = self;
    lowerouter33 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter33;
  }
if (objclass33 == NULL) {
  Method *reader35 = addmethodrealflags(obj33, "line",&reader_lexer_line_35, MFLAG_DEF);
  reader35->definitionModule = modulename;
  reader35->definitionLine = 26;
}
adddatum2(obj33, alloc_Undefined(), 1);
if (objclass33 == NULL) {
  Method *reader36 = addmethodrealflags(obj33, "indent",&reader_lexer_indent_36, MFLAG_DEF);
  reader36->definitionModule = modulename;
  reader36->definitionLine = 27;
}
adddatum2(obj33, alloc_Undefined(), 2);
if (objclass33 == NULL) {
  Method *reader37 = addmethodrealflags(obj33, "linePos",&reader_lexer_linePos_37, MFLAG_DEF);
  reader37->definitionModule = modulename;
  reader37->definitionLine = 28;
}
adddatum2(obj33, alloc_Undefined(), 3);
if (objclass33 == NULL) {
  Method *reader38 = addmethodrealflags(obj33, "next",&reader_lexer_next_38, 0);
  Method *writer38 = addmethodrealflags(obj33, "next:=",&writer_lexer_next_38, 0);
  reader38->definitionModule = modulename;
  writer38->definitionModule = modulename;
  reader38->definitionLine = 30;
  writer38->definitionLine = 30;
}
obj33->flags |= OFLAG_MUTABLE;
adddatum2(obj33, alloc_Undefined(), 4);
if (objclass33 == NULL) {
  Method *reader39 = addmethodrealflags(obj33, "prev",&reader_lexer_prev_39, 0);
  Method *writer39 = addmethodrealflags(obj33, "prev:=",&writer_lexer_prev_39, 0);
  reader39->definitionModule = modulename;
  writer39->definitionModule = modulename;
  reader39->definitionLine = 31;
  writer39->definitionLine = 31;
}
obj33->flags |= OFLAG_MUTABLE;
adddatum2(obj33, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo40 = (struct UserObject*)obj33;
  uo40->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_40 = addmethod2pos(obj33, "==", &meth_lexer__61__61_40, 6);
  int argcv_meth_lexer__61__61_40[] = {1};
  meth_meth_lexer__61__61_40->type = alloc_MethodType(1, argcv_meth_lexer__61__61_40);
  meth_meth_lexer__61__61_40->definitionModule = modulename;
  meth_meth_lexer__61__61_40->definitionLine = 33;
// method asString
  struct UserObject *uo64 = (struct UserObject*)obj33;
  uo64->data[7] = emptyclosure;
  Method *meth_meth_lexer_asString64 = addmethod2pos(obj33, "asString", &meth_lexer_asString64, 7);
  int argcv_meth_lexer_asString64[] = {0};
  meth_meth_lexer_asString64->type = alloc_MethodType(1, argcv_meth_lexer_asString64);
  meth_meth_lexer_asString64->definitionModule = modulename;
  meth_meth_lexer_asString64->definitionLine = 40;
  sourceObject = obj33;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  adddatum2(obj33, *var_lineNumber, 1);
  sourceObject = obj33;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_indentLevel (depth = 5)
  adddatum2(obj33, *var_indentLevel, 2);
  sourceObject = obj33;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startPosition (depth = 5)
  adddatum2(obj33, *var_startPosition, 3);
  sourceObject = obj33;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool102 = alloc_Boolean(0);
// compiled identifier node returning bool102 (depth = 5)
  adddatum2(obj33, bool102, 4);
  sourceObject = obj33;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 5)
  adddatum2(obj33, bool103, 5);
  sourceObject = obj33;
  sourceObject = obj33;
  objclass33 = obj33->class;
  objclass33->definitionModule = modulename;
  objclass33->definitionLine = 25;
  (*(struct UserObject *)self).data[0] = lowerouter33;
  self = oldself33;
  selfslot = oldselfslot33;
  stackframe = oldstackframe33;
  gc_frame_end(frame);
  return obj33;
}
Object meth_lexer_new107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj108 = alloc_userobj2(4,5, objclass108);
  gc_frame_newslot(obj108);
if (objclass108 == NULL) {
  glfree(obj108->class->name);
  obj108->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj108, self, 0);
  addmethodreal(obj108,"outer", &reader_lexer_outer_109);
  Object oldself108 = self;
  struct StackFrameObject *oldstackframe108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe108);
  gc_frame_newslot((Object)stackframe);
  self = obj108;
  Object *oldselfslot108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter108 = (*(struct UserObject *)self).data[0], lowerouter108 = thisouter108;
  if (inheritingObject108) {
    struct UserObject *inho108 = (struct UserObject *)inheritingObject108;
    while (inho108->super != GraceDefaultObject) inho108 = (struct UserObject *)inho108->super;
    inho108->super = obj108;
    self = inheritingObject108;
    *selfslot = self;
    lowerouter108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter108;
  }
if (objclass108 == NULL) {
  Method *reader110 = addmethodrealflags(obj108, "kind",&reader_lexer_kind_110, MFLAG_DEF);
  reader110->definitionModule = modulename;
  reader110->definitionLine = 46;
}
adddatum2(obj108, alloc_Undefined(), 1);
if (objclass108 == NULL) {
  Method *reader111 = addmethodrealflags(obj108, "value",&reader_lexer_value_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 47;
}
adddatum2(obj108, alloc_Undefined(), 2);
if (objclass108 == NULL) {
  Method *reader112 = addmethodrealflags(obj108, "size",&reader_lexer_size_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 48;
}
adddatum2(obj108, alloc_Undefined(), 3);
  sourceObject = obj108;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe113 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call114 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe113);
// compiled call node returning call114 (depth = 5)
  struct UserObject *obj108_uo = (struct UserObject *)obj108;
  obj108_uo->super = call114;
  sourceObject = obj108;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit115 == NULL) {
    strlit115 = alloc_String("identifier");
    gc_root(strlit115);
  }
// compiled string node returning strlit115 (depth = 5)
  adddatum2(obj108, strlit115, 1);
  sourceObject = obj108;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj108, *var_s, 2);
  sourceObject = obj108;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call117 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 6)
// compiled member node returning call117 (depth = 5)
  adddatum2(obj108, call117, 3);
  objclass108 = obj108->class;
  objclass108->definitionModule = modulename;
  objclass108->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter108;
  self = oldself108;
  selfslot = oldselfslot108;
  stackframe = oldstackframe108;
  gc_frame_end(frame);
  return obj108;
}
Object meth_lexer_new107_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj108 = alloc_userobj2(4,5, objclass108);
  gc_frame_newslot(obj108);
if (objclass108 == NULL) {
  glfree(obj108->class->name);
  obj108->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj108, self, 0);
  addmethodreal(obj108,"outer", &reader_lexer_outer_109);
  Object oldself108 = self;
  struct StackFrameObject *oldstackframe108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe108);
  gc_frame_newslot((Object)stackframe);
  self = obj108;
  Object *oldselfslot108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter108 = (*(struct UserObject *)self).data[0], lowerouter108 = thisouter108;
  if (inheritingObject108) {
    struct UserObject *inho108 = (struct UserObject *)inheritingObject108;
    while (inho108->super != GraceDefaultObject) inho108 = (struct UserObject *)inho108->super;
    inho108->super = obj108;
    self = inheritingObject108;
    *selfslot = self;
    lowerouter108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter108;
  }
if (objclass108 == NULL) {
  Method *reader110 = addmethodrealflags(obj108, "kind",&reader_lexer_kind_110, MFLAG_DEF);
  reader110->definitionModule = modulename;
  reader110->definitionLine = 46;
}
adddatum2(obj108, alloc_Undefined(), 1);
if (objclass108 == NULL) {
  Method *reader111 = addmethodrealflags(obj108, "value",&reader_lexer_value_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 47;
}
adddatum2(obj108, alloc_Undefined(), 2);
if (objclass108 == NULL) {
  Method *reader112 = addmethodrealflags(obj108, "size",&reader_lexer_size_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 48;
}
adddatum2(obj108, alloc_Undefined(), 3);
  sourceObject = obj108;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe113 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call114 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe113);
// compiled call node returning call114 (depth = 5)
  struct UserObject *obj108_uo = (struct UserObject *)obj108;
  obj108_uo->super = call114;
  sourceObject = obj108;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit115 == NULL) {
    strlit115 = alloc_String("identifier");
    gc_root(strlit115);
  }
// compiled string node returning strlit115 (depth = 5)
  adddatum2(obj108, strlit115, 1);
  sourceObject = obj108;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj108, *var_s, 2);
  sourceObject = obj108;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call117 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 6)
// compiled member node returning call117 (depth = 5)
  adddatum2(obj108, call117, 3);
  objclass108 = obj108->class;
  objclass108->definitionModule = modulename;
  objclass108->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter108;
  self = oldself108;
  selfslot = oldselfslot108;
  stackframe = oldstackframe108;
  gc_frame_end(frame);
  return obj108;
}
Object meth_lexer_new121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_stringStart = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject122 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj122 = alloc_userobj2(4,5, objclass122);
  gc_frame_newslot(obj122);
if (objclass122 == NULL) {
  glfree(obj122->class->name);
  obj122->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj122, self, 0);
  addmethodreal(obj122,"outer", &reader_lexer_outer_123);
  Object oldself122 = self;
  struct StackFrameObject *oldstackframe122 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe122);
  gc_frame_newslot((Object)stackframe);
  self = obj122;
  Object *oldselfslot122 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter122 = (*(struct UserObject *)self).data[0], lowerouter122 = thisouter122;
  if (inheritingObject122) {
    struct UserObject *inho122 = (struct UserObject *)inheritingObject122;
    while (inho122->super != GraceDefaultObject) inho122 = (struct UserObject *)inho122->super;
    inho122->super = obj122;
    self = inheritingObject122;
    *selfslot = self;
    lowerouter122 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter122;
  }
if (objclass122 == NULL) {
  Method *reader124 = addmethodrealflags(obj122, "kind",&reader_lexer_kind_124, MFLAG_DEF);
  reader124->definitionModule = modulename;
  reader124->definitionLine = 52;
}
adddatum2(obj122, alloc_Undefined(), 1);
if (objclass122 == NULL) {
  Method *reader125 = addmethodrealflags(obj122, "value",&reader_lexer_value_125, MFLAG_DEF);
  reader125->definitionModule = modulename;
  reader125->definitionLine = 53;
}
adddatum2(obj122, alloc_Undefined(), 2);
if (objclass122 == NULL) {
  Method *reader126 = addmethodrealflags(obj122, "size",&reader_lexer_size_126, MFLAG_DEF);
  reader126->definitionModule = modulename;
  reader126->definitionLine = 54;
}
adddatum2(obj122, alloc_Undefined(), 3);
  sourceObject = obj122;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call128 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 5)
  struct UserObject *obj122_uo = (struct UserObject *)obj122;
  obj122_uo->super = call128;
  sourceObject = obj122;
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit129 == NULL) {
    strlit129 = alloc_String("string");
    gc_root(strlit129);
  }
// compiled string node returning strlit129 (depth = 5)
  adddatum2(obj122, strlit129, 1);
  sourceObject = obj122;
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj122, *var_s, 2);
  sourceObject = obj122;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num131 = alloc_Float64(1);
// compiled num node returning num131 (depth = 6)
  int op_slot_right_130 = gc_frame_newslot(num131);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_stringStart (depth = 7)
  int op_slot_right_133 = gc_frame_newslot(*var_stringStart);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_133 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_stringStart;
  partcv[0] = 1;
  Object diff135 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff135 (depth = 6)
  int op_slot_left_130 = gc_frame_newslot(diff135);
  params[0] = num131;
  partcv[0] = 1;
  Object sum136 = callmethod(diff135, "+", 1, partcv, params);
// compiled op node returning sum136 (depth = 5)
  adddatum2(obj122, sum136, 3);
  objclass122 = obj122->class;
  objclass122->definitionModule = modulename;
  objclass122->definitionLine = 50;
  (*(struct UserObject *)self).data[0] = lowerouter122;
  self = oldself122;
  selfslot = oldselfslot122;
  stackframe = oldstackframe122;
  gc_frame_end(frame);
  return obj122;
}
Object meth_lexer_new121_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_stringStart = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject122 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj122 = alloc_userobj2(4,5, objclass122);
  gc_frame_newslot(obj122);
if (objclass122 == NULL) {
  glfree(obj122->class->name);
  obj122->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj122, self, 0);
  addmethodreal(obj122,"outer", &reader_lexer_outer_123);
  Object oldself122 = self;
  struct StackFrameObject *oldstackframe122 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe122);
  gc_frame_newslot((Object)stackframe);
  self = obj122;
  Object *oldselfslot122 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter122 = (*(struct UserObject *)self).data[0], lowerouter122 = thisouter122;
  if (inheritingObject122) {
    struct UserObject *inho122 = (struct UserObject *)inheritingObject122;
    while (inho122->super != GraceDefaultObject) inho122 = (struct UserObject *)inho122->super;
    inho122->super = obj122;
    self = inheritingObject122;
    *selfslot = self;
    lowerouter122 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter122;
  }
if (objclass122 == NULL) {
  Method *reader124 = addmethodrealflags(obj122, "kind",&reader_lexer_kind_124, MFLAG_DEF);
  reader124->definitionModule = modulename;
  reader124->definitionLine = 52;
}
adddatum2(obj122, alloc_Undefined(), 1);
if (objclass122 == NULL) {
  Method *reader125 = addmethodrealflags(obj122, "value",&reader_lexer_value_125, MFLAG_DEF);
  reader125->definitionModule = modulename;
  reader125->definitionLine = 53;
}
adddatum2(obj122, alloc_Undefined(), 2);
if (objclass122 == NULL) {
  Method *reader126 = addmethodrealflags(obj122, "size",&reader_lexer_size_126, MFLAG_DEF);
  reader126->definitionModule = modulename;
  reader126->definitionLine = 54;
}
adddatum2(obj122, alloc_Undefined(), 3);
  sourceObject = obj122;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call128 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 5)
  struct UserObject *obj122_uo = (struct UserObject *)obj122;
  obj122_uo->super = call128;
  sourceObject = obj122;
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit129 == NULL) {
    strlit129 = alloc_String("string");
    gc_root(strlit129);
  }
// compiled string node returning strlit129 (depth = 5)
  adddatum2(obj122, strlit129, 1);
  sourceObject = obj122;
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj122, *var_s, 2);
  sourceObject = obj122;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num131 = alloc_Float64(1);
// compiled num node returning num131 (depth = 6)
  int op_slot_right_130 = gc_frame_newslot(num131);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_stringStart (depth = 7)
  int op_slot_right_133 = gc_frame_newslot(*var_stringStart);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_133 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_stringStart;
  partcv[0] = 1;
  Object diff135 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff135 (depth = 6)
  int op_slot_left_130 = gc_frame_newslot(diff135);
  params[0] = num131;
  partcv[0] = 1;
  Object sum136 = callmethod(diff135, "+", 1, partcv, params);
// compiled op node returning sum136 (depth = 5)
  adddatum2(obj122, sum136, 3);
  objclass122 = obj122->class;
  objclass122->definitionModule = modulename;
  objclass122->definitionLine = 50;
  (*(struct UserObject *)self).data[0] = lowerouter122;
  self = oldself122;
  selfslot = oldselfslot122;
  stackframe = oldstackframe122;
  gc_frame_end(frame);
  return obj122;
}
Object meth_lexer_line148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "line");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for line (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for line");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call150 = callmethodflags(self, "line'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe149);
// compiled call node returning call150 (depth = 6)
// compiled member node returning call150 (depth = 5)
  gc_frame_end(frame);
  return call150;
}
Object meth_lexer_linePos151(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "linePos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linePos (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for linePos");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call153 = callmethodflags(self, "linePos'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe152);
// compiled call node returning call153 (depth = 6)
// compiled member node returning call153 (depth = 5)
  gc_frame_end(frame);
  return call153;
}
Object meth_lexer_new140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startLine = getfromclosure(closure, 1);
  Object *var_stringStart = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj141 = alloc_userobj2(8,9, objclass141);
  gc_frame_newslot(obj141);
if (objclass141 == NULL) {
  glfree(obj141->class->name);
  obj141->class->name = "MultiLineStringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj141, self, 0);
  addmethodreal(obj141,"outer", &reader_lexer_outer_142);
  Object oldself141 = self;
  struct StackFrameObject *oldstackframe141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe141);
  gc_frame_newslot((Object)stackframe);
  self = obj141;
  Object *oldselfslot141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter141 = (*(struct UserObject *)self).data[0], lowerouter141 = thisouter141;
  if (inheritingObject141) {
    struct UserObject *inho141 = (struct UserObject *)inheritingObject141;
    while (inho141->super != GraceDefaultObject) inho141 = (struct UserObject *)inho141->super;
    inho141->super = obj141;
    self = inheritingObject141;
    *selfslot = self;
    lowerouter141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter141;
  }
if (objclass141 == NULL) {
  Method *reader143 = addmethodrealflags(obj141, "kind",&reader_lexer_kind_143, MFLAG_DEF);
  reader143->definitionModule = modulename;
  reader143->definitionLine = 58;
}
adddatum2(obj141, alloc_Undefined(), 1);
if (objclass141 == NULL) {
  Method *reader144 = addmethodrealflags(obj141, "value",&reader_lexer_value_144, MFLAG_DEF);
  reader144->definitionModule = modulename;
  reader144->definitionLine = 59;
}
adddatum2(obj141, alloc_Undefined(), 2);
if (objclass141 == NULL) {
  Method *reader145 = addmethodrealflags(obj141, "size",&reader_lexer_size_145, MFLAG_DEF);
  reader145->definitionModule = modulename;
  reader145->definitionLine = 60;
}
adddatum2(obj141, alloc_Undefined(), 3);
if (objclass141 == NULL) {
  Method *reader146 = addmethodrealflags(obj141, "line'",&reader_lexer_line_39__146, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader146->definitionModule = modulename;
  reader146->definitionLine = 61;
}
adddatum2(obj141, alloc_Undefined(), 4);
if (objclass141 == NULL) {
  Method *reader147 = addmethodrealflags(obj141, "linePos'",&reader_lexer_linePos_39__147, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader147->definitionModule = modulename;
  reader147->definitionLine = 62;
}
adddatum2(obj141, alloc_Undefined(), 5);
// method line
  struct UserObject *uo148 = (struct UserObject*)obj141;
  uo148->data[6] = emptyclosure;
  Method *meth_meth_lexer_line148 = addmethod2pos(obj141, "line", &meth_lexer_line148, 6);
  int argcv_meth_lexer_line148[] = {0};
  meth_meth_lexer_line148->type = alloc_MethodType(1, argcv_meth_lexer_line148);
  meth_meth_lexer_line148->definitionModule = modulename;
  meth_meth_lexer_line148->definitionLine = 63;
// method linePos
  struct UserObject *uo151 = (struct UserObject*)obj141;
  uo151->data[7] = emptyclosure;
  Method *meth_meth_lexer_linePos151 = addmethod2pos(obj141, "linePos", &meth_lexer_linePos151, 7);
  int argcv_meth_lexer_linePos151[] = {0};
  meth_meth_lexer_linePos151->type = alloc_MethodType(1, argcv_meth_lexer_linePos151);
  meth_meth_lexer_linePos151->definitionModule = modulename;
  meth_meth_lexer_linePos151->definitionLine = 64;
  sourceObject = obj141;
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe154 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call155 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe154);
// compiled call node returning call155 (depth = 5)
  struct UserObject *obj141_uo = (struct UserObject *)obj141;
  obj141_uo->super = call155;
  sourceObject = obj141;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit156 == NULL) {
    strlit156 = alloc_String("string");
    gc_root(strlit156);
  }
// compiled string node returning strlit156 (depth = 5)
  adddatum2(obj141, strlit156, 1);
  sourceObject = obj141;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj141, *var_s, 2);
  sourceObject = obj141;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num158 = alloc_Float64(2);
// compiled num node returning num158 (depth = 6)
  int op_slot_right_157 = gc_frame_newslot(num158);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call161 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe160);
// compiled call node returning call161 (depth = 7)
// compiled member node returning call161 (depth = 6)
  int op_slot_left_157 = gc_frame_newslot(call161);
  params[0] = num158;
  partcv[0] = 1;
  Object sum162 = callmethod(call161, "+", 1, partcv, params);
// compiled op node returning sum162 (depth = 5)
  adddatum2(obj141, sum162, 3);
  sourceObject = obj141;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startLine (depth = 5)
  adddatum2(obj141, *var_startLine, 4);
  sourceObject = obj141;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringStart (depth = 5)
  adddatum2(obj141, *var_stringStart, 5);
  sourceObject = obj141;
  sourceObject = obj141;
  objclass141 = obj141->class;
  objclass141->definitionModule = modulename;
  objclass141->definitionLine = 56;
  (*(struct UserObject *)self).data[0] = lowerouter141;
  self = oldself141;
  selfslot = oldselfslot141;
  stackframe = oldstackframe141;
  gc_frame_end(frame);
  return obj141;
}
Object meth_lexer_new140_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startLine = getfromclosure(closure, 1);
  Object *var_stringStart = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj141 = alloc_userobj2(8,9, objclass141);
  gc_frame_newslot(obj141);
if (objclass141 == NULL) {
  glfree(obj141->class->name);
  obj141->class->name = "MultiLineStringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj141, self, 0);
  addmethodreal(obj141,"outer", &reader_lexer_outer_142);
  Object oldself141 = self;
  struct StackFrameObject *oldstackframe141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe141);
  gc_frame_newslot((Object)stackframe);
  self = obj141;
  Object *oldselfslot141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter141 = (*(struct UserObject *)self).data[0], lowerouter141 = thisouter141;
  if (inheritingObject141) {
    struct UserObject *inho141 = (struct UserObject *)inheritingObject141;
    while (inho141->super != GraceDefaultObject) inho141 = (struct UserObject *)inho141->super;
    inho141->super = obj141;
    self = inheritingObject141;
    *selfslot = self;
    lowerouter141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter141;
  }
if (objclass141 == NULL) {
  Method *reader143 = addmethodrealflags(obj141, "kind",&reader_lexer_kind_143, MFLAG_DEF);
  reader143->definitionModule = modulename;
  reader143->definitionLine = 58;
}
adddatum2(obj141, alloc_Undefined(), 1);
if (objclass141 == NULL) {
  Method *reader144 = addmethodrealflags(obj141, "value",&reader_lexer_value_144, MFLAG_DEF);
  reader144->definitionModule = modulename;
  reader144->definitionLine = 59;
}
adddatum2(obj141, alloc_Undefined(), 2);
if (objclass141 == NULL) {
  Method *reader145 = addmethodrealflags(obj141, "size",&reader_lexer_size_145, MFLAG_DEF);
  reader145->definitionModule = modulename;
  reader145->definitionLine = 60;
}
adddatum2(obj141, alloc_Undefined(), 3);
if (objclass141 == NULL) {
  Method *reader146 = addmethodrealflags(obj141, "line'",&reader_lexer_line_39__146, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader146->definitionModule = modulename;
  reader146->definitionLine = 61;
}
adddatum2(obj141, alloc_Undefined(), 4);
if (objclass141 == NULL) {
  Method *reader147 = addmethodrealflags(obj141, "linePos'",&reader_lexer_linePos_39__147, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader147->definitionModule = modulename;
  reader147->definitionLine = 62;
}
adddatum2(obj141, alloc_Undefined(), 5);
// method line
  struct UserObject *uo148 = (struct UserObject*)obj141;
  uo148->data[6] = emptyclosure;
  Method *meth_meth_lexer_line148 = addmethod2pos(obj141, "line", &meth_lexer_line148, 6);
  int argcv_meth_lexer_line148[] = {0};
  meth_meth_lexer_line148->type = alloc_MethodType(1, argcv_meth_lexer_line148);
  meth_meth_lexer_line148->definitionModule = modulename;
  meth_meth_lexer_line148->definitionLine = 63;
// method linePos
  struct UserObject *uo151 = (struct UserObject*)obj141;
  uo151->data[7] = emptyclosure;
  Method *meth_meth_lexer_linePos151 = addmethod2pos(obj141, "linePos", &meth_lexer_linePos151, 7);
  int argcv_meth_lexer_linePos151[] = {0};
  meth_meth_lexer_linePos151->type = alloc_MethodType(1, argcv_meth_lexer_linePos151);
  meth_meth_lexer_linePos151->definitionModule = modulename;
  meth_meth_lexer_linePos151->definitionLine = 64;
  sourceObject = obj141;
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe154 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call155 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe154);
// compiled call node returning call155 (depth = 5)
  struct UserObject *obj141_uo = (struct UserObject *)obj141;
  obj141_uo->super = call155;
  sourceObject = obj141;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit156 == NULL) {
    strlit156 = alloc_String("string");
    gc_root(strlit156);
  }
// compiled string node returning strlit156 (depth = 5)
  adddatum2(obj141, strlit156, 1);
  sourceObject = obj141;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj141, *var_s, 2);
  sourceObject = obj141;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num158 = alloc_Float64(2);
// compiled num node returning num158 (depth = 6)
  int op_slot_right_157 = gc_frame_newslot(num158);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call161 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe160);
// compiled call node returning call161 (depth = 7)
// compiled member node returning call161 (depth = 6)
  int op_slot_left_157 = gc_frame_newslot(call161);
  params[0] = num158;
  partcv[0] = 1;
  Object sum162 = callmethod(call161, "+", 1, partcv, params);
// compiled op node returning sum162 (depth = 5)
  adddatum2(obj141, sum162, 3);
  sourceObject = obj141;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startLine (depth = 5)
  adddatum2(obj141, *var_startLine, 4);
  sourceObject = obj141;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringStart (depth = 5)
  adddatum2(obj141, *var_stringStart, 5);
  sourceObject = obj141;
  sourceObject = obj141;
  objclass141 = obj141->class;
  objclass141->definitionModule = modulename;
  objclass141->definitionLine = 56;
  (*(struct UserObject *)self).data[0] = lowerouter141;
  self = oldself141;
  selfslot = oldselfslot141;
  stackframe = oldstackframe141;
  gc_frame_end(frame);
  return obj141;
}
Object meth_lexer_new166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject167 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj167 = alloc_userobj2(4,5, objclass167);
  gc_frame_newslot(obj167);
if (objclass167 == NULL) {
  glfree(obj167->class->name);
  obj167->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj167, self, 0);
  addmethodreal(obj167,"outer", &reader_lexer_outer_168);
  Object oldself167 = self;
  struct StackFrameObject *oldstackframe167 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe167);
  gc_frame_newslot((Object)stackframe);
  self = obj167;
  Object *oldselfslot167 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter167 = (*(struct UserObject *)self).data[0], lowerouter167 = thisouter167;
  if (inheritingObject167) {
    struct UserObject *inho167 = (struct UserObject *)inheritingObject167;
    while (inho167->super != GraceDefaultObject) inho167 = (struct UserObject *)inho167->super;
    inho167->super = obj167;
    self = inheritingObject167;
    *selfslot = self;
    lowerouter167 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter167;
  }
if (objclass167 == NULL) {
  Method *reader169 = addmethodrealflags(obj167, "kind",&reader_lexer_kind_169, MFLAG_DEF);
  reader169->definitionModule = modulename;
  reader169->definitionLine = 68;
}
adddatum2(obj167, alloc_Undefined(), 1);
if (objclass167 == NULL) {
  Method *reader170 = addmethodrealflags(obj167, "value",&reader_lexer_value_170, MFLAG_DEF);
  reader170->definitionModule = modulename;
  reader170->definitionLine = 69;
}
adddatum2(obj167, alloc_Undefined(), 2);
if (objclass167 == NULL) {
  Method *reader171 = addmethodrealflags(obj167, "size",&reader_lexer_size_171, MFLAG_DEF);
  reader171->definitionModule = modulename;
  reader171->definitionLine = 70;
}
adddatum2(obj167, alloc_Undefined(), 3);
  sourceObject = obj167;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe172 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call173 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe172);
// compiled call node returning call173 (depth = 5)
  struct UserObject *obj167_uo = (struct UserObject *)obj167;
  obj167_uo->super = call173;
  sourceObject = obj167;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit174 == NULL) {
    strlit174 = alloc_String("comment");
    gc_root(strlit174);
  }
// compiled string node returning strlit174 (depth = 5)
  adddatum2(obj167, strlit174, 1);
  sourceObject = obj167;
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj167, *var_s, 2);
  sourceObject = obj167;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num176 = alloc_Float64(2);
// compiled num node returning num176 (depth = 6)
  int op_slot_right_175 = gc_frame_newslot(num176);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call179 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 7)
// compiled member node returning call179 (depth = 6)
  int op_slot_left_175 = gc_frame_newslot(call179);
  params[0] = num176;
  partcv[0] = 1;
  Object sum180 = callmethod(call179, "+", 1, partcv, params);
// compiled op node returning sum180 (depth = 5)
  adddatum2(obj167, sum180, 3);
  objclass167 = obj167->class;
  objclass167->definitionModule = modulename;
  objclass167->definitionLine = 66;
  (*(struct UserObject *)self).data[0] = lowerouter167;
  self = oldself167;
  selfslot = oldselfslot167;
  stackframe = oldstackframe167;
  gc_frame_end(frame);
  return obj167;
}
Object meth_lexer_new166_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject167 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj167 = alloc_userobj2(4,5, objclass167);
  gc_frame_newslot(obj167);
if (objclass167 == NULL) {
  glfree(obj167->class->name);
  obj167->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj167, self, 0);
  addmethodreal(obj167,"outer", &reader_lexer_outer_168);
  Object oldself167 = self;
  struct StackFrameObject *oldstackframe167 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe167);
  gc_frame_newslot((Object)stackframe);
  self = obj167;
  Object *oldselfslot167 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter167 = (*(struct UserObject *)self).data[0], lowerouter167 = thisouter167;
  if (inheritingObject167) {
    struct UserObject *inho167 = (struct UserObject *)inheritingObject167;
    while (inho167->super != GraceDefaultObject) inho167 = (struct UserObject *)inho167->super;
    inho167->super = obj167;
    self = inheritingObject167;
    *selfslot = self;
    lowerouter167 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter167;
  }
if (objclass167 == NULL) {
  Method *reader169 = addmethodrealflags(obj167, "kind",&reader_lexer_kind_169, MFLAG_DEF);
  reader169->definitionModule = modulename;
  reader169->definitionLine = 68;
}
adddatum2(obj167, alloc_Undefined(), 1);
if (objclass167 == NULL) {
  Method *reader170 = addmethodrealflags(obj167, "value",&reader_lexer_value_170, MFLAG_DEF);
  reader170->definitionModule = modulename;
  reader170->definitionLine = 69;
}
adddatum2(obj167, alloc_Undefined(), 2);
if (objclass167 == NULL) {
  Method *reader171 = addmethodrealflags(obj167, "size",&reader_lexer_size_171, MFLAG_DEF);
  reader171->definitionModule = modulename;
  reader171->definitionLine = 70;
}
adddatum2(obj167, alloc_Undefined(), 3);
  sourceObject = obj167;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe172 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call173 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe172);
// compiled call node returning call173 (depth = 5)
  struct UserObject *obj167_uo = (struct UserObject *)obj167;
  obj167_uo->super = call173;
  sourceObject = obj167;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit174 == NULL) {
    strlit174 = alloc_String("comment");
    gc_root(strlit174);
  }
// compiled string node returning strlit174 (depth = 5)
  adddatum2(obj167, strlit174, 1);
  sourceObject = obj167;
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  adddatum2(obj167, *var_s, 2);
  sourceObject = obj167;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num176 = alloc_Float64(2);
// compiled num node returning num176 (depth = 6)
  int op_slot_right_175 = gc_frame_newslot(num176);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call179 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 7)
// compiled member node returning call179 (depth = 6)
  int op_slot_left_175 = gc_frame_newslot(call179);
  params[0] = num176;
  partcv[0] = 1;
  Object sum180 = callmethod(call179, "+", 1, partcv, params);
// compiled op node returning sum180 (depth = 5)
  adddatum2(obj167, sum180, 3);
  objclass167 = obj167->class;
  objclass167->definitionModule = modulename;
  objclass167->definitionLine = 66;
  (*(struct UserObject *)self).data[0] = lowerouter167;
  self = oldself167;
  selfslot = oldselfslot167;
  stackframe = oldstackframe167;
  gc_frame_end(frame);
  return obj167;
}
Object meth_lexer_new184(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject185 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj185 = alloc_userobj2(4,5, objclass185);
  gc_frame_newslot(obj185);
if (objclass185 == NULL) {
  glfree(obj185->class->name);
  obj185->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj185, self, 0);
  addmethodreal(obj185,"outer", &reader_lexer_outer_186);
  Object oldself185 = self;
  struct StackFrameObject *oldstackframe185 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe185);
  gc_frame_newslot((Object)stackframe);
  self = obj185;
  Object *oldselfslot185 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter185 = (*(struct UserObject *)self).data[0], lowerouter185 = thisouter185;
  if (inheritingObject185) {
    struct UserObject *inho185 = (struct UserObject *)inheritingObject185;
    while (inho185->super != GraceDefaultObject) inho185 = (struct UserObject *)inho185->super;
    inho185->super = obj185;
    self = inheritingObject185;
    *selfslot = self;
    lowerouter185 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter185;
  }
if (objclass185 == NULL) {
  Method *reader187 = addmethodrealflags(obj185, "kind",&reader_lexer_kind_187, MFLAG_DEF);
  reader187->definitionModule = modulename;
  reader187->definitionLine = 74;
}
adddatum2(obj185, alloc_Undefined(), 1);
if (objclass185 == NULL) {
  Method *reader188 = addmethodrealflags(obj185, "value",&reader_lexer_value_188, MFLAG_DEF);
  reader188->definitionModule = modulename;
  reader188->definitionLine = 75;
}
adddatum2(obj185, alloc_Undefined(), 2);
if (objclass185 == NULL) {
  Method *reader189 = addmethodrealflags(obj185, "size",&reader_lexer_size_189, MFLAG_DEF);
  reader189->definitionModule = modulename;
  reader189->definitionLine = 76;
}
adddatum2(obj185, alloc_Undefined(), 3);
  sourceObject = obj185;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe190 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call191 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe190);
// compiled call node returning call191 (depth = 5)
  struct UserObject *obj185_uo = (struct UserObject *)obj185;
  obj185_uo->super = call191;
  sourceObject = obj185;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("lbrace");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 5)
  adddatum2(obj185, strlit192, 1);
  sourceObject = obj185;
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("{");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 5)
  adddatum2(obj185, strlit193, 2);
  sourceObject = obj185;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num194 = alloc_Float64(1);
// compiled num node returning num194 (depth = 5)
  adddatum2(obj185, num194, 3);
  objclass185 = obj185->class;
  objclass185->definitionModule = modulename;
  objclass185->definitionLine = 72;
  (*(struct UserObject *)self).data[0] = lowerouter185;
  self = oldself185;
  selfslot = oldselfslot185;
  stackframe = oldstackframe185;
  gc_frame_end(frame);
  return obj185;
}
Object meth_lexer_new184_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject185 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj185 = alloc_userobj2(4,5, objclass185);
  gc_frame_newslot(obj185);
if (objclass185 == NULL) {
  glfree(obj185->class->name);
  obj185->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj185, self, 0);
  addmethodreal(obj185,"outer", &reader_lexer_outer_186);
  Object oldself185 = self;
  struct StackFrameObject *oldstackframe185 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe185);
  gc_frame_newslot((Object)stackframe);
  self = obj185;
  Object *oldselfslot185 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter185 = (*(struct UserObject *)self).data[0], lowerouter185 = thisouter185;
  if (inheritingObject185) {
    struct UserObject *inho185 = (struct UserObject *)inheritingObject185;
    while (inho185->super != GraceDefaultObject) inho185 = (struct UserObject *)inho185->super;
    inho185->super = obj185;
    self = inheritingObject185;
    *selfslot = self;
    lowerouter185 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter185;
  }
if (objclass185 == NULL) {
  Method *reader187 = addmethodrealflags(obj185, "kind",&reader_lexer_kind_187, MFLAG_DEF);
  reader187->definitionModule = modulename;
  reader187->definitionLine = 74;
}
adddatum2(obj185, alloc_Undefined(), 1);
if (objclass185 == NULL) {
  Method *reader188 = addmethodrealflags(obj185, "value",&reader_lexer_value_188, MFLAG_DEF);
  reader188->definitionModule = modulename;
  reader188->definitionLine = 75;
}
adddatum2(obj185, alloc_Undefined(), 2);
if (objclass185 == NULL) {
  Method *reader189 = addmethodrealflags(obj185, "size",&reader_lexer_size_189, MFLAG_DEF);
  reader189->definitionModule = modulename;
  reader189->definitionLine = 76;
}
adddatum2(obj185, alloc_Undefined(), 3);
  sourceObject = obj185;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe190 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call191 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe190);
// compiled call node returning call191 (depth = 5)
  struct UserObject *obj185_uo = (struct UserObject *)obj185;
  obj185_uo->super = call191;
  sourceObject = obj185;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("lbrace");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 5)
  adddatum2(obj185, strlit192, 1);
  sourceObject = obj185;
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("{");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 5)
  adddatum2(obj185, strlit193, 2);
  sourceObject = obj185;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num194 = alloc_Float64(1);
// compiled num node returning num194 (depth = 5)
  adddatum2(obj185, num194, 3);
  objclass185 = obj185->class;
  objclass185->definitionModule = modulename;
  objclass185->definitionLine = 72;
  (*(struct UserObject *)self).data[0] = lowerouter185;
  self = oldself185;
  selfslot = oldselfslot185;
  stackframe = oldstackframe185;
  gc_frame_end(frame);
  return obj185;
}
Object meth_lexer_new198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj199 = alloc_userobj2(4,5, objclass199);
  gc_frame_newslot(obj199);
if (objclass199 == NULL) {
  glfree(obj199->class->name);
  obj199->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj199, self, 0);
  addmethodreal(obj199,"outer", &reader_lexer_outer_200);
  Object oldself199 = self;
  struct StackFrameObject *oldstackframe199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe199);
  gc_frame_newslot((Object)stackframe);
  self = obj199;
  Object *oldselfslot199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter199 = (*(struct UserObject *)self).data[0], lowerouter199 = thisouter199;
  if (inheritingObject199) {
    struct UserObject *inho199 = (struct UserObject *)inheritingObject199;
    while (inho199->super != GraceDefaultObject) inho199 = (struct UserObject *)inho199->super;
    inho199->super = obj199;
    self = inheritingObject199;
    *selfslot = self;
    lowerouter199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter199;
  }
if (objclass199 == NULL) {
  Method *reader201 = addmethodrealflags(obj199, "kind",&reader_lexer_kind_201, MFLAG_DEF);
  reader201->definitionModule = modulename;
  reader201->definitionLine = 80;
}
adddatum2(obj199, alloc_Undefined(), 1);
if (objclass199 == NULL) {
  Method *reader202 = addmethodrealflags(obj199, "value",&reader_lexer_value_202, MFLAG_DEF);
  reader202->definitionModule = modulename;
  reader202->definitionLine = 81;
}
adddatum2(obj199, alloc_Undefined(), 2);
if (objclass199 == NULL) {
  Method *reader203 = addmethodrealflags(obj199, "size",&reader_lexer_size_203, MFLAG_DEF);
  reader203->definitionModule = modulename;
  reader203->definitionLine = 82;
}
adddatum2(obj199, alloc_Undefined(), 3);
  sourceObject = obj199;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe204 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call205 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe204);
// compiled call node returning call205 (depth = 5)
  struct UserObject *obj199_uo = (struct UserObject *)obj199;
  obj199_uo->super = call205;
  sourceObject = obj199;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit206 == NULL) {
    strlit206 = alloc_String("rbrace");
    gc_root(strlit206);
  }
// compiled string node returning strlit206 (depth = 5)
  adddatum2(obj199, strlit206, 1);
  sourceObject = obj199;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit207 == NULL) {
    strlit207 = alloc_String("}");
    gc_root(strlit207);
  }
// compiled string node returning strlit207 (depth = 5)
  adddatum2(obj199, strlit207, 2);
  sourceObject = obj199;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num208 = alloc_Float64(1);
// compiled num node returning num208 (depth = 5)
  adddatum2(obj199, num208, 3);
  objclass199 = obj199->class;
  objclass199->definitionModule = modulename;
  objclass199->definitionLine = 78;
  (*(struct UserObject *)self).data[0] = lowerouter199;
  self = oldself199;
  selfslot = oldselfslot199;
  stackframe = oldstackframe199;
  gc_frame_end(frame);
  return obj199;
}
Object meth_lexer_new198_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj199 = alloc_userobj2(4,5, objclass199);
  gc_frame_newslot(obj199);
if (objclass199 == NULL) {
  glfree(obj199->class->name);
  obj199->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj199, self, 0);
  addmethodreal(obj199,"outer", &reader_lexer_outer_200);
  Object oldself199 = self;
  struct StackFrameObject *oldstackframe199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe199);
  gc_frame_newslot((Object)stackframe);
  self = obj199;
  Object *oldselfslot199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter199 = (*(struct UserObject *)self).data[0], lowerouter199 = thisouter199;
  if (inheritingObject199) {
    struct UserObject *inho199 = (struct UserObject *)inheritingObject199;
    while (inho199->super != GraceDefaultObject) inho199 = (struct UserObject *)inho199->super;
    inho199->super = obj199;
    self = inheritingObject199;
    *selfslot = self;
    lowerouter199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter199;
  }
if (objclass199 == NULL) {
  Method *reader201 = addmethodrealflags(obj199, "kind",&reader_lexer_kind_201, MFLAG_DEF);
  reader201->definitionModule = modulename;
  reader201->definitionLine = 80;
}
adddatum2(obj199, alloc_Undefined(), 1);
if (objclass199 == NULL) {
  Method *reader202 = addmethodrealflags(obj199, "value",&reader_lexer_value_202, MFLAG_DEF);
  reader202->definitionModule = modulename;
  reader202->definitionLine = 81;
}
adddatum2(obj199, alloc_Undefined(), 2);
if (objclass199 == NULL) {
  Method *reader203 = addmethodrealflags(obj199, "size",&reader_lexer_size_203, MFLAG_DEF);
  reader203->definitionModule = modulename;
  reader203->definitionLine = 82;
}
adddatum2(obj199, alloc_Undefined(), 3);
  sourceObject = obj199;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe204 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call205 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe204);
// compiled call node returning call205 (depth = 5)
  struct UserObject *obj199_uo = (struct UserObject *)obj199;
  obj199_uo->super = call205;
  sourceObject = obj199;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit206 == NULL) {
    strlit206 = alloc_String("rbrace");
    gc_root(strlit206);
  }
// compiled string node returning strlit206 (depth = 5)
  adddatum2(obj199, strlit206, 1);
  sourceObject = obj199;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit207 == NULL) {
    strlit207 = alloc_String("}");
    gc_root(strlit207);
  }
// compiled string node returning strlit207 (depth = 5)
  adddatum2(obj199, strlit207, 2);
  sourceObject = obj199;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num208 = alloc_Float64(1);
// compiled num node returning num208 (depth = 5)
  adddatum2(obj199, num208, 3);
  objclass199 = obj199->class;
  objclass199->definitionModule = modulename;
  objclass199->definitionLine = 78;
  (*(struct UserObject *)self).data[0] = lowerouter199;
  self = oldself199;
  selfslot = oldselfslot199;
  stackframe = oldstackframe199;
  gc_frame_end(frame);
  return obj199;
}
Object meth_lexer_new212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject213 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj213 = alloc_userobj2(4,5, objclass213);
  gc_frame_newslot(obj213);
if (objclass213 == NULL) {
  glfree(obj213->class->name);
  obj213->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj213, self, 0);
  addmethodreal(obj213,"outer", &reader_lexer_outer_214);
  Object oldself213 = self;
  struct StackFrameObject *oldstackframe213 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe213);
  gc_frame_newslot((Object)stackframe);
  self = obj213;
  Object *oldselfslot213 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter213 = (*(struct UserObject *)self).data[0], lowerouter213 = thisouter213;
  if (inheritingObject213) {
    struct UserObject *inho213 = (struct UserObject *)inheritingObject213;
    while (inho213->super != GraceDefaultObject) inho213 = (struct UserObject *)inho213->super;
    inho213->super = obj213;
    self = inheritingObject213;
    *selfslot = self;
    lowerouter213 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter213;
  }
if (objclass213 == NULL) {
  Method *reader215 = addmethodrealflags(obj213, "kind",&reader_lexer_kind_215, MFLAG_DEF);
  reader215->definitionModule = modulename;
  reader215->definitionLine = 86;
}
adddatum2(obj213, alloc_Undefined(), 1);
if (objclass213 == NULL) {
  Method *reader216 = addmethodrealflags(obj213, "value",&reader_lexer_value_216, MFLAG_DEF);
  reader216->definitionModule = modulename;
  reader216->definitionLine = 87;
}
adddatum2(obj213, alloc_Undefined(), 2);
if (objclass213 == NULL) {
  Method *reader217 = addmethodrealflags(obj213, "size",&reader_lexer_size_217, MFLAG_DEF);
  reader217->definitionModule = modulename;
  reader217->definitionLine = 88;
}
adddatum2(obj213, alloc_Undefined(), 3);
  sourceObject = obj213;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe218 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call219 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call219 (depth = 5)
  struct UserObject *obj213_uo = (struct UserObject *)obj213;
  obj213_uo->super = call219;
  sourceObject = obj213;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit220 == NULL) {
    strlit220 = alloc_String("lparen");
    gc_root(strlit220);
  }
// compiled string node returning strlit220 (depth = 5)
  adddatum2(obj213, strlit220, 1);
  sourceObject = obj213;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit221 == NULL) {
    strlit221 = alloc_String("(");
    gc_root(strlit221);
  }
// compiled string node returning strlit221 (depth = 5)
  adddatum2(obj213, strlit221, 2);
  sourceObject = obj213;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num222 = alloc_Float64(1);
// compiled num node returning num222 (depth = 5)
  adddatum2(obj213, num222, 3);
  objclass213 = obj213->class;
  objclass213->definitionModule = modulename;
  objclass213->definitionLine = 84;
  (*(struct UserObject *)self).data[0] = lowerouter213;
  self = oldself213;
  selfslot = oldselfslot213;
  stackframe = oldstackframe213;
  gc_frame_end(frame);
  return obj213;
}
Object meth_lexer_new212_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject213 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj213 = alloc_userobj2(4,5, objclass213);
  gc_frame_newslot(obj213);
if (objclass213 == NULL) {
  glfree(obj213->class->name);
  obj213->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj213, self, 0);
  addmethodreal(obj213,"outer", &reader_lexer_outer_214);
  Object oldself213 = self;
  struct StackFrameObject *oldstackframe213 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe213);
  gc_frame_newslot((Object)stackframe);
  self = obj213;
  Object *oldselfslot213 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter213 = (*(struct UserObject *)self).data[0], lowerouter213 = thisouter213;
  if (inheritingObject213) {
    struct UserObject *inho213 = (struct UserObject *)inheritingObject213;
    while (inho213->super != GraceDefaultObject) inho213 = (struct UserObject *)inho213->super;
    inho213->super = obj213;
    self = inheritingObject213;
    *selfslot = self;
    lowerouter213 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter213;
  }
if (objclass213 == NULL) {
  Method *reader215 = addmethodrealflags(obj213, "kind",&reader_lexer_kind_215, MFLAG_DEF);
  reader215->definitionModule = modulename;
  reader215->definitionLine = 86;
}
adddatum2(obj213, alloc_Undefined(), 1);
if (objclass213 == NULL) {
  Method *reader216 = addmethodrealflags(obj213, "value",&reader_lexer_value_216, MFLAG_DEF);
  reader216->definitionModule = modulename;
  reader216->definitionLine = 87;
}
adddatum2(obj213, alloc_Undefined(), 2);
if (objclass213 == NULL) {
  Method *reader217 = addmethodrealflags(obj213, "size",&reader_lexer_size_217, MFLAG_DEF);
  reader217->definitionModule = modulename;
  reader217->definitionLine = 88;
}
adddatum2(obj213, alloc_Undefined(), 3);
  sourceObject = obj213;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe218 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call219 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call219 (depth = 5)
  struct UserObject *obj213_uo = (struct UserObject *)obj213;
  obj213_uo->super = call219;
  sourceObject = obj213;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit220 == NULL) {
    strlit220 = alloc_String("lparen");
    gc_root(strlit220);
  }
// compiled string node returning strlit220 (depth = 5)
  adddatum2(obj213, strlit220, 1);
  sourceObject = obj213;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit221 == NULL) {
    strlit221 = alloc_String("(");
    gc_root(strlit221);
  }
// compiled string node returning strlit221 (depth = 5)
  adddatum2(obj213, strlit221, 2);
  sourceObject = obj213;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num222 = alloc_Float64(1);
// compiled num node returning num222 (depth = 5)
  adddatum2(obj213, num222, 3);
  objclass213 = obj213->class;
  objclass213->definitionModule = modulename;
  objclass213->definitionLine = 84;
  (*(struct UserObject *)self).data[0] = lowerouter213;
  self = oldself213;
  selfslot = oldselfslot213;
  stackframe = oldstackframe213;
  gc_frame_end(frame);
  return obj213;
}
Object meth_lexer_new226(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject227 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj227 = alloc_userobj2(4,5, objclass227);
  gc_frame_newslot(obj227);
if (objclass227 == NULL) {
  glfree(obj227->class->name);
  obj227->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj227, self, 0);
  addmethodreal(obj227,"outer", &reader_lexer_outer_228);
  Object oldself227 = self;
  struct StackFrameObject *oldstackframe227 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe227);
  gc_frame_newslot((Object)stackframe);
  self = obj227;
  Object *oldselfslot227 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter227 = (*(struct UserObject *)self).data[0], lowerouter227 = thisouter227;
  if (inheritingObject227) {
    struct UserObject *inho227 = (struct UserObject *)inheritingObject227;
    while (inho227->super != GraceDefaultObject) inho227 = (struct UserObject *)inho227->super;
    inho227->super = obj227;
    self = inheritingObject227;
    *selfslot = self;
    lowerouter227 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter227;
  }
if (objclass227 == NULL) {
  Method *reader229 = addmethodrealflags(obj227, "kind",&reader_lexer_kind_229, MFLAG_DEF);
  reader229->definitionModule = modulename;
  reader229->definitionLine = 92;
}
adddatum2(obj227, alloc_Undefined(), 1);
if (objclass227 == NULL) {
  Method *reader230 = addmethodrealflags(obj227, "value",&reader_lexer_value_230, MFLAG_DEF);
  reader230->definitionModule = modulename;
  reader230->definitionLine = 93;
}
adddatum2(obj227, alloc_Undefined(), 2);
if (objclass227 == NULL) {
  Method *reader231 = addmethodrealflags(obj227, "size",&reader_lexer_size_231, MFLAG_DEF);
  reader231->definitionModule = modulename;
  reader231->definitionLine = 94;
}
adddatum2(obj227, alloc_Undefined(), 3);
  sourceObject = obj227;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe232 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call233 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe232);
// compiled call node returning call233 (depth = 5)
  struct UserObject *obj227_uo = (struct UserObject *)obj227;
  obj227_uo->super = call233;
  sourceObject = obj227;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit234 == NULL) {
    strlit234 = alloc_String("rparen");
    gc_root(strlit234);
  }
// compiled string node returning strlit234 (depth = 5)
  adddatum2(obj227, strlit234, 1);
  sourceObject = obj227;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit235 == NULL) {
    strlit235 = alloc_String(")");
    gc_root(strlit235);
  }
// compiled string node returning strlit235 (depth = 5)
  adddatum2(obj227, strlit235, 2);
  sourceObject = obj227;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num236 = alloc_Float64(1);
// compiled num node returning num236 (depth = 5)
  adddatum2(obj227, num236, 3);
  objclass227 = obj227->class;
  objclass227->definitionModule = modulename;
  objclass227->definitionLine = 90;
  (*(struct UserObject *)self).data[0] = lowerouter227;
  self = oldself227;
  selfslot = oldselfslot227;
  stackframe = oldstackframe227;
  gc_frame_end(frame);
  return obj227;
}
Object meth_lexer_new226_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject227 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj227 = alloc_userobj2(4,5, objclass227);
  gc_frame_newslot(obj227);
if (objclass227 == NULL) {
  glfree(obj227->class->name);
  obj227->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj227, self, 0);
  addmethodreal(obj227,"outer", &reader_lexer_outer_228);
  Object oldself227 = self;
  struct StackFrameObject *oldstackframe227 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe227);
  gc_frame_newslot((Object)stackframe);
  self = obj227;
  Object *oldselfslot227 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter227 = (*(struct UserObject *)self).data[0], lowerouter227 = thisouter227;
  if (inheritingObject227) {
    struct UserObject *inho227 = (struct UserObject *)inheritingObject227;
    while (inho227->super != GraceDefaultObject) inho227 = (struct UserObject *)inho227->super;
    inho227->super = obj227;
    self = inheritingObject227;
    *selfslot = self;
    lowerouter227 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter227;
  }
if (objclass227 == NULL) {
  Method *reader229 = addmethodrealflags(obj227, "kind",&reader_lexer_kind_229, MFLAG_DEF);
  reader229->definitionModule = modulename;
  reader229->definitionLine = 92;
}
adddatum2(obj227, alloc_Undefined(), 1);
if (objclass227 == NULL) {
  Method *reader230 = addmethodrealflags(obj227, "value",&reader_lexer_value_230, MFLAG_DEF);
  reader230->definitionModule = modulename;
  reader230->definitionLine = 93;
}
adddatum2(obj227, alloc_Undefined(), 2);
if (objclass227 == NULL) {
  Method *reader231 = addmethodrealflags(obj227, "size",&reader_lexer_size_231, MFLAG_DEF);
  reader231->definitionModule = modulename;
  reader231->definitionLine = 94;
}
adddatum2(obj227, alloc_Undefined(), 3);
  sourceObject = obj227;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe232 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call233 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe232);
// compiled call node returning call233 (depth = 5)
  struct UserObject *obj227_uo = (struct UserObject *)obj227;
  obj227_uo->super = call233;
  sourceObject = obj227;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit234 == NULL) {
    strlit234 = alloc_String("rparen");
    gc_root(strlit234);
  }
// compiled string node returning strlit234 (depth = 5)
  adddatum2(obj227, strlit234, 1);
  sourceObject = obj227;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit235 == NULL) {
    strlit235 = alloc_String(")");
    gc_root(strlit235);
  }
// compiled string node returning strlit235 (depth = 5)
  adddatum2(obj227, strlit235, 2);
  sourceObject = obj227;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num236 = alloc_Float64(1);
// compiled num node returning num236 (depth = 5)
  adddatum2(obj227, num236, 3);
  objclass227 = obj227->class;
  objclass227->definitionModule = modulename;
  objclass227->definitionLine = 90;
  (*(struct UserObject *)self).data[0] = lowerouter227;
  self = oldself227;
  selfslot = oldselfslot227;
  stackframe = oldstackframe227;
  gc_frame_end(frame);
  return obj227;
}
Object meth_lexer_new240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject241 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj241 = alloc_userobj2(4,5, objclass241);
  gc_frame_newslot(obj241);
if (objclass241 == NULL) {
  glfree(obj241->class->name);
  obj241->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj241, self, 0);
  addmethodreal(obj241,"outer", &reader_lexer_outer_242);
  Object oldself241 = self;
  struct StackFrameObject *oldstackframe241 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe241);
  gc_frame_newslot((Object)stackframe);
  self = obj241;
  Object *oldselfslot241 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter241 = (*(struct UserObject *)self).data[0], lowerouter241 = thisouter241;
  if (inheritingObject241) {
    struct UserObject *inho241 = (struct UserObject *)inheritingObject241;
    while (inho241->super != GraceDefaultObject) inho241 = (struct UserObject *)inho241->super;
    inho241->super = obj241;
    self = inheritingObject241;
    *selfslot = self;
    lowerouter241 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter241;
  }
if (objclass241 == NULL) {
  Method *reader243 = addmethodrealflags(obj241, "kind",&reader_lexer_kind_243, MFLAG_DEF);
  reader243->definitionModule = modulename;
  reader243->definitionLine = 98;
}
adddatum2(obj241, alloc_Undefined(), 1);
if (objclass241 == NULL) {
  Method *reader244 = addmethodrealflags(obj241, "value",&reader_lexer_value_244, MFLAG_DEF);
  reader244->definitionModule = modulename;
  reader244->definitionLine = 99;
}
adddatum2(obj241, alloc_Undefined(), 2);
if (objclass241 == NULL) {
  Method *reader245 = addmethodrealflags(obj241, "size",&reader_lexer_size_245, MFLAG_DEF);
  reader245->definitionModule = modulename;
  reader245->definitionLine = 100;
}
adddatum2(obj241, alloc_Undefined(), 3);
  sourceObject = obj241;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe246 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call247 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe246);
// compiled call node returning call247 (depth = 5)
  struct UserObject *obj241_uo = (struct UserObject *)obj241;
  obj241_uo->super = call247;
  sourceObject = obj241;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit248 == NULL) {
    strlit248 = alloc_String("lsquare");
    gc_root(strlit248);
  }
// compiled string node returning strlit248 (depth = 5)
  adddatum2(obj241, strlit248, 1);
  sourceObject = obj241;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit249 == NULL) {
    strlit249 = alloc_String("[");
    gc_root(strlit249);
  }
// compiled string node returning strlit249 (depth = 5)
  adddatum2(obj241, strlit249, 2);
  sourceObject = obj241;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num250 = alloc_Float64(1);
// compiled num node returning num250 (depth = 5)
  adddatum2(obj241, num250, 3);
  objclass241 = obj241->class;
  objclass241->definitionModule = modulename;
  objclass241->definitionLine = 96;
  (*(struct UserObject *)self).data[0] = lowerouter241;
  self = oldself241;
  selfslot = oldselfslot241;
  stackframe = oldstackframe241;
  gc_frame_end(frame);
  return obj241;
}
Object meth_lexer_new240_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject241 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj241 = alloc_userobj2(4,5, objclass241);
  gc_frame_newslot(obj241);
if (objclass241 == NULL) {
  glfree(obj241->class->name);
  obj241->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj241, self, 0);
  addmethodreal(obj241,"outer", &reader_lexer_outer_242);
  Object oldself241 = self;
  struct StackFrameObject *oldstackframe241 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe241);
  gc_frame_newslot((Object)stackframe);
  self = obj241;
  Object *oldselfslot241 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter241 = (*(struct UserObject *)self).data[0], lowerouter241 = thisouter241;
  if (inheritingObject241) {
    struct UserObject *inho241 = (struct UserObject *)inheritingObject241;
    while (inho241->super != GraceDefaultObject) inho241 = (struct UserObject *)inho241->super;
    inho241->super = obj241;
    self = inheritingObject241;
    *selfslot = self;
    lowerouter241 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter241;
  }
if (objclass241 == NULL) {
  Method *reader243 = addmethodrealflags(obj241, "kind",&reader_lexer_kind_243, MFLAG_DEF);
  reader243->definitionModule = modulename;
  reader243->definitionLine = 98;
}
adddatum2(obj241, alloc_Undefined(), 1);
if (objclass241 == NULL) {
  Method *reader244 = addmethodrealflags(obj241, "value",&reader_lexer_value_244, MFLAG_DEF);
  reader244->definitionModule = modulename;
  reader244->definitionLine = 99;
}
adddatum2(obj241, alloc_Undefined(), 2);
if (objclass241 == NULL) {
  Method *reader245 = addmethodrealflags(obj241, "size",&reader_lexer_size_245, MFLAG_DEF);
  reader245->definitionModule = modulename;
  reader245->definitionLine = 100;
}
adddatum2(obj241, alloc_Undefined(), 3);
  sourceObject = obj241;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe246 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call247 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe246);
// compiled call node returning call247 (depth = 5)
  struct UserObject *obj241_uo = (struct UserObject *)obj241;
  obj241_uo->super = call247;
  sourceObject = obj241;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit248 == NULL) {
    strlit248 = alloc_String("lsquare");
    gc_root(strlit248);
  }
// compiled string node returning strlit248 (depth = 5)
  adddatum2(obj241, strlit248, 1);
  sourceObject = obj241;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit249 == NULL) {
    strlit249 = alloc_String("[");
    gc_root(strlit249);
  }
// compiled string node returning strlit249 (depth = 5)
  adddatum2(obj241, strlit249, 2);
  sourceObject = obj241;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num250 = alloc_Float64(1);
// compiled num node returning num250 (depth = 5)
  adddatum2(obj241, num250, 3);
  objclass241 = obj241->class;
  objclass241->definitionModule = modulename;
  objclass241->definitionLine = 96;
  (*(struct UserObject *)self).data[0] = lowerouter241;
  self = oldself241;
  selfslot = oldselfslot241;
  stackframe = oldstackframe241;
  gc_frame_end(frame);
  return obj241;
}
Object meth_lexer_new254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj255 = alloc_userobj2(4,5, objclass255);
  gc_frame_newslot(obj255);
if (objclass255 == NULL) {
  glfree(obj255->class->name);
  obj255->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj255, self, 0);
  addmethodreal(obj255,"outer", &reader_lexer_outer_256);
  Object oldself255 = self;
  struct StackFrameObject *oldstackframe255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe255);
  gc_frame_newslot((Object)stackframe);
  self = obj255;
  Object *oldselfslot255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter255 = (*(struct UserObject *)self).data[0], lowerouter255 = thisouter255;
  if (inheritingObject255) {
    struct UserObject *inho255 = (struct UserObject *)inheritingObject255;
    while (inho255->super != GraceDefaultObject) inho255 = (struct UserObject *)inho255->super;
    inho255->super = obj255;
    self = inheritingObject255;
    *selfslot = self;
    lowerouter255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter255;
  }
if (objclass255 == NULL) {
  Method *reader257 = addmethodrealflags(obj255, "kind",&reader_lexer_kind_257, MFLAG_DEF);
  reader257->definitionModule = modulename;
  reader257->definitionLine = 104;
}
adddatum2(obj255, alloc_Undefined(), 1);
if (objclass255 == NULL) {
  Method *reader258 = addmethodrealflags(obj255, "value",&reader_lexer_value_258, MFLAG_DEF);
  reader258->definitionModule = modulename;
  reader258->definitionLine = 105;
}
adddatum2(obj255, alloc_Undefined(), 2);
if (objclass255 == NULL) {
  Method *reader259 = addmethodrealflags(obj255, "size",&reader_lexer_size_259, MFLAG_DEF);
  reader259->definitionModule = modulename;
  reader259->definitionLine = 106;
}
adddatum2(obj255, alloc_Undefined(), 3);
  sourceObject = obj255;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe260 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call261 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe260);
// compiled call node returning call261 (depth = 5)
  struct UserObject *obj255_uo = (struct UserObject *)obj255;
  obj255_uo->super = call261;
  sourceObject = obj255;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit262 == NULL) {
    strlit262 = alloc_String("rsquare");
    gc_root(strlit262);
  }
// compiled string node returning strlit262 (depth = 5)
  adddatum2(obj255, strlit262, 1);
  sourceObject = obj255;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("]");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 5)
  adddatum2(obj255, strlit263, 2);
  sourceObject = obj255;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num264 = alloc_Float64(1);
// compiled num node returning num264 (depth = 5)
  adddatum2(obj255, num264, 3);
  objclass255 = obj255->class;
  objclass255->definitionModule = modulename;
  objclass255->definitionLine = 102;
  (*(struct UserObject *)self).data[0] = lowerouter255;
  self = oldself255;
  selfslot = oldselfslot255;
  stackframe = oldstackframe255;
  gc_frame_end(frame);
  return obj255;
}
Object meth_lexer_new254_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj255 = alloc_userobj2(4,5, objclass255);
  gc_frame_newslot(obj255);
if (objclass255 == NULL) {
  glfree(obj255->class->name);
  obj255->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj255, self, 0);
  addmethodreal(obj255,"outer", &reader_lexer_outer_256);
  Object oldself255 = self;
  struct StackFrameObject *oldstackframe255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe255);
  gc_frame_newslot((Object)stackframe);
  self = obj255;
  Object *oldselfslot255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter255 = (*(struct UserObject *)self).data[0], lowerouter255 = thisouter255;
  if (inheritingObject255) {
    struct UserObject *inho255 = (struct UserObject *)inheritingObject255;
    while (inho255->super != GraceDefaultObject) inho255 = (struct UserObject *)inho255->super;
    inho255->super = obj255;
    self = inheritingObject255;
    *selfslot = self;
    lowerouter255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter255;
  }
if (objclass255 == NULL) {
  Method *reader257 = addmethodrealflags(obj255, "kind",&reader_lexer_kind_257, MFLAG_DEF);
  reader257->definitionModule = modulename;
  reader257->definitionLine = 104;
}
adddatum2(obj255, alloc_Undefined(), 1);
if (objclass255 == NULL) {
  Method *reader258 = addmethodrealflags(obj255, "value",&reader_lexer_value_258, MFLAG_DEF);
  reader258->definitionModule = modulename;
  reader258->definitionLine = 105;
}
adddatum2(obj255, alloc_Undefined(), 2);
if (objclass255 == NULL) {
  Method *reader259 = addmethodrealflags(obj255, "size",&reader_lexer_size_259, MFLAG_DEF);
  reader259->definitionModule = modulename;
  reader259->definitionLine = 106;
}
adddatum2(obj255, alloc_Undefined(), 3);
  sourceObject = obj255;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe260 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call261 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe260);
// compiled call node returning call261 (depth = 5)
  struct UserObject *obj255_uo = (struct UserObject *)obj255;
  obj255_uo->super = call261;
  sourceObject = obj255;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit262 == NULL) {
    strlit262 = alloc_String("rsquare");
    gc_root(strlit262);
  }
// compiled string node returning strlit262 (depth = 5)
  adddatum2(obj255, strlit262, 1);
  sourceObject = obj255;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("]");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 5)
  adddatum2(obj255, strlit263, 2);
  sourceObject = obj255;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num264 = alloc_Float64(1);
// compiled num node returning num264 (depth = 5)
  adddatum2(obj255, num264, 3);
  objclass255 = obj255->class;
  objclass255->definitionModule = modulename;
  objclass255->definitionLine = 102;
  (*(struct UserObject *)self).data[0] = lowerouter255;
  self = oldself255;
  selfslot = oldselfslot255;
  stackframe = oldstackframe255;
  gc_frame_end(frame);
  return obj255;
}
Object meth_lexer_new268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject269 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj269 = alloc_userobj2(4,5, objclass269);
  gc_frame_newslot(obj269);
if (objclass269 == NULL) {
  glfree(obj269->class->name);
  obj269->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj269, self, 0);
  addmethodreal(obj269,"outer", &reader_lexer_outer_270);
  Object oldself269 = self;
  struct StackFrameObject *oldstackframe269 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe269);
  gc_frame_newslot((Object)stackframe);
  self = obj269;
  Object *oldselfslot269 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter269 = (*(struct UserObject *)self).data[0], lowerouter269 = thisouter269;
  if (inheritingObject269) {
    struct UserObject *inho269 = (struct UserObject *)inheritingObject269;
    while (inho269->super != GraceDefaultObject) inho269 = (struct UserObject *)inho269->super;
    inho269->super = obj269;
    self = inheritingObject269;
    *selfslot = self;
    lowerouter269 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter269;
  }
if (objclass269 == NULL) {
  Method *reader271 = addmethodrealflags(obj269, "kind",&reader_lexer_kind_271, MFLAG_DEF);
  reader271->definitionModule = modulename;
  reader271->definitionLine = 110;
}
adddatum2(obj269, alloc_Undefined(), 1);
if (objclass269 == NULL) {
  Method *reader272 = addmethodrealflags(obj269, "value",&reader_lexer_value_272, MFLAG_DEF);
  reader272->definitionModule = modulename;
  reader272->definitionLine = 111;
}
adddatum2(obj269, alloc_Undefined(), 2);
if (objclass269 == NULL) {
  Method *reader273 = addmethodrealflags(obj269, "size",&reader_lexer_size_273, MFLAG_DEF);
  reader273->definitionModule = modulename;
  reader273->definitionLine = 112;
}
adddatum2(obj269, alloc_Undefined(), 3);
  sourceObject = obj269;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe274 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call275 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe274);
// compiled call node returning call275 (depth = 5)
  struct UserObject *obj269_uo = (struct UserObject *)obj269;
  obj269_uo->super = call275;
  sourceObject = obj269;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit276 == NULL) {
    strlit276 = alloc_String("comma");
    gc_root(strlit276);
  }
// compiled string node returning strlit276 (depth = 5)
  adddatum2(obj269, strlit276, 1);
  sourceObject = obj269;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit277 == NULL) {
    strlit277 = alloc_String(",");
    gc_root(strlit277);
  }
// compiled string node returning strlit277 (depth = 5)
  adddatum2(obj269, strlit277, 2);
  sourceObject = obj269;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num278 = alloc_Float64(1);
// compiled num node returning num278 (depth = 5)
  adddatum2(obj269, num278, 3);
  objclass269 = obj269->class;
  objclass269->definitionModule = modulename;
  objclass269->definitionLine = 108;
  (*(struct UserObject *)self).data[0] = lowerouter269;
  self = oldself269;
  selfslot = oldselfslot269;
  stackframe = oldstackframe269;
  gc_frame_end(frame);
  return obj269;
}
Object meth_lexer_new268_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject269 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj269 = alloc_userobj2(4,5, objclass269);
  gc_frame_newslot(obj269);
if (objclass269 == NULL) {
  glfree(obj269->class->name);
  obj269->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj269, self, 0);
  addmethodreal(obj269,"outer", &reader_lexer_outer_270);
  Object oldself269 = self;
  struct StackFrameObject *oldstackframe269 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe269);
  gc_frame_newslot((Object)stackframe);
  self = obj269;
  Object *oldselfslot269 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter269 = (*(struct UserObject *)self).data[0], lowerouter269 = thisouter269;
  if (inheritingObject269) {
    struct UserObject *inho269 = (struct UserObject *)inheritingObject269;
    while (inho269->super != GraceDefaultObject) inho269 = (struct UserObject *)inho269->super;
    inho269->super = obj269;
    self = inheritingObject269;
    *selfslot = self;
    lowerouter269 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter269;
  }
if (objclass269 == NULL) {
  Method *reader271 = addmethodrealflags(obj269, "kind",&reader_lexer_kind_271, MFLAG_DEF);
  reader271->definitionModule = modulename;
  reader271->definitionLine = 110;
}
adddatum2(obj269, alloc_Undefined(), 1);
if (objclass269 == NULL) {
  Method *reader272 = addmethodrealflags(obj269, "value",&reader_lexer_value_272, MFLAG_DEF);
  reader272->definitionModule = modulename;
  reader272->definitionLine = 111;
}
adddatum2(obj269, alloc_Undefined(), 2);
if (objclass269 == NULL) {
  Method *reader273 = addmethodrealflags(obj269, "size",&reader_lexer_size_273, MFLAG_DEF);
  reader273->definitionModule = modulename;
  reader273->definitionLine = 112;
}
adddatum2(obj269, alloc_Undefined(), 3);
  sourceObject = obj269;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe274 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call275 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe274);
// compiled call node returning call275 (depth = 5)
  struct UserObject *obj269_uo = (struct UserObject *)obj269;
  obj269_uo->super = call275;
  sourceObject = obj269;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit276 == NULL) {
    strlit276 = alloc_String("comma");
    gc_root(strlit276);
  }
// compiled string node returning strlit276 (depth = 5)
  adddatum2(obj269, strlit276, 1);
  sourceObject = obj269;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit277 == NULL) {
    strlit277 = alloc_String(",");
    gc_root(strlit277);
  }
// compiled string node returning strlit277 (depth = 5)
  adddatum2(obj269, strlit277, 2);
  sourceObject = obj269;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num278 = alloc_Float64(1);
// compiled num node returning num278 (depth = 5)
  adddatum2(obj269, num278, 3);
  objclass269 = obj269->class;
  objclass269->definitionModule = modulename;
  objclass269->definitionLine = 108;
  (*(struct UserObject *)self).data[0] = lowerouter269;
  self = oldself269;
  selfslot = oldselfslot269;
  stackframe = oldstackframe269;
  gc_frame_end(frame);
  return obj269;
}
Object meth_lexer_new282(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject283 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj283 = alloc_userobj2(4,5, objclass283);
  gc_frame_newslot(obj283);
if (objclass283 == NULL) {
  glfree(obj283->class->name);
  obj283->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj283, self, 0);
  addmethodreal(obj283,"outer", &reader_lexer_outer_284);
  Object oldself283 = self;
  struct StackFrameObject *oldstackframe283 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe283);
  gc_frame_newslot((Object)stackframe);
  self = obj283;
  Object *oldselfslot283 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter283 = (*(struct UserObject *)self).data[0], lowerouter283 = thisouter283;
  if (inheritingObject283) {
    struct UserObject *inho283 = (struct UserObject *)inheritingObject283;
    while (inho283->super != GraceDefaultObject) inho283 = (struct UserObject *)inho283->super;
    inho283->super = obj283;
    self = inheritingObject283;
    *selfslot = self;
    lowerouter283 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter283;
  }
if (objclass283 == NULL) {
  Method *reader285 = addmethodrealflags(obj283, "kind",&reader_lexer_kind_285, MFLAG_DEF);
  reader285->definitionModule = modulename;
  reader285->definitionLine = 116;
}
adddatum2(obj283, alloc_Undefined(), 1);
if (objclass283 == NULL) {
  Method *reader286 = addmethodrealflags(obj283, "value",&reader_lexer_value_286, MFLAG_DEF);
  reader286->definitionModule = modulename;
  reader286->definitionLine = 117;
}
adddatum2(obj283, alloc_Undefined(), 2);
if (objclass283 == NULL) {
  Method *reader287 = addmethodrealflags(obj283, "size",&reader_lexer_size_287, MFLAG_DEF);
  reader287->definitionModule = modulename;
  reader287->definitionLine = 118;
}
adddatum2(obj283, alloc_Undefined(), 3);
  sourceObject = obj283;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe288 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call289 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe288);
// compiled call node returning call289 (depth = 5)
  struct UserObject *obj283_uo = (struct UserObject *)obj283;
  obj283_uo->super = call289;
  sourceObject = obj283;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit290 == NULL) {
    strlit290 = alloc_String("colon");
    gc_root(strlit290);
  }
// compiled string node returning strlit290 (depth = 5)
  adddatum2(obj283, strlit290, 1);
  sourceObject = obj283;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit291 == NULL) {
    strlit291 = alloc_String(":");
    gc_root(strlit291);
  }
// compiled string node returning strlit291 (depth = 5)
  adddatum2(obj283, strlit291, 2);
  sourceObject = obj283;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num292 = alloc_Float64(1);
// compiled num node returning num292 (depth = 5)
  adddatum2(obj283, num292, 3);
  objclass283 = obj283->class;
  objclass283->definitionModule = modulename;
  objclass283->definitionLine = 114;
  (*(struct UserObject *)self).data[0] = lowerouter283;
  self = oldself283;
  selfslot = oldselfslot283;
  stackframe = oldstackframe283;
  gc_frame_end(frame);
  return obj283;
}
Object meth_lexer_new282_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject283 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj283 = alloc_userobj2(4,5, objclass283);
  gc_frame_newslot(obj283);
if (objclass283 == NULL) {
  glfree(obj283->class->name);
  obj283->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj283, self, 0);
  addmethodreal(obj283,"outer", &reader_lexer_outer_284);
  Object oldself283 = self;
  struct StackFrameObject *oldstackframe283 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe283);
  gc_frame_newslot((Object)stackframe);
  self = obj283;
  Object *oldselfslot283 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter283 = (*(struct UserObject *)self).data[0], lowerouter283 = thisouter283;
  if (inheritingObject283) {
    struct UserObject *inho283 = (struct UserObject *)inheritingObject283;
    while (inho283->super != GraceDefaultObject) inho283 = (struct UserObject *)inho283->super;
    inho283->super = obj283;
    self = inheritingObject283;
    *selfslot = self;
    lowerouter283 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter283;
  }
if (objclass283 == NULL) {
  Method *reader285 = addmethodrealflags(obj283, "kind",&reader_lexer_kind_285, MFLAG_DEF);
  reader285->definitionModule = modulename;
  reader285->definitionLine = 116;
}
adddatum2(obj283, alloc_Undefined(), 1);
if (objclass283 == NULL) {
  Method *reader286 = addmethodrealflags(obj283, "value",&reader_lexer_value_286, MFLAG_DEF);
  reader286->definitionModule = modulename;
  reader286->definitionLine = 117;
}
adddatum2(obj283, alloc_Undefined(), 2);
if (objclass283 == NULL) {
  Method *reader287 = addmethodrealflags(obj283, "size",&reader_lexer_size_287, MFLAG_DEF);
  reader287->definitionModule = modulename;
  reader287->definitionLine = 118;
}
adddatum2(obj283, alloc_Undefined(), 3);
  sourceObject = obj283;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe288 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call289 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe288);
// compiled call node returning call289 (depth = 5)
  struct UserObject *obj283_uo = (struct UserObject *)obj283;
  obj283_uo->super = call289;
  sourceObject = obj283;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit290 == NULL) {
    strlit290 = alloc_String("colon");
    gc_root(strlit290);
  }
// compiled string node returning strlit290 (depth = 5)
  adddatum2(obj283, strlit290, 1);
  sourceObject = obj283;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit291 == NULL) {
    strlit291 = alloc_String(":");
    gc_root(strlit291);
  }
// compiled string node returning strlit291 (depth = 5)
  adddatum2(obj283, strlit291, 2);
  sourceObject = obj283;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num292 = alloc_Float64(1);
// compiled num node returning num292 (depth = 5)
  adddatum2(obj283, num292, 3);
  objclass283 = obj283->class;
  objclass283->definitionModule = modulename;
  objclass283->definitionLine = 114;
  (*(struct UserObject *)self).data[0] = lowerouter283;
  self = oldself283;
  selfslot = oldselfslot283;
  stackframe = oldstackframe283;
  gc_frame_end(frame);
  return obj283;
}
Object meth_lexer_new296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject297 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj297 = alloc_userobj2(4,5, objclass297);
  gc_frame_newslot(obj297);
if (objclass297 == NULL) {
  glfree(obj297->class->name);
  obj297->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj297, self, 0);
  addmethodreal(obj297,"outer", &reader_lexer_outer_298);
  Object oldself297 = self;
  struct StackFrameObject *oldstackframe297 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe297);
  gc_frame_newslot((Object)stackframe);
  self = obj297;
  Object *oldselfslot297 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter297 = (*(struct UserObject *)self).data[0], lowerouter297 = thisouter297;
  if (inheritingObject297) {
    struct UserObject *inho297 = (struct UserObject *)inheritingObject297;
    while (inho297->super != GraceDefaultObject) inho297 = (struct UserObject *)inho297->super;
    inho297->super = obj297;
    self = inheritingObject297;
    *selfslot = self;
    lowerouter297 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter297;
  }
if (objclass297 == NULL) {
  Method *reader299 = addmethodrealflags(obj297, "kind",&reader_lexer_kind_299, MFLAG_DEF);
  reader299->definitionModule = modulename;
  reader299->definitionLine = 122;
}
adddatum2(obj297, alloc_Undefined(), 1);
if (objclass297 == NULL) {
  Method *reader300 = addmethodrealflags(obj297, "value",&reader_lexer_value_300, MFLAG_DEF);
  reader300->definitionModule = modulename;
  reader300->definitionLine = 123;
}
adddatum2(obj297, alloc_Undefined(), 2);
if (objclass297 == NULL) {
  Method *reader301 = addmethodrealflags(obj297, "size",&reader_lexer_size_301, MFLAG_DEF);
  reader301->definitionModule = modulename;
  reader301->definitionLine = 124;
}
adddatum2(obj297, alloc_Undefined(), 3);
  sourceObject = obj297;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe302 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call303 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 5)
  struct UserObject *obj297_uo = (struct UserObject *)obj297;
  obj297_uo->super = call303;
  sourceObject = obj297;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit304 == NULL) {
    strlit304 = alloc_String("dot");
    gc_root(strlit304);
  }
// compiled string node returning strlit304 (depth = 5)
  adddatum2(obj297, strlit304, 1);
  sourceObject = obj297;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit305 == NULL) {
    strlit305 = alloc_String(".");
    gc_root(strlit305);
  }
// compiled string node returning strlit305 (depth = 5)
  adddatum2(obj297, strlit305, 2);
  sourceObject = obj297;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num306 = alloc_Float64(1);
// compiled num node returning num306 (depth = 5)
  adddatum2(obj297, num306, 3);
  objclass297 = obj297->class;
  objclass297->definitionModule = modulename;
  objclass297->definitionLine = 120;
  (*(struct UserObject *)self).data[0] = lowerouter297;
  self = oldself297;
  selfslot = oldselfslot297;
  stackframe = oldstackframe297;
  gc_frame_end(frame);
  return obj297;
}
Object meth_lexer_new296_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject297 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj297 = alloc_userobj2(4,5, objclass297);
  gc_frame_newslot(obj297);
if (objclass297 == NULL) {
  glfree(obj297->class->name);
  obj297->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj297, self, 0);
  addmethodreal(obj297,"outer", &reader_lexer_outer_298);
  Object oldself297 = self;
  struct StackFrameObject *oldstackframe297 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe297);
  gc_frame_newslot((Object)stackframe);
  self = obj297;
  Object *oldselfslot297 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter297 = (*(struct UserObject *)self).data[0], lowerouter297 = thisouter297;
  if (inheritingObject297) {
    struct UserObject *inho297 = (struct UserObject *)inheritingObject297;
    while (inho297->super != GraceDefaultObject) inho297 = (struct UserObject *)inho297->super;
    inho297->super = obj297;
    self = inheritingObject297;
    *selfslot = self;
    lowerouter297 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter297;
  }
if (objclass297 == NULL) {
  Method *reader299 = addmethodrealflags(obj297, "kind",&reader_lexer_kind_299, MFLAG_DEF);
  reader299->definitionModule = modulename;
  reader299->definitionLine = 122;
}
adddatum2(obj297, alloc_Undefined(), 1);
if (objclass297 == NULL) {
  Method *reader300 = addmethodrealflags(obj297, "value",&reader_lexer_value_300, MFLAG_DEF);
  reader300->definitionModule = modulename;
  reader300->definitionLine = 123;
}
adddatum2(obj297, alloc_Undefined(), 2);
if (objclass297 == NULL) {
  Method *reader301 = addmethodrealflags(obj297, "size",&reader_lexer_size_301, MFLAG_DEF);
  reader301->definitionModule = modulename;
  reader301->definitionLine = 124;
}
adddatum2(obj297, alloc_Undefined(), 3);
  sourceObject = obj297;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe302 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call303 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 5)
  struct UserObject *obj297_uo = (struct UserObject *)obj297;
  obj297_uo->super = call303;
  sourceObject = obj297;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit304 == NULL) {
    strlit304 = alloc_String("dot");
    gc_root(strlit304);
  }
// compiled string node returning strlit304 (depth = 5)
  adddatum2(obj297, strlit304, 1);
  sourceObject = obj297;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit305 == NULL) {
    strlit305 = alloc_String(".");
    gc_root(strlit305);
  }
// compiled string node returning strlit305 (depth = 5)
  adddatum2(obj297, strlit305, 2);
  sourceObject = obj297;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num306 = alloc_Float64(1);
// compiled num node returning num306 (depth = 5)
  adddatum2(obj297, num306, 3);
  objclass297 = obj297->class;
  objclass297->definitionModule = modulename;
  objclass297->definitionLine = 120;
  (*(struct UserObject *)self).data[0] = lowerouter297;
  self = oldself297;
  selfslot = oldselfslot297;
  stackframe = oldstackframe297;
  gc_frame_end(frame);
  return obj297;
}
Object meth_lexer_new310(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject311 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj311 = alloc_userobj2(5,6, objclass311);
  gc_frame_newslot(obj311);
if (objclass311 == NULL) {
  glfree(obj311->class->name);
  obj311->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj311, self, 0);
  addmethodreal(obj311,"outer", &reader_lexer_outer_312);
  Object oldself311 = self;
  struct StackFrameObject *oldstackframe311 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe311);
  gc_frame_newslot((Object)stackframe);
  self = obj311;
  Object *oldselfslot311 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter311 = (*(struct UserObject *)self).data[0], lowerouter311 = thisouter311;
  if (inheritingObject311) {
    struct UserObject *inho311 = (struct UserObject *)inheritingObject311;
    while (inho311->super != GraceDefaultObject) inho311 = (struct UserObject *)inho311->super;
    inho311->super = obj311;
    self = inheritingObject311;
    *selfslot = self;
    lowerouter311 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter311;
  }
if (objclass311 == NULL) {
  Method *reader313 = addmethodrealflags(obj311, "kind",&reader_lexer_kind_313, MFLAG_DEF);
  reader313->definitionModule = modulename;
  reader313->definitionLine = 128;
}
adddatum2(obj311, alloc_Undefined(), 1);
if (objclass311 == NULL) {
  Method *reader314 = addmethodrealflags(obj311, "value",&reader_lexer_value_314, MFLAG_DEF);
  reader314->definitionModule = modulename;
  reader314->definitionLine = 129;
}
adddatum2(obj311, alloc_Undefined(), 2);
if (objclass311 == NULL) {
  Method *reader315 = addmethodrealflags(obj311, "base",&reader_lexer_base_315, MFLAG_DEF);
  reader315->definitionModule = modulename;
  reader315->definitionLine = 130;
}
adddatum2(obj311, alloc_Undefined(), 3);
if (objclass311 == NULL) {
  Method *reader316 = addmethodrealflags(obj311, "size",&reader_lexer_size_316, MFLAG_DEF);
  reader316->definitionModule = modulename;
  reader316->definitionLine = 131;
}
adddatum2(obj311, alloc_Undefined(), 4);
  sourceObject = obj311;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe317 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call318 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe317);
// compiled call node returning call318 (depth = 5)
  struct UserObject *obj311_uo = (struct UserObject *)obj311;
  obj311_uo->super = call318;
  sourceObject = obj311;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit319 == NULL) {
    strlit319 = alloc_String("num");
    gc_root(strlit319);
  }
// compiled string node returning strlit319 (depth = 5)
  adddatum2(obj311, strlit319, 1);
  sourceObject = obj311;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj311, *var_v, 2);
  sourceObject = obj311;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  adddatum2(obj311, *var_b, 3);
  sourceObject = obj311;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  int op_slot_right_320 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  int op_slot_left_320 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff322 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff322 (depth = 5)
  adddatum2(obj311, diff322, 4);
  objclass311 = obj311->class;
  objclass311->definitionModule = modulename;
  objclass311->definitionLine = 126;
  (*(struct UserObject *)self).data[0] = lowerouter311;
  self = oldself311;
  selfslot = oldselfslot311;
  stackframe = oldstackframe311;
  gc_frame_end(frame);
  return obj311;
}
Object meth_lexer_new310_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject311 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj311 = alloc_userobj2(5,6, objclass311);
  gc_frame_newslot(obj311);
if (objclass311 == NULL) {
  glfree(obj311->class->name);
  obj311->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj311, self, 0);
  addmethodreal(obj311,"outer", &reader_lexer_outer_312);
  Object oldself311 = self;
  struct StackFrameObject *oldstackframe311 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe311);
  gc_frame_newslot((Object)stackframe);
  self = obj311;
  Object *oldselfslot311 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter311 = (*(struct UserObject *)self).data[0], lowerouter311 = thisouter311;
  if (inheritingObject311) {
    struct UserObject *inho311 = (struct UserObject *)inheritingObject311;
    while (inho311->super != GraceDefaultObject) inho311 = (struct UserObject *)inho311->super;
    inho311->super = obj311;
    self = inheritingObject311;
    *selfslot = self;
    lowerouter311 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter311;
  }
if (objclass311 == NULL) {
  Method *reader313 = addmethodrealflags(obj311, "kind",&reader_lexer_kind_313, MFLAG_DEF);
  reader313->definitionModule = modulename;
  reader313->definitionLine = 128;
}
adddatum2(obj311, alloc_Undefined(), 1);
if (objclass311 == NULL) {
  Method *reader314 = addmethodrealflags(obj311, "value",&reader_lexer_value_314, MFLAG_DEF);
  reader314->definitionModule = modulename;
  reader314->definitionLine = 129;
}
adddatum2(obj311, alloc_Undefined(), 2);
if (objclass311 == NULL) {
  Method *reader315 = addmethodrealflags(obj311, "base",&reader_lexer_base_315, MFLAG_DEF);
  reader315->definitionModule = modulename;
  reader315->definitionLine = 130;
}
adddatum2(obj311, alloc_Undefined(), 3);
if (objclass311 == NULL) {
  Method *reader316 = addmethodrealflags(obj311, "size",&reader_lexer_size_316, MFLAG_DEF);
  reader316->definitionModule = modulename;
  reader316->definitionLine = 131;
}
adddatum2(obj311, alloc_Undefined(), 4);
  sourceObject = obj311;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe317 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call318 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe317);
// compiled call node returning call318 (depth = 5)
  struct UserObject *obj311_uo = (struct UserObject *)obj311;
  obj311_uo->super = call318;
  sourceObject = obj311;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit319 == NULL) {
    strlit319 = alloc_String("num");
    gc_root(strlit319);
  }
// compiled string node returning strlit319 (depth = 5)
  adddatum2(obj311, strlit319, 1);
  sourceObject = obj311;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj311, *var_v, 2);
  sourceObject = obj311;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  adddatum2(obj311, *var_b, 3);
  sourceObject = obj311;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  int op_slot_right_320 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  int op_slot_left_320 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff322 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff322 (depth = 5)
  adddatum2(obj311, diff322, 4);
  objclass311 = obj311->class;
  objclass311->definitionModule = modulename;
  objclass311->definitionLine = 126;
  (*(struct UserObject *)self).data[0] = lowerouter311;
  self = oldself311;
  selfslot = oldselfslot311;
  stackframe = oldstackframe311;
  gc_frame_end(frame);
  return obj311;
}
Object meth_lexer_new326(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject327 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj327 = alloc_userobj2(4,5, objclass327);
  gc_frame_newslot(obj327);
if (objclass327 == NULL) {
  glfree(obj327->class->name);
  obj327->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj327, self, 0);
  addmethodreal(obj327,"outer", &reader_lexer_outer_328);
  Object oldself327 = self;
  struct StackFrameObject *oldstackframe327 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe327);
  gc_frame_newslot((Object)stackframe);
  self = obj327;
  Object *oldselfslot327 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter327 = (*(struct UserObject *)self).data[0], lowerouter327 = thisouter327;
  if (inheritingObject327) {
    struct UserObject *inho327 = (struct UserObject *)inheritingObject327;
    while (inho327->super != GraceDefaultObject) inho327 = (struct UserObject *)inho327->super;
    inho327->super = obj327;
    self = inheritingObject327;
    *selfslot = self;
    lowerouter327 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter327;
  }
if (objclass327 == NULL) {
  Method *reader329 = addmethodrealflags(obj327, "kind",&reader_lexer_kind_329, MFLAG_DEF);
  reader329->definitionModule = modulename;
  reader329->definitionLine = 135;
}
adddatum2(obj327, alloc_Undefined(), 1);
if (objclass327 == NULL) {
  Method *reader330 = addmethodrealflags(obj327, "value",&reader_lexer_value_330, MFLAG_DEF);
  reader330->definitionModule = modulename;
  reader330->definitionLine = 136;
}
adddatum2(obj327, alloc_Undefined(), 2);
if (objclass327 == NULL) {
  Method *reader331 = addmethodrealflags(obj327, "size",&reader_lexer_size_331, MFLAG_DEF);
  reader331->definitionModule = modulename;
  reader331->definitionLine = 137;
}
adddatum2(obj327, alloc_Undefined(), 3);
  sourceObject = obj327;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe332 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call333 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe332);
// compiled call node returning call333 (depth = 5)
  struct UserObject *obj327_uo = (struct UserObject *)obj327;
  obj327_uo->super = call333;
  sourceObject = obj327;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit334 == NULL) {
    strlit334 = alloc_String("keyword");
    gc_root(strlit334);
  }
// compiled string node returning strlit334 (depth = 5)
  adddatum2(obj327, strlit334, 1);
  sourceObject = obj327;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj327, *var_v, 2);
  sourceObject = obj327;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call336 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe335);
// compiled call node returning call336 (depth = 6)
// compiled member node returning call336 (depth = 5)
  adddatum2(obj327, call336, 3);
  objclass327 = obj327->class;
  objclass327->definitionModule = modulename;
  objclass327->definitionLine = 133;
  (*(struct UserObject *)self).data[0] = lowerouter327;
  self = oldself327;
  selfslot = oldselfslot327;
  stackframe = oldstackframe327;
  gc_frame_end(frame);
  return obj327;
}
Object meth_lexer_new326_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject327 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj327 = alloc_userobj2(4,5, objclass327);
  gc_frame_newslot(obj327);
if (objclass327 == NULL) {
  glfree(obj327->class->name);
  obj327->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj327, self, 0);
  addmethodreal(obj327,"outer", &reader_lexer_outer_328);
  Object oldself327 = self;
  struct StackFrameObject *oldstackframe327 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe327);
  gc_frame_newslot((Object)stackframe);
  self = obj327;
  Object *oldselfslot327 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter327 = (*(struct UserObject *)self).data[0], lowerouter327 = thisouter327;
  if (inheritingObject327) {
    struct UserObject *inho327 = (struct UserObject *)inheritingObject327;
    while (inho327->super != GraceDefaultObject) inho327 = (struct UserObject *)inho327->super;
    inho327->super = obj327;
    self = inheritingObject327;
    *selfslot = self;
    lowerouter327 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter327;
  }
if (objclass327 == NULL) {
  Method *reader329 = addmethodrealflags(obj327, "kind",&reader_lexer_kind_329, MFLAG_DEF);
  reader329->definitionModule = modulename;
  reader329->definitionLine = 135;
}
adddatum2(obj327, alloc_Undefined(), 1);
if (objclass327 == NULL) {
  Method *reader330 = addmethodrealflags(obj327, "value",&reader_lexer_value_330, MFLAG_DEF);
  reader330->definitionModule = modulename;
  reader330->definitionLine = 136;
}
adddatum2(obj327, alloc_Undefined(), 2);
if (objclass327 == NULL) {
  Method *reader331 = addmethodrealflags(obj327, "size",&reader_lexer_size_331, MFLAG_DEF);
  reader331->definitionModule = modulename;
  reader331->definitionLine = 137;
}
adddatum2(obj327, alloc_Undefined(), 3);
  sourceObject = obj327;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe332 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call333 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe332);
// compiled call node returning call333 (depth = 5)
  struct UserObject *obj327_uo = (struct UserObject *)obj327;
  obj327_uo->super = call333;
  sourceObject = obj327;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit334 == NULL) {
    strlit334 = alloc_String("keyword");
    gc_root(strlit334);
  }
// compiled string node returning strlit334 (depth = 5)
  adddatum2(obj327, strlit334, 1);
  sourceObject = obj327;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj327, *var_v, 2);
  sourceObject = obj327;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call336 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe335);
// compiled call node returning call336 (depth = 6)
// compiled member node returning call336 (depth = 5)
  adddatum2(obj327, call336, 3);
  objclass327 = obj327->class;
  objclass327->definitionModule = modulename;
  objclass327->definitionLine = 133;
  (*(struct UserObject *)self).data[0] = lowerouter327;
  self = oldself327;
  selfslot = oldselfslot327;
  stackframe = oldstackframe327;
  gc_frame_end(frame);
  return obj327;
}
Object meth_lexer_new340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj341 = alloc_userobj2(4,5, objclass341);
  gc_frame_newslot(obj341);
if (objclass341 == NULL) {
  glfree(obj341->class->name);
  obj341->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj341, self, 0);
  addmethodreal(obj341,"outer", &reader_lexer_outer_342);
  Object oldself341 = self;
  struct StackFrameObject *oldstackframe341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe341);
  gc_frame_newslot((Object)stackframe);
  self = obj341;
  Object *oldselfslot341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter341 = (*(struct UserObject *)self).data[0], lowerouter341 = thisouter341;
  if (inheritingObject341) {
    struct UserObject *inho341 = (struct UserObject *)inheritingObject341;
    while (inho341->super != GraceDefaultObject) inho341 = (struct UserObject *)inho341->super;
    inho341->super = obj341;
    self = inheritingObject341;
    *selfslot = self;
    lowerouter341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter341;
  }
if (objclass341 == NULL) {
  Method *reader343 = addmethodrealflags(obj341, "kind",&reader_lexer_kind_343, MFLAG_DEF);
  reader343->definitionModule = modulename;
  reader343->definitionLine = 141;
}
adddatum2(obj341, alloc_Undefined(), 1);
if (objclass341 == NULL) {
  Method *reader344 = addmethodrealflags(obj341, "value",&reader_lexer_value_344, MFLAG_DEF);
  reader344->definitionModule = modulename;
  reader344->definitionLine = 142;
}
adddatum2(obj341, alloc_Undefined(), 2);
if (objclass341 == NULL) {
  Method *reader345 = addmethodrealflags(obj341, "size",&reader_lexer_size_345, MFLAG_DEF);
  reader345->definitionModule = modulename;
  reader345->definitionLine = 143;
}
adddatum2(obj341, alloc_Undefined(), 3);
  sourceObject = obj341;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe346 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call347 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe346);
// compiled call node returning call347 (depth = 5)
  struct UserObject *obj341_uo = (struct UserObject *)obj341;
  obj341_uo->super = call347;
  sourceObject = obj341;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("op");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 5)
  adddatum2(obj341, strlit348, 1);
  sourceObject = obj341;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj341, *var_v, 2);
  sourceObject = obj341;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe349 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call350 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe349);
// compiled call node returning call350 (depth = 6)
// compiled member node returning call350 (depth = 5)
  adddatum2(obj341, call350, 3);
  objclass341 = obj341->class;
  objclass341->definitionModule = modulename;
  objclass341->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter341;
  self = oldself341;
  selfslot = oldselfslot341;
  stackframe = oldstackframe341;
  gc_frame_end(frame);
  return obj341;
}
Object meth_lexer_new340_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj341 = alloc_userobj2(4,5, objclass341);
  gc_frame_newslot(obj341);
if (objclass341 == NULL) {
  glfree(obj341->class->name);
  obj341->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj341, self, 0);
  addmethodreal(obj341,"outer", &reader_lexer_outer_342);
  Object oldself341 = self;
  struct StackFrameObject *oldstackframe341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe341);
  gc_frame_newslot((Object)stackframe);
  self = obj341;
  Object *oldselfslot341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter341 = (*(struct UserObject *)self).data[0], lowerouter341 = thisouter341;
  if (inheritingObject341) {
    struct UserObject *inho341 = (struct UserObject *)inheritingObject341;
    while (inho341->super != GraceDefaultObject) inho341 = (struct UserObject *)inho341->super;
    inho341->super = obj341;
    self = inheritingObject341;
    *selfslot = self;
    lowerouter341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter341;
  }
if (objclass341 == NULL) {
  Method *reader343 = addmethodrealflags(obj341, "kind",&reader_lexer_kind_343, MFLAG_DEF);
  reader343->definitionModule = modulename;
  reader343->definitionLine = 141;
}
adddatum2(obj341, alloc_Undefined(), 1);
if (objclass341 == NULL) {
  Method *reader344 = addmethodrealflags(obj341, "value",&reader_lexer_value_344, MFLAG_DEF);
  reader344->definitionModule = modulename;
  reader344->definitionLine = 142;
}
adddatum2(obj341, alloc_Undefined(), 2);
if (objclass341 == NULL) {
  Method *reader345 = addmethodrealflags(obj341, "size",&reader_lexer_size_345, MFLAG_DEF);
  reader345->definitionModule = modulename;
  reader345->definitionLine = 143;
}
adddatum2(obj341, alloc_Undefined(), 3);
  sourceObject = obj341;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe346 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call347 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe346);
// compiled call node returning call347 (depth = 5)
  struct UserObject *obj341_uo = (struct UserObject *)obj341;
  obj341_uo->super = call347;
  sourceObject = obj341;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("op");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 5)
  adddatum2(obj341, strlit348, 1);
  sourceObject = obj341;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  adddatum2(obj341, *var_v, 2);
  sourceObject = obj341;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe349 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call350 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe349);
// compiled call node returning call350 (depth = 6)
// compiled member node returning call350 (depth = 5)
  adddatum2(obj341, call350, 3);
  objclass341 = obj341->class;
  objclass341->definitionModule = modulename;
  objclass341->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter341;
  self = oldself341;
  selfslot = oldselfslot341;
  stackframe = oldstackframe341;
  gc_frame_end(frame);
  return obj341;
}
Object meth_lexer_new354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject355 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj355 = alloc_userobj2(4,5, objclass355);
  gc_frame_newslot(obj355);
if (objclass355 == NULL) {
  glfree(obj355->class->name);
  obj355->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj355, self, 0);
  addmethodreal(obj355,"outer", &reader_lexer_outer_356);
  Object oldself355 = self;
  struct StackFrameObject *oldstackframe355 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe355);
  gc_frame_newslot((Object)stackframe);
  self = obj355;
  Object *oldselfslot355 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter355 = (*(struct UserObject *)self).data[0], lowerouter355 = thisouter355;
  if (inheritingObject355) {
    struct UserObject *inho355 = (struct UserObject *)inheritingObject355;
    while (inho355->super != GraceDefaultObject) inho355 = (struct UserObject *)inho355->super;
    inho355->super = obj355;
    self = inheritingObject355;
    *selfslot = self;
    lowerouter355 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter355;
  }
if (objclass355 == NULL) {
  Method *reader357 = addmethodrealflags(obj355, "kind",&reader_lexer_kind_357, MFLAG_DEF);
  reader357->definitionModule = modulename;
  reader357->definitionLine = 147;
}
adddatum2(obj355, alloc_Undefined(), 1);
if (objclass355 == NULL) {
  Method *reader358 = addmethodrealflags(obj355, "value",&reader_lexer_value_358, MFLAG_DEF);
  reader358->definitionModule = modulename;
  reader358->definitionLine = 148;
}
adddatum2(obj355, alloc_Undefined(), 2);
if (objclass355 == NULL) {
  Method *reader359 = addmethodrealflags(obj355, "size",&reader_lexer_size_359, MFLAG_DEF);
  reader359->definitionModule = modulename;
  reader359->definitionLine = 149;
}
adddatum2(obj355, alloc_Undefined(), 3);
  sourceObject = obj355;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe360 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call361 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call361 (depth = 5)
  struct UserObject *obj355_uo = (struct UserObject *)obj355;
  obj355_uo->super = call361;
  sourceObject = obj355;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit362 == NULL) {
    strlit362 = alloc_String("arrow");
    gc_root(strlit362);
  }
// compiled string node returning strlit362 (depth = 5)
  adddatum2(obj355, strlit362, 1);
  sourceObject = obj355;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit363 == NULL) {
    strlit363 = alloc_String("->");
    gc_root(strlit363);
  }
// compiled string node returning strlit363 (depth = 5)
  adddatum2(obj355, strlit363, 2);
  sourceObject = obj355;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num364 = alloc_Float64(2);
// compiled num node returning num364 (depth = 5)
  adddatum2(obj355, num364, 3);
  objclass355 = obj355->class;
  objclass355->definitionModule = modulename;
  objclass355->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter355;
  self = oldself355;
  selfslot = oldselfslot355;
  stackframe = oldstackframe355;
  gc_frame_end(frame);
  return obj355;
}
Object meth_lexer_new354_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject355 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj355 = alloc_userobj2(4,5, objclass355);
  gc_frame_newslot(obj355);
if (objclass355 == NULL) {
  glfree(obj355->class->name);
  obj355->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj355, self, 0);
  addmethodreal(obj355,"outer", &reader_lexer_outer_356);
  Object oldself355 = self;
  struct StackFrameObject *oldstackframe355 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe355);
  gc_frame_newslot((Object)stackframe);
  self = obj355;
  Object *oldselfslot355 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter355 = (*(struct UserObject *)self).data[0], lowerouter355 = thisouter355;
  if (inheritingObject355) {
    struct UserObject *inho355 = (struct UserObject *)inheritingObject355;
    while (inho355->super != GraceDefaultObject) inho355 = (struct UserObject *)inho355->super;
    inho355->super = obj355;
    self = inheritingObject355;
    *selfslot = self;
    lowerouter355 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter355;
  }
if (objclass355 == NULL) {
  Method *reader357 = addmethodrealflags(obj355, "kind",&reader_lexer_kind_357, MFLAG_DEF);
  reader357->definitionModule = modulename;
  reader357->definitionLine = 147;
}
adddatum2(obj355, alloc_Undefined(), 1);
if (objclass355 == NULL) {
  Method *reader358 = addmethodrealflags(obj355, "value",&reader_lexer_value_358, MFLAG_DEF);
  reader358->definitionModule = modulename;
  reader358->definitionLine = 148;
}
adddatum2(obj355, alloc_Undefined(), 2);
if (objclass355 == NULL) {
  Method *reader359 = addmethodrealflags(obj355, "size",&reader_lexer_size_359, MFLAG_DEF);
  reader359->definitionModule = modulename;
  reader359->definitionLine = 149;
}
adddatum2(obj355, alloc_Undefined(), 3);
  sourceObject = obj355;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe360 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call361 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call361 (depth = 5)
  struct UserObject *obj355_uo = (struct UserObject *)obj355;
  obj355_uo->super = call361;
  sourceObject = obj355;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit362 == NULL) {
    strlit362 = alloc_String("arrow");
    gc_root(strlit362);
  }
// compiled string node returning strlit362 (depth = 5)
  adddatum2(obj355, strlit362, 1);
  sourceObject = obj355;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit363 == NULL) {
    strlit363 = alloc_String("->");
    gc_root(strlit363);
  }
// compiled string node returning strlit363 (depth = 5)
  adddatum2(obj355, strlit363, 2);
  sourceObject = obj355;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num364 = alloc_Float64(2);
// compiled num node returning num364 (depth = 5)
  adddatum2(obj355, num364, 3);
  objclass355 = obj355->class;
  objclass355->definitionModule = modulename;
  objclass355->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter355;
  self = oldself355;
  selfslot = oldselfslot355;
  stackframe = oldstackframe355;
  gc_frame_end(frame);
  return obj355;
}
Object meth_lexer_new368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject369 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj369 = alloc_userobj2(4,5, objclass369);
  gc_frame_newslot(obj369);
if (objclass369 == NULL) {
  glfree(obj369->class->name);
  obj369->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj369, self, 0);
  addmethodreal(obj369,"outer", &reader_lexer_outer_370);
  Object oldself369 = self;
  struct StackFrameObject *oldstackframe369 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe369);
  gc_frame_newslot((Object)stackframe);
  self = obj369;
  Object *oldselfslot369 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter369 = (*(struct UserObject *)self).data[0], lowerouter369 = thisouter369;
  if (inheritingObject369) {
    struct UserObject *inho369 = (struct UserObject *)inheritingObject369;
    while (inho369->super != GraceDefaultObject) inho369 = (struct UserObject *)inho369->super;
    inho369->super = obj369;
    self = inheritingObject369;
    *selfslot = self;
    lowerouter369 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter369;
  }
if (objclass369 == NULL) {
  Method *reader371 = addmethodrealflags(obj369, "kind",&reader_lexer_kind_371, MFLAG_DEF);
  reader371->definitionModule = modulename;
  reader371->definitionLine = 153;
}
adddatum2(obj369, alloc_Undefined(), 1);
if (objclass369 == NULL) {
  Method *reader372 = addmethodrealflags(obj369, "value",&reader_lexer_value_372, MFLAG_DEF);
  reader372->definitionModule = modulename;
  reader372->definitionLine = 154;
}
adddatum2(obj369, alloc_Undefined(), 2);
if (objclass369 == NULL) {
  Method *reader373 = addmethodrealflags(obj369, "size",&reader_lexer_size_373, MFLAG_DEF);
  reader373->definitionModule = modulename;
  reader373->definitionLine = 155;
}
adddatum2(obj369, alloc_Undefined(), 3);
  sourceObject = obj369;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe374 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compiled call node returning call375 (depth = 5)
  struct UserObject *obj369_uo = (struct UserObject *)obj369;
  obj369_uo->super = call375;
  sourceObject = obj369;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit376 == NULL) {
    strlit376 = alloc_String("bind");
    gc_root(strlit376);
  }
// compiled string node returning strlit376 (depth = 5)
  adddatum2(obj369, strlit376, 1);
  sourceObject = obj369;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit377 == NULL) {
    strlit377 = alloc_String(":=");
    gc_root(strlit377);
  }
// compiled string node returning strlit377 (depth = 5)
  adddatum2(obj369, strlit377, 2);
  sourceObject = obj369;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num378 = alloc_Float64(2);
// compiled num node returning num378 (depth = 5)
  adddatum2(obj369, num378, 3);
  objclass369 = obj369->class;
  objclass369->definitionModule = modulename;
  objclass369->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter369;
  self = oldself369;
  selfslot = oldselfslot369;
  stackframe = oldstackframe369;
  gc_frame_end(frame);
  return obj369;
}
Object meth_lexer_new368_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject369 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj369 = alloc_userobj2(4,5, objclass369);
  gc_frame_newslot(obj369);
if (objclass369 == NULL) {
  glfree(obj369->class->name);
  obj369->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj369, self, 0);
  addmethodreal(obj369,"outer", &reader_lexer_outer_370);
  Object oldself369 = self;
  struct StackFrameObject *oldstackframe369 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe369);
  gc_frame_newslot((Object)stackframe);
  self = obj369;
  Object *oldselfslot369 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter369 = (*(struct UserObject *)self).data[0], lowerouter369 = thisouter369;
  if (inheritingObject369) {
    struct UserObject *inho369 = (struct UserObject *)inheritingObject369;
    while (inho369->super != GraceDefaultObject) inho369 = (struct UserObject *)inho369->super;
    inho369->super = obj369;
    self = inheritingObject369;
    *selfslot = self;
    lowerouter369 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter369;
  }
if (objclass369 == NULL) {
  Method *reader371 = addmethodrealflags(obj369, "kind",&reader_lexer_kind_371, MFLAG_DEF);
  reader371->definitionModule = modulename;
  reader371->definitionLine = 153;
}
adddatum2(obj369, alloc_Undefined(), 1);
if (objclass369 == NULL) {
  Method *reader372 = addmethodrealflags(obj369, "value",&reader_lexer_value_372, MFLAG_DEF);
  reader372->definitionModule = modulename;
  reader372->definitionLine = 154;
}
adddatum2(obj369, alloc_Undefined(), 2);
if (objclass369 == NULL) {
  Method *reader373 = addmethodrealflags(obj369, "size",&reader_lexer_size_373, MFLAG_DEF);
  reader373->definitionModule = modulename;
  reader373->definitionLine = 155;
}
adddatum2(obj369, alloc_Undefined(), 3);
  sourceObject = obj369;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe374 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compiled call node returning call375 (depth = 5)
  struct UserObject *obj369_uo = (struct UserObject *)obj369;
  obj369_uo->super = call375;
  sourceObject = obj369;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit376 == NULL) {
    strlit376 = alloc_String("bind");
    gc_root(strlit376);
  }
// compiled string node returning strlit376 (depth = 5)
  adddatum2(obj369, strlit376, 1);
  sourceObject = obj369;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit377 == NULL) {
    strlit377 = alloc_String(":=");
    gc_root(strlit377);
  }
// compiled string node returning strlit377 (depth = 5)
  adddatum2(obj369, strlit377, 2);
  sourceObject = obj369;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num378 = alloc_Float64(2);
// compiled num node returning num378 (depth = 5)
  adddatum2(obj369, num378, 3);
  objclass369 = obj369->class;
  objclass369->definitionModule = modulename;
  objclass369->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter369;
  self = oldself369;
  selfslot = oldselfslot369;
  stackframe = oldstackframe369;
  gc_frame_end(frame);
  return obj369;
}
Object meth_lexer_new382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject383 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj383 = alloc_userobj2(4,5, objclass383);
  gc_frame_newslot(obj383);
if (objclass383 == NULL) {
  glfree(obj383->class->name);
  obj383->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj383, self, 0);
  addmethodreal(obj383,"outer", &reader_lexer_outer_384);
  Object oldself383 = self;
  struct StackFrameObject *oldstackframe383 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe383);
  gc_frame_newslot((Object)stackframe);
  self = obj383;
  Object *oldselfslot383 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter383 = (*(struct UserObject *)self).data[0], lowerouter383 = thisouter383;
  if (inheritingObject383) {
    struct UserObject *inho383 = (struct UserObject *)inheritingObject383;
    while (inho383->super != GraceDefaultObject) inho383 = (struct UserObject *)inho383->super;
    inho383->super = obj383;
    self = inheritingObject383;
    *selfslot = self;
    lowerouter383 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter383;
  }
if (objclass383 == NULL) {
  Method *reader385 = addmethodrealflags(obj383, "kind",&reader_lexer_kind_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 159;
}
adddatum2(obj383, alloc_Undefined(), 1);
if (objclass383 == NULL) {
  Method *reader386 = addmethodrealflags(obj383, "value",&reader_lexer_value_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 160;
}
adddatum2(obj383, alloc_Undefined(), 2);
if (objclass383 == NULL) {
  Method *reader387 = addmethodrealflags(obj383, "size",&reader_lexer_size_387, MFLAG_DEF);
  reader387->definitionModule = modulename;
  reader387->definitionLine = 161;
}
adddatum2(obj383, alloc_Undefined(), 3);
  sourceObject = obj383;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe388 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call389 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe388);
// compiled call node returning call389 (depth = 5)
  struct UserObject *obj383_uo = (struct UserObject *)obj383;
  obj383_uo->super = call389;
  sourceObject = obj383;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit390 == NULL) {
    strlit390 = alloc_String("semicolon");
    gc_root(strlit390);
  }
// compiled string node returning strlit390 (depth = 5)
  adddatum2(obj383, strlit390, 1);
  sourceObject = obj383;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit391 == NULL) {
    strlit391 = alloc_String(";");
    gc_root(strlit391);
  }
// compiled string node returning strlit391 (depth = 5)
  adddatum2(obj383, strlit391, 2);
  sourceObject = obj383;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num392 = alloc_Float64(1);
// compiled num node returning num392 (depth = 5)
  adddatum2(obj383, num392, 3);
  objclass383 = obj383->class;
  objclass383->definitionModule = modulename;
  objclass383->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter383;
  self = oldself383;
  selfslot = oldselfslot383;
  stackframe = oldstackframe383;
  gc_frame_end(frame);
  return obj383;
}
Object meth_lexer_new382_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject383 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj383 = alloc_userobj2(4,5, objclass383);
  gc_frame_newslot(obj383);
if (objclass383 == NULL) {
  glfree(obj383->class->name);
  obj383->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj383, self, 0);
  addmethodreal(obj383,"outer", &reader_lexer_outer_384);
  Object oldself383 = self;
  struct StackFrameObject *oldstackframe383 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe383);
  gc_frame_newslot((Object)stackframe);
  self = obj383;
  Object *oldselfslot383 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter383 = (*(struct UserObject *)self).data[0], lowerouter383 = thisouter383;
  if (inheritingObject383) {
    struct UserObject *inho383 = (struct UserObject *)inheritingObject383;
    while (inho383->super != GraceDefaultObject) inho383 = (struct UserObject *)inho383->super;
    inho383->super = obj383;
    self = inheritingObject383;
    *selfslot = self;
    lowerouter383 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter383;
  }
if (objclass383 == NULL) {
  Method *reader385 = addmethodrealflags(obj383, "kind",&reader_lexer_kind_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 159;
}
adddatum2(obj383, alloc_Undefined(), 1);
if (objclass383 == NULL) {
  Method *reader386 = addmethodrealflags(obj383, "value",&reader_lexer_value_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 160;
}
adddatum2(obj383, alloc_Undefined(), 2);
if (objclass383 == NULL) {
  Method *reader387 = addmethodrealflags(obj383, "size",&reader_lexer_size_387, MFLAG_DEF);
  reader387->definitionModule = modulename;
  reader387->definitionLine = 161;
}
adddatum2(obj383, alloc_Undefined(), 3);
  sourceObject = obj383;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe388 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call389 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe388);
// compiled call node returning call389 (depth = 5)
  struct UserObject *obj383_uo = (struct UserObject *)obj383;
  obj383_uo->super = call389;
  sourceObject = obj383;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit390 == NULL) {
    strlit390 = alloc_String("semicolon");
    gc_root(strlit390);
  }
// compiled string node returning strlit390 (depth = 5)
  adddatum2(obj383, strlit390, 1);
  sourceObject = obj383;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit391 == NULL) {
    strlit391 = alloc_String(";");
    gc_root(strlit391);
  }
// compiled string node returning strlit391 (depth = 5)
  adddatum2(obj383, strlit391, 2);
  sourceObject = obj383;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num392 = alloc_Float64(1);
// compiled num node returning num392 (depth = 5)
  adddatum2(obj383, num392, 3);
  objclass383 = obj383->class;
  objclass383->definitionModule = modulename;
  objclass383->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter383;
  self = oldself383;
  selfslot = oldselfslot383;
  stackframe = oldstackframe383;
  gc_frame_end(frame);
  return obj383;
}
Object meth_lexer_new396(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject397 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj397 = alloc_userobj2(4,5, objclass397);
  gc_frame_newslot(obj397);
if (objclass397 == NULL) {
  glfree(obj397->class->name);
  obj397->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj397, self, 0);
  addmethodreal(obj397,"outer", &reader_lexer_outer_398);
  Object oldself397 = self;
  struct StackFrameObject *oldstackframe397 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe397);
  gc_frame_newslot((Object)stackframe);
  self = obj397;
  Object *oldselfslot397 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter397 = (*(struct UserObject *)self).data[0], lowerouter397 = thisouter397;
  if (inheritingObject397) {
    struct UserObject *inho397 = (struct UserObject *)inheritingObject397;
    while (inho397->super != GraceDefaultObject) inho397 = (struct UserObject *)inho397->super;
    inho397->super = obj397;
    self = inheritingObject397;
    *selfslot = self;
    lowerouter397 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter397;
  }
if (objclass397 == NULL) {
  Method *reader399 = addmethodrealflags(obj397, "kind",&reader_lexer_kind_399, MFLAG_DEF);
  reader399->definitionModule = modulename;
  reader399->definitionLine = 165;
}
adddatum2(obj397, alloc_Undefined(), 1);
if (objclass397 == NULL) {
  Method *reader400 = addmethodrealflags(obj397, "value",&reader_lexer_value_400, MFLAG_DEF);
  reader400->definitionModule = modulename;
  reader400->definitionLine = 166;
}
adddatum2(obj397, alloc_Undefined(), 2);
if (objclass397 == NULL) {
  Method *reader401 = addmethodrealflags(obj397, "size",&reader_lexer_size_401, MFLAG_DEF);
  reader401->definitionModule = modulename;
  reader401->definitionLine = 167;
}
adddatum2(obj397, alloc_Undefined(), 3);
  sourceObject = obj397;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call403 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe402);
// compiled call node returning call403 (depth = 5)
  struct UserObject *obj397_uo = (struct UserObject *)obj397;
  obj397_uo->super = call403;
  sourceObject = obj397;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit404 == NULL) {
    strlit404 = alloc_String("lgeneric");
    gc_root(strlit404);
  }
// compiled string node returning strlit404 (depth = 5)
  adddatum2(obj397, strlit404, 1);
  sourceObject = obj397;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit405 == NULL) {
    strlit405 = alloc_String("<");
    gc_root(strlit405);
  }
// compiled string node returning strlit405 (depth = 5)
  adddatum2(obj397, strlit405, 2);
  sourceObject = obj397;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num406 = alloc_Float64(1);
// compiled num node returning num406 (depth = 5)
  adddatum2(obj397, num406, 3);
  objclass397 = obj397->class;
  objclass397->definitionModule = modulename;
  objclass397->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter397;
  self = oldself397;
  selfslot = oldselfslot397;
  stackframe = oldstackframe397;
  gc_frame_end(frame);
  return obj397;
}
Object meth_lexer_new396_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject397 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj397 = alloc_userobj2(4,5, objclass397);
  gc_frame_newslot(obj397);
if (objclass397 == NULL) {
  glfree(obj397->class->name);
  obj397->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj397, self, 0);
  addmethodreal(obj397,"outer", &reader_lexer_outer_398);
  Object oldself397 = self;
  struct StackFrameObject *oldstackframe397 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe397);
  gc_frame_newslot((Object)stackframe);
  self = obj397;
  Object *oldselfslot397 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter397 = (*(struct UserObject *)self).data[0], lowerouter397 = thisouter397;
  if (inheritingObject397) {
    struct UserObject *inho397 = (struct UserObject *)inheritingObject397;
    while (inho397->super != GraceDefaultObject) inho397 = (struct UserObject *)inho397->super;
    inho397->super = obj397;
    self = inheritingObject397;
    *selfslot = self;
    lowerouter397 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter397;
  }
if (objclass397 == NULL) {
  Method *reader399 = addmethodrealflags(obj397, "kind",&reader_lexer_kind_399, MFLAG_DEF);
  reader399->definitionModule = modulename;
  reader399->definitionLine = 165;
}
adddatum2(obj397, alloc_Undefined(), 1);
if (objclass397 == NULL) {
  Method *reader400 = addmethodrealflags(obj397, "value",&reader_lexer_value_400, MFLAG_DEF);
  reader400->definitionModule = modulename;
  reader400->definitionLine = 166;
}
adddatum2(obj397, alloc_Undefined(), 2);
if (objclass397 == NULL) {
  Method *reader401 = addmethodrealflags(obj397, "size",&reader_lexer_size_401, MFLAG_DEF);
  reader401->definitionModule = modulename;
  reader401->definitionLine = 167;
}
adddatum2(obj397, alloc_Undefined(), 3);
  sourceObject = obj397;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call403 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe402);
// compiled call node returning call403 (depth = 5)
  struct UserObject *obj397_uo = (struct UserObject *)obj397;
  obj397_uo->super = call403;
  sourceObject = obj397;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit404 == NULL) {
    strlit404 = alloc_String("lgeneric");
    gc_root(strlit404);
  }
// compiled string node returning strlit404 (depth = 5)
  adddatum2(obj397, strlit404, 1);
  sourceObject = obj397;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit405 == NULL) {
    strlit405 = alloc_String("<");
    gc_root(strlit405);
  }
// compiled string node returning strlit405 (depth = 5)
  adddatum2(obj397, strlit405, 2);
  sourceObject = obj397;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num406 = alloc_Float64(1);
// compiled num node returning num406 (depth = 5)
  adddatum2(obj397, num406, 3);
  objclass397 = obj397->class;
  objclass397->definitionModule = modulename;
  objclass397->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter397;
  self = oldself397;
  selfslot = oldselfslot397;
  stackframe = oldstackframe397;
  gc_frame_end(frame);
  return obj397;
}
Object meth_lexer_new410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject411 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj411 = alloc_userobj2(4,5, objclass411);
  gc_frame_newslot(obj411);
if (objclass411 == NULL) {
  glfree(obj411->class->name);
  obj411->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj411, self, 0);
  addmethodreal(obj411,"outer", &reader_lexer_outer_412);
  Object oldself411 = self;
  struct StackFrameObject *oldstackframe411 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe411);
  gc_frame_newslot((Object)stackframe);
  self = obj411;
  Object *oldselfslot411 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter411 = (*(struct UserObject *)self).data[0], lowerouter411 = thisouter411;
  if (inheritingObject411) {
    struct UserObject *inho411 = (struct UserObject *)inheritingObject411;
    while (inho411->super != GraceDefaultObject) inho411 = (struct UserObject *)inho411->super;
    inho411->super = obj411;
    self = inheritingObject411;
    *selfslot = self;
    lowerouter411 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter411;
  }
if (objclass411 == NULL) {
  Method *reader413 = addmethodrealflags(obj411, "kind",&reader_lexer_kind_413, MFLAG_DEF);
  reader413->definitionModule = modulename;
  reader413->definitionLine = 171;
}
adddatum2(obj411, alloc_Undefined(), 1);
if (objclass411 == NULL) {
  Method *reader414 = addmethodrealflags(obj411, "value",&reader_lexer_value_414, MFLAG_DEF);
  reader414->definitionModule = modulename;
  reader414->definitionLine = 172;
}
adddatum2(obj411, alloc_Undefined(), 2);
if (objclass411 == NULL) {
  Method *reader415 = addmethodrealflags(obj411, "size",&reader_lexer_size_415, MFLAG_DEF);
  reader415->definitionModule = modulename;
  reader415->definitionLine = 173;
}
adddatum2(obj411, alloc_Undefined(), 3);
  sourceObject = obj411;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe416 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call417 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe416);
// compiled call node returning call417 (depth = 5)
  struct UserObject *obj411_uo = (struct UserObject *)obj411;
  obj411_uo->super = call417;
  sourceObject = obj411;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit418 == NULL) {
    strlit418 = alloc_String("rgeneric");
    gc_root(strlit418);
  }
// compiled string node returning strlit418 (depth = 5)
  adddatum2(obj411, strlit418, 1);
  sourceObject = obj411;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit419 == NULL) {
    strlit419 = alloc_String(">");
    gc_root(strlit419);
  }
// compiled string node returning strlit419 (depth = 5)
  adddatum2(obj411, strlit419, 2);
  sourceObject = obj411;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num420 = alloc_Float64(1);
// compiled num node returning num420 (depth = 5)
  adddatum2(obj411, num420, 3);
  objclass411 = obj411->class;
  objclass411->definitionModule = modulename;
  objclass411->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter411;
  self = oldself411;
  selfslot = oldselfslot411;
  stackframe = oldstackframe411;
  gc_frame_end(frame);
  return obj411;
}
Object meth_lexer_new410_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject411 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj411 = alloc_userobj2(4,5, objclass411);
  gc_frame_newslot(obj411);
if (objclass411 == NULL) {
  glfree(obj411->class->name);
  obj411->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj411, self, 0);
  addmethodreal(obj411,"outer", &reader_lexer_outer_412);
  Object oldself411 = self;
  struct StackFrameObject *oldstackframe411 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe411);
  gc_frame_newslot((Object)stackframe);
  self = obj411;
  Object *oldselfslot411 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter411 = (*(struct UserObject *)self).data[0], lowerouter411 = thisouter411;
  if (inheritingObject411) {
    struct UserObject *inho411 = (struct UserObject *)inheritingObject411;
    while (inho411->super != GraceDefaultObject) inho411 = (struct UserObject *)inho411->super;
    inho411->super = obj411;
    self = inheritingObject411;
    *selfslot = self;
    lowerouter411 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter411;
  }
if (objclass411 == NULL) {
  Method *reader413 = addmethodrealflags(obj411, "kind",&reader_lexer_kind_413, MFLAG_DEF);
  reader413->definitionModule = modulename;
  reader413->definitionLine = 171;
}
adddatum2(obj411, alloc_Undefined(), 1);
if (objclass411 == NULL) {
  Method *reader414 = addmethodrealflags(obj411, "value",&reader_lexer_value_414, MFLAG_DEF);
  reader414->definitionModule = modulename;
  reader414->definitionLine = 172;
}
adddatum2(obj411, alloc_Undefined(), 2);
if (objclass411 == NULL) {
  Method *reader415 = addmethodrealflags(obj411, "size",&reader_lexer_size_415, MFLAG_DEF);
  reader415->definitionModule = modulename;
  reader415->definitionLine = 173;
}
adddatum2(obj411, alloc_Undefined(), 3);
  sourceObject = obj411;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe416 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call417 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe416);
// compiled call node returning call417 (depth = 5)
  struct UserObject *obj411_uo = (struct UserObject *)obj411;
  obj411_uo->super = call417;
  sourceObject = obj411;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit418 == NULL) {
    strlit418 = alloc_String("rgeneric");
    gc_root(strlit418);
  }
// compiled string node returning strlit418 (depth = 5)
  adddatum2(obj411, strlit418, 1);
  sourceObject = obj411;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit419 == NULL) {
    strlit419 = alloc_String(">");
    gc_root(strlit419);
  }
// compiled string node returning strlit419 (depth = 5)
  adddatum2(obj411, strlit419, 2);
  sourceObject = obj411;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num420 = alloc_Float64(1);
// compiled num node returning num420 (depth = 5)
  adddatum2(obj411, num420, 3);
  objclass411 = obj411->class;
  objclass411->definitionModule = modulename;
  objclass411->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter411;
  self = oldself411;
  selfslot = oldselfslot411;
  stackframe = oldstackframe411;
  gc_frame_end(frame);
  return obj411;
}
Object meth_lexer_new424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj425 = alloc_userobj2(4,5, objclass425);
  gc_frame_newslot(obj425);
if (objclass425 == NULL) {
  glfree(obj425->class->name);
  obj425->class->name = "eofToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj425, self, 0);
  addmethodreal(obj425,"outer", &reader_lexer_outer_426);
  Object oldself425 = self;
  struct StackFrameObject *oldstackframe425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe425);
  gc_frame_newslot((Object)stackframe);
  self = obj425;
  Object *oldselfslot425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter425 = (*(struct UserObject *)self).data[0], lowerouter425 = thisouter425;
  if (inheritingObject425) {
    struct UserObject *inho425 = (struct UserObject *)inheritingObject425;
    while (inho425->super != GraceDefaultObject) inho425 = (struct UserObject *)inho425->super;
    inho425->super = obj425;
    self = inheritingObject425;
    *selfslot = self;
    lowerouter425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter425;
  }
if (objclass425 == NULL) {
  Method *reader427 = addmethodrealflags(obj425, "kind",&reader_lexer_kind_427, MFLAG_DEF);
  reader427->definitionModule = modulename;
  reader427->definitionLine = 177;
}
adddatum2(obj425, alloc_Undefined(), 1);
if (objclass425 == NULL) {
  Method *reader428 = addmethodrealflags(obj425, "value",&reader_lexer_value_428, MFLAG_DEF);
  reader428->definitionModule = modulename;
  reader428->definitionLine = 178;
}
adddatum2(obj425, alloc_Undefined(), 2);
if (objclass425 == NULL) {
  Method *reader429 = addmethodrealflags(obj425, "size",&reader_lexer_size_429, MFLAG_DEF);
  reader429->definitionModule = modulename;
  reader429->definitionLine = 179;
}
adddatum2(obj425, alloc_Undefined(), 3);
  sourceObject = obj425;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe430 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call431 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe430);
// compiled call node returning call431 (depth = 5)
  struct UserObject *obj425_uo = (struct UserObject *)obj425;
  obj425_uo->super = call431;
  sourceObject = obj425;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit432 == NULL) {
    strlit432 = alloc_String("eof");
    gc_root(strlit432);
  }
// compiled string node returning strlit432 (depth = 5)
  adddatum2(obj425, strlit432, 1);
  sourceObject = obj425;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit433 == NULL) {
    strlit433 = alloc_String("");
    gc_root(strlit433);
  }
// compiled string node returning strlit433 (depth = 5)
  adddatum2(obj425, strlit433, 2);
  sourceObject = obj425;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num434 = alloc_Float64(0);
// compiled num node returning num434 (depth = 5)
  adddatum2(obj425, num434, 3);
  objclass425 = obj425->class;
  objclass425->definitionModule = modulename;
  objclass425->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter425;
  self = oldself425;
  selfslot = oldselfslot425;
  stackframe = oldstackframe425;
  gc_frame_end(frame);
  return obj425;
}
Object meth_lexer_new424_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj425 = alloc_userobj2(4,5, objclass425);
  gc_frame_newslot(obj425);
if (objclass425 == NULL) {
  glfree(obj425->class->name);
  obj425->class->name = "eofToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj425, self, 0);
  addmethodreal(obj425,"outer", &reader_lexer_outer_426);
  Object oldself425 = self;
  struct StackFrameObject *oldstackframe425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe425);
  gc_frame_newslot((Object)stackframe);
  self = obj425;
  Object *oldselfslot425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter425 = (*(struct UserObject *)self).data[0], lowerouter425 = thisouter425;
  if (inheritingObject425) {
    struct UserObject *inho425 = (struct UserObject *)inheritingObject425;
    while (inho425->super != GraceDefaultObject) inho425 = (struct UserObject *)inho425->super;
    inho425->super = obj425;
    self = inheritingObject425;
    *selfslot = self;
    lowerouter425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter425;
  }
if (objclass425 == NULL) {
  Method *reader427 = addmethodrealflags(obj425, "kind",&reader_lexer_kind_427, MFLAG_DEF);
  reader427->definitionModule = modulename;
  reader427->definitionLine = 177;
}
adddatum2(obj425, alloc_Undefined(), 1);
if (objclass425 == NULL) {
  Method *reader428 = addmethodrealflags(obj425, "value",&reader_lexer_value_428, MFLAG_DEF);
  reader428->definitionModule = modulename;
  reader428->definitionLine = 178;
}
adddatum2(obj425, alloc_Undefined(), 2);
if (objclass425 == NULL) {
  Method *reader429 = addmethodrealflags(obj425, "size",&reader_lexer_size_429, MFLAG_DEF);
  reader429->definitionModule = modulename;
  reader429->definitionLine = 179;
}
adddatum2(obj425, alloc_Undefined(), 3);
  sourceObject = obj425;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe430 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Token (depth = 6)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call431 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe430);
// compiled call node returning call431 (depth = 5)
  struct UserObject *obj425_uo = (struct UserObject *)obj425;
  obj425_uo->super = call431;
  sourceObject = obj425;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit432 == NULL) {
    strlit432 = alloc_String("eof");
    gc_root(strlit432);
  }
// compiled string node returning strlit432 (depth = 5)
  adddatum2(obj425, strlit432, 1);
  sourceObject = obj425;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit433 == NULL) {
    strlit433 = alloc_String("");
    gc_root(strlit433);
  }
// compiled string node returning strlit433 (depth = 5)
  adddatum2(obj425, strlit433, 2);
  sourceObject = obj425;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num434 = alloc_Float64(0);
// compiled num node returning num434 (depth = 5)
  adddatum2(obj425, num434, 3);
  objclass425 = obj425->class;
  objclass425->definitionModule = modulename;
  objclass425->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter425;
  self = oldself425;
  selfslot = oldselfslot425;
  stackframe = oldstackframe425;
  gc_frame_end(frame);
  return obj425;
}
Object meth_lexer__apply742(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit744 == NULL) {
    strlit744 = alloc_String("dot");
    gc_root(strlit744);
  }
// compiled string node returning strlit744 (depth = 12)
  int op_slot_right_743 = gc_frame_newslot(strlit744);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe746 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe747 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call748 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe747);
// compiled call node returning call748 (depth = 15)
// compiled member node returning call748 (depth = 14)
  partcv[0] = 0;
  Object call749 = callmethod(call748, "kind",
    1, partcv, params);
  gc_frame_end(callframe746);
// compiled call node returning call749 (depth = 13)
// compiled member node returning call749 (depth = 12)
  int op_slot_left_743 = gc_frame_newslot(call749);
  params[0] = strlit744;
  partcv[0] = 1;
  Object opresult750 = callmethod(call749, "==", 1, partcv, params);
// compiled op node returning opresult750 (depth = 11)
  gc_frame_end(frame);
  return opresult750;
}
Object meth_lexer__apply1133(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstNonSpace = getfromclosure(closure, 0);
  Object *var_accum = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit1135 == NULL) {
    strlit1135 = alloc_String(" ");
    gc_root(strlit1135);
  }
// compiled string node returning strlit1135 (depth = 17)
  int op_slot_right_1134 = gc_frame_newslot(strlit1135);
// starting to compile call node (depth = 17)
  int callframe1137 = gc_frame_new();
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_firstNonSpace (depth = 18)
  gc_frame_newslot(*var_firstNonSpace);
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  params[0] = *var_firstNonSpace;
  partcv[0] = 1;
  Object call1138 = callmethod(*var_accum, "at",
    1, partcv, params);
  gc_frame_end(callframe1137);
// compiled call node returning call1138 (depth = 17)
  int op_slot_left_1134 = gc_frame_newslot(call1138);
  params[0] = strlit1135;
  partcv[0] = 1;
  Object opresult1139 = callmethod(call1138, "==", 1, partcv, params);
// compiled op node returning opresult1139 (depth = 16)
  gc_frame_end(frame);
  return opresult1139;
}
Object meth_lexer__apply1130(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstNonSpace = getfromclosure(closure, 0);
  Object *var_accum = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 14)
  int callframe1131 = gc_frame_new();
// starting to compile block node (depth = 15)
  Object block1132 = alloc_Block(NULL, NULL, "lexer", 362);
  gc_frame_newslot(block1132);
// method _apply
  block_savedest(block1132);
  Object closure1133 = createclosure(3, "_apply");
  setclosureframe(closure1133, stackframe);
  addtoclosure(closure1133, var_firstNonSpace);
  addtoclosure(closure1133, var_accum);
  addtoclosure(closure1133, selfslot);
  struct UserObject *uo1133 = (struct UserObject*)block1132;
  uo1133->data[0] = (Object)closure1133;
  Method *meth_meth_lexer__apply1133 = addmethod2pos(block1132, "_apply", &meth_lexer__apply1133, 0);
  int argcv_meth_lexer__apply1133[] = {0};
  meth_meth_lexer__apply1133->type = alloc_MethodType(1, argcv_meth_lexer__apply1133);
  meth_meth_lexer__apply1133->definitionModule = modulename;
  meth_meth_lexer__apply1133->definitionLine = 361;
// compiled block node returning block1132 (depth = 15)
  gc_frame_newslot(block1132);
// call case 6: other member request
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe1142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  partcv[0] = 0;
  Object call1143 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1142);
// compiled call node returning call1143 (depth = 17)
// compiled member node returning call1143 (depth = 16)
  int op_slot_right_1141 = gc_frame_newslot(call1143);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_firstNonSpace (depth = 16)
  int op_slot_left_1141 = gc_frame_newslot(*var_firstNonSpace);
  params[0] = call1143;
  partcv[0] = 1;
  Object opresult1145 = callmethod(*var_firstNonSpace, "<=", 1, partcv, params);
// compiled op node returning opresult1145 (depth = 15)
  params[0] = block1132;
  partcv[0] = 1;
  Object call1146 = callmethod(opresult1145, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1131);
// compiled call node returning call1146 (depth = 14)
  gc_frame_end(frame);
  return call1146;
}
Object meth_lexer__apply1149(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstNonSpace = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 14)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile num node (depth = 16)
  Object num1151 = alloc_Float64(1);
// compiled num node returning num1151 (depth = 16)
  int op_slot_right_1150 = gc_frame_newslot(num1151);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_firstNonSpace (depth = 16)
  int op_slot_left_1150 = gc_frame_newslot(*var_firstNonSpace);
  params[0] = num1151;
  partcv[0] = 1;
  Object sum1153 = callmethod(*var_firstNonSpace, "+", 1, partcv, params);
// compiled op node returning sum1153 (depth = 15)
  *var_firstNonSpace = sum1153;
  if (sum1153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_modechange438(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(20, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "modechange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method modechange");
  Object params[5];
  int partcv[3];
  Object *var_IdentifierToken = getfromclosure(closure, 0);
  Object *var_KeywordToken = getfromclosure(closure, 1);
  Object *var_StringToken = getfromclosure(closure, 2);
  Object *var_MultiLineStringToken = getfromclosure(closure, 3);
  Object *var_CommaToken = getfromclosure(closure, 4);
  Object *var_DotToken = getfromclosure(closure, 5);
  Object *var_LBraceToken = getfromclosure(closure, 6);
  Object *var_RBraceToken = getfromclosure(closure, 7);
  Object *var_LParenToken = getfromclosure(closure, 8);
  Object *var_RParenToken = getfromclosure(closure, 9);
  Object *var_LSquareToken = getfromclosure(closure, 10);
  Object *var_RSquareToken = getfromclosure(closure, 11);
  Object *var_LGenericToken = getfromclosure(closure, 12);
  Object *var_RGenericToken = getfromclosure(closure, 13);
  Object *var_SemicolonToken = getfromclosure(closure, 14);
  Object *var_NumToken = getfromclosure(closure, 15);
  Object *var_errormessages = getfromclosure(closure, 16);
  Object *var_linePosition = getfromclosure(closure, 17);
  Object *var_lineNumber = getfromclosure(closure, 18);
  Object *var_OpToken = getfromclosure(closure, 19);
  Object *var_ArrowToken = getfromclosure(closure, 20);
  Object *var_BindToken = getfromclosure(closure, 21);
  Object *var_ColonToken = getfromclosure(closure, 22);
  Object *var_indentLevel = getfromclosure(closure, 23);
  Object *var_CommentToken = getfromclosure(closure, 24);
  Object *var_util = getfromclosure(closure, 25);
  Object *var_startPosition = getfromclosure(closure, 26);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for modechange (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokens = &(stackframe->slots[0]);
  *var_tokens = args[curarg];
  curarg++;
  Object *var_mode = &(stackframe->slots[1]);
  *var_mode = args[curarg];
  curarg++;
  Object *var_accum = &(stackframe->slots[2]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for modechange");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isDone = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "isDone");
  Object *var_tok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tok");
  Object *var_dot = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dot");
  Object *var_decimal = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "decimal");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
  Object *var_suggestion = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "suggestion");
  Object *var_firstNonSpace = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "firstNonSpace");
  Object *var_accumSize = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "accumSize");
  Object *var_cmt = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "cmt");
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool439 = alloc_Boolean(0);
// compiled identifier node returning bool439 (depth = 3)
  *var_isDone = bool439;
  if (bool439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num440 = alloc_Float64(0);
// compiled num node returning num440 (depth = 3)
  *var_tok = num440;
  if (num440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num444 = alloc_Float64(0);
// compiled num node returning num444 (depth = 5)
  int op_slot_right_443 = gc_frame_newslot(num444);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  partcv[0] = 0;
  Object call447 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe446);
// compiled call node returning call447 (depth = 6)
// compiled member node returning call447 (depth = 5)
  int op_slot_left_443 = gc_frame_newslot(call447);
  params[0] = num444;
  partcv[0] = 1;
  Object opresult448 = callmethod(call447, ">", 1, partcv, params);
// compiled op node returning opresult448 (depth = 4)
  int op_slot_right_442 = gc_frame_newslot(opresult448);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit451 == NULL) {
    strlit451 = alloc_String("n");
    gc_root(strlit451);
  }
// compiled string node returning strlit451 (depth = 5)
  int op_slot_right_450 = gc_frame_newslot(strlit451);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mode (depth = 5)
  int op_slot_left_450 = gc_frame_newslot(*var_mode);
  params[0] = strlit451;
  partcv[0] = 1;
  Object opresult453 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult453 (depth = 4)
  int op_slot_left_442 = gc_frame_newslot(opresult453);
  params[0] = opresult448;
  partcv[0] = 1;
  Object opresult454 = callmethod(opresult453, "||", 1, partcv, params);
// compiled op node returning opresult454 (depth = 3)
  Object if441 = done;
  if (istrue(opresult454)) {
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit457 == NULL) {
    strlit457 = alloc_String("i");
    gc_root(strlit457);
  }
// compiled string node returning strlit457 (depth = 5)
  int op_slot_right_456 = gc_frame_newslot(strlit457);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mode (depth = 5)
  int op_slot_left_456 = gc_frame_newslot(*var_mode);
  params[0] = strlit457;
  partcv[0] = 1;
  Object opresult459 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult459 (depth = 4)
  Object if455 = done;
  if (istrue(opresult459)) {
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe460 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_accum (depth = 6)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IdentifierToken (depth = 6)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call461 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe460);
// compiled call node returning call461 (depth = 5)
  *var_tok = call461;
  if (call461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit466 == NULL) {
    strlit466 = alloc_String("factory");
    gc_root(strlit466);
  }
// compiled string node returning strlit466 (depth = 7)
  int op_slot_right_465 = gc_frame_newslot(strlit466);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  int op_slot_left_465 = gc_frame_newslot(*var_accum);
  params[0] = strlit466;
  partcv[0] = 1;
  Object opresult468 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult468 (depth = 6)
  int op_slot_right_464 = gc_frame_newslot(opresult468);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit472 == NULL) {
    strlit472 = alloc_String("dialect");
    gc_root(strlit472);
  }
// compiled string node returning strlit472 (depth = 8)
  int op_slot_right_471 = gc_frame_newslot(strlit472);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  int op_slot_left_471 = gc_frame_newslot(*var_accum);
  params[0] = strlit472;
  partcv[0] = 1;
  Object opresult474 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult474 (depth = 7)
  int op_slot_right_470 = gc_frame_newslot(opresult474);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit478 == NULL) {
    strlit478 = alloc_String("is");
    gc_root(strlit478);
  }
// compiled string node returning strlit478 (depth = 9)
  int op_slot_right_477 = gc_frame_newslot(strlit478);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_477 = gc_frame_newslot(*var_accum);
  params[0] = strlit478;
  partcv[0] = 1;
  Object opresult480 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult480 (depth = 8)
  int op_slot_right_476 = gc_frame_newslot(opresult480);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit484 == NULL) {
    strlit484 = alloc_String("inherits");
    gc_root(strlit484);
  }
// compiled string node returning strlit484 (depth = 10)
  int op_slot_right_483 = gc_frame_newslot(strlit484);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_483 = gc_frame_newslot(*var_accum);
  params[0] = strlit484;
  partcv[0] = 1;
  Object opresult486 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult486 (depth = 9)
  int op_slot_right_482 = gc_frame_newslot(opresult486);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit490 == NULL) {
    strlit490 = alloc_String("def");
    gc_root(strlit490);
  }
// compiled string node returning strlit490 (depth = 11)
  int op_slot_right_489 = gc_frame_newslot(strlit490);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_489 = gc_frame_newslot(*var_accum);
  params[0] = strlit490;
  partcv[0] = 1;
  Object opresult492 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult492 (depth = 10)
  int op_slot_right_488 = gc_frame_newslot(opresult492);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit496 == NULL) {
    strlit496 = alloc_String("return");
    gc_root(strlit496);
  }
// compiled string node returning strlit496 (depth = 12)
  int op_slot_right_495 = gc_frame_newslot(strlit496);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_495 = gc_frame_newslot(*var_accum);
  params[0] = strlit496;
  partcv[0] = 1;
  Object opresult498 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult498 (depth = 11)
  int op_slot_right_494 = gc_frame_newslot(opresult498);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit502 == NULL) {
    strlit502 = alloc_String("class");
    gc_root(strlit502);
  }
// compiled string node returning strlit502 (depth = 13)
  int op_slot_right_501 = gc_frame_newslot(strlit502);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_501 = gc_frame_newslot(*var_accum);
  params[0] = strlit502;
  partcv[0] = 1;
  Object opresult504 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult504 (depth = 12)
  int op_slot_right_500 = gc_frame_newslot(opresult504);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit508 == NULL) {
    strlit508 = alloc_String("import");
    gc_root(strlit508);
  }
// compiled string node returning strlit508 (depth = 14)
  int op_slot_right_507 = gc_frame_newslot(strlit508);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_507 = gc_frame_newslot(*var_accum);
  params[0] = strlit508;
  partcv[0] = 1;
  Object opresult510 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult510 (depth = 13)
  int op_slot_right_506 = gc_frame_newslot(opresult510);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit514 == NULL) {
    strlit514 = alloc_String("type");
    gc_root(strlit514);
  }
// compiled string node returning strlit514 (depth = 15)
  int op_slot_right_513 = gc_frame_newslot(strlit514);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_513 = gc_frame_newslot(*var_accum);
  params[0] = strlit514;
  partcv[0] = 1;
  Object opresult516 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult516 (depth = 14)
  int op_slot_right_512 = gc_frame_newslot(opresult516);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit520 == NULL) {
    strlit520 = alloc_String("var");
    gc_root(strlit520);
  }
// compiled string node returning strlit520 (depth = 16)
  int op_slot_right_519 = gc_frame_newslot(strlit520);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_519 = gc_frame_newslot(*var_accum);
  params[0] = strlit520;
  partcv[0] = 1;
  Object opresult522 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult522 (depth = 15)
  int op_slot_right_518 = gc_frame_newslot(opresult522);
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit526 == NULL) {
    strlit526 = alloc_String("method");
    gc_root(strlit526);
  }
// compiled string node returning strlit526 (depth = 17)
  int op_slot_right_525 = gc_frame_newslot(strlit526);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_525 = gc_frame_newslot(*var_accum);
  params[0] = strlit526;
  partcv[0] = 1;
  Object opresult528 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult528 (depth = 16)
  int op_slot_right_524 = gc_frame_newslot(opresult528);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit531 == NULL) {
    strlit531 = alloc_String("object");
    gc_root(strlit531);
  }
// compiled string node returning strlit531 (depth = 17)
  int op_slot_right_530 = gc_frame_newslot(strlit531);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_530 = gc_frame_newslot(*var_accum);
  params[0] = strlit531;
  partcv[0] = 1;
  Object opresult533 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult533 (depth = 16)
  int op_slot_left_524 = gc_frame_newslot(opresult533);
  params[0] = opresult528;
  partcv[0] = 1;
  Object opresult534 = callmethod(opresult533, "||", 1, partcv, params);
// compiled op node returning opresult534 (depth = 15)
  int op_slot_left_518 = gc_frame_newslot(opresult534);
  params[0] = opresult522;
  partcv[0] = 1;
  Object opresult535 = callmethod(opresult534, "||", 1, partcv, params);
// compiled op node returning opresult535 (depth = 14)
  int op_slot_left_512 = gc_frame_newslot(opresult535);
  params[0] = opresult516;
  partcv[0] = 1;
  Object opresult536 = callmethod(opresult535, "||", 1, partcv, params);
// compiled op node returning opresult536 (depth = 13)
  int op_slot_left_506 = gc_frame_newslot(opresult536);
  params[0] = opresult510;
  partcv[0] = 1;
  Object opresult537 = callmethod(opresult536, "||", 1, partcv, params);
// compiled op node returning opresult537 (depth = 12)
  int op_slot_left_500 = gc_frame_newslot(opresult537);
  params[0] = opresult504;
  partcv[0] = 1;
  Object opresult538 = callmethod(opresult537, "||", 1, partcv, params);
// compiled op node returning opresult538 (depth = 11)
  int op_slot_left_494 = gc_frame_newslot(opresult538);
  params[0] = opresult498;
  partcv[0] = 1;
  Object opresult539 = callmethod(opresult538, "||", 1, partcv, params);
// compiled op node returning opresult539 (depth = 10)
  int op_slot_left_488 = gc_frame_newslot(opresult539);
  params[0] = opresult492;
  partcv[0] = 1;
  Object opresult540 = callmethod(opresult539, "||", 1, partcv, params);
// compiled op node returning opresult540 (depth = 9)
  int op_slot_left_482 = gc_frame_newslot(opresult540);
  params[0] = opresult486;
  partcv[0] = 1;
  Object opresult541 = callmethod(opresult540, "||", 1, partcv, params);
// compiled op node returning opresult541 (depth = 8)
  int op_slot_left_476 = gc_frame_newslot(opresult541);
  params[0] = opresult480;
  partcv[0] = 1;
  Object opresult542 = callmethod(opresult541, "||", 1, partcv, params);
// compiled op node returning opresult542 (depth = 7)
  int op_slot_left_470 = gc_frame_newslot(opresult542);
  params[0] = opresult474;
  partcv[0] = 1;
  Object opresult543 = callmethod(opresult542, "||", 1, partcv, params);
// compiled op node returning opresult543 (depth = 6)
  int op_slot_left_464 = gc_frame_newslot(opresult543);
  params[0] = opresult468;
  partcv[0] = 1;
  Object opresult544 = callmethod(opresult543, "||", 1, partcv, params);
// compiled op node returning opresult544 (depth = 5)
  Object if463 = done;
  if (istrue(opresult544)) {
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe545 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_KeywordToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call546 = callmethod(*var_KeywordToken, "new",
    1, partcv, params);
  gc_frame_end(callframe545);
// compiled call node returning call546 (depth = 6)
  *var_tok = call546;
  if (call546 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if463 = done;
  } else {
  }
// compiled if node returning if463 (depth = 4)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe548 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call549 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe548);
// compiled call node returning call549 (depth = 4)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool550 = alloc_Boolean(1);
// compiled identifier node returning bool550 (depth = 5)
  *var_isDone = bool550;
  if (bool550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if455 = done;
  } else {
  }
// compiled if node returning if455 (depth = 3)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit554 == NULL) {
    strlit554 = alloc_String("I");
    gc_root(strlit554);
  }
// compiled string node returning strlit554 (depth = 5)
  int op_slot_right_553 = gc_frame_newslot(strlit554);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mode (depth = 5)
  int op_slot_left_553 = gc_frame_newslot(*var_mode);
  params[0] = strlit554;
  partcv[0] = 1;
  Object opresult556 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult556 (depth = 4)
  Object if552 = done;
  if (istrue(opresult556)) {
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe557 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_accum (depth = 6)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IdentifierToken (depth = 6)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call558 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe557);
// compiled call node returning call558 (depth = 5)
  *var_tok = call558;
  if (call558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe560 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call561 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe560);
// compiled call node returning call561 (depth = 4)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool562 = alloc_Boolean(1);
// compiled identifier node returning bool562 (depth = 5)
  *var_isDone = bool562;
  if (bool562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if552 = done;
  } else {
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit566 == NULL) {
    strlit566 = alloc_String("""\x22""");
    gc_root(strlit566);
  }
// compiled string node returning strlit566 (depth = 6)
  int op_slot_right_565 = gc_frame_newslot(strlit566);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_565 = gc_frame_newslot(*var_mode);
  params[0] = strlit566;
  partcv[0] = 1;
  Object opresult568 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult568 (depth = 5)
  Object if564 = done;
  if (istrue(opresult568)) {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe569 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_StringToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call570 = callmethod(*var_StringToken, "new",
    1, partcv, params);
  gc_frame_end(callframe569);
// compiled call node returning call570 (depth = 6)
  *var_tok = call570;
  if (call570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe572 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call573 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe572);
// compiled call node returning call573 (depth = 5)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool574 = alloc_Boolean(1);
// compiled identifier node returning bool574 (depth = 6)
  *var_isDone = bool574;
  if (bool574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if564 = done;
  } else {
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit578 == NULL) {
    strlit578 = alloc_String("q");
    gc_root(strlit578);
  }
// compiled string node returning strlit578 (depth = 7)
  int op_slot_right_577 = gc_frame_newslot(strlit578);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_577 = gc_frame_newslot(*var_mode);
  params[0] = strlit578;
  partcv[0] = 1;
  Object opresult580 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult580 (depth = 6)
  Object if576 = done;
  if (istrue(opresult580)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe581 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_MultiLineStringToken (depth = 8)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call582 = callmethod(*var_MultiLineStringToken, "new",
    1, partcv, params);
  gc_frame_end(callframe581);
// compiled call node returning call582 (depth = 7)
  *var_tok = call582;
  if (call582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe584 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call585 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe584);
// compiled call node returning call585 (depth = 6)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool586 = alloc_Boolean(1);
// compiled identifier node returning bool586 (depth = 7)
  *var_isDone = bool586;
  if (bool586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if576 = done;
  } else {
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit590 == NULL) {
    strlit590 = alloc_String("x");
    gc_root(strlit590);
  }
// compiled string node returning strlit590 (depth = 8)
  int op_slot_right_589 = gc_frame_newslot(strlit590);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_589 = gc_frame_newslot(*var_mode);
  params[0] = strlit590;
  partcv[0] = 1;
  Object opresult592 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult592 (depth = 7)
  Object if588 = done;
  if (istrue(opresult592)) {
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe593 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit594 == NULL) {
    strlit594 = alloc_String("obsolete Octet-token mode in lexer""\x0a""");
    gc_root(strlit594);
  }
// compiled string node returning strlit594 (depth = 8)
  gc_frame_newslot(strlit594);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe595 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call596 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe595);
// compiled call node returning call596 (depth = 9)
// compiled member node returning call596 (depth = 8)
  params[0] = strlit594;
  partcv[0] = 1;
  Object call597 = callmethod(call596, "raise",
    1, partcv, params);
  gc_frame_end(callframe593);
// compiled call node returning call597 (depth = 7)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe598 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call599 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe598);
// compiled call node returning call599 (depth = 7)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool600 = alloc_Boolean(1);
// compiled identifier node returning bool600 (depth = 8)
  *var_isDone = bool600;
  if (bool600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if588 = done;
  } else {
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit604 == NULL) {
    strlit604 = alloc_String(",");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 9)
  int op_slot_right_603 = gc_frame_newslot(strlit604);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_603 = gc_frame_newslot(*var_mode);
  params[0] = strlit604;
  partcv[0] = 1;
  Object opresult606 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult606 (depth = 8)
  Object if602 = done;
  if (istrue(opresult606)) {
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_CommaToken (depth = 11)
  partcv[0] = 0;
  Object call608 = callmethod(*var_CommaToken, "new",
    1, partcv, params);
  gc_frame_end(callframe607);
// compiled call node returning call608 (depth = 10)
// compiled member node returning call608 (depth = 9)
  *var_tok = call608;
  if (call608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe610 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call611 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe610);
// compiled call node returning call611 (depth = 8)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool612 = alloc_Boolean(1);
// compiled identifier node returning bool612 (depth = 9)
  *var_isDone = bool612;
  if (bool612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if602 = done;
  } else {
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit616 == NULL) {
    strlit616 = alloc_String(".");
    gc_root(strlit616);
  }
// compiled string node returning strlit616 (depth = 10)
  int op_slot_right_615 = gc_frame_newslot(strlit616);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_615 = gc_frame_newslot(*var_mode);
  params[0] = strlit616;
  partcv[0] = 1;
  Object opresult618 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult618 (depth = 9)
  Object if614 = done;
  if (istrue(opresult618)) {
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe619 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_DotToken (depth = 12)
  partcv[0] = 0;
  Object call620 = callmethod(*var_DotToken, "new",
    1, partcv, params);
  gc_frame_end(callframe619);
// compiled call node returning call620 (depth = 11)
// compiled member node returning call620 (depth = 10)
  *var_tok = call620;
  if (call620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe622 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call623 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe622);
// compiled call node returning call623 (depth = 9)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool624 = alloc_Boolean(1);
// compiled identifier node returning bool624 (depth = 10)
  *var_isDone = bool624;
  if (bool624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if614 = done;
  } else {
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit628 == NULL) {
    strlit628 = alloc_String("{");
    gc_root(strlit628);
  }
// compiled string node returning strlit628 (depth = 11)
  int op_slot_right_627 = gc_frame_newslot(strlit628);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_627 = gc_frame_newslot(*var_mode);
  params[0] = strlit628;
  partcv[0] = 1;
  Object opresult630 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult630 (depth = 10)
  Object if626 = done;
  if (istrue(opresult630)) {
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_LBraceToken (depth = 13)
  partcv[0] = 0;
  Object call632 = callmethod(*var_LBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe631);
// compiled call node returning call632 (depth = 12)
// compiled member node returning call632 (depth = 11)
  *var_tok = call632;
  if (call632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe634 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call635 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe634);
// compiled call node returning call635 (depth = 10)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool636 = alloc_Boolean(1);
// compiled identifier node returning bool636 (depth = 11)
  *var_isDone = bool636;
  if (bool636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if626 = done;
  } else {
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit640 == NULL) {
    strlit640 = alloc_String("}");
    gc_root(strlit640);
  }
// compiled string node returning strlit640 (depth = 12)
  int op_slot_right_639 = gc_frame_newslot(strlit640);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_639 = gc_frame_newslot(*var_mode);
  params[0] = strlit640;
  partcv[0] = 1;
  Object opresult642 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult642 (depth = 11)
  Object if638 = done;
  if (istrue(opresult642)) {
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_RBraceToken (depth = 14)
  partcv[0] = 0;
  Object call644 = callmethod(*var_RBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe643);
// compiled call node returning call644 (depth = 13)
// compiled member node returning call644 (depth = 12)
  *var_tok = call644;
  if (call644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe646 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call647 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe646);
// compiled call node returning call647 (depth = 11)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool648 = alloc_Boolean(1);
// compiled identifier node returning bool648 (depth = 12)
  *var_isDone = bool648;
  if (bool648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if638 = done;
  } else {
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit652 == NULL) {
    strlit652 = alloc_String("(");
    gc_root(strlit652);
  }
// compiled string node returning strlit652 (depth = 13)
  int op_slot_right_651 = gc_frame_newslot(strlit652);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_651 = gc_frame_newslot(*var_mode);
  params[0] = strlit652;
  partcv[0] = 1;
  Object opresult654 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult654 (depth = 12)
  Object if650 = done;
  if (istrue(opresult654)) {
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_LParenToken (depth = 15)
  partcv[0] = 0;
  Object call656 = callmethod(*var_LParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe655);
// compiled call node returning call656 (depth = 14)
// compiled member node returning call656 (depth = 13)
  *var_tok = call656;
  if (call656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe658 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call659 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe658);
// compiled call node returning call659 (depth = 12)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile identifier node (depth = 13)
  Object bool660 = alloc_Boolean(1);
// compiled identifier node returning bool660 (depth = 13)
  *var_isDone = bool660;
  if (bool660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if650 = done;
  } else {
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit664 == NULL) {
    strlit664 = alloc_String(")");
    gc_root(strlit664);
  }
// compiled string node returning strlit664 (depth = 14)
  int op_slot_right_663 = gc_frame_newslot(strlit664);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_663 = gc_frame_newslot(*var_mode);
  params[0] = strlit664;
  partcv[0] = 1;
  Object opresult666 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult666 (depth = 13)
  Object if662 = done;
  if (istrue(opresult666)) {
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_RParenToken (depth = 16)
  partcv[0] = 0;
  Object call668 = callmethod(*var_RParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe667);
// compiled call node returning call668 (depth = 15)
// compiled member node returning call668 (depth = 14)
  *var_tok = call668;
  if (call668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe670 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call671 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe670);
// compiled call node returning call671 (depth = 13)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile identifier node (depth = 14)
  Object bool672 = alloc_Boolean(1);
// compiled identifier node returning bool672 (depth = 14)
  *var_isDone = bool672;
  if (bool672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if662 = done;
  } else {
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit676 == NULL) {
    strlit676 = alloc_String("[");
    gc_root(strlit676);
  }
// compiled string node returning strlit676 (depth = 15)
  int op_slot_right_675 = gc_frame_newslot(strlit676);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_mode (depth = 15)
  int op_slot_left_675 = gc_frame_newslot(*var_mode);
  params[0] = strlit676;
  partcv[0] = 1;
  Object opresult678 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult678 (depth = 14)
  Object if674 = done;
  if (istrue(opresult678)) {
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_LSquareToken (depth = 17)
  partcv[0] = 0;
  Object call680 = callmethod(*var_LSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe679);
// compiled call node returning call680 (depth = 16)
// compiled member node returning call680 (depth = 15)
  *var_tok = call680;
  if (call680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe682 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call683 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 14)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// starting to compile identifier node (depth = 15)
  Object bool684 = alloc_Boolean(1);
// compiled identifier node returning bool684 (depth = 15)
  *var_isDone = bool684;
  if (bool684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if674 = done;
  } else {
  }
// compiled if node returning if674 (depth = 13)
    gc_frame_newslot(if674);
    if662 = if674;
  }
// compiled if node returning if662 (depth = 12)
    gc_frame_newslot(if662);
    if650 = if662;
  }
// compiled if node returning if650 (depth = 11)
    gc_frame_newslot(if650);
    if638 = if650;
  }
// compiled if node returning if638 (depth = 10)
    gc_frame_newslot(if638);
    if626 = if638;
  }
// compiled if node returning if626 (depth = 9)
    gc_frame_newslot(if626);
    if614 = if626;
  }
// compiled if node returning if614 (depth = 8)
    gc_frame_newslot(if614);
    if602 = if614;
  }
// compiled if node returning if602 (depth = 7)
    gc_frame_newslot(if602);
    if588 = if602;
  }
// compiled if node returning if588 (depth = 6)
    gc_frame_newslot(if588);
    if576 = if588;
  }
// compiled if node returning if576 (depth = 5)
    gc_frame_newslot(if576);
    if564 = if576;
  }
// compiled if node returning if564 (depth = 4)
    gc_frame_newslot(if564);
    if552 = if564;
  }
// compiled if node returning if552 (depth = 3)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit688 == NULL) {
    strlit688 = alloc_String("]");
    gc_root(strlit688);
  }
// compiled string node returning strlit688 (depth = 5)
  int op_slot_right_687 = gc_frame_newslot(strlit688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mode (depth = 5)
  int op_slot_left_687 = gc_frame_newslot(*var_mode);
  params[0] = strlit688;
  partcv[0] = 1;
  Object opresult690 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult690 (depth = 4)
  Object if686 = done;
  if (istrue(opresult690)) {
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_RSquareToken (depth = 7)
  partcv[0] = 0;
  Object call692 = callmethod(*var_RSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call692 (depth = 6)
// compiled member node returning call692 (depth = 5)
  *var_tok = call692;
  if (call692 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe694 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call695 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe694);
// compiled call node returning call695 (depth = 4)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool696 = alloc_Boolean(1);
// compiled identifier node returning bool696 (depth = 5)
  *var_isDone = bool696;
  if (bool696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if686 = done;
  } else {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit700 == NULL) {
    strlit700 = alloc_String("<");
    gc_root(strlit700);
  }
// compiled string node returning strlit700 (depth = 6)
  int op_slot_right_699 = gc_frame_newslot(strlit700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_699 = gc_frame_newslot(*var_mode);
  params[0] = strlit700;
  partcv[0] = 1;
  Object opresult702 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult702 (depth = 5)
  Object if698 = done;
  if (istrue(opresult702)) {
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe703 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_LGenericToken (depth = 8)
  partcv[0] = 0;
  Object call704 = callmethod(*var_LGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe703);
// compiled call node returning call704 (depth = 7)
// compiled member node returning call704 (depth = 6)
  *var_tok = call704;
  if (call704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe706 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call707 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe706);
// compiled call node returning call707 (depth = 5)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool708 = alloc_Boolean(1);
// compiled identifier node returning bool708 (depth = 6)
  *var_isDone = bool708;
  if (bool708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if698 = done;
  } else {
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit712 == NULL) {
    strlit712 = alloc_String(">");
    gc_root(strlit712);
  }
// compiled string node returning strlit712 (depth = 7)
  int op_slot_right_711 = gc_frame_newslot(strlit712);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_711 = gc_frame_newslot(*var_mode);
  params[0] = strlit712;
  partcv[0] = 1;
  Object opresult714 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult714 (depth = 6)
  Object if710 = done;
  if (istrue(opresult714)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_RGenericToken (depth = 9)
  partcv[0] = 0;
  Object call716 = callmethod(*var_RGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe715);
// compiled call node returning call716 (depth = 8)
// compiled member node returning call716 (depth = 7)
  *var_tok = call716;
  if (call716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe718 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call719 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe718);
// compiled call node returning call719 (depth = 6)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool720 = alloc_Boolean(1);
// compiled identifier node returning bool720 (depth = 7)
  *var_isDone = bool720;
  if (bool720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if710 = done;
  } else {
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit724 == NULL) {
    strlit724 = alloc_String(";");
    gc_root(strlit724);
  }
// compiled string node returning strlit724 (depth = 8)
  int op_slot_right_723 = gc_frame_newslot(strlit724);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_723 = gc_frame_newslot(*var_mode);
  params[0] = strlit724;
  partcv[0] = 1;
  Object opresult726 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult726 (depth = 7)
  Object if722 = done;
  if (istrue(opresult726)) {
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_SemicolonToken (depth = 10)
  partcv[0] = 0;
  Object call728 = callmethod(*var_SemicolonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe727);
// compiled call node returning call728 (depth = 9)
// compiled member node returning call728 (depth = 8)
  *var_tok = call728;
  if (call728 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe730 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call731 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe730);
// compiled call node returning call731 (depth = 7)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool732 = alloc_Boolean(1);
// compiled identifier node returning bool732 (depth = 8)
  *var_isDone = bool732;
  if (bool732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if722 = done;
  } else {
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit736 == NULL) {
    strlit736 = alloc_String("m");
    gc_root(strlit736);
  }
// compiled string node returning strlit736 (depth = 9)
  int op_slot_right_735 = gc_frame_newslot(strlit736);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_735 = gc_frame_newslot(*var_mode);
  params[0] = strlit736;
  partcv[0] = 1;
  Object opresult738 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult738 (depth = 8)
  Object if734 = done;
  if (istrue(opresult738)) {
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe740 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block741 = alloc_Block(NULL, NULL, "lexer", 279);
  gc_frame_newslot(block741);
// method _apply
  block_savedest(block741);
  Object closure742 = createclosure(2, "_apply");
  setclosureframe(closure742, stackframe);
  addtoclosure(closure742, var_tokens);
  addtoclosure(closure742, selfslot);
  struct UserObject *uo742 = (struct UserObject*)block741;
  uo742->data[0] = (Object)closure742;
  Method *meth_meth_lexer__apply742 = addmethod2pos(block741, "_apply", &meth_lexer__apply742, 0);
  int argcv_meth_lexer__apply742[] = {0};
  meth_meth_lexer__apply742->type = alloc_MethodType(1, argcv_meth_lexer__apply742);
  meth_meth_lexer__apply742->definitionModule = modulename;
  meth_meth_lexer__apply742->definitionLine = 275;
// compiled block node returning block741 (depth = 10)
  gc_frame_newslot(block741);
// call case 6: other member request
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num753 = alloc_Float64(1);
// compiled num node returning num753 (depth = 11)
  int op_slot_right_752 = gc_frame_newslot(num753);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call756 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe755);
// compiled call node returning call756 (depth = 12)
// compiled member node returning call756 (depth = 11)
  int op_slot_left_752 = gc_frame_newslot(call756);
  params[0] = num753;
  partcv[0] = 1;
  Object opresult757 = callmethod(call756, ">", 1, partcv, params);
// compiled op node returning opresult757 (depth = 10)
  params[0] = block741;
  partcv[0] = 1;
  Object call758 = callmethod(opresult757, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe740);
// compiled call node returning call758 (depth = 9)
  Object if739 = done;
  if (istrue(call758)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call760 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe759);
// compiled call node returning call760 (depth = 11)
// compiled member node returning call760 (depth = 10)
  *var_dot = call760;
  if (call760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit763 == NULL) {
    strlit763 = alloc_String("num");
    gc_root(strlit763);
  }
// compiled string node returning strlit763 (depth = 11)
  int op_slot_right_762 = gc_frame_newslot(strlit763);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe765 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  partcv[0] = 0;
  Object call767 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe766);
// compiled call node returning call767 (depth = 14)
// compiled member node returning call767 (depth = 13)
  partcv[0] = 0;
  Object call768 = callmethod(call767, "kind",
    1, partcv, params);
  gc_frame_end(callframe765);
// compiled call node returning call768 (depth = 12)
// compiled member node returning call768 (depth = 11)
  int op_slot_left_762 = gc_frame_newslot(call768);
  params[0] = strlit763;
  partcv[0] = 1;
  Object opresult769 = callmethod(call768, "==", 1, partcv, params);
// compiled op node returning opresult769 (depth = 10)
  Object if761 = done;
  if (istrue(opresult769)) {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num772 = alloc_Float64(10);
// compiled num node returning num772 (depth = 12)
  int op_slot_right_771 = gc_frame_newslot(num772);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe774 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call776 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe775);
// compiled call node returning call776 (depth = 15)
// compiled member node returning call776 (depth = 14)
  partcv[0] = 0;
  Object call777 = callmethod(call776, "base",
    1, partcv, params);
  gc_frame_end(callframe774);
// compiled call node returning call777 (depth = 13)
// compiled member node returning call777 (depth = 12)
  int op_slot_left_771 = gc_frame_newslot(call777);
  params[0] = num772;
  partcv[0] = 1;
  Object opresult778 = callmethod(call777, "==", 1, partcv, params);
// compiled op node returning opresult778 (depth = 11)
  Object if770 = done;
  if (istrue(opresult778)) {
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call780 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe779);
// compiled call node returning call780 (depth = 13)
// compiled member node returning call780 (depth = 12)
  *var_tok = call780;
  if (call780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe782 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call783 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe782);
// compiled call node returning call783 (depth = 12)
  *var_decimal = call783;
  if (call783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 11)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num786 = alloc_Float64(10);
// compiled num node returning num786 (depth = 13)
  int op_slot_right_785 = gc_frame_newslot(num786);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_decimal (depth = 15)
  partcv[0] = 0;
  Object call789 = callmethod(*var_decimal, "base",
    1, partcv, params);
  gc_frame_end(callframe788);
// compiled call node returning call789 (depth = 14)
// compiled member node returning call789 (depth = 13)
  int op_slot_left_785 = gc_frame_newslot(call789);
  params[0] = num786;
  partcv[0] = 1;
  Object opresult790 = callmethod(call789, "==", 1, partcv, params);
// compiled op node returning opresult790 (depth = 12)
  Object if784 = done;
  if (istrue(opresult790)) {
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe791 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_right_792 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit795 == NULL) {
    strlit795 = alloc_String(".");
    gc_root(strlit795);
  }
// compiled string node returning strlit795 (depth = 16)
  int op_slot_right_794 = gc_frame_newslot(strlit795);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tok (depth = 18)
  partcv[0] = 0;
  Object call798 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe797);
// compiled call node returning call798 (depth = 17)
// compiled member node returning call798 (depth = 16)
  int op_slot_left_794 = gc_frame_newslot(call798);
  params[0] = strlit795;
  partcv[0] = 1;
  Object opresult799 = callmethod(call798, "++", 1, partcv, params);
// compiled op node returning opresult799 (depth = 15)
  int op_slot_left_792 = gc_frame_newslot(opresult799);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult800 = callmethod(opresult799, "++", 1, partcv, params);
// compiled op node returning opresult800 (depth = 14)
  gc_frame_newslot(opresult800);
// starting to compile num node (depth = 14)
  Object num801 = alloc_Float64(10);
// compiled num node returning num801 (depth = 14)
  gc_frame_newslot(num801);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_NumToken (depth = 14)
  params[0] = opresult800;
  params[1] = num801;
  partcv[0] = 2;
  Object call802 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe791);
// compiled call node returning call802 (depth = 13)
  *var_tok = call802;
  if (call802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if784 = done;
  } else {
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// starting to compile array node (depth = 13)
  Object array804 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array804 (depth = 13)
  *var_suggestions = array804;
  if (array804 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe805 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call807 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe806);
// compiled call node returning call807 (depth = 16)
// compiled member node returning call807 (depth = 15)
  partcv[0] = 0;
  Object call808 = callmethod(call807, "new",
    1, partcv, params);
  gc_frame_end(callframe805);
// compiled call node returning call808 (depth = 14)
// compiled member node returning call808 (depth = 13)
  *var_suggestion = call808;
  if (call808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe809 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num811 = alloc_Float64(1);
// compiled num node returning num811 (depth = 14)
  int op_slot_right_810 = gc_frame_newslot(num811);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call814 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe813);
// compiled call node returning call814 (depth = 15)
// compiled member node returning call814 (depth = 14)
  int op_slot_left_810 = gc_frame_newslot(call814);
  params[0] = num811;
  partcv[0] = 1;
  Object sum815 = callmethod(call814, "+", 1, partcv, params);
// compiled op node returning sum815 (depth = 13)
  gc_frame_newslot(sum815);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num817 = alloc_Float64(1);
// compiled num node returning num817 (depth = 14)
  int op_slot_right_816 = gc_frame_newslot(num817);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_linePosition (depth = 14)
  int op_slot_left_816 = gc_frame_newslot(*var_linePosition);
  params[0] = num817;
  partcv[0] = 1;
  Object diff819 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff819 (depth = 13)
  gc_frame_newslot(diff819);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_decimal (depth = 15)
  partcv[0] = 0;
  Object call821 = callmethod(*var_decimal, "value",
    1, partcv, params);
  gc_frame_end(callframe820);
// compiled call node returning call821 (depth = 14)
// compiled member node returning call821 (depth = 13)
  gc_frame_newslot(call821);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = sum815;
  params[1] = diff819;
  params[2] = call821;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call822 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call822 (depth = 12)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe823 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call824 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call824 (depth = 12)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe825 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call827 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe826);
// compiled call node returning call827 (depth = 16)
// compiled member node returning call827 (depth = 15)
  partcv[0] = 0;
  Object call828 = callmethod(call827, "new",
    1, partcv, params);
  gc_frame_end(callframe825);
// compiled call node returning call828 (depth = 14)
// compiled member node returning call828 (depth = 13)
  *var_suggestion = call828;
  if (call828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe830 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call832 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe831);
// compiled call node returning call832 (depth = 14)
// compiled member node returning call832 (depth = 13)
  gc_frame_newslot(call832);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num834 = alloc_Float64(1);
// compiled num node returning num834 (depth = 14)
  int op_slot_right_833 = gc_frame_newslot(num834);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_linePosition (depth = 14)
  int op_slot_left_833 = gc_frame_newslot(*var_linePosition);
  params[0] = num834;
  partcv[0] = 1;
  Object diff836 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff836 (depth = 13)
  gc_frame_newslot(diff836);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call832;
  params[1] = diff836;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call837 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe830);
// compiled call node returning call837 (depth = 12)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe838 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call839 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe838);
// compiled call node returning call839 (depth = 12)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe840 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit841 == NULL) {
    strlit841 = alloc_String("The fractional part of a number must be in base 10.");
    gc_root(strlit841);
  }
// compiled string node returning strlit841 (depth = 13)
  gc_frame_newslot(strlit841);
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num843 = alloc_Float64(1);
// compiled num node returning num843 (depth = 14)
  int op_slot_right_842 = gc_frame_newslot(num843);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call846 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call846 (depth = 15)
// compiled member node returning call846 (depth = 14)
  int op_slot_left_842 = gc_frame_newslot(call846);
  params[0] = num843;
  partcv[0] = 1;
  Object sum847 = callmethod(call846, "+", 1, partcv, params);
// compiled op node returning sum847 (depth = 13)
  gc_frame_newslot(sum847);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num849 = alloc_Float64(1);
// compiled num node returning num849 (depth = 14)
  int op_slot_right_848 = gc_frame_newslot(num849);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_linePosition (depth = 14)
  int op_slot_left_848 = gc_frame_newslot(*var_linePosition);
  params[0] = num849;
  partcv[0] = 1;
  Object diff851 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff851 (depth = 13)
  gc_frame_newslot(diff851);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = strlit841;
  params[1] = *var_lineNumber;
  params[2] = sum847;
  params[3] = diff851;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call852 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe840);
// compiled call node returning call852 (depth = 12)
    gc_frame_newslot(call852);
    if784 = call852;
  }
// compiled if node returning if784 (depth = 11)
    gc_frame_newslot(if784);
    if770 = if784;
  } else {
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 11)
// starting to compile array node (depth = 12)
  Object array853 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array853 (depth = 12)
  *var_suggestions = array853;
  if (array853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 11)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe854 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe855 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  partcv[0] = 0;
  Object call856 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe855);
// compiled call node returning call856 (depth = 15)
// compiled member node returning call856 (depth = 14)
  partcv[0] = 0;
  Object call857 = callmethod(call856, "new",
    1, partcv, params);
  gc_frame_end(callframe854);
// compiled call node returning call857 (depth = 13)
// compiled member node returning call857 (depth = 12)
  *var_suggestion = call857;
  if (call857 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 11)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe858 = gc_frame_new();
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe859 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call861 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 15)
// compiled member node returning call861 (depth = 14)
  partcv[0] = 0;
  Object call862 = callmethod(call861, "linePos",
    1, partcv, params);
  gc_frame_end(callframe859);
// compiled call node returning call862 (depth = 13)
// compiled member node returning call862 (depth = 12)
  gc_frame_newslot(call862);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num864 = alloc_Float64(1);
// compiled num node returning num864 (depth = 13)
  int op_slot_right_863 = gc_frame_newslot(num864);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call867 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe866);
// compiled call node returning call867 (depth = 14)
// compiled member node returning call867 (depth = 13)
  int op_slot_left_863 = gc_frame_newslot(call867);
  params[0] = num864;
  partcv[0] = 1;
  Object diff868 = callmethod(call867, "-", 1, partcv, params);
// compiled op node returning diff868 (depth = 12)
  gc_frame_newslot(diff868);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe869 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call871 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe870);
// compiled call node returning call871 (depth = 15)
// compiled member node returning call871 (depth = 14)
  partcv[0] = 0;
  Object call872 = callmethod(call871, "value",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call872 (depth = 13)
// compiled member node returning call872 (depth = 12)
  gc_frame_newslot(call872);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = call862;
  params[1] = diff868;
  params[2] = call872;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call873 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe858);
// compiled call node returning call873 (depth = 11)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe874 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestions (depth = 12)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call875 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe874);
// compiled call node returning call875 (depth = 11)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe876 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  partcv[0] = 0;
  Object call878 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 15)
// compiled member node returning call878 (depth = 14)
  partcv[0] = 0;
  Object call879 = callmethod(call878, "new",
    1, partcv, params);
  gc_frame_end(callframe876);
// compiled call node returning call879 (depth = 13)
// compiled member node returning call879 (depth = 12)
  *var_suggestion = call879;
  if (call879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe881 = gc_frame_new();
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe882 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call883 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe882);
// compiled call node returning call883 (depth = 13)
// compiled member node returning call883 (depth = 12)
  gc_frame_newslot(call883);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = call883;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call884 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call884 (depth = 11)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe885 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestions (depth = 12)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call886 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe885);
// compiled call node returning call886 (depth = 11)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe887 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit889 == NULL) {
    strlit889 = alloc_String(" cannot have a fractional part.");
    gc_root(strlit889);
  }
// compiled string node returning strlit889 (depth = 13)
  int op_slot_right_888 = gc_frame_newslot(strlit889);
// starting to compile op node (depth = 13)
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe892 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tokens (depth = 18)
  partcv[0] = 0;
  Object call894 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe893);
// compiled call node returning call894 (depth = 17)
// compiled member node returning call894 (depth = 16)
  partcv[0] = 0;
  Object call895 = callmethod(call894, "base",
    1, partcv, params);
  gc_frame_end(callframe892);
// compiled call node returning call895 (depth = 15)
// compiled member node returning call895 (depth = 14)
  int op_slot_right_891 = gc_frame_newslot(call895);
// starting to compile string node (depth = 14)
  if (strlit897 == NULL) {
    strlit897 = alloc_String("A number in base ");
    gc_root(strlit897);
  }
// compiled string node returning strlit897 (depth = 14)
  int op_slot_left_891 = gc_frame_newslot(strlit897);
  params[0] = call895;
  partcv[0] = 1;
  Object opresult898 = callmethod(strlit897, "++", 1, partcv, params);
// compiled op node returning opresult898 (depth = 13)
  int op_slot_left_888 = gc_frame_newslot(opresult898);
  params[0] = strlit889;
  partcv[0] = 1;
  Object opresult899 = callmethod(opresult898, "++", 1, partcv, params);
// compiled op node returning opresult899 (depth = 12)
  gc_frame_newslot(opresult899);
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call901 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe900);
// compiled call node returning call901 (depth = 13)
// compiled member node returning call901 (depth = 12)
  gc_frame_newslot(call901);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num903 = alloc_Float64(1);
// compiled num node returning num903 (depth = 13)
  int op_slot_right_902 = gc_frame_newslot(num903);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_902 = gc_frame_newslot(*var_linePosition);
  params[0] = num903;
  partcv[0] = 1;
  Object diff905 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff905 (depth = 12)
  gc_frame_newslot(diff905);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestions (depth = 12)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = opresult899;
  params[1] = *var_lineNumber;
  params[2] = call901;
  params[3] = diff905;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call906 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe887);
// compiled call node returning call906 (depth = 11)
    gc_frame_newslot(call906);
    if770 = call906;
  }
// compiled if node returning if770 (depth = 10)
    gc_frame_newslot(if770);
    if761 = if770;
  } else {
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit909 == NULL) {
    strlit909 = alloc_String("string");
    gc_root(strlit909);
  }
// compiled string node returning strlit909 (depth = 12)
  int op_slot_right_908 = gc_frame_newslot(strlit909);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe911 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call913 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe912);
// compiled call node returning call913 (depth = 15)
// compiled member node returning call913 (depth = 14)
  partcv[0] = 0;
  Object call914 = callmethod(call913, "kind",
    1, partcv, params);
  gc_frame_end(callframe911);
// compiled call node returning call914 (depth = 13)
// compiled member node returning call914 (depth = 12)
  int op_slot_left_908 = gc_frame_newslot(call914);
  params[0] = strlit909;
  partcv[0] = 1;
  Object opresult915 = callmethod(call914, "==", 1, partcv, params);
// compiled op node returning opresult915 (depth = 11)
  Object if907 = done;
  if (istrue(opresult915)) {
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe916 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  partcv[0] = 0;
  Object call918 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe917);
// compiled call node returning call918 (depth = 15)
// compiled member node returning call918 (depth = 14)
  partcv[0] = 0;
  Object call919 = callmethod(call918, "new",
    1, partcv, params);
  gc_frame_end(callframe916);
// compiled call node returning call919 (depth = 13)
// compiled member node returning call919 (depth = 12)
  *var_suggestion = call919;
  if (call919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 11)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe920 = gc_frame_new();
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call922 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe921);
// compiled call node returning call922 (depth = 13)
// compiled member node returning call922 (depth = 12)
  gc_frame_newslot(call922);
// starting to compile string node (depth = 12)
  if (strlit923 == NULL) {
    strlit923 = alloc_String("++");
    gc_root(strlit923);
  }
// compiled string node returning strlit923 (depth = 12)
  gc_frame_newslot(strlit923);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call925 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 13)
// compiled member node returning call925 (depth = 12)
  gc_frame_newslot(call925);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = call922;
  params[1] = strlit923;
  params[2] = call925;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call926 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe920);
// compiled call node returning call926 (depth = 11)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe927 = gc_frame_new();
// starting to compile op node (depth = 12)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit929 == NULL) {
    strlit929 = alloc_String("To join a number to a string, use '++'.");
    gc_root(strlit929);
  }
// compiled string node returning strlit929 (depth = 13)
  int op_slot_right_928 = gc_frame_newslot(strlit929);
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit931 == NULL) {
    strlit931 = alloc_String("A number may follow a '.' only if there is a number before the '.'. ");
    gc_root(strlit931);
  }
// compiled string node returning strlit931 (depth = 13)
  int op_slot_left_928 = gc_frame_newslot(strlit931);
  params[0] = strlit929;
  partcv[0] = 1;
  Object opresult932 = callmethod(strlit931, "++", 1, partcv, params);
// compiled op node returning opresult932 (depth = 12)
  gc_frame_newslot(opresult932);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call934 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe933);
// compiled call node returning call934 (depth = 13)
// compiled member node returning call934 (depth = 12)
  gc_frame_newslot(call934);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call936 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe935);
// compiled call node returning call936 (depth = 13)
// compiled member node returning call936 (depth = 12)
  gc_frame_newslot(call936);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_dot (depth = 14)
  partcv[0] = 0;
  Object call938 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe937);
// compiled call node returning call938 (depth = 13)
// compiled member node returning call938 (depth = 12)
  gc_frame_newslot(call938);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = opresult932;
  params[1] = call934;
  params[2] = call936;
  params[3] = call938;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call939 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe927);
// compiled call node returning call939 (depth = 11)
    gc_frame_newslot(call939);
    if907 = call939;
  } else {
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit943 == NULL) {
    strlit943 = alloc_String("bind");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 14)
  int op_slot_right_942 = gc_frame_newslot(strlit943);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe945 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tokens (depth = 18)
  partcv[0] = 0;
  Object call947 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 17)
// compiled member node returning call947 (depth = 16)
  partcv[0] = 0;
  Object call948 = callmethod(call947, "kind",
    1, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call948 (depth = 15)
// compiled member node returning call948 (depth = 14)
  int op_slot_left_942 = gc_frame_newslot(call948);
  params[0] = strlit943;
  partcv[0] = 1;
  Object opresult949 = callmethod(call948, "==", 1, partcv, params);
// compiled op node returning opresult949 (depth = 13)
  int op_slot_right_941 = gc_frame_newslot(opresult949);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit952 == NULL) {
    strlit952 = alloc_String("op");
    gc_root(strlit952);
  }
// compiled string node returning strlit952 (depth = 14)
  int op_slot_right_951 = gc_frame_newslot(strlit952);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe954 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tokens (depth = 18)
  partcv[0] = 0;
  Object call956 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe955);
// compiled call node returning call956 (depth = 17)
// compiled member node returning call956 (depth = 16)
  partcv[0] = 0;
  Object call957 = callmethod(call956, "kind",
    1, partcv, params);
  gc_frame_end(callframe954);
// compiled call node returning call957 (depth = 15)
// compiled member node returning call957 (depth = 14)
  int op_slot_left_951 = gc_frame_newslot(call957);
  params[0] = strlit952;
  partcv[0] = 1;
  Object opresult958 = callmethod(call957, "==", 1, partcv, params);
// compiled op node returning opresult958 (depth = 13)
  int op_slot_left_941 = gc_frame_newslot(opresult958);
  params[0] = opresult949;
  partcv[0] = 1;
  Object opresult959 = callmethod(opresult958, "||", 1, partcv, params);
// compiled op node returning opresult959 (depth = 12)
  Object if940 = done;
  if (istrue(opresult959)) {
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe960 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call962 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe961);
// compiled call node returning call962 (depth = 16)
// compiled member node returning call962 (depth = 15)
  partcv[0] = 0;
  Object call963 = callmethod(call962, "new",
    1, partcv, params);
  gc_frame_end(callframe960);
// compiled call node returning call963 (depth = 14)
// compiled member node returning call963 (depth = 13)
  *var_suggestion = call963;
  if (call963 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe964 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit965 == NULL) {
    strlit965 = alloc_String("0");
    gc_root(strlit965);
  }
// compiled string node returning strlit965 (depth = 13)
  gc_frame_newslot(strlit965);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call967 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe966);
// compiled call node returning call967 (depth = 14)
// compiled member node returning call967 (depth = 13)
  gc_frame_newslot(call967);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call969 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe968);
// compiled call node returning call969 (depth = 14)
// compiled member node returning call969 (depth = 13)
  gc_frame_newslot(call969);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit965;
  params[1] = call967;
  params[2] = call969;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call970 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe964);
// compiled call node returning call970 (depth = 12)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe971 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit972 == NULL) {
    strlit972 = alloc_String("A number must have a digit before the decimal point.");
    gc_root(strlit972);
  }
// compiled string node returning strlit972 (depth = 13)
  gc_frame_newslot(strlit972);
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call974 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe973);
// compiled call node returning call974 (depth = 14)
// compiled member node returning call974 (depth = 13)
  gc_frame_newslot(call974);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call976 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe975);
// compiled call node returning call976 (depth = 14)
// compiled member node returning call976 (depth = 13)
  gc_frame_newslot(call976);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = strlit972;
  params[1] = call974;
  params[2] = call976;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call977 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe971);
// compiled call node returning call977 (depth = 12)
    gc_frame_newslot(call977);
    if940 = call977;
  } else {
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit980 == NULL) {
    strlit980 = alloc_String("identifier");
    gc_root(strlit980);
  }
// compiled string node returning strlit980 (depth = 14)
  int op_slot_right_979 = gc_frame_newslot(strlit980);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe982 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tokens (depth = 18)
  partcv[0] = 0;
  Object call984 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe983);
// compiled call node returning call984 (depth = 17)
// compiled member node returning call984 (depth = 16)
  partcv[0] = 0;
  Object call985 = callmethod(call984, "kind",
    1, partcv, params);
  gc_frame_end(callframe982);
// compiled call node returning call985 (depth = 15)
// compiled member node returning call985 (depth = 14)
  int op_slot_left_979 = gc_frame_newslot(call985);
  params[0] = strlit980;
  partcv[0] = 1;
  Object opresult986 = callmethod(call985, "==", 1, partcv, params);
// compiled op node returning opresult986 (depth = 13)
  Object if978 = done;
  if (istrue(opresult986)) {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// starting to compile array node (depth = 14)
  Object array987 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array987 (depth = 14)
  *var_suggestions = array987;
  if (array987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit990 == NULL) {
    strlit990 = alloc_String("o");
    gc_root(strlit990);
  }
// compiled string node returning strlit990 (depth = 15)
  int op_slot_right_989 = gc_frame_newslot(strlit990);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe992 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call994 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe993);
// compiled call node returning call994 (depth = 18)
// compiled member node returning call994 (depth = 17)
  partcv[0] = 0;
  Object call995 = callmethod(call994, "value",
    1, partcv, params);
  gc_frame_end(callframe992);
// compiled call node returning call995 (depth = 16)
// compiled member node returning call995 (depth = 15)
  int op_slot_left_989 = gc_frame_newslot(call995);
  params[0] = strlit990;
  partcv[0] = 1;
  Object opresult996 = callmethod(call995, "==", 1, partcv, params);
// compiled op node returning opresult996 (depth = 14)
  Object if988 = done;
  if (istrue(opresult996)) {
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe997 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe998 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_errormessages (depth = 19)
  partcv[0] = 0;
  Object call999 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 18)
// compiled member node returning call999 (depth = 17)
  partcv[0] = 0;
  Object call1000 = callmethod(call999, "new",
    1, partcv, params);
  gc_frame_end(callframe997);
// compiled call node returning call1000 (depth = 16)
// compiled member node returning call1000 (depth = 15)
  *var_suggestion = call1000;
  if (call1000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 14)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1001 = gc_frame_new();
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1002 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe1003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call1004 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compiled call node returning call1004 (depth = 18)
// compiled member node returning call1004 (depth = 17)
  partcv[0] = 0;
  Object call1005 = callmethod(call1004, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1002);
// compiled call node returning call1005 (depth = 16)
// compiled member node returning call1005 (depth = 15)
  gc_frame_newslot(call1005);
// starting to compile string node (depth = 15)
  if (strlit1006 == NULL) {
    strlit1006 = alloc_String("0");
    gc_root(strlit1006);
  }
// compiled string node returning strlit1006 (depth = 15)
  gc_frame_newslot(strlit1006);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1007 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe1008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call1009 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe1008);
// compiled call node returning call1009 (depth = 18)
// compiled member node returning call1009 (depth = 17)
  partcv[0] = 0;
  Object call1010 = callmethod(call1009, "line",
    1, partcv, params);
  gc_frame_end(callframe1007);
// compiled call node returning call1010 (depth = 16)
// compiled member node returning call1010 (depth = 15)
  gc_frame_newslot(call1010);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  params[0] = call1005;
  params[1] = strlit1006;
  params[2] = call1010;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1011 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe1001);
// compiled call node returning call1011 (depth = 14)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1012 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestions (depth = 15)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1013 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1012);
// compiled call node returning call1013 (depth = 14)
    gc_frame_newslot(call1013);
    if988 = call1013;
  } else {
  }
// compiled if node returning if988 (depth = 13)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1014 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe1015 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call1016 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1015);
// compiled call node returning call1016 (depth = 17)
// compiled member node returning call1016 (depth = 16)
  partcv[0] = 0;
  Object call1017 = callmethod(call1016, "new",
    1, partcv, params);
  gc_frame_end(callframe1014);
// compiled call node returning call1017 (depth = 15)
// compiled member node returning call1017 (depth = 14)
  *var_suggestion = call1017;
  if (call1017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1018 = gc_frame_new();
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1020 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1019);
// compiled call node returning call1020 (depth = 15)
// compiled member node returning call1020 (depth = 14)
  gc_frame_newslot(call1020);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num1022 = alloc_Float64(1);
// compiled num node returning num1022 (depth = 15)
  int op_slot_right_1021 = gc_frame_newslot(num1022);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_1021 = gc_frame_newslot(*var_linePosition);
  params[0] = num1022;
  partcv[0] = 1;
  Object diff1024 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1024 (depth = 14)
  gc_frame_newslot(diff1024);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1026 == NULL) {
    strlit1026 = alloc_String(")");
    gc_root(strlit1026);
  }
// compiled string node returning strlit1026 (depth = 15)
  int op_slot_right_1025 = gc_frame_newslot(strlit1026);
// starting to compile op node (depth = 15)
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_right_1028 = gc_frame_newslot(*var_accum);
// starting to compile string node (depth = 16)
  if (strlit1030 == NULL) {
    strlit1030 = alloc_String("(");
    gc_root(strlit1030);
  }
// compiled string node returning strlit1030 (depth = 16)
  int op_slot_left_1028 = gc_frame_newslot(strlit1030);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult1031 = callmethod(strlit1030, "++", 1, partcv, params);
// compiled op node returning opresult1031 (depth = 15)
  int op_slot_left_1025 = gc_frame_newslot(opresult1031);
  params[0] = strlit1026;
  partcv[0] = 1;
  Object opresult1032 = callmethod(opresult1031, "++", 1, partcv, params);
// compiled op node returning opresult1032 (depth = 14)
  gc_frame_newslot(opresult1032);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1033 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe1034 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_tokens (depth = 18)
  partcv[0] = 0;
  Object call1035 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 17)
// compiled member node returning call1035 (depth = 16)
  partcv[0] = 0;
  Object call1036 = callmethod(call1035, "line",
    1, partcv, params);
  gc_frame_end(callframe1033);
// compiled call node returning call1036 (depth = 15)
// compiled member node returning call1036 (depth = 14)
  gc_frame_newslot(call1036);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = call1020;
  params[1] = diff1024;
  params[2] = opresult1032;
  params[3] = call1036;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1037 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe1018);
// compiled call node returning call1037 (depth = 13)
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1038 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1039 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1038);
// compiled call node returning call1039 (depth = 13)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1040 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit1041 == NULL) {
    strlit1041 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit1041);
  }
// compiled string node returning strlit1041 (depth = 14)
  gc_frame_newslot(strlit1041);
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1043 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe1042);
// compiled call node returning call1043 (depth = 15)
// compiled member node returning call1043 (depth = 14)
  gc_frame_newslot(call1043);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1044 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1045 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1044);
// compiled call node returning call1045 (depth = 15)
// compiled member node returning call1045 (depth = 14)
  gc_frame_newslot(call1045);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1047 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1046);
// compiled call node returning call1047 (depth = 15)
// compiled member node returning call1047 (depth = 14)
  gc_frame_newslot(call1047);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit1041;
  params[1] = call1043;
  params[2] = call1045;
  params[3] = call1047;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1048 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1040);
// compiled call node returning call1048 (depth = 13)
    gc_frame_newslot(call1048);
    if978 = call1048;
  } else {
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1049 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit1050 == NULL) {
    strlit1050 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit1050);
  }
// compiled string node returning strlit1050 (depth = 14)
  gc_frame_newslot(strlit1050);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1052 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe1051);
// compiled call node returning call1052 (depth = 15)
// compiled member node returning call1052 (depth = 14)
  gc_frame_newslot(call1052);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1054 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1053);
// compiled call node returning call1054 (depth = 15)
// compiled member node returning call1054 (depth = 14)
  gc_frame_newslot(call1054);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call1056 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1055);
// compiled call node returning call1056 (depth = 15)
// compiled member node returning call1056 (depth = 14)
  gc_frame_newslot(call1056);
// call case 6: other member request
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit1050;
  params[1] = call1052;
  params[2] = call1054;
  params[3] = call1056;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1057 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe1049);
// compiled call node returning call1057 (depth = 13)
    gc_frame_newslot(call1057);
    if978 = call1057;
  }
// compiled if node returning if978 (depth = 12)
    gc_frame_newslot(if978);
    if940 = if978;
  }
// compiled if node returning if940 (depth = 11)
    gc_frame_newslot(if940);
    if907 = if940;
  }
// compiled if node returning if907 (depth = 10)
    gc_frame_newslot(if907);
    if761 = if907;
  }
// compiled if node returning if761 (depth = 9)
    gc_frame_newslot(if761);
    if739 = if761;
  } else {
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1058 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1059 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1058);
// compiled call node returning call1059 (depth = 10)
  *var_tok = call1059;
  if (call1059 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if739 = done;
  }
// compiled if node returning if739 (depth = 8)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1061 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1062 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1061);
// compiled call node returning call1062 (depth = 8)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1063 = alloc_Boolean(1);
// compiled identifier node returning bool1063 (depth = 9)
  *var_isDone = bool1063;
  if (bool1063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if734 = done;
  } else {
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1067 == NULL) {
    strlit1067 = alloc_String("o");
    gc_root(strlit1067);
  }
// compiled string node returning strlit1067 (depth = 10)
  int op_slot_right_1066 = gc_frame_newslot(strlit1067);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_1066 = gc_frame_newslot(*var_mode);
  params[0] = strlit1067;
  partcv[0] = 1;
  Object opresult1069 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1069 (depth = 9)
  Object if1065 = done;
  if (istrue(opresult1069)) {
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1070 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_OpToken (depth = 11)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1071 = callmethod(*var_OpToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1070);
// compiled call node returning call1071 (depth = 10)
  *var_tok = call1071;
  if (call1071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1075 == NULL) {
    strlit1075 = alloc_String("->");
    gc_root(strlit1075);
  }
// compiled string node returning strlit1075 (depth = 11)
  int op_slot_right_1074 = gc_frame_newslot(strlit1075);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_1074 = gc_frame_newslot(*var_accum);
  params[0] = strlit1075;
  partcv[0] = 1;
  Object opresult1077 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1077 (depth = 10)
  Object if1073 = done;
  if (istrue(opresult1077)) {
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ArrowToken (depth = 13)
  partcv[0] = 0;
  Object call1079 = callmethod(*var_ArrowToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1078);
// compiled call node returning call1079 (depth = 12)
// compiled member node returning call1079 (depth = 11)
  *var_tok = call1079;
  if (call1079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1073 = done;
  } else {
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1083 == NULL) {
    strlit1083 = alloc_String(":=");
    gc_root(strlit1083);
  }
// compiled string node returning strlit1083 (depth = 12)
  int op_slot_right_1082 = gc_frame_newslot(strlit1083);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_1082 = gc_frame_newslot(*var_accum);
  params[0] = strlit1083;
  partcv[0] = 1;
  Object opresult1085 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1085 (depth = 11)
  Object if1081 = done;
  if (istrue(opresult1085)) {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_BindToken (depth = 14)
  partcv[0] = 0;
  Object call1087 = callmethod(*var_BindToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1086);
// compiled call node returning call1087 (depth = 13)
// compiled member node returning call1087 (depth = 12)
  *var_tok = call1087;
  if (call1087 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1081 = done;
  } else {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String(":");
    gc_root(strlit1091);
  }
// compiled string node returning strlit1091 (depth = 13)
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_1090 = gc_frame_newslot(*var_accum);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1093 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1093 (depth = 12)
  Object if1089 = done;
  if (istrue(opresult1093)) {
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1094 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_ColonToken (depth = 15)
  partcv[0] = 0;
  Object call1095 = callmethod(*var_ColonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1094);
// compiled call node returning call1095 (depth = 14)
// compiled member node returning call1095 (depth = 13)
  *var_tok = call1095;
  if (call1095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1089 = done;
  } else {
  }
// compiled if node returning if1089 (depth = 11)
    gc_frame_newslot(if1089);
    if1081 = if1089;
  }
// compiled if node returning if1081 (depth = 10)
    gc_frame_newslot(if1081);
    if1073 = if1081;
  }
// compiled if node returning if1073 (depth = 9)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1097 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1098 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1097);
// compiled call node returning call1098 (depth = 9)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1099 = alloc_Boolean(1);
// compiled identifier node returning bool1099 (depth = 10)
  *var_isDone = bool1099;
  if (bool1099 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1065 = done;
  } else {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1103 == NULL) {
    strlit1103 = alloc_String("d");
    gc_root(strlit1103);
  }
// compiled string node returning strlit1103 (depth = 11)
  int op_slot_right_1102 = gc_frame_newslot(strlit1103);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_1102 = gc_frame_newslot(*var_mode);
  params[0] = strlit1103;
  partcv[0] = 1;
  Object opresult1105 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1105 (depth = 10)
  Object if1101 = done;
  if (istrue(opresult1105)) {
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1107 = alloc_Float64(1);
// compiled num node returning num1107 (depth = 12)
  int op_slot_right_1106 = gc_frame_newslot(num1107);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_linePosition (depth = 12)
  int op_slot_left_1106 = gc_frame_newslot(*var_linePosition);
  params[0] = num1107;
  partcv[0] = 1;
  Object diff1109 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1109 (depth = 11)
  *var_indentLevel = diff1109;
  if (diff1109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1111 = alloc_Boolean(1);
// compiled identifier node returning bool1111 (depth = 11)
  *var_isDone = bool1111;
  if (bool1111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1101 = done;
  } else {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1115 == NULL) {
    strlit1115 = alloc_String("n");
    gc_root(strlit1115);
  }
// compiled string node returning strlit1115 (depth = 12)
  int op_slot_right_1114 = gc_frame_newslot(strlit1115);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_1114 = gc_frame_newslot(*var_mode);
  params[0] = strlit1115;
  partcv[0] = 1;
  Object opresult1117 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1117 (depth = 11)
  Object if1113 = done;
  if (istrue(opresult1117)) {
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool1118 = alloc_Boolean(1);
// compiled identifier node returning bool1118 (depth = 12)
  *var_isDone = bool1118;
  if (bool1118 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1113 = done;
  } else {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1122 == NULL) {
    strlit1122 = alloc_String("c");
    gc_root(strlit1122);
  }
// compiled string node returning strlit1122 (depth = 13)
  int op_slot_right_1121 = gc_frame_newslot(strlit1122);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_1121 = gc_frame_newslot(*var_mode);
  params[0] = strlit1122;
  partcv[0] = 1;
  Object opresult1124 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1124 (depth = 12)
  Object if1120 = done;
  if (istrue(opresult1124)) {
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// starting to compile num node (depth = 13)
  Object num1125 = alloc_Float64(3);
// compiled num node returning num1125 (depth = 13)
  *var_firstNonSpace = num1125;
  if (num1125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  partcv[0] = 0;
  Object call1127 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1126);
// compiled call node returning call1127 (depth = 14)
// compiled member node returning call1127 (depth = 13)
  *var_accumSize = call1127;
  if (call1127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe1128 = gc_frame_new();
// starting to compile block node (depth = 13)
  Object block1129 = alloc_Block(NULL, NULL, "lexer", 362);
  gc_frame_newslot(block1129);
// method _apply
  block_savedest(block1129);
  Object closure1130 = createclosure(3, "_apply");
  setclosureframe(closure1130, stackframe);
  addtoclosure(closure1130, var_firstNonSpace);
  addtoclosure(closure1130, var_accum);
  addtoclosure(closure1130, selfslot);
  struct UserObject *uo1130 = (struct UserObject*)block1129;
  uo1130->data[0] = (Object)closure1130;
  Method *meth_meth_lexer__apply1130 = addmethod2pos(block1129, "_apply", &meth_lexer__apply1130, 0);
  int argcv_meth_lexer__apply1130[] = {0};
  meth_meth_lexer__apply1130->type = alloc_MethodType(1, argcv_meth_lexer__apply1130);
  meth_meth_lexer__apply1130->definitionModule = modulename;
  meth_meth_lexer__apply1130->definitionLine = 361;
// compiled block node returning block1129 (depth = 13)
  gc_frame_newslot(block1129);
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 13)
  Object block1148 = alloc_Block(NULL, NULL, "lexer", 363);
  gc_frame_newslot(block1148);
// method _apply
  block_savedest(block1148);
  Object closure1149 = createclosure(2, "_apply");
  setclosureframe(closure1149, stackframe);
  addtoclosure(closure1149, var_firstNonSpace);
  addtoclosure(closure1149, selfslot);
  struct UserObject *uo1149 = (struct UserObject*)block1148;
  uo1149->data[0] = (Object)closure1149;
  Method *meth_meth_lexer__apply1149 = addmethod2pos(block1148, "_apply", &meth_lexer__apply1149, 0);
  int argcv_meth_lexer__apply1149[] = {0};
  meth_meth_lexer__apply1149->type = alloc_MethodType(1, argcv_meth_lexer__apply1149);
  meth_meth_lexer__apply1149->definitionModule = modulename;
  meth_meth_lexer__apply1149->definitionLine = 362;
// compiled block node returning block1148 (depth = 13)
  gc_frame_newslot(block1148);
// call case 5: prelude request
  params[0] = block1129;
  params[1] = block1148;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1156 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1128);
// compiled call node returning call1156 (depth = 12)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1157 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_firstNonSpace (depth = 14)
  gc_frame_newslot(*var_firstNonSpace);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  partcv[0] = 0;
  Object call1159 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1158);
// compiled call node returning call1159 (depth = 15)
// compiled member node returning call1159 (depth = 14)
  gc_frame_newslot(call1159);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  params[0] = *var_firstNonSpace;
  params[1] = call1159;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1160 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1157);
// compiled call node returning call1160 (depth = 13)
  *var_cmt = call1160;
  if (call1160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe1161 = gc_frame_new();
// starting to compile call node (depth = 13)
  int callframe1162 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_cmt (depth = 14)
  gc_frame_newslot(*var_cmt);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_CommentToken (depth = 14)
  params[0] = *var_cmt;
  partcv[0] = 1;
  Object call1163 = callmethod(*var_CommentToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1162);
// compiled call node returning call1163 (depth = 13)
  gc_frame_newslot(call1163);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  params[0] = call1163;
  partcv[0] = 1;
  Object call1164 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1161);
// compiled call node returning call1164 (depth = 12)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile identifier node (depth = 13)
  Object bool1165 = alloc_Boolean(1);
// compiled identifier node returning bool1165 (depth = 13)
  *var_isDone = bool1165;
  if (bool1165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1120 = done;
  } else {
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1169 == NULL) {
    strlit1169 = alloc_String("p");
    gc_root(strlit1169);
  }
// compiled string node returning strlit1169 (depth = 14)
  int op_slot_right_1168 = gc_frame_newslot(strlit1169);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_1168 = gc_frame_newslot(*var_mode);
  params[0] = strlit1169;
  partcv[0] = 1;
  Object opresult1171 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1171 (depth = 13)
  Object if1167 = done;
  if (istrue(opresult1171)) {
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1174 == NULL) {
    strlit1174 = alloc_String("#pragma ");
    gc_root(strlit1174);
  }
// compiled string node returning strlit1174 (depth = 15)
  int op_slot_right_1173 = gc_frame_newslot(strlit1174);
// starting to compile call node (depth = 15)
  int callframe1176 = gc_frame_new();
// starting to compile num node (depth = 16)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 16)
  gc_frame_newslot(num1177);
// starting to compile num node (depth = 16)
  Object num1178 = alloc_Float64(8);
// compiled num node returning num1178 (depth = 16)
  gc_frame_newslot(num1178);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  params[0] = num1177;
  params[1] = num1178;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1179 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1176);
// compiled call node returning call1179 (depth = 15)
  int op_slot_left_1173 = gc_frame_newslot(call1179);
  params[0] = strlit1174;
  partcv[0] = 1;
  Object opresult1180 = callmethod(call1179, "==", 1, partcv, params);
// compiled op node returning opresult1180 (depth = 14)
  Object if1172 = done;
  if (istrue(opresult1180)) {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1181 = gc_frame_new();
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe1182 = gc_frame_new();
// starting to compile num node (depth = 16)
  Object num1183 = alloc_Float64(9);
// compiled num node returning num1183 (depth = 16)
  gc_frame_newslot(num1183);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe1184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  partcv[0] = 0;
  Object call1185 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1184);
// compiled call node returning call1185 (depth = 17)
// compiled member node returning call1185 (depth = 16)
  gc_frame_newslot(call1185);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  params[0] = num1183;
  params[1] = call1185;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1186 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1182);
// compiled call node returning call1186 (depth = 15)
  gc_frame_newslot(call1186);
// call case 6: other member request
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  params[0] = call1186;
  partcv[0] = 1;
  Object call1187 = callmethod(*var_util, "processExtension",
    1, partcv, params);
  gc_frame_end(callframe1181);
// compiled call node returning call1187 (depth = 14)
    gc_frame_newslot(call1187);
    if1172 = call1187;
  } else {
  }
// compiled if node returning if1172 (depth = 13)
    gc_frame_newslot(if1172);
    if1167 = if1172;
  } else {
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_isDone (depth = 14)
  Object if1188 = done;
  if (istrue(*var_isDone)) {
    gc_frame_newslot(done);
    if1188 = done;
  } else {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1189 = gc_frame_new();
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1191 == NULL) {
    strlit1191 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit1191);
  }
// compiled string node returning strlit1191 (depth = 16)
  int op_slot_right_1190 = gc_frame_newslot(strlit1191);
// starting to compile op node (depth = 16)
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_right_1193 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit1196 == NULL) {
    strlit1196 = alloc_String(" with accum ""\xe2""""\x80""""\xb9""");
    gc_root(strlit1196);
  }
// compiled string node returning strlit1196 (depth = 18)
  int op_slot_right_1195 = gc_frame_newslot(strlit1196);
// starting to compile op node (depth = 18)
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_mode (depth = 19)
  int op_slot_right_1198 = gc_frame_newslot(*var_mode);
// starting to compile string node (depth = 19)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("Lexing error: no handler for mode ");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 19)
  int op_slot_left_1198 = gc_frame_newslot(strlit1200);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult1201 = callmethod(strlit1200, "++", 1, partcv, params);
// compiled op node returning opresult1201 (depth = 18)
  int op_slot_left_1195 = gc_frame_newslot(opresult1201);
  params[0] = strlit1196;
  partcv[0] = 1;
  Object opresult1202 = callmethod(opresult1201, "++", 1, partcv, params);
// compiled op node returning opresult1202 (depth = 17)
  int op_slot_left_1193 = gc_frame_newslot(opresult1202);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult1203 = callmethod(opresult1202, "++", 1, partcv, params);
// compiled op node returning opresult1203 (depth = 16)
  int op_slot_left_1190 = gc_frame_newslot(opresult1203);
  params[0] = strlit1191;
  partcv[0] = 1;
  Object opresult1204 = callmethod(opresult1203, "++", 1, partcv, params);
// compiled op node returning opresult1204 (depth = 15)
  gc_frame_newslot(opresult1204);
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_lineNumber (depth = 15)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = opresult1204;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call1205 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe1189);
// compiled call node returning call1205 (depth = 14)
    gc_frame_newslot(call1205);
    if1188 = call1205;
  }
// compiled if node returning if1188 (depth = 13)
    gc_frame_newslot(if1188);
    if1167 = if1188;
  }
// compiled if node returning if1167 (depth = 12)
    gc_frame_newslot(if1167);
    if1120 = if1167;
  }
// compiled if node returning if1120 (depth = 11)
    gc_frame_newslot(if1120);
    if1113 = if1120;
  }
// compiled if node returning if1113 (depth = 10)
    gc_frame_newslot(if1113);
    if1101 = if1113;
  }
// compiled if node returning if1101 (depth = 9)
    gc_frame_newslot(if1101);
    if1065 = if1101;
  }
// compiled if node returning if1065 (depth = 8)
    gc_frame_newslot(if1065);
    if734 = if1065;
  }
// compiled if node returning if734 (depth = 7)
    gc_frame_newslot(if734);
    if722 = if734;
  }
// compiled if node returning if722 (depth = 6)
    gc_frame_newslot(if722);
    if710 = if722;
  }
// compiled if node returning if710 (depth = 5)
    gc_frame_newslot(if710);
    if698 = if710;
  }
// compiled if node returning if698 (depth = 4)
    gc_frame_newslot(if698);
    if686 = if698;
  }
// compiled if node returning if686 (depth = 3)
    gc_frame_newslot(if686);
    if441 = if686;
  } else {
  }
// compiled if node returning if441 (depth = 2)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_linePosition (depth = 3)
  *var_startPosition = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply1212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_base = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_linePosition = getfromclosure(closure, 4);
  Object *var_lineNumber = getfromclosure(closure, 5);
  Object *var_i = getfromclosure(closure, 6);
  Object *var_unicode = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_inc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "inc");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_validDigits = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "validDigits");
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  partcv[0] = 0;
  Object call1214 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe1213);
// compiled call node returning call1214 (depth = 6)
// compiled member node returning call1214 (depth = 5)
  *var_n = call1214;
  if (call1214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_base (depth = 6)
  int op_slot_right_1215 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_1215 = gc_frame_newslot(*var_val);
  params[0] = *var_base;
  partcv[0] = 1;
  Object prod1217 = callmethod(*var_val, "*", 1, partcv, params);
// compiled op node returning prod1217 (depth = 5)
  *var_val = prod1217;
  if (prod1217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1219 = alloc_Float64(0);
// compiled num node returning num1219 (depth = 5)
  *var_inc = num1219;
  if (num1219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1223 = alloc_Float64(57);
// compiled num node returning num1223 (depth = 7)
  int op_slot_right_1222 = gc_frame_newslot(num1223);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1222 = gc_frame_newslot(*var_n);
  params[0] = num1223;
  partcv[0] = 1;
  Object opresult1225 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1225 (depth = 6)
  int op_slot_right_1221 = gc_frame_newslot(opresult1225);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1228 = alloc_Float64(48);
// compiled num node returning num1228 (depth = 7)
  int op_slot_right_1227 = gc_frame_newslot(num1228);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1227 = gc_frame_newslot(*var_n);
  params[0] = num1228;
  partcv[0] = 1;
  Object opresult1230 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1230 (depth = 6)
  int op_slot_left_1221 = gc_frame_newslot(opresult1230);
  params[0] = opresult1225;
  partcv[0] = 1;
  Object opresult1231 = callmethod(opresult1230, "&&", 1, partcv, params);
// compiled op node returning opresult1231 (depth = 5)
  Object if1220 = done;
  if (istrue(opresult1231)) {
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1233 = alloc_Float64(48);
// compiled num node returning num1233 (depth = 7)
  int op_slot_right_1232 = gc_frame_newslot(num1233);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1232 = gc_frame_newslot(*var_n);
  params[0] = num1233;
  partcv[0] = 1;
  Object diff1235 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1235 (depth = 6)
  *var_inc = diff1235;
  if (diff1235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1220 = done;
  } else {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1240 = alloc_Float64(90);
// compiled num node returning num1240 (depth = 8)
  int op_slot_right_1239 = gc_frame_newslot(num1240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1239 = gc_frame_newslot(*var_n);
  params[0] = num1240;
  partcv[0] = 1;
  Object opresult1242 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1242 (depth = 7)
  int op_slot_right_1238 = gc_frame_newslot(opresult1242);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1245 = alloc_Float64(65);
// compiled num node returning num1245 (depth = 8)
  int op_slot_right_1244 = gc_frame_newslot(num1245);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1244 = gc_frame_newslot(*var_n);
  params[0] = num1245;
  partcv[0] = 1;
  Object opresult1247 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 7)
  int op_slot_left_1238 = gc_frame_newslot(opresult1247);
  params[0] = opresult1242;
  partcv[0] = 1;
  Object opresult1248 = callmethod(opresult1247, "&&", 1, partcv, params);
// compiled op node returning opresult1248 (depth = 6)
  Object if1237 = done;
  if (istrue(opresult1248)) {
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1250 = alloc_Float64(55);
// compiled num node returning num1250 (depth = 8)
  int op_slot_right_1249 = gc_frame_newslot(num1250);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1249 = gc_frame_newslot(*var_n);
  params[0] = num1250;
  partcv[0] = 1;
  Object diff1252 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1252 (depth = 7)
  *var_inc = diff1252;
  if (diff1252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1237 = done;
  } else {
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1255 = alloc_Float64(87);
// compiled num node returning num1255 (depth = 8)
  int op_slot_right_1254 = gc_frame_newslot(num1255);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1254 = gc_frame_newslot(*var_n);
  params[0] = num1255;
  partcv[0] = 1;
  Object diff1257 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1257 (depth = 7)
  *var_inc = diff1257;
  if (diff1257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1237 = done;
  }
// compiled if node returning if1237 (depth = 5)
    gc_frame_newslot(if1237);
    if1220 = if1237;
  }
// compiled if node returning if1220 (depth = 4)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_base (depth = 6)
  int op_slot_right_1260 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inc (depth = 6)
  int op_slot_left_1260 = gc_frame_newslot(*var_inc);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1262 = callmethod(*var_inc, ">=", 1, partcv, params);
// compiled op node returning opresult1262 (depth = 5)
  Object if1259 = done;
  if (istrue(opresult1262)) {
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1266 = alloc_Float64(16);
// compiled num node returning num1266 (depth = 8)
  int op_slot_right_1265 = gc_frame_newslot(num1266);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inc (depth = 8)
  int op_slot_left_1265 = gc_frame_newslot(*var_inc);
  params[0] = num1266;
  partcv[0] = 1;
  Object opresult1268 = callmethod(*var_inc, "<", 1, partcv, params);
// compiled op node returning opresult1268 (depth = 7)
  int op_slot_right_1264 = gc_frame_newslot(opresult1268);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1271 == NULL) {
    strlit1271 = alloc_String("0");
    gc_root(strlit1271);
  }
// compiled string node returning strlit1271 (depth = 8)
  int op_slot_right_1270 = gc_frame_newslot(strlit1271);
// starting to compile index node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
// starting to compile num node (depth = 9)
  Object num1273 = alloc_Float64(1);
// compiled num node returning num1273 (depth = 9)
  params[0] = num1273;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1274 = callmethod(*var_str, "[]", 1, partcv, params);
// compiled index node returning idxres1274 (depth = 8)
  int op_slot_left_1270 = gc_frame_newslot(idxres1274);
  params[0] = strlit1271;
  partcv[0] = 1;
  Object opresult1275 = callmethod(idxres1274, "==", 1, partcv, params);
// compiled op node returning opresult1275 (depth = 7)
  int op_slot_left_1264 = gc_frame_newslot(opresult1275);
  params[0] = opresult1268;
  partcv[0] = 1;
  Object opresult1276 = callmethod(opresult1275, "&&", 1, partcv, params);
// compiled op node returning opresult1276 (depth = 6)
  Object if1263 = done;
  if (istrue(opresult1276)) {
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1277 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1278 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1279 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1278);
// compiled call node returning call1279 (depth = 10)
// compiled member node returning call1279 (depth = 9)
  partcv[0] = 0;
  Object call1280 = callmethod(call1279, "new",
    1, partcv, params);
  gc_frame_end(callframe1277);
// compiled call node returning call1280 (depth = 8)
// compiled member node returning call1280 (depth = 7)
  *var_suggestion = call1280;
  if (call1280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1281 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1282 == NULL) {
    strlit1282 = alloc_String("x");
    gc_root(strlit1282);
  }
// compiled string node returning strlit1282 (depth = 7)
  gc_frame_newslot(strlit1282);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1284 = alloc_Float64(1);
// compiled num node returning num1284 (depth = 8)
  int op_slot_right_1283 = gc_frame_newslot(num1284);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1288 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1287);
// compiled call node returning call1288 (depth = 10)
// compiled member node returning call1288 (depth = 9)
  int op_slot_right_1286 = gc_frame_newslot(call1288);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1286 = gc_frame_newslot(*var_linePosition);
  params[0] = call1288;
  partcv[0] = 1;
  Object diff1290 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1290 (depth = 8)
  int op_slot_left_1283 = gc_frame_newslot(diff1290);
  params[0] = num1284;
  partcv[0] = 1;
  Object sum1291 = callmethod(diff1290, "+", 1, partcv, params);
// compiled op node returning sum1291 (depth = 7)
  gc_frame_newslot(sum1291);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1282;
  params[1] = sum1291;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1292 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1281);
// compiled call node returning call1292 (depth = 6)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1293 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1294 == NULL) {
    strlit1294 = alloc_String("A number in base 16 must start with '0x'.");
    gc_root(strlit1294);
  }
// compiled string node returning strlit1294 (depth = 7)
  gc_frame_newslot(strlit1294);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1296 = alloc_Float64(1);
// compiled num node returning num1296 (depth = 8)
  int op_slot_right_1295 = gc_frame_newslot(num1296);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1300 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1299);
// compiled call node returning call1300 (depth = 10)
// compiled member node returning call1300 (depth = 9)
  int op_slot_right_1298 = gc_frame_newslot(call1300);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1298 = gc_frame_newslot(*var_linePosition);
  params[0] = call1300;
  partcv[0] = 1;
  Object diff1302 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1302 (depth = 8)
  int op_slot_left_1295 = gc_frame_newslot(diff1302);
  params[0] = num1296;
  partcv[0] = 1;
  Object sum1303 = callmethod(diff1302, "+", 1, partcv, params);
// compiled op node returning sum1303 (depth = 7)
  gc_frame_newslot(sum1303);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1294;
  params[1] = *var_lineNumber;
  params[2] = sum1303;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1304 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1293);
// compiled call node returning call1304 (depth = 6)
    gc_frame_newslot(call1304);
    if1263 = call1304;
  } else {
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1305 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1307 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1306);
// compiled call node returning call1307 (depth = 10)
// compiled member node returning call1307 (depth = 9)
  partcv[0] = 0;
  Object call1308 = callmethod(call1307, "new",
    1, partcv, params);
  gc_frame_end(callframe1305);
// compiled call node returning call1308 (depth = 8)
// compiled member node returning call1308 (depth = 7)
  *var_suggestion = call1308;
  if (call1308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1311 = alloc_Float64(1);
// compiled num node returning num1311 (depth = 8)
  int op_slot_right_1310 = gc_frame_newslot(num1311);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call1314 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1313);
// compiled call node returning call1314 (depth = 9)
// compiled member node returning call1314 (depth = 8)
  int op_slot_left_1310 = gc_frame_newslot(call1314);
  params[0] = num1311;
  partcv[0] = 1;
  Object opresult1315 = callmethod(call1314, "==", 1, partcv, params);
// compiled op node returning opresult1315 (depth = 7)
  Object if1309 = done;
  if (istrue(opresult1315)) {
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1316 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1318 = alloc_Float64(1);
// compiled num node returning num1318 (depth = 9)
  int op_slot_right_1317 = gc_frame_newslot(num1318);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1321 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1322 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 11)
// compiled member node returning call1322 (depth = 10)
  int op_slot_right_1320 = gc_frame_newslot(call1322);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1320 = gc_frame_newslot(*var_linePosition);
  params[0] = call1322;
  partcv[0] = 1;
  Object diff1324 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1324 (depth = 9)
  int op_slot_left_1317 = gc_frame_newslot(diff1324);
  params[0] = num1318;
  partcv[0] = 1;
  Object diff1325 = callmethod(diff1324, "-", 1, partcv, params);
// compiled op node returning diff1325 (depth = 8)
  gc_frame_newslot(diff1325);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1327 = alloc_Float64(1);
// compiled num node returning num1327 (depth = 9)
  int op_slot_right_1326 = gc_frame_newslot(num1327);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1326 = gc_frame_newslot(*var_linePosition);
  params[0] = num1327;
  partcv[0] = 1;
  Object diff1329 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1329 (depth = 8)
  gc_frame_newslot(diff1329);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = diff1325;
  params[1] = diff1329;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1330 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1316);
// compiled call node returning call1330 (depth = 7)
    gc_frame_newslot(call1330);
    if1309 = call1330;
  } else {
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1331 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1332 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1336 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1335);
// compiled call node returning call1336 (depth = 11)
// compiled member node returning call1336 (depth = 10)
  int op_slot_right_1334 = gc_frame_newslot(call1336);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1334 = gc_frame_newslot(*var_linePosition);
  params[0] = call1336;
  partcv[0] = 1;
  Object diff1338 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1338 (depth = 9)
  int op_slot_left_1332 = gc_frame_newslot(diff1338);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1339 = callmethod(diff1338, "+", 1, partcv, params);
// compiled op node returning sum1339 (depth = 8)
  gc_frame_newslot(sum1339);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1339;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1340 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe1331);
// compiled call node returning call1340 (depth = 7)
    gc_frame_newslot(call1340);
    if1309 = call1340;
  }
// compiled if node returning if1309 (depth = 6)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1343 = alloc_Float64(10);
// compiled num node returning num1343 (depth = 9)
  int op_slot_right_1342 = gc_frame_newslot(num1343);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1342 = gc_frame_newslot(*var_base);
  params[0] = num1343;
  partcv[0] = 1;
  Object opresult1345 = callmethod(*var_base, "<=", 1, partcv, params);
// compiled op node returning opresult1345 (depth = 8)
  Object if1341 = done;
struct StackFrameObject *iftmpstackframe1341 = stackframe;
  if (istrue(opresult1345)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1341);
gc_frame_newslot((Object)stackframe);
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1347 == NULL) {
    strlit1347 = alloc_String("'");
    gc_root(strlit1347);
  }
// compiled string node returning strlit1347 (depth = 9)
  int op_slot_right_1346 = gc_frame_newslot(strlit1347);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1351 = alloc_Float64(1);
// compiled num node returning num1351 (depth = 11)
  int op_slot_right_1350 = gc_frame_newslot(num1351);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_base (depth = 11)
  int op_slot_left_1350 = gc_frame_newslot(*var_base);
  params[0] = num1351;
  partcv[0] = 1;
  Object diff1353 = callmethod(*var_base, "-", 1, partcv, params);
// compiled op node returning diff1353 (depth = 10)
  int op_slot_right_1349 = gc_frame_newslot(diff1353);
// starting to compile string node (depth = 10)
  if (strlit1355 == NULL) {
    strlit1355 = alloc_String("'0' to '");
    gc_root(strlit1355);
  }
// compiled string node returning strlit1355 (depth = 10)
  int op_slot_left_1349 = gc_frame_newslot(strlit1355);
  params[0] = diff1353;
  partcv[0] = 1;
  Object opresult1356 = callmethod(strlit1355, "++", 1, partcv, params);
// compiled op node returning opresult1356 (depth = 9)
  int op_slot_left_1346 = gc_frame_newslot(opresult1356);
  params[0] = strlit1347;
  partcv[0] = 1;
  Object opresult1357 = callmethod(opresult1356, "++", 1, partcv, params);
// compiled op node returning opresult1357 (depth = 8)
    gc_frame_newslot(opresult1357);
    if1341 = opresult1357;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1341);
  gc_frame_newslot((Object)stackframe);
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1359 == NULL) {
    strlit1359 = alloc_String("'");
    gc_root(strlit1359);
  }
// compiled string node returning strlit1359 (depth = 9)
  int op_slot_right_1358 = gc_frame_newslot(strlit1359);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1362 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_right_1363 = gc_frame_newslot(*var_base);
// starting to compile num node (depth = 12)
  Object num1365 = alloc_Float64(87);
// compiled num node returning num1365 (depth = 12)
  int op_slot_left_1363 = gc_frame_newslot(num1365);
  params[0] = *var_base;
  partcv[0] = 1;
  Object sum1366 = callmethod(num1365, "+", 1, partcv, params);
// compiled op node returning sum1366 (depth = 11)
  gc_frame_newslot(sum1366);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = sum1366;
  partcv[0] = 1;
  Object call1367 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe1362);
// compiled call node returning call1367 (depth = 10)
  int op_slot_right_1361 = gc_frame_newslot(call1367);
// starting to compile string node (depth = 10)
  if (strlit1369 == NULL) {
    strlit1369 = alloc_String("'0' to '9', 'a' to '");
    gc_root(strlit1369);
  }
// compiled string node returning strlit1369 (depth = 10)
  int op_slot_left_1361 = gc_frame_newslot(strlit1369);
  params[0] = call1367;
  partcv[0] = 1;
  Object opresult1370 = callmethod(strlit1369, "++", 1, partcv, params);
// compiled op node returning opresult1370 (depth = 9)
  int op_slot_left_1358 = gc_frame_newslot(opresult1370);
  params[0] = strlit1359;
  partcv[0] = 1;
  Object opresult1371 = callmethod(opresult1370, "++", 1, partcv, params);
// compiled op node returning opresult1371 (depth = 8)
    gc_frame_newslot(opresult1371);
    if1341 = opresult1371;
  }
stackframe = iftmpstackframe1341;
// compiled if node returning if1341 (depth = 7)
  *var_validDigits = if1341;
  if (if1341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1372 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1374 == NULL) {
    strlit1374 = alloc_String(".");
    gc_root(strlit1374);
  }
// compiled string node returning strlit1374 (depth = 8)
  int op_slot_right_1373 = gc_frame_newslot(strlit1374);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validDigits (depth = 9)
  int op_slot_right_1376 = gc_frame_newslot(*var_validDigits);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1379 == NULL) {
    strlit1379 = alloc_String(". Valid digits are ");
    gc_root(strlit1379);
  }
// compiled string node returning strlit1379 (depth = 10)
  int op_slot_right_1378 = gc_frame_newslot(strlit1379);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_base (depth = 11)
  int op_slot_right_1381 = gc_frame_newslot(*var_base);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1384 == NULL) {
    strlit1384 = alloc_String("' is not a valid digit in base ");
    gc_root(strlit1384);
  }
// compiled string node returning strlit1384 (depth = 12)
  int op_slot_right_1383 = gc_frame_newslot(strlit1384);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_right_1386 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 13)
  if (strlit1388 == NULL) {
    strlit1388 = alloc_String("'");
    gc_root(strlit1388);
  }
// compiled string node returning strlit1388 (depth = 13)
  int op_slot_left_1386 = gc_frame_newslot(strlit1388);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1389 = callmethod(strlit1388, "++", 1, partcv, params);
// compiled op node returning opresult1389 (depth = 12)
  int op_slot_left_1383 = gc_frame_newslot(opresult1389);
  params[0] = strlit1384;
  partcv[0] = 1;
  Object opresult1390 = callmethod(opresult1389, "++", 1, partcv, params);
// compiled op node returning opresult1390 (depth = 11)
  int op_slot_left_1381 = gc_frame_newslot(opresult1390);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1391 = callmethod(opresult1390, "++", 1, partcv, params);
// compiled op node returning opresult1391 (depth = 10)
  int op_slot_left_1378 = gc_frame_newslot(opresult1391);
  params[0] = strlit1379;
  partcv[0] = 1;
  Object opresult1392 = callmethod(opresult1391, "++", 1, partcv, params);
// compiled op node returning opresult1392 (depth = 9)
  int op_slot_left_1376 = gc_frame_newslot(opresult1392);
  params[0] = *var_validDigits;
  partcv[0] = 1;
  Object opresult1393 = callmethod(opresult1392, "++", 1, partcv, params);
// compiled op node returning opresult1393 (depth = 8)
  int op_slot_left_1373 = gc_frame_newslot(opresult1393);
  params[0] = strlit1374;
  partcv[0] = 1;
  Object opresult1394 = callmethod(opresult1393, "++", 1, partcv, params);
// compiled op node returning opresult1394 (depth = 7)
  gc_frame_newslot(opresult1394);
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1395 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1399 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1398);
// compiled call node returning call1399 (depth = 10)
// compiled member node returning call1399 (depth = 9)
  int op_slot_right_1397 = gc_frame_newslot(call1399);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1397 = gc_frame_newslot(*var_linePosition);
  params[0] = call1399;
  partcv[0] = 1;
  Object diff1401 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1401 (depth = 8)
  int op_slot_left_1395 = gc_frame_newslot(diff1401);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1402 = callmethod(diff1401, "+", 1, partcv, params);
// compiled op node returning sum1402 (depth = 7)
  gc_frame_newslot(sum1402);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1403 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1407 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1406);
// compiled call node returning call1407 (depth = 10)
// compiled member node returning call1407 (depth = 9)
  int op_slot_right_1405 = gc_frame_newslot(call1407);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1405 = gc_frame_newslot(*var_linePosition);
  params[0] = call1407;
  partcv[0] = 1;
  Object diff1409 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1409 (depth = 8)
  int op_slot_left_1403 = gc_frame_newslot(diff1409);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1410 = callmethod(diff1409, "+", 1, partcv, params);
// compiled op node returning sum1410 (depth = 7)
  gc_frame_newslot(sum1410);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1394;
  params[1] = *var_lineNumber;
  params[2] = sum1402;
  params[3] = sum1410;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1411 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1372);
// compiled call node returning call1411 (depth = 6)
    gc_frame_newslot(call1411);
    if1263 = call1411;
  }
// compiled if node returning if1263 (depth = 5)
    gc_frame_newslot(if1263);
    if1259 = if1263;
  } else {
  }
// compiled if node returning if1259 (depth = 4)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inc (depth = 6)
  int op_slot_right_1412 = gc_frame_newslot(*var_inc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_1412 = gc_frame_newslot(*var_val);
  params[0] = *var_inc;
  partcv[0] = 1;
  Object sum1414 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum1414 (depth = 5)
  *var_val = sum1414;
  if (sum1414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1417 = alloc_Float64(1);
// compiled num node returning num1417 (depth = 6)
  int op_slot_right_1416 = gc_frame_newslot(num1417);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1416 = gc_frame_newslot(*var_i);
  params[0] = num1417;
  partcv[0] = 1;
  Object sum1419 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1419 (depth = 5)
  *var_i = sum1419;
  if (sum1419 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_fromBase1207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromBase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method fromBase");
  Object params[2];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_unicode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromBase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  Object *var_base = &(stackframe->slots[1]);
  *var_base = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for fromBase");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1208 = alloc_Float64(0);
// compiled num node returning num1208 (depth = 3)
  *var_val = num1208;
  if (num1208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1209 = alloc_Float64(0);
// compiled num node returning num1209 (depth = 3)
  *var_i = num1209;
  if (num1209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1210 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_str (depth = 3)
  gc_frame_newslot(*var_str);
// starting to compile block node (depth = 3)
  Object block1211 = alloc_Block(NULL, NULL, "lexer", 387);
  gc_frame_newslot(block1211);
// method _apply
  block_savedest(block1211);
  Object closure1212 = createclosure(9, "_apply");
  setclosureframe(closure1212, stackframe);
  addtoclosure(closure1212, var_base);
  addtoclosure(closure1212, var_val);
  addtoclosure(closure1212, var_str);
  addtoclosure(closure1212, var_errormessages);
  addtoclosure(closure1212, var_linePosition);
  addtoclosure(closure1212, var_lineNumber);
  addtoclosure(closure1212, var_i);
  addtoclosure(closure1212, var_unicode);
  addtoclosure(closure1212, selfslot);
  struct UserObject *uo1212 = (struct UserObject*)block1211;
  uo1212->data[0] = (Object)closure1212;
  Method *meth_meth_lexer__apply1212 = addmethod2pos(block1211, "_apply", &meth_lexer__apply1212, 0);
  int argcv_meth_lexer__apply1212[] = {1};
  meth_meth_lexer__apply1212->type = alloc_MethodType(1, argcv_meth_lexer__apply1212);
  meth_meth_lexer__apply1212->definitionModule = modulename;
  meth_meth_lexer__apply1212->definitionLine = 372;
// compiled block node returning block1211 (depth = 3)
  gc_frame_newslot(block1211);
// call case 5: prelude request
  params[0] = *var_str;
  params[1] = block1211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1422 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1210);
// compiled call node returning call1422 (depth = 2)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_val (depth = 2)
  gc_frame_end(frame);
  return *var_val;
}
Object meth_lexer_hexdecchar1423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hexdecchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method hexdecchar");
  Object params[4];
  int partcv[2];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hexdecchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for hexdecchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_AOrd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "AOrd");
  Object *var_aOrd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "aOrd");
  Object *var_zeroOrd = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "zeroOrd");
  Object *var_cOrd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cOrd");
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1424 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 5)
  if (strlit1425 == NULL) {
    strlit1425 = alloc_String("A");
    gc_root(strlit1425);
  }
// compiled string node returning strlit1425 (depth = 5)
  partcv[0] = 0;
  Object call1426 = callmethod(strlit1425, "ord",
    1, partcv, params);
  gc_frame_end(callframe1424);
// compiled call node returning call1426 (depth = 4)
// compiled member node returning call1426 (depth = 3)
  *var_AOrd = call1426;
  if (call1426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1427 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 5)
  if (strlit1428 == NULL) {
    strlit1428 = alloc_String("a");
    gc_root(strlit1428);
  }
// compiled string node returning strlit1428 (depth = 5)
  partcv[0] = 0;
  Object call1429 = callmethod(strlit1428, "ord",
    1, partcv, params);
  gc_frame_end(callframe1427);
// compiled call node returning call1429 (depth = 4)
// compiled member node returning call1429 (depth = 3)
  *var_aOrd = call1429;
  if (call1429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1430 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 5)
  if (strlit1431 == NULL) {
    strlit1431 = alloc_String("0");
    gc_root(strlit1431);
  }
// compiled string node returning strlit1431 (depth = 5)
  partcv[0] = 0;
  Object call1432 = callmethod(strlit1431, "ord",
    1, partcv, params);
  gc_frame_end(callframe1430);
// compiled call node returning call1432 (depth = 4)
// compiled member node returning call1432 (depth = 3)
  *var_zeroOrd = call1432;
  if (call1432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  partcv[0] = 0;
  Object call1434 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe1433);
// compiled call node returning call1434 (depth = 4)
// compiled member node returning call1434 (depth = 3)
  *var_cOrd = call1434;
  if (call1434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1438 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1439 == NULL) {
    strlit1439 = alloc_String("F");
    gc_root(strlit1439);
  }
// compiled string node returning strlit1439 (depth = 7)
  partcv[0] = 0;
  Object call1440 = callmethod(strlit1439, "ord",
    1, partcv, params);
  gc_frame_end(callframe1438);
// compiled call node returning call1440 (depth = 6)
// compiled member node returning call1440 (depth = 5)
  int op_slot_right_1437 = gc_frame_newslot(call1440);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1437 = gc_frame_newslot(*var_cOrd);
  params[0] = call1440;
  partcv[0] = 1;
  Object opresult1442 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 4)
  int op_slot_right_1436 = gc_frame_newslot(opresult1442);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AOrd (depth = 5)
  int op_slot_right_1444 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1444 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object opresult1446 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 4)
  int op_slot_left_1436 = gc_frame_newslot(opresult1446);
  params[0] = opresult1442;
  partcv[0] = 1;
  Object opresult1447 = callmethod(opresult1446, "&&", 1, partcv, params);
// compiled op node returning opresult1447 (depth = 3)
  Object if1435 = done;
  if (istrue(opresult1447)) {
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1449 = alloc_Float64(10);
// compiled num node returning num1449 (depth = 4)
  int op_slot_right_1448 = gc_frame_newslot(num1449);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AOrd (depth = 5)
  int op_slot_right_1451 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1451 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object diff1453 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1453 (depth = 4)
  int op_slot_left_1448 = gc_frame_newslot(diff1453);
  params[0] = num1449;
  partcv[0] = 1;
  Object sum1454 = callmethod(diff1453, "+", 1, partcv, params);
// compiled op node returning sum1454 (depth = 3)
    gc_frame_newslot(sum1454);
    if1435 = sum1454;
  } else {
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1458 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 8)
  if (strlit1459 == NULL) {
    strlit1459 = alloc_String("f");
    gc_root(strlit1459);
  }
// compiled string node returning strlit1459 (depth = 8)
  partcv[0] = 0;
  Object call1460 = callmethod(strlit1459, "ord",
    1, partcv, params);
  gc_frame_end(callframe1458);
// compiled call node returning call1460 (depth = 7)
// compiled member node returning call1460 (depth = 6)
  int op_slot_right_1457 = gc_frame_newslot(call1460);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1457 = gc_frame_newslot(*var_cOrd);
  params[0] = call1460;
  partcv[0] = 1;
  Object opresult1462 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1462 (depth = 5)
  int op_slot_right_1456 = gc_frame_newslot(opresult1462);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_aOrd (depth = 6)
  int op_slot_right_1464 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1464 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object opresult1466 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1466 (depth = 5)
  int op_slot_left_1456 = gc_frame_newslot(opresult1466);
  params[0] = opresult1462;
  partcv[0] = 1;
  Object opresult1467 = callmethod(opresult1466, "&&", 1, partcv, params);
// compiled op node returning opresult1467 (depth = 4)
  Object if1455 = done;
  if (istrue(opresult1467)) {
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1469 = alloc_Float64(10);
// compiled num node returning num1469 (depth = 5)
  int op_slot_right_1468 = gc_frame_newslot(num1469);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_aOrd (depth = 6)
  int op_slot_right_1471 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1471 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object diff1473 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1473 (depth = 5)
  int op_slot_left_1468 = gc_frame_newslot(diff1473);
  params[0] = num1469;
  partcv[0] = 1;
  Object sum1474 = callmethod(diff1473, "+", 1, partcv, params);
// compiled op node returning sum1474 (depth = 4)
    gc_frame_newslot(sum1474);
    if1455 = sum1474;
  } else {
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1478 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 9)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("9");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 9)
  partcv[0] = 0;
  Object call1480 = callmethod(strlit1479, "ord",
    1, partcv, params);
  gc_frame_end(callframe1478);
// compiled call node returning call1480 (depth = 8)
// compiled member node returning call1480 (depth = 7)
  int op_slot_right_1477 = gc_frame_newslot(call1480);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1477 = gc_frame_newslot(*var_cOrd);
  params[0] = call1480;
  partcv[0] = 1;
  Object opresult1482 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1482 (depth = 6)
  int op_slot_right_1476 = gc_frame_newslot(opresult1482);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_zeroOrd (depth = 7)
  int op_slot_right_1484 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1484 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object opresult1486 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1486 (depth = 6)
  int op_slot_left_1476 = gc_frame_newslot(opresult1486);
  params[0] = opresult1482;
  partcv[0] = 1;
  Object opresult1487 = callmethod(opresult1486, "&&", 1, partcv, params);
// compiled op node returning opresult1487 (depth = 5)
  Object if1475 = done;
  if (istrue(opresult1487)) {
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_zeroOrd (depth = 6)
  int op_slot_right_1488 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1488 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object diff1490 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1490 (depth = 5)
    gc_frame_newslot(diff1490);
    if1475 = diff1490;
  } else {
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1491 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1493 == NULL) {
    strlit1493 = alloc_String("' must be a hexadecimal digit");
    gc_root(strlit1493);
  }
// compiled string node returning strlit1493 (depth = 7)
  int op_slot_right_1492 = gc_frame_newslot(strlit1493);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_1495 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 8)
  if (strlit1497 == NULL) {
    strlit1497 = alloc_String("The character '");
    gc_root(strlit1497);
  }
// compiled string node returning strlit1497 (depth = 8)
  int op_slot_left_1495 = gc_frame_newslot(strlit1497);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1498 = callmethod(strlit1497, "++", 1, partcv, params);
// compiled op node returning opresult1498 (depth = 7)
  int op_slot_left_1492 = gc_frame_newslot(opresult1498);
  params[0] = strlit1493;
  partcv[0] = 1;
  Object opresult1499 = callmethod(opresult1498, "++", 1, partcv, params);
// compiled op node returning opresult1499 (depth = 6)
  gc_frame_newslot(opresult1499);
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1499;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1500 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe1491);
// compiled call node returning call1500 (depth = 5)
    gc_frame_newslot(call1500);
    if1475 = call1500;
  }
// compiled if node returning if1475 (depth = 4)
    gc_frame_newslot(if1475);
    if1455 = if1475;
  }
// compiled if node returning if1455 (depth = 3)
    gc_frame_newslot(if1455);
    if1435 = if1455;
  }
// compiled if node returning if1435 (depth = 2)
  gc_frame_end(frame);
  return if1435;
}
Object meth_lexer__apply1508(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_baseSet = getfromclosure(closure, 0);
  Object *var_sofar = getfromclosure(closure, 1);
  Object *var_base = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_i = getfromclosure(closure, 4);
  Object *var_accum = getfromclosure(closure, 5);
  Object *var_linePosition = getfromclosure(closure, 6);
  Object *var_lineNumber = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_baseSet (depth = 7)
  partcv[0] = 0;
  Object call1512 = callmethod(*var_baseSet, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1511);
// compiled call node returning call1512 (depth = 6)
  int op_slot_right_1510 = gc_frame_newslot(call1512);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1515 == NULL) {
    strlit1515 = alloc_String("x");
    gc_root(strlit1515);
  }
// compiled string node returning strlit1515 (depth = 7)
  int op_slot_right_1514 = gc_frame_newslot(strlit1515);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1514 = gc_frame_newslot(*var_c);
  params[0] = strlit1515;
  partcv[0] = 1;
  Object opresult1517 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1517 (depth = 6)
  int op_slot_left_1510 = gc_frame_newslot(opresult1517);
  params[0] = call1512;
  partcv[0] = 1;
  Object opresult1518 = callmethod(opresult1517, "&&", 1, partcv, params);
// compiled op node returning opresult1518 (depth = 5)
  Object if1509 = done;
  if (istrue(opresult1518)) {
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sofar (depth = 8)
  partcv[0] = 0;
  Object call1520 = callmethod(*var_sofar, "asNumber",
    1, partcv, params);
  gc_frame_end(callframe1519);
// compiled call node returning call1520 (depth = 7)
// compiled member node returning call1520 (depth = 6)
  *var_base = call1520;
  if (call1520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1522 = alloc_Boolean(1);
// compiled identifier node returning bool1522 (depth = 6)
  *var_baseSet = bool1522;
  if (bool1522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1526 = alloc_Float64(0);
// compiled num node returning num1526 (depth = 7)
  int op_slot_right_1525 = gc_frame_newslot(num1526);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_left_1525 = gc_frame_newslot(*var_base);
  params[0] = num1526;
  partcv[0] = 1;
  Object opresult1528 = callmethod(*var_base, "==", 1, partcv, params);
// compiled op node returning opresult1528 (depth = 6)
  Object if1524 = done;
  if (istrue(opresult1528)) {
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1529 = alloc_Float64(16);
// compiled num node returning num1529 (depth = 7)
  *var_base = num1529;
  if (num1529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1524 = done;
  } else {
  }
// compiled if node returning if1524 (depth = 5)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1534 = alloc_Float64(36);
// compiled num node returning num1534 (depth = 8)
  int op_slot_right_1533 = gc_frame_newslot(num1534);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_base (depth = 8)
  int op_slot_left_1533 = gc_frame_newslot(*var_base);
  params[0] = num1534;
  partcv[0] = 1;
  Object opresult1536 = callmethod(*var_base, ">", 1, partcv, params);
// compiled op node returning opresult1536 (depth = 7)
  int op_slot_right_1532 = gc_frame_newslot(opresult1536);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1539 = alloc_Float64(2);
// compiled num node returning num1539 (depth = 8)
  int op_slot_right_1538 = gc_frame_newslot(num1539);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_base (depth = 8)
  int op_slot_left_1538 = gc_frame_newslot(*var_base);
  params[0] = num1539;
  partcv[0] = 1;
  Object opresult1541 = callmethod(*var_base, "<", 1, partcv, params);
// compiled op node returning opresult1541 (depth = 7)
  int op_slot_left_1532 = gc_frame_newslot(opresult1541);
  params[0] = opresult1536;
  partcv[0] = 1;
  Object opresult1542 = callmethod(opresult1541, "||", 1, partcv, params);
// compiled op node returning opresult1542 (depth = 6)
  Object if1531 = done;
  if (istrue(opresult1542)) {
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array1543 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1543 (depth = 7)
  *var_suggestions = array1543;
  if (array1543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1544 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1545 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1546 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1545);
// compiled call node returning call1546 (depth = 10)
// compiled member node returning call1546 (depth = 9)
  partcv[0] = 0;
  Object call1547 = callmethod(call1546, "new",
    1, partcv, params);
  gc_frame_end(callframe1544);
// compiled call node returning call1547 (depth = 8)
// compiled member node returning call1547 (depth = 7)
  *var_suggestion = call1547;
  if (call1547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1548 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1549 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1553 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1552);
// compiled call node returning call1553 (depth = 10)
// compiled member node returning call1553 (depth = 9)
  int op_slot_right_1551 = gc_frame_newslot(call1553);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1551 = gc_frame_newslot(*var_linePosition);
  params[0] = call1553;
  partcv[0] = 1;
  Object diff1555 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1555 (depth = 8)
  int op_slot_left_1549 = gc_frame_newslot(diff1555);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1556 = callmethod(diff1555, "+", 1, partcv, params);
// compiled op node returning sum1556 (depth = 7)
  gc_frame_newslot(sum1556);
// starting to compile string node (depth = 7)
  if (strlit1557 == NULL) {
    strlit1557 = alloc_String("*");
    gc_root(strlit1557);
  }
// compiled string node returning strlit1557 (depth = 7)
  gc_frame_newslot(strlit1557);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum1556;
  params[1] = strlit1557;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1558 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe1548);
// compiled call node returning call1558 (depth = 6)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1559 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1560 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1559);
// compiled call node returning call1560 (depth = 6)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1561 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1563 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1562);
// compiled call node returning call1563 (depth = 10)
// compiled member node returning call1563 (depth = 9)
  partcv[0] = 0;
  Object call1564 = callmethod(call1563, "new",
    1, partcv, params);
  gc_frame_end(callframe1561);
// compiled call node returning call1564 (depth = 8)
// compiled member node returning call1564 (depth = 7)
  *var_suggestion = call1564;
  if (call1564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1566 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  partcv[0] = 0;
  Object call1569 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1568);
// compiled call node returning call1569 (depth = 9)
// compiled member node returning call1569 (depth = 8)
  int op_slot_right_1567 = gc_frame_newslot(call1569);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_1567 = gc_frame_newslot(*var_linePosition);
  params[0] = call1569;
  partcv[0] = 1;
  Object diff1571 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1571 (depth = 7)
  gc_frame_newslot(diff1571);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1572 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1575 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1576 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1575);
// compiled call node returning call1576 (depth = 10)
// compiled member node returning call1576 (depth = 9)
  int op_slot_right_1574 = gc_frame_newslot(call1576);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1574 = gc_frame_newslot(*var_linePosition);
  params[0] = call1576;
  partcv[0] = 1;
  Object diff1578 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1578 (depth = 8)
  int op_slot_left_1572 = gc_frame_newslot(diff1578);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1579 = callmethod(diff1578, "+", 1, partcv, params);
// compiled op node returning sum1579 (depth = 7)
  gc_frame_newslot(sum1579);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = diff1571;
  params[1] = sum1579;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1580 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1566);
// compiled call node returning call1580 (depth = 6)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1581 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1582 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1581);
// compiled call node returning call1582 (depth = 6)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1583 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1585 == NULL) {
    strlit1585 = alloc_String(" is not a valid numerical base.");
    gc_root(strlit1585);
  }
// compiled string node returning strlit1585 (depth = 8)
  int op_slot_right_1584 = gc_frame_newslot(strlit1585);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_right_1587 = gc_frame_newslot(*var_base);
// starting to compile string node (depth = 9)
  if (strlit1589 == NULL) {
    strlit1589 = alloc_String("Base ");
    gc_root(strlit1589);
  }
// compiled string node returning strlit1589 (depth = 9)
  int op_slot_left_1587 = gc_frame_newslot(strlit1589);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1590 = callmethod(strlit1589, "++", 1, partcv, params);
// compiled op node returning opresult1590 (depth = 8)
  int op_slot_left_1584 = gc_frame_newslot(opresult1590);
  params[0] = strlit1585;
  partcv[0] = 1;
  Object opresult1591 = callmethod(opresult1590, "++", 1, partcv, params);
// compiled op node returning opresult1591 (depth = 7)
  gc_frame_newslot(opresult1591);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1593 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  partcv[0] = 0;
  Object call1594 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1593);
// compiled call node returning call1594 (depth = 9)
// compiled member node returning call1594 (depth = 8)
  int op_slot_right_1592 = gc_frame_newslot(call1594);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_1592 = gc_frame_newslot(*var_linePosition);
  params[0] = call1594;
  partcv[0] = 1;
  Object diff1596 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1596 (depth = 7)
  gc_frame_newslot(diff1596);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1598 = alloc_Float64(1);
// compiled num node returning num1598 (depth = 8)
  int op_slot_right_1597 = gc_frame_newslot(num1598);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1600 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1603 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  partcv[0] = 0;
  Object call1604 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1603);
// compiled call node returning call1604 (depth = 11)
// compiled member node returning call1604 (depth = 10)
  int op_slot_right_1602 = gc_frame_newslot(call1604);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1602 = gc_frame_newslot(*var_linePosition);
  params[0] = call1604;
  partcv[0] = 1;
  Object diff1606 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1606 (depth = 9)
  int op_slot_left_1600 = gc_frame_newslot(diff1606);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1607 = callmethod(diff1606, "+", 1, partcv, params);
// compiled op node returning sum1607 (depth = 8)
  int op_slot_left_1597 = gc_frame_newslot(sum1607);
  params[0] = num1598;
  partcv[0] = 1;
  Object diff1608 = callmethod(sum1607, "-", 1, partcv, params);
// compiled op node returning diff1608 (depth = 7)
  gc_frame_newslot(diff1608);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1591;
  params[1] = *var_lineNumber;
  params[2] = diff1596;
  params[3] = diff1608;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1609 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1583);
// compiled call node returning call1609 (depth = 6)
    gc_frame_newslot(call1609);
    if1531 = call1609;
  } else {
  }
// compiled if node returning if1531 (depth = 5)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1610 == NULL) {
    strlit1610 = alloc_String("");
    gc_root(strlit1610);
  }
// compiled string node returning strlit1610 (depth = 6)
  *var_sofar = strlit1610;
  if (strlit1610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1509 = done;
  } else {
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_right_1612 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sofar (depth = 7)
  int op_slot_left_1612 = gc_frame_newslot(*var_sofar);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1614 = callmethod(*var_sofar, "++", 1, partcv, params);
// compiled op node returning opresult1614 (depth = 6)
  *var_sofar = opresult1614;
  if (opresult1614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1509 = done;
  }
// compiled if node returning if1509 (depth = 4)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1617 = alloc_Float64(1);
// compiled num node returning num1617 (depth = 6)
  int op_slot_right_1616 = gc_frame_newslot(num1617);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1616 = gc_frame_newslot(*var_i);
  params[0] = num1617;
  partcv[0] = 1;
  Object sum1619 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1619 (depth = 5)
  *var_i = sum1619;
  if (sum1619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_makeNumToken1501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "makeNumToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method makeNumToken");
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_NumToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for makeNumToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_accum = &(stackframe->slots[0]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for makeNumToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_base = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "base");
  Object *var_baseSet = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "baseSet");
  Object *var_sofar = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sofar");
  Object *var_i = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "i");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1502 = alloc_Float64(10);
// compiled num node returning num1502 (depth = 3)
  *var_base = num1502;
  if (num1502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1503 = alloc_Boolean(0);
// compiled identifier node returning bool1503 (depth = 3)
  *var_baseSet = bool1503;
  if (bool1503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1504 == NULL) {
    strlit1504 = alloc_String("");
    gc_root(strlit1504);
  }
// compiled string node returning strlit1504 (depth = 3)
  *var_sofar = strlit1504;
  if (strlit1504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1505 = alloc_Float64(0);
// compiled num node returning num1505 (depth = 3)
  *var_i = num1505;
  if (num1505 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1506 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_accum (depth = 3)
  gc_frame_newslot(*var_accum);
// starting to compile block node (depth = 3)
  Object block1507 = alloc_Block(NULL, NULL, "lexer", 449);
  gc_frame_newslot(block1507);
// method _apply
  block_savedest(block1507);
  Object closure1508 = createclosure(9, "_apply");
  setclosureframe(closure1508, stackframe);
  addtoclosure(closure1508, var_baseSet);
  addtoclosure(closure1508, var_sofar);
  addtoclosure(closure1508, var_base);
  addtoclosure(closure1508, var_errormessages);
  addtoclosure(closure1508, var_i);
  addtoclosure(closure1508, var_accum);
  addtoclosure(closure1508, var_linePosition);
  addtoclosure(closure1508, var_lineNumber);
  addtoclosure(closure1508, selfslot);
  struct UserObject *uo1508 = (struct UserObject*)block1507;
  uo1508->data[0] = (Object)closure1508;
  Method *meth_meth_lexer__apply1508 = addmethod2pos(block1507, "_apply", &meth_lexer__apply1508, 0);
  int argcv_meth_lexer__apply1508[] = {1};
  meth_meth_lexer__apply1508->type = alloc_MethodType(1, argcv_meth_lexer__apply1508);
  meth_meth_lexer__apply1508->definitionModule = modulename;
  meth_meth_lexer__apply1508->definitionLine = 436;
// compiled block node returning block1507 (depth = 3)
  gc_frame_newslot(block1507);
// call case 5: prelude request
  params[0] = *var_accum;
  params[1] = block1507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1622 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1506);
// compiled call node returning call1622 (depth = 2)
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1625 == NULL) {
    strlit1625 = alloc_String("");
    gc_root(strlit1625);
  }
// compiled string node returning strlit1625 (depth = 4)
  int op_slot_right_1624 = gc_frame_newslot(strlit1625);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sofar (depth = 4)
  int op_slot_left_1624 = gc_frame_newslot(*var_sofar);
  params[0] = strlit1625;
  partcv[0] = 1;
  Object opresult1627 = callmethod(*var_sofar, "==", 1, partcv, params);
// compiled op node returning opresult1627 (depth = 3)
  Object if1623 = done;
  if (istrue(opresult1627)) {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1628 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1628 (depth = 4)
  *var_suggestions = array1628;
  if (array1628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1629 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call1631 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1630);
// compiled call node returning call1631 (depth = 7)
// compiled member node returning call1631 (depth = 6)
  partcv[0] = 0;
  Object call1632 = callmethod(call1631, "new",
    1, partcv, params);
  gc_frame_end(callframe1629);
// compiled call node returning call1632 (depth = 5)
// compiled member node returning call1632 (depth = 4)
  *var_suggestion = call1632;
  if (call1632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1633 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1635 = alloc_Float64(1);
// compiled num node returning num1635 (depth = 5)
  int op_slot_right_1634 = gc_frame_newslot(num1635);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_right_1637 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  partcv[0] = 0;
  Object call1641 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1640);
// compiled call node returning call1641 (depth = 8)
// compiled member node returning call1641 (depth = 7)
  int op_slot_right_1639 = gc_frame_newslot(call1641);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_1639 = gc_frame_newslot(*var_linePosition);
  params[0] = call1641;
  partcv[0] = 1;
  Object diff1643 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1643 (depth = 6)
  int op_slot_left_1637 = gc_frame_newslot(diff1643);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1644 = callmethod(diff1643, "+", 1, partcv, params);
// compiled op node returning sum1644 (depth = 5)
  int op_slot_left_1634 = gc_frame_newslot(sum1644);
  params[0] = num1635;
  partcv[0] = 1;
  Object diff1645 = callmethod(sum1644, "-", 1, partcv, params);
// compiled op node returning diff1645 (depth = 4)
  gc_frame_newslot(diff1645);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1647 = alloc_Float64(1);
// compiled num node returning num1647 (depth = 5)
  int op_slot_right_1646 = gc_frame_newslot(num1647);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  int op_slot_left_1646 = gc_frame_newslot(*var_linePosition);
  params[0] = num1647;
  partcv[0] = 1;
  Object diff1649 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1649 (depth = 4)
  gc_frame_newslot(diff1649);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = diff1645;
  params[1] = diff1649;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1650 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1633);
// compiled call node returning call1650 (depth = 3)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1651 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1652 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1651);
// compiled call node returning call1652 (depth = 3)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1653 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call1655 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1654);
// compiled call node returning call1655 (depth = 7)
// compiled member node returning call1655 (depth = 6)
  partcv[0] = 0;
  Object call1656 = callmethod(call1655, "new",
    1, partcv, params);
  gc_frame_end(callframe1653);
// compiled call node returning call1656 (depth = 5)
// compiled member node returning call1656 (depth = 4)
  *var_suggestion = call1656;
  if (call1656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1658 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1659 == NULL) {
    strlit1659 = alloc_String("0");
    gc_root(strlit1659);
  }
// compiled string node returning strlit1659 (depth = 4)
  gc_frame_newslot(strlit1659);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_linePosition (depth = 4)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1659;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1660 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1658);
// compiled call node returning call1660 (depth = 3)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1661 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1662 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1661);
// compiled call node returning call1662 (depth = 3)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1663 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1664 == NULL) {
    strlit1664 = alloc_String("At least one digit must follow the 'x' in a number.");
    gc_root(strlit1664);
  }
// compiled string node returning strlit1664 (depth = 4)
  gc_frame_newslot(strlit1664);
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_right_1665 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  partcv[0] = 0;
  Object call1669 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1668);
// compiled call node returning call1669 (depth = 7)
// compiled member node returning call1669 (depth = 6)
  int op_slot_right_1667 = gc_frame_newslot(call1669);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  int op_slot_left_1667 = gc_frame_newslot(*var_linePosition);
  params[0] = call1669;
  partcv[0] = 1;
  Object diff1671 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1671 (depth = 5)
  int op_slot_left_1665 = gc_frame_newslot(diff1671);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1672 = callmethod(diff1671, "+", 1, partcv, params);
// compiled op node returning sum1672 (depth = 4)
  gc_frame_newslot(sum1672);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit1664;
  params[1] = *var_lineNumber;
  params[2] = sum1672;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1673 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1663);
// compiled call node returning call1673 (depth = 3)
    gc_frame_newslot(call1673);
    if1623 = call1673;
  } else {
  }
// compiled if node returning if1623 (depth = 2)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1674 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1675 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1676 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sofar (depth = 6)
  gc_frame_newslot(*var_sofar);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_base (depth = 6)
  gc_frame_newslot(*var_base);
// call case 4: self request
  params[0] = *var_sofar;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1677 = callmethodflags(self, "fromBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1676);
// compiled call node returning call1677 (depth = 5)
  partcv[0] = 0;
  Object call1678 = callmethod(call1677, "asString",
    1, partcv, params);
  gc_frame_end(callframe1675);
// compiled call node returning call1678 (depth = 4)
// compiled member node returning call1678 (depth = 3)
  gc_frame_newslot(call1678);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  gc_frame_newslot(*var_base);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NumToken (depth = 3)
  params[0] = call1678;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1679 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1674);
// compiled call node returning call1679 (depth = 2)
  gc_frame_end(frame);
  return call1679;
}
Object meth_lexer_isidentifierchar1680(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isidentifierchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method isidentifierchar");
  Object params[1];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isidentifierchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ov = &(stackframe->slots[0]);
  *var_ov = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for isidentifierchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1682 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ov (depth = 4)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1683 = callmethod(*var_unicode, "isLetter",
    1, partcv, params);
  gc_frame_end(callframe1682);
// compiled call node returning call1683 (depth = 3)
  Object if1681 = done;
  if (istrue(call1683)) {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1684 = alloc_Boolean(1);
// compiled identifier node returning bool1684 (depth = 4)
  return bool1684;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1681 = undefined;
  } else {
  }
// compiled if node returning if1681 (depth = 2)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1686 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ov (depth = 4)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1687 = callmethod(*var_unicode, "isNumber",
    1, partcv, params);
  gc_frame_end(callframe1686);
// compiled call node returning call1687 (depth = 3)
  Object if1685 = done;
  if (istrue(call1687)) {
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1688 = alloc_Boolean(1);
// compiled identifier node returning bool1688 (depth = 4)
  return bool1688;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1685 = undefined;
  } else {
  }
// compiled if node returning if1685 (depth = 2)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1692 = alloc_Float64(39);
// compiled num node returning num1692 (depth = 5)
  int op_slot_right_1691 = gc_frame_newslot(num1692);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  int op_slot_left_1691 = gc_frame_newslot(*var_ov);
  params[0] = num1692;
  partcv[0] = 1;
  Object opresult1694 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1694 (depth = 4)
  int op_slot_right_1690 = gc_frame_newslot(opresult1694);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1697 = alloc_Float64(95);
// compiled num node returning num1697 (depth = 5)
  int op_slot_right_1696 = gc_frame_newslot(num1697);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  int op_slot_left_1696 = gc_frame_newslot(*var_ov);
  params[0] = num1697;
  partcv[0] = 1;
  Object opresult1699 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1699 (depth = 4)
  int op_slot_left_1690 = gc_frame_newslot(opresult1699);
  params[0] = opresult1694;
  partcv[0] = 1;
  Object opresult1700 = callmethod(opresult1699, "||", 1, partcv, params);
// compiled op node returning opresult1700 (depth = 3)
  Object if1689 = done;
  if (istrue(opresult1700)) {
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1701 = alloc_Boolean(1);
// compiled identifier node returning bool1701 (depth = 3)
    gc_frame_newslot(bool1701);
    if1689 = bool1701;
  } else {
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1702 = alloc_Boolean(0);
// compiled identifier node returning bool1702 (depth = 3)
    gc_frame_newslot(bool1702);
    if1689 = bool1702;
  }
// compiled if node returning if1689 (depth = 2)
  gc_frame_end(frame);
  return if1689;
}
Object meth_lexer_isoperatorchar1703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isoperatorchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method isoperatorchar");
  Object params[2];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isoperatorchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *var_ordval = &(stackframe->slots[1]);
  *var_ordval = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for isoperatorchar");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1707 == NULL) {
    strlit1707 = alloc_String("!");
    gc_root(strlit1707);
  }
// compiled string node returning strlit1707 (depth = 5)
  int op_slot_right_1706 = gc_frame_newslot(strlit1707);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_1706 = gc_frame_newslot(*var_c);
  params[0] = strlit1707;
  partcv[0] = 1;
  Object opresult1709 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1709 (depth = 4)
  int op_slot_right_1705 = gc_frame_newslot(opresult1709);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1713 == NULL) {
    strlit1713 = alloc_String("+");
    gc_root(strlit1713);
  }
// compiled string node returning strlit1713 (depth = 6)
  int op_slot_right_1712 = gc_frame_newslot(strlit1713);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_1712 = gc_frame_newslot(*var_c);
  params[0] = strlit1713;
  partcv[0] = 1;
  Object opresult1715 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1715 (depth = 5)
  int op_slot_right_1711 = gc_frame_newslot(opresult1715);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1719 == NULL) {
    strlit1719 = alloc_String("/");
    gc_root(strlit1719);
  }
// compiled string node returning strlit1719 (depth = 7)
  int op_slot_right_1718 = gc_frame_newslot(strlit1719);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1718 = gc_frame_newslot(*var_c);
  params[0] = strlit1719;
  partcv[0] = 1;
  Object opresult1721 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1721 (depth = 6)
  int op_slot_right_1717 = gc_frame_newslot(opresult1721);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1725 == NULL) {
    strlit1725 = alloc_String("*");
    gc_root(strlit1725);
  }
// compiled string node returning strlit1725 (depth = 8)
  int op_slot_right_1724 = gc_frame_newslot(strlit1725);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1724 = gc_frame_newslot(*var_c);
  params[0] = strlit1725;
  partcv[0] = 1;
  Object opresult1727 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1727 (depth = 7)
  int op_slot_right_1723 = gc_frame_newslot(opresult1727);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1731 == NULL) {
    strlit1731 = alloc_String("?");
    gc_root(strlit1731);
  }
// compiled string node returning strlit1731 (depth = 9)
  int op_slot_right_1730 = gc_frame_newslot(strlit1731);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1730 = gc_frame_newslot(*var_c);
  params[0] = strlit1731;
  partcv[0] = 1;
  Object opresult1733 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1733 (depth = 8)
  int op_slot_right_1729 = gc_frame_newslot(opresult1733);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1737 == NULL) {
    strlit1737 = alloc_String("@");
    gc_root(strlit1737);
  }
// compiled string node returning strlit1737 (depth = 10)
  int op_slot_right_1736 = gc_frame_newslot(strlit1737);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1736 = gc_frame_newslot(*var_c);
  params[0] = strlit1737;
  partcv[0] = 1;
  Object opresult1739 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1739 (depth = 9)
  int op_slot_right_1735 = gc_frame_newslot(opresult1739);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1743 == NULL) {
    strlit1743 = alloc_String("^");
    gc_root(strlit1743);
  }
// compiled string node returning strlit1743 (depth = 11)
  int op_slot_right_1742 = gc_frame_newslot(strlit1743);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_1742 = gc_frame_newslot(*var_c);
  params[0] = strlit1743;
  partcv[0] = 1;
  Object opresult1745 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1745 (depth = 10)
  int op_slot_right_1741 = gc_frame_newslot(opresult1745);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1749 == NULL) {
    strlit1749 = alloc_String("%");
    gc_root(strlit1749);
  }
// compiled string node returning strlit1749 (depth = 12)
  int op_slot_right_1748 = gc_frame_newslot(strlit1749);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_1748 = gc_frame_newslot(*var_c);
  params[0] = strlit1749;
  partcv[0] = 1;
  Object opresult1751 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1751 (depth = 11)
  int op_slot_right_1747 = gc_frame_newslot(opresult1751);
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String(":");
    gc_root(strlit1755);
  }
// compiled string node returning strlit1755 (depth = 13)
  int op_slot_right_1754 = gc_frame_newslot(strlit1755);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_1754 = gc_frame_newslot(*var_c);
  params[0] = strlit1755;
  partcv[0] = 1;
  Object opresult1757 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1757 (depth = 12)
  int op_slot_right_1753 = gc_frame_newslot(opresult1757);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1761 == NULL) {
    strlit1761 = alloc_String("|");
    gc_root(strlit1761);
  }
// compiled string node returning strlit1761 (depth = 14)
  int op_slot_right_1760 = gc_frame_newslot(strlit1761);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_1760 = gc_frame_newslot(*var_c);
  params[0] = strlit1761;
  partcv[0] = 1;
  Object opresult1763 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1763 (depth = 13)
  int op_slot_right_1759 = gc_frame_newslot(opresult1763);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1767 == NULL) {
    strlit1767 = alloc_String("&");
    gc_root(strlit1767);
  }
// compiled string node returning strlit1767 (depth = 15)
  int op_slot_right_1766 = gc_frame_newslot(strlit1767);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_1766 = gc_frame_newslot(*var_c);
  params[0] = strlit1767;
  partcv[0] = 1;
  Object opresult1769 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1769 (depth = 14)
  int op_slot_right_1765 = gc_frame_newslot(opresult1769);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("-");
    gc_root(strlit1772);
  }
// compiled string node returning strlit1772 (depth = 15)
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_1771 = gc_frame_newslot(*var_c);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1774 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1774 (depth = 14)
  int op_slot_left_1765 = gc_frame_newslot(opresult1774);
  params[0] = opresult1769;
  partcv[0] = 1;
  Object opresult1775 = callmethod(opresult1774, "||", 1, partcv, params);
// compiled op node returning opresult1775 (depth = 13)
  int op_slot_left_1759 = gc_frame_newslot(opresult1775);
  params[0] = opresult1763;
  partcv[0] = 1;
  Object opresult1776 = callmethod(opresult1775, "||", 1, partcv, params);
// compiled op node returning opresult1776 (depth = 12)
  int op_slot_left_1753 = gc_frame_newslot(opresult1776);
  params[0] = opresult1757;
  partcv[0] = 1;
  Object opresult1777 = callmethod(opresult1776, "||", 1, partcv, params);
// compiled op node returning opresult1777 (depth = 11)
  int op_slot_left_1747 = gc_frame_newslot(opresult1777);
  params[0] = opresult1751;
  partcv[0] = 1;
  Object opresult1778 = callmethod(opresult1777, "||", 1, partcv, params);
// compiled op node returning opresult1778 (depth = 10)
  int op_slot_left_1741 = gc_frame_newslot(opresult1778);
  params[0] = opresult1745;
  partcv[0] = 1;
  Object opresult1779 = callmethod(opresult1778, "||", 1, partcv, params);
// compiled op node returning opresult1779 (depth = 9)
  int op_slot_left_1735 = gc_frame_newslot(opresult1779);
  params[0] = opresult1739;
  partcv[0] = 1;
  Object opresult1780 = callmethod(opresult1779, "||", 1, partcv, params);
// compiled op node returning opresult1780 (depth = 8)
  int op_slot_left_1729 = gc_frame_newslot(opresult1780);
  params[0] = opresult1733;
  partcv[0] = 1;
  Object opresult1781 = callmethod(opresult1780, "||", 1, partcv, params);
// compiled op node returning opresult1781 (depth = 7)
  int op_slot_left_1723 = gc_frame_newslot(opresult1781);
  params[0] = opresult1727;
  partcv[0] = 1;
  Object opresult1782 = callmethod(opresult1781, "||", 1, partcv, params);
// compiled op node returning opresult1782 (depth = 6)
  int op_slot_left_1717 = gc_frame_newslot(opresult1782);
  params[0] = opresult1721;
  partcv[0] = 1;
  Object opresult1783 = callmethod(opresult1782, "||", 1, partcv, params);
// compiled op node returning opresult1783 (depth = 5)
  int op_slot_left_1711 = gc_frame_newslot(opresult1783);
  params[0] = opresult1715;
  partcv[0] = 1;
  Object opresult1784 = callmethod(opresult1783, "||", 1, partcv, params);
// compiled op node returning opresult1784 (depth = 4)
  int op_slot_left_1705 = gc_frame_newslot(opresult1784);
  params[0] = opresult1709;
  partcv[0] = 1;
  Object opresult1785 = callmethod(opresult1784, "||", 1, partcv, params);
// compiled op node returning opresult1785 (depth = 3)
  Object if1704 = done;
  if (istrue(opresult1785)) {
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1786 = alloc_Boolean(1);
// compiled identifier node returning bool1786 (depth = 4)
  return bool1786;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1704 = undefined;
  } else {
  }
// compiled if node returning if1704 (depth = 2)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1788 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ordval (depth = 4)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call1789 = callmethod(*var_unicode, "isSymbolMathematical",
    1, partcv, params);
  gc_frame_end(callframe1788);
// compiled call node returning call1789 (depth = 3)
  Object if1787 = done;
  if (istrue(call1789)) {
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1790 = alloc_Boolean(1);
// compiled identifier node returning bool1790 (depth = 4)
  return bool1790;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1787 = undefined;
  } else {
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1792 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// starting to compile string node (depth = 5)
  if (strlit1793 == NULL) {
    strlit1793 = alloc_String("So");
    gc_root(strlit1793);
  }
// compiled string node returning strlit1793 (depth = 5)
  gc_frame_newslot(strlit1793);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_c;
  params[1] = strlit1793;
  partcv[0] = 2;
  Object call1794 = callmethod(*var_unicode, "iscategory",
    1, partcv, params);
  gc_frame_end(callframe1792);
// compiled call node returning call1794 (depth = 4)
  Object if1791 = done;
  if (istrue(call1794)) {
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1795 = alloc_Boolean(1);
// compiled identifier node returning bool1795 (depth = 5)
  return bool1795;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1791 = undefined;
  } else {
  }
// compiled if node returning if1791 (depth = 3)
    gc_frame_newslot(if1791);
    if1787 = if1791;
  }
// compiled if node returning if1787 (depth = 2)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1796 = alloc_Boolean(0);
// compiled identifier node returning bool1796 (depth = 3)
  return bool1796;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer__apply1807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_lines = getfromclosure(closure, 1);
  Object *var_cLine = getfromclosure(closure, 2);
  Object *var_cLines = getfromclosure(closure, 3);
  Object *var_wasCR = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("""\x0d""");
    gc_root(strlit1810);
  }
// compiled string node returning strlit1810 (depth = 6)
  int op_slot_right_1809 = gc_frame_newslot(strlit1810);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_1809 = gc_frame_newslot(*var_c);
  params[0] = strlit1810;
  partcv[0] = 1;
  Object opresult1812 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1812 (depth = 5)
  Object if1808 = done;
  if (istrue(opresult1812)) {
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1813 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lines (depth = 6)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1814 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1813);
// compiled call node returning call1814 (depth = 5)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1815 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cLine (depth = 6)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cLines (depth = 6)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1816 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1815);
// compiled call node returning call1816 (depth = 5)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String("");
    gc_root(strlit1817);
  }
// compiled string node returning strlit1817 (depth = 6)
  *var_line = strlit1817;
  if (strlit1817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1819 == NULL) {
    strlit1819 = alloc_String("");
    gc_root(strlit1819);
  }
// compiled string node returning strlit1819 (depth = 6)
  *var_cLine = strlit1819;
  if (strlit1819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1821 = alloc_Boolean(1);
// compiled identifier node returning bool1821 (depth = 6)
  *var_wasCR = bool1821;
  if (bool1821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1808 = done;
  } else {
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1825 == NULL) {
    strlit1825 = alloc_String("""\x0a""");
    gc_root(strlit1825);
  }
// compiled string node returning strlit1825 (depth = 7)
  int op_slot_right_1824 = gc_frame_newslot(strlit1825);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1824 = gc_frame_newslot(*var_c);
  params[0] = strlit1825;
  partcv[0] = 1;
  Object opresult1827 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1827 (depth = 6)
  Object if1823 = done;
  if (istrue(opresult1827)) {
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_wasCR (depth = 7)
  Object if1828 = done;
  if (istrue(*var_wasCR)) {
    gc_frame_newslot(done);
    if1828 = done;
  } else {
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1829 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lines (depth = 8)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1830 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1829);
// compiled call node returning call1830 (depth = 7)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1831 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLine (depth = 8)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLines (depth = 8)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1832 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1831);
// compiled call node returning call1832 (depth = 7)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1833 == NULL) {
    strlit1833 = alloc_String("");
    gc_root(strlit1833);
  }
// compiled string node returning strlit1833 (depth = 8)
  *var_line = strlit1833;
  if (strlit1833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1835 == NULL) {
    strlit1835 = alloc_String("");
    gc_root(strlit1835);
  }
// compiled string node returning strlit1835 (depth = 8)
  *var_cLine = strlit1835;
  if (strlit1835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1828 = done;
  }
// compiled if node returning if1828 (depth = 6)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1837 = alloc_Boolean(0);
// compiled identifier node returning bool1837 (depth = 7)
  *var_wasCR = bool1837;
  if (bool1837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1823 = done;
  } else {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1841 == NULL) {
    strlit1841 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit1841);
  }
// compiled string node returning strlit1841 (depth = 8)
  int op_slot_right_1840 = gc_frame_newslot(strlit1841);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1840 = gc_frame_newslot(*var_c);
  params[0] = strlit1841;
  partcv[0] = 1;
  Object opresult1843 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1843 (depth = 7)
  Object if1839 = done;
  if (istrue(opresult1843)) {
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1844 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lines (depth = 8)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1845 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1844);
// compiled call node returning call1845 (depth = 7)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1846 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLine (depth = 8)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLines (depth = 8)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1847 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1846);
// compiled call node returning call1847 (depth = 7)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1848 == NULL) {
    strlit1848 = alloc_String("");
    gc_root(strlit1848);
  }
// compiled string node returning strlit1848 (depth = 8)
  *var_line = strlit1848;
  if (strlit1848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1850 == NULL) {
    strlit1850 = alloc_String("");
    gc_root(strlit1850);
  }
// compiled string node returning strlit1850 (depth = 8)
  *var_cLine = strlit1850;
  if (strlit1850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1852 = alloc_Boolean(0);
// compiled identifier node returning bool1852 (depth = 8)
  *var_wasCR = bool1852;
  if (bool1852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1839 = done;
  } else {
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1856 == NULL) {
    strlit1856 = alloc_String("\\");
    gc_root(strlit1856);
  }
// compiled string node returning strlit1856 (depth = 9)
  int op_slot_right_1855 = gc_frame_newslot(strlit1856);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1855 = gc_frame_newslot(*var_c);
  params[0] = strlit1856;
  partcv[0] = 1;
  Object opresult1858 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1858 (depth = 8)
  Object if1854 = done;
  if (istrue(opresult1858)) {
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1860 == NULL) {
    strlit1860 = alloc_String("\\");
    gc_root(strlit1860);
  }
// compiled string node returning strlit1860 (depth = 10)
  int op_slot_right_1859 = gc_frame_newslot(strlit1860);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_1859 = gc_frame_newslot(*var_line);
  params[0] = strlit1860;
  partcv[0] = 1;
  Object opresult1862 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1862 (depth = 9)
  *var_line = opresult1862;
  if (opresult1862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1865 == NULL) {
    strlit1865 = alloc_String("\\\\");
    gc_root(strlit1865);
  }
// compiled string node returning strlit1865 (depth = 10)
  int op_slot_right_1864 = gc_frame_newslot(strlit1865);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_cLine (depth = 10)
  int op_slot_left_1864 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1865;
  partcv[0] = 1;
  Object opresult1867 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1867 (depth = 9)
  *var_cLine = opresult1867;
  if (opresult1867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1869 = alloc_Boolean(0);
// compiled identifier node returning bool1869 (depth = 9)
  *var_wasCR = bool1869;
  if (bool1869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1854 = done;
  } else {
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1873 == NULL) {
    strlit1873 = alloc_String("""\x22""");
    gc_root(strlit1873);
  }
// compiled string node returning strlit1873 (depth = 10)
  int op_slot_right_1872 = gc_frame_newslot(strlit1873);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1872 = gc_frame_newslot(*var_c);
  params[0] = strlit1873;
  partcv[0] = 1;
  Object opresult1875 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1875 (depth = 9)
  Object if1871 = done;
  if (istrue(opresult1875)) {
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1877 == NULL) {
    strlit1877 = alloc_String("""\x22""");
    gc_root(strlit1877);
  }
// compiled string node returning strlit1877 (depth = 11)
  int op_slot_right_1876 = gc_frame_newslot(strlit1877);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1876 = gc_frame_newslot(*var_line);
  params[0] = strlit1877;
  partcv[0] = 1;
  Object opresult1879 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1879 (depth = 10)
  *var_line = opresult1879;
  if (opresult1879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1882 == NULL) {
    strlit1882 = alloc_String("\\""\x22""");
    gc_root(strlit1882);
  }
// compiled string node returning strlit1882 (depth = 11)
  int op_slot_right_1881 = gc_frame_newslot(strlit1882);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1881 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1882;
  partcv[0] = 1;
  Object opresult1884 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1884 (depth = 10)
  *var_cLine = opresult1884;
  if (opresult1884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1886 = alloc_Boolean(0);
// compiled identifier node returning bool1886 (depth = 10)
  *var_wasCR = bool1886;
  if (bool1886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1871 = done;
  } else {
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1888 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1888 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1890 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1890 (depth = 10)
  *var_line = opresult1890;
  if (opresult1890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1892 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1892 = gc_frame_newslot(*var_cLine);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1894 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 10)
  *var_cLine = opresult1894;
  if (opresult1894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1896 = alloc_Boolean(0);
// compiled identifier node returning bool1896 (depth = 10)
  *var_wasCR = bool1896;
  if (bool1896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1871 = done;
  }
// compiled if node returning if1871 (depth = 8)
    gc_frame_newslot(if1871);
    if1854 = if1871;
  }
// compiled if node returning if1854 (depth = 7)
    gc_frame_newslot(if1854);
    if1839 = if1854;
  }
// compiled if node returning if1839 (depth = 6)
    gc_frame_newslot(if1839);
    if1823 = if1839;
  }
// compiled if node returning if1823 (depth = 5)
    gc_frame_newslot(if1823);
    if1808 = if1823;
  }
// compiled if node returning if1808 (depth = 4)
  gc_frame_end(frame);
  return if1808;
}
Object meth_lexer_lexfile1797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexfile");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexfile");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexfile (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_file = &(stackframe->slots[0]);
  *var_file = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexfile");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lines = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lines");
  Object *var_cLines = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "cLines");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_cLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cLine");
  Object *var_wasCR = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "wasCR");
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1798 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1798 (depth = 3)
  *var_lines = array1798;
  if (array1798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1799 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1799 (depth = 3)
  *var_cLines = array1799;
  if (array1799 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1800 == NULL) {
    strlit1800 = alloc_String("");
    gc_root(strlit1800);
  }
// compiled string node returning strlit1800 (depth = 3)
  *var_line = strlit1800;
  if (strlit1800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1801 == NULL) {
    strlit1801 = alloc_String("");
    gc_root(strlit1801);
  }
// compiled string node returning strlit1801 (depth = 3)
  *var_cLine = strlit1801;
  if (strlit1801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1802 = alloc_Boolean(0);
// compiled identifier node returning bool1802 (depth = 3)
  *var_wasCR = bool1802;
  if (bool1802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1803 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_file (depth = 5)
  partcv[0] = 0;
  Object call1805 = callmethod(*var_file, "read",
    1, partcv, params);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 4)
// compiled member node returning call1805 (depth = 3)
  gc_frame_newslot(call1805);
// starting to compile block node (depth = 3)
  Object block1806 = alloc_Block(NULL, NULL, "lexer", 528);
  gc_frame_newslot(block1806);
// method _apply
  block_savedest(block1806);
  Object closure1807 = createclosure(6, "_apply");
  setclosureframe(closure1807, stackframe);
  addtoclosure(closure1807, var_line);
  addtoclosure(closure1807, var_lines);
  addtoclosure(closure1807, var_cLine);
  addtoclosure(closure1807, var_cLines);
  addtoclosure(closure1807, var_wasCR);
  addtoclosure(closure1807, selfslot);
  struct UserObject *uo1807 = (struct UserObject*)block1806;
  uo1807->data[0] = (Object)closure1807;
  Method *meth_meth_lexer__apply1807 = addmethod2pos(block1806, "_apply", &meth_lexer__apply1807, 0);
  int argcv_meth_lexer__apply1807[] = {1};
  meth_meth_lexer__apply1807->type = alloc_MethodType(1, argcv_meth_lexer__apply1807);
  meth_meth_lexer__apply1807->definitionModule = modulename;
  meth_meth_lexer__apply1807->definitionLine = 528;
// compiled block node returning block1806 (depth = 3)
  gc_frame_newslot(block1806);
// call case 5: prelude request
  params[0] = call1805;
  params[1] = block1806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1899 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1803);
// compiled call node returning call1899 (depth = 2)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1902 == NULL) {
    strlit1902 = alloc_String("");
    gc_root(strlit1902);
  }
// compiled string node returning strlit1902 (depth = 4)
  int op_slot_right_1901 = gc_frame_newslot(strlit1902);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  int op_slot_left_1901 = gc_frame_newslot(*var_line);
  params[0] = strlit1902;
  partcv[0] = 1;
  Object opresult1904 = callmethod(*var_line, "!=", 1, partcv, params);
// compiled op node returning opresult1904 (depth = 3)
  Object if1900 = done;
  if (istrue(opresult1904)) {
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1905 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lines (depth = 4)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1906 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1905);
// compiled call node returning call1906 (depth = 3)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1907 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cLine (depth = 4)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cLines (depth = 4)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1908 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1907);
// compiled call node returning call1908 (depth = 3)
    gc_frame_newslot(call1908);
    if1900 = call1908;
  } else {
  }
// compiled if node returning if1900 (depth = 2)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1909 = gc_frame_new();
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lines (depth = 4)
  gc_frame_newslot(*var_lines);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lines;
  partcv[0] = 1;
  Object call1910 = callmethod(*var_util, "lines:=",
    1, partcv, params);
  gc_frame_end(callframe1909);
// compiled call node returning call1910 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1911 = gc_frame_new();
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cLines (depth = 4)
  gc_frame_newslot(*var_cLines);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_cLines;
  partcv[0] = 1;
  Object call1912 = callmethod(*var_util, "cLines:=",
    1, partcv, params);
  gc_frame_end(callframe1911);
// compiled call node returning call1912 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1913 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lines (depth = 3)
  gc_frame_newslot(*var_lines);
// call case 4: self request
  params[0] = *var_lines;
  partcv[0] = 1;
  Object call1914 = callmethodflags(self, "lexinput", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1913);
// compiled call node returning call1914 (depth = 2)
  gc_frame_end(frame);
  return call1914;
}
Object meth_lexer_push1921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method push");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1924 = alloc_Boolean(0);
// compiled identifier node returning bool1924 (depth = 6)
  int op_slot_right_1923 = gc_frame_newslot(bool1924);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1927 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compiled call node returning call1927 (depth = 7)
// compiled member node returning call1927 (depth = 6)
  int op_slot_left_1923 = gc_frame_newslot(call1927);
  params[0] = bool1924;
  partcv[0] = 1;
  Object opresult1928 = callmethod(call1927, "==", 1, partcv, params);
// compiled op node returning opresult1928 (depth = 5)
  Object if1922 = done;
  if (istrue(opresult1928)) {
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1929 = gc_frame_new();
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1930 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call1930 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1931 = gc_frame_new();
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1932 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1931);
// compiled call node returning call1932 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1922 = done;
  } else {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1933 = gc_frame_new();
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1934 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1935 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1935 (depth = 8)
// compiled member node returning call1935 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1936 = callmethod(call1935, "next:=",
    1, partcv, params);
  gc_frame_end(callframe1933);
// compiled call node returning call1936 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1937 = gc_frame_new();
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1938 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1939 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1938);
// compiled call node returning call1939 (depth = 8)
// compiled member node returning call1939 (depth = 7)
  gc_frame_newslot(call1939);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = call1939;
  partcv[0] = 1;
  Object call1940 = callmethod(*var_t, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe1937);
// compiled call node returning call1940 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1941 = gc_frame_new();
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1942 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1941);
// compiled call node returning call1942 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1922 = done;
  }
// compiled if node returning if1922 (depth = 4)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1943 = gc_frame_new();
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1945 = alloc_Float64(1);
// compiled num node returning num1945 (depth = 7)
  int op_slot_right_1944 = gc_frame_newslot(num1945);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1947 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1948 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1947);
// compiled call node returning call1948 (depth = 8)
// compiled member node returning call1948 (depth = 7)
  int op_slot_left_1944 = gc_frame_newslot(call1948);
  params[0] = num1945;
  partcv[0] = 1;
  Object sum1949 = callmethod(call1948, "+", 1, partcv, params);
// compiled op node returning sum1949 (depth = 6)
  gc_frame_newslot(sum1949);
// call case 4: self request
  params[0] = sum1949;
  partcv[0] = 1;
  Object call1950 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1943);
// compiled call node returning call1950 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_pop1951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_popped = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "popped");
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1954 = alloc_Boolean(0);
// compiled identifier node returning bool1954 (depth = 6)
  int op_slot_right_1953 = gc_frame_newslot(bool1954);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1956 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1957 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1956);
// compiled call node returning call1957 (depth = 7)
// compiled member node returning call1957 (depth = 6)
  int op_slot_left_1953 = gc_frame_newslot(call1957);
  params[0] = bool1954;
  partcv[0] = 1;
  Object opresult1958 = callmethod(call1957, "!=", 1, partcv, params);
// compiled op node returning opresult1958 (depth = 5)
  Object if1952 = done;
  if (istrue(opresult1958)) {
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1960 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled call node returning call1960 (depth = 7)
// compiled member node returning call1960 (depth = 6)
  *var_popped = call1960;
  if (call1960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1961 = gc_frame_new();
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1962 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1964 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1963);
// compiled call node returning call1964 (depth = 10)
// compiled member node returning call1964 (depth = 9)
  partcv[0] = 0;
  Object call1965 = callmethod(call1964, "prev",
    1, partcv, params);
  gc_frame_end(callframe1962);
// compiled call node returning call1965 (depth = 8)
// compiled member node returning call1965 (depth = 7)
  gc_frame_newslot(call1965);
// call case 4: self request
  params[0] = call1965;
  partcv[0] = 1;
  Object call1966 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1961);
// compiled call node returning call1966 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1969 = alloc_Boolean(0);
// compiled identifier node returning bool1969 (depth = 7)
  int op_slot_right_1968 = gc_frame_newslot(bool1969);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1972 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1971);
// compiled call node returning call1972 (depth = 8)
// compiled member node returning call1972 (depth = 7)
  int op_slot_left_1968 = gc_frame_newslot(call1972);
  params[0] = bool1969;
  partcv[0] = 1;
  Object opresult1973 = callmethod(call1972, "==", 1, partcv, params);
// compiled op node returning opresult1973 (depth = 6)
  Object if1967 = done;
  if (istrue(opresult1973)) {
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1974 = gc_frame_new();
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool1975 = alloc_Boolean(0);
// compiled identifier node returning bool1975 (depth = 8)
  gc_frame_newslot(bool1975);
// call case 4: self request
  params[0] = bool1975;
  partcv[0] = 1;
  Object call1976 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1974);
// compiled call node returning call1976 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1967 = done;
  } else {
  }
// compiled if node returning if1967 (depth = 5)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1977 = gc_frame_new();
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1979 = alloc_Float64(1);
// compiled num node returning num1979 (depth = 8)
  int op_slot_right_1978 = gc_frame_newslot(num1979);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1982 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1981);
// compiled call node returning call1982 (depth = 9)
// compiled member node returning call1982 (depth = 8)
  int op_slot_left_1978 = gc_frame_newslot(call1982);
  params[0] = num1979;
  partcv[0] = 1;
  Object diff1983 = callmethod(call1982, "-", 1, partcv, params);
// compiled op node returning diff1983 (depth = 7)
  gc_frame_newslot(diff1983);
// call case 4: self request
  params[0] = diff1983;
  partcv[0] = 1;
  Object call1984 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1977);
// compiled call node returning call1984 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_popped (depth = 5)
    gc_frame_newslot(*var_popped);
    if1952 = *var_popped;
  } else {
  }
// compiled if node returning if1952 (depth = 4)
  gc_frame_end(frame);
  return if1952;
}
Object meth_lexer_poll1985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "poll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for poll (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for poll");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_polled = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "polled");
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1988 = alloc_Boolean(0);
// compiled identifier node returning bool1988 (depth = 6)
  int op_slot_right_1987 = gc_frame_newslot(bool1988);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1990 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1991 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1990);
// compiled call node returning call1991 (depth = 7)
// compiled member node returning call1991 (depth = 6)
  int op_slot_left_1987 = gc_frame_newslot(call1991);
  params[0] = bool1988;
  partcv[0] = 1;
  Object opresult1992 = callmethod(call1991, "!=", 1, partcv, params);
// compiled op node returning opresult1992 (depth = 5)
  Object if1986 = done;
  if (istrue(opresult1992)) {
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1994 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled call node returning call1994 (depth = 7)
// compiled member node returning call1994 (depth = 6)
  *var_polled = call1994;
  if (call1994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1995 = gc_frame_new();
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1996 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1997 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1998 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1997);
// compiled call node returning call1998 (depth = 10)
// compiled member node returning call1998 (depth = 9)
  partcv[0] = 0;
  Object call1999 = callmethod(call1998, "next",
    1, partcv, params);
  gc_frame_end(callframe1996);
// compiled call node returning call1999 (depth = 8)
// compiled member node returning call1999 (depth = 7)
  gc_frame_newslot(call1999);
// call case 4: self request
  params[0] = call1999;
  partcv[0] = 1;
  Object call2000 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1995);
// compiled call node returning call2000 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2003 = alloc_Boolean(0);
// compiled identifier node returning bool2003 (depth = 7)
  int op_slot_right_2002 = gc_frame_newslot(bool2003);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2005 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2006 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2005);
// compiled call node returning call2006 (depth = 8)
// compiled member node returning call2006 (depth = 7)
  int op_slot_left_2002 = gc_frame_newslot(call2006);
  params[0] = bool2003;
  partcv[0] = 1;
  Object opresult2007 = callmethod(call2006, "==", 1, partcv, params);
// compiled op node returning opresult2007 (depth = 6)
  Object if2001 = done;
  if (istrue(opresult2007)) {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2008 = gc_frame_new();
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool2009 = alloc_Boolean(0);
// compiled identifier node returning bool2009 (depth = 8)
  gc_frame_newslot(bool2009);
// call case 4: self request
  params[0] = bool2009;
  partcv[0] = 1;
  Object call2010 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2008);
// compiled call node returning call2010 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2001 = done;
  } else {
  }
// compiled if node returning if2001 (depth = 5)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2011 = gc_frame_new();
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2013 = alloc_Float64(1);
// compiled num node returning num2013 (depth = 8)
  int op_slot_right_2012 = gc_frame_newslot(num2013);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2016 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2015);
// compiled call node returning call2016 (depth = 9)
// compiled member node returning call2016 (depth = 8)
  int op_slot_left_2012 = gc_frame_newslot(call2016);
  params[0] = num2013;
  partcv[0] = 1;
  Object diff2017 = callmethod(call2016, "-", 1, partcv, params);
// compiled op node returning diff2017 (depth = 7)
  gc_frame_newslot(diff2017);
// call case 4: self request
  params[0] = diff2017;
  partcv[0] = 1;
  Object call2018 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2011);
// compiled call node returning call2018 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_polled (depth = 5)
    gc_frame_newslot(*var_polled);
    if1986 = *var_polled;
  } else {
  }
// compiled if node returning if1986 (depth = 4)
  gc_frame_end(frame);
  return if1986;
}
Object meth_lexer_size2019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2021 = alloc_Float64(0);
// compiled num node returning num2021 (depth = 5)
  int op_slot_right_2020 = gc_frame_newslot(num2021);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2024 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 6)
// compiled member node returning call2024 (depth = 5)
  int op_slot_left_2020 = gc_frame_newslot(call2024);
  params[0] = num2021;
  partcv[0] = 1;
  Object sum2025 = callmethod(call2024, "+", 1, partcv, params);
// compiled op node returning sum2025 (depth = 4)
  gc_frame_end(frame);
  return sum2025;
}
Object meth_lexer_havemore2030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "havemore");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for havemore (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for havemore");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2032 = alloc_Boolean(0);
// compiled identifier node returning bool2032 (depth = 5)
  int op_slot_right_2031 = gc_frame_newslot(bool2032);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2035 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2034);
// compiled call node returning call2035 (depth = 6)
// compiled member node returning call2035 (depth = 5)
  int op_slot_left_2031 = gc_frame_newslot(call2035);
  params[0] = bool2032;
  partcv[0] = 1;
  Object opresult2036 = callmethod(call2035, "!=", 1, partcv, params);
// compiled op node returning opresult2036 (depth = 4)
  gc_frame_end(frame);
  return opresult2036;
}
Object meth_lexer_hasNext2037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2039 = alloc_Boolean(0);
// compiled identifier node returning bool2039 (depth = 5)
  int op_slot_right_2038 = gc_frame_newslot(bool2039);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2041 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2042 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2041);
// compiled call node returning call2042 (depth = 6)
// compiled member node returning call2042 (depth = 5)
  int op_slot_left_2038 = gc_frame_newslot(call2042);
  params[0] = bool2039;
  partcv[0] = 1;
  Object opresult2043 = callmethod(call2042, "!=", 1, partcv, params);
// compiled op node returning opresult2043 (depth = 4)
  gc_frame_end(frame);
  return opresult2043;
}
Object meth_lexer_next2044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2045 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2046 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2045);
// compiled call node returning call2046 (depth = 6)
// compiled member node returning call2046 (depth = 5)
  *var_ret = call2046;
  if (call2046 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2047 = gc_frame_new();
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2048 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2050 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2049);
// compiled call node returning call2050 (depth = 9)
// compiled member node returning call2050 (depth = 8)
  partcv[0] = 0;
  Object call2051 = callmethod(call2050, "next",
    1, partcv, params);
  gc_frame_end(callframe2048);
// compiled call node returning call2051 (depth = 7)
// compiled member node returning call2051 (depth = 6)
  gc_frame_newslot(call2051);
// call case 4: self request
  params[0] = call2051;
  partcv[0] = 1;
  Object call2052 = callmethodflags(self, "n:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2047);
// compiled call node returning call2052 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ret (depth = 4)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_lexer_iter2026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2027 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2027 = alloc_userobj2(5,5, objclass2027);
  gc_frame_newslot(obj2027);
if (objclass2027 == NULL) {
  glfree(obj2027->class->name);
  obj2027->class->name = "obj1916.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2027, self, 0);
  addmethodreal(obj2027,"outer", &reader_lexer_outer_2028);
  Object oldself2027 = self;
  struct StackFrameObject *oldstackframe2027 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2027);
  gc_frame_newslot((Object)stackframe);
  self = obj2027;
  Object *oldselfslot2027 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2027 = (*(struct UserObject *)self).data[0], lowerouter2027 = thisouter2027;
  if (inheritingObject2027) {
    struct UserObject *inho2027 = (struct UserObject *)inheritingObject2027;
    while (inho2027->super != GraceDefaultObject) inho2027 = (struct UserObject *)inho2027->super;
    inho2027->super = obj2027;
    self = inheritingObject2027;
    *selfslot = self;
    lowerouter2027 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2027;
  }
if (objclass2027 == NULL) {
  Method *reader2029 = addmethodrealflags(obj2027, "n",&reader_lexer_n_2029, MFLAG_CONFIDENTIAL);
  Method *writer2029 = addmethodrealflags(obj2027, "n:=",&writer_lexer_n_2029, MFLAG_CONFIDENTIAL);
  reader2029->definitionModule = modulename;
  writer2029->definitionModule = modulename;
  reader2029->definitionLine = 625;
  writer2029->definitionLine = 625;
}
obj2027->flags |= OFLAG_MUTABLE;
adddatum2(obj2027, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo2030 = (struct UserObject*)obj2027;
  uo2030->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore2030 = addmethod2pos(obj2027, "havemore", &meth_lexer_havemore2030, 2);
  int argcv_meth_lexer_havemore2030[] = {0};
  meth_meth_lexer_havemore2030->type = alloc_MethodType(1, argcv_meth_lexer_havemore2030);
  meth_meth_lexer_havemore2030->definitionModule = modulename;
  meth_meth_lexer_havemore2030->definitionLine = 626;
// method hasNext
  struct UserObject *uo2037 = (struct UserObject*)obj2027;
  uo2037->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext2037 = addmethod2pos(obj2027, "hasNext", &meth_lexer_hasNext2037, 3);
  int argcv_meth_lexer_hasNext2037[] = {0};
  meth_meth_lexer_hasNext2037->type = alloc_MethodType(1, argcv_meth_lexer_hasNext2037);
  meth_meth_lexer_hasNext2037->definitionModule = modulename;
  meth_meth_lexer_hasNext2037->definitionLine = 629;
// method next
  struct UserObject *uo2044 = (struct UserObject*)obj2027;
  uo2044->data[4] = emptyclosure;
  Method *meth_meth_lexer_next2044 = addmethod2pos(obj2027, "next", &meth_lexer_next2044, 4);
  int argcv_meth_lexer_next2044[] = {0};
  meth_meth_lexer_next2044->type = alloc_MethodType(1, argcv_meth_lexer_next2044);
  meth_meth_lexer_next2044->definitionModule = modulename;
  meth_meth_lexer_next2044->definitionLine = 632;
  sourceObject = obj2027;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2053 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2054 = gc_frame_new();
// call case 3: self.outer request
  Object call2055 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2054);
// compiled call node returning call2055 (depth = 7)
// compiled member node returning call2055 (depth = 6)
  partcv[0] = 0;
  Object call2056 = callmethodflags(call2055, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2056 (depth = 5)
// compiled member node returning call2056 (depth = 4)
  adddatum2(obj2027, call2056, 1);
  sourceObject = obj2027;
  sourceObject = obj2027;
  sourceObject = obj2027;
  objclass2027 = obj2027->class;
  objclass2027->definitionModule = modulename;
  objclass2027->definitionLine = 624;
  (*(struct UserObject *)self).data[0] = lowerouter2027;
  self = oldself2027;
  selfslot = oldselfslot2027;
  stackframe = oldstackframe2027;
  gc_frame_end(frame);
  return obj2027;
}
Object meth_lexer_iter2026_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2027 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2027 = alloc_userobj2(5,5, objclass2027);
  gc_frame_newslot(obj2027);
if (objclass2027 == NULL) {
  glfree(obj2027->class->name);
  obj2027->class->name = "obj1916.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2027, self, 0);
  addmethodreal(obj2027,"outer", &reader_lexer_outer_2028);
  Object oldself2027 = self;
  struct StackFrameObject *oldstackframe2027 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2027);
  gc_frame_newslot((Object)stackframe);
  self = obj2027;
  Object *oldselfslot2027 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2027 = (*(struct UserObject *)self).data[0], lowerouter2027 = thisouter2027;
  if (inheritingObject2027) {
    struct UserObject *inho2027 = (struct UserObject *)inheritingObject2027;
    while (inho2027->super != GraceDefaultObject) inho2027 = (struct UserObject *)inho2027->super;
    inho2027->super = obj2027;
    self = inheritingObject2027;
    *selfslot = self;
    lowerouter2027 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2027;
  }
if (objclass2027 == NULL) {
  Method *reader2029 = addmethodrealflags(obj2027, "n",&reader_lexer_n_2029, MFLAG_CONFIDENTIAL);
  Method *writer2029 = addmethodrealflags(obj2027, "n:=",&writer_lexer_n_2029, MFLAG_CONFIDENTIAL);
  reader2029->definitionModule = modulename;
  writer2029->definitionModule = modulename;
  reader2029->definitionLine = 625;
  writer2029->definitionLine = 625;
}
obj2027->flags |= OFLAG_MUTABLE;
adddatum2(obj2027, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo2030 = (struct UserObject*)obj2027;
  uo2030->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore2030 = addmethod2pos(obj2027, "havemore", &meth_lexer_havemore2030, 2);
  int argcv_meth_lexer_havemore2030[] = {0};
  meth_meth_lexer_havemore2030->type = alloc_MethodType(1, argcv_meth_lexer_havemore2030);
  meth_meth_lexer_havemore2030->definitionModule = modulename;
  meth_meth_lexer_havemore2030->definitionLine = 626;
// method hasNext
  struct UserObject *uo2037 = (struct UserObject*)obj2027;
  uo2037->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext2037 = addmethod2pos(obj2027, "hasNext", &meth_lexer_hasNext2037, 3);
  int argcv_meth_lexer_hasNext2037[] = {0};
  meth_meth_lexer_hasNext2037->type = alloc_MethodType(1, argcv_meth_lexer_hasNext2037);
  meth_meth_lexer_hasNext2037->definitionModule = modulename;
  meth_meth_lexer_hasNext2037->definitionLine = 629;
// method next
  struct UserObject *uo2044 = (struct UserObject*)obj2027;
  uo2044->data[4] = emptyclosure;
  Method *meth_meth_lexer_next2044 = addmethod2pos(obj2027, "next", &meth_lexer_next2044, 4);
  int argcv_meth_lexer_next2044[] = {0};
  meth_meth_lexer_next2044->type = alloc_MethodType(1, argcv_meth_lexer_next2044);
  meth_meth_lexer_next2044->definitionModule = modulename;
  meth_meth_lexer_next2044->definitionLine = 632;
  sourceObject = obj2027;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2053 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2054 = gc_frame_new();
// call case 3: self.outer request
  Object call2055 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2054);
// compiled call node returning call2055 (depth = 7)
// compiled member node returning call2055 (depth = 6)
  partcv[0] = 0;
  Object call2056 = callmethodflags(call2055, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2056 (depth = 5)
// compiled member node returning call2056 (depth = 4)
  adddatum2(obj2027, call2056, 1);
  sourceObject = obj2027;
  sourceObject = obj2027;
  sourceObject = obj2027;
  objclass2027 = obj2027->class;
  objclass2027->definitionModule = modulename;
  objclass2027->definitionLine = 624;
  (*(struct UserObject *)self).data[0] = lowerouter2027;
  self = oldself2027;
  selfslot = oldselfslot2027;
  stackframe = oldstackframe2027;
  gc_frame_end(frame);
  return obj2027;
}
Object meth_lexer_iterator2058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2060 = callmethodflags(self, "iter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2059);
// compiled call node returning call2060 (depth = 5)
// compiled member node returning call2060 (depth = 4)
  gc_frame_end(frame);
  return call2060;
}
Object meth_lexer__apply2238(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_mode = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2240 == NULL) {
    strlit2240 = alloc_String("q");
    gc_root(strlit2240);
  }
// compiled string node returning strlit2240 (depth = 8)
  int op_slot_right_2239 = gc_frame_newslot(strlit2240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2239 = gc_frame_newslot(*var_mode);
  params[0] = strlit2240;
  partcv[0] = 1;
  Object opresult2242 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2242 (depth = 7)
  gc_frame_end(frame);
  return opresult2242;
}
Object meth_lexer__apply2428(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_mode = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2430 == NULL) {
    strlit2430 = alloc_String("q");
    gc_root(strlit2430);
  }
// compiled string node returning strlit2430 (depth = 9)
  int op_slot_right_2429 = gc_frame_newslot(strlit2430);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2429 = gc_frame_newslot(*var_mode);
  params[0] = strlit2430;
  partcv[0] = 1;
  Object opresult2432 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2432 (depth = 8)
  gc_frame_end(frame);
  return opresult2432;
}
Object meth_lexer__apply3015(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_i = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3017 == NULL) {
    strlit3017 = alloc_String("{");
    gc_root(strlit3017);
  }
// compiled string node returning strlit3017 (depth = 11)
  int op_slot_right_3016 = gc_frame_newslot(strlit3017);
// starting to compile index node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3019 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_line (depth = 13)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call3021 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3020);
// compiled call node returning call3021 (depth = 14)
// compiled member node returning call3021 (depth = 13)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call3022 = callmethod(call3021, "at",
    1, partcv, params);
  gc_frame_end(callframe3019);
// compiled call node returning call3022 (depth = 12)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3023 = callmethod(call3022, "[]", 1, partcv, params);
// compiled index node returning idxres3023 (depth = 11)
  int op_slot_left_3016 = gc_frame_newslot(idxres3023);
  params[0] = strlit3017;
  partcv[0] = 1;
  Object opresult3024 = callmethod(idxres3023, "!=", 1, partcv, params);
// compiled op node returning opresult3024 (depth = 10)
  gc_frame_end(frame);
  return opresult3024;
}
Object meth_lexer__apply3027(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_line = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3029 = alloc_Float64(1);
// compiled num node returning num3029 (depth = 12)
  int op_slot_right_3028 = gc_frame_newslot(num3029);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_3028 = gc_frame_newslot(*var_i);
  params[0] = num3029;
  partcv[0] = 1;
  Object diff3031 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff3031 (depth = 11)
  *var_i = diff3031;
  if (diff3031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3035 = alloc_Float64(0);
// compiled num node returning num3035 (depth = 12)
  int op_slot_right_3034 = gc_frame_newslot(num3035);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_3034 = gc_frame_newslot(*var_i);
  params[0] = num3035;
  partcv[0] = 1;
  Object opresult3037 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult3037 (depth = 11)
  Object if3033 = done;
  if (istrue(opresult3037)) {
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3039 = alloc_Float64(1);
// compiled num node returning num3039 (depth = 13)
  int op_slot_right_3038 = gc_frame_newslot(num3039);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_line (depth = 13)
  int op_slot_left_3038 = gc_frame_newslot(*var_line);
  params[0] = num3039;
  partcv[0] = 1;
  Object diff3041 = callmethod(*var_line, "-", 1, partcv, params);
// compiled op node returning diff3041 (depth = 12)
  *var_lineNumber = diff3041;
  if (diff3041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3043 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 14)
  int callframe3044 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_line (depth = 15)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe3045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_util (depth = 17)
  partcv[0] = 0;
  Object call3046 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3045);
// compiled call node returning call3046 (depth = 16)
// compiled member node returning call3046 (depth = 15)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call3047 = callmethod(call3046, "at",
    1, partcv, params);
  gc_frame_end(callframe3044);
// compiled call node returning call3047 (depth = 14)
  partcv[0] = 0;
  Object call3048 = callmethod(call3047, "size",
    1, partcv, params);
  gc_frame_end(callframe3043);
// compiled call node returning call3048 (depth = 13)
// compiled member node returning call3048 (depth = 12)
  *var_i = call3048;
  if (call3048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3033 = done;
  } else {
  }
// compiled if node returning if3033 (depth = 10)
  gc_frame_end(frame);
  return if3033;
}
Object meth_lexer__apply3139(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3141 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextLine (depth = 13)
  partcv[0] = 0;
  Object call3142 = callmethod(*var_nextLine, "size",
    1, partcv, params);
  gc_frame_end(callframe3141);
// compiled call node returning call3142 (depth = 12)
// compiled member node returning call3142 (depth = 11)
  int op_slot_right_3140 = gc_frame_newslot(call3142);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_3140 = gc_frame_newslot(*var_i);
  params[0] = call3142;
  partcv[0] = 1;
  Object opresult3144 = callmethod(*var_i, "<=", 1, partcv, params);
// compiled op node returning opresult3144 (depth = 10)
  gc_frame_end(frame);
  return opresult3144;
}
Object meth_lexer__apply3147(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object *var_count = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3150 == NULL) {
    strlit3150 = alloc_String("""\x22""");
    gc_root(strlit3150);
  }
// compiled string node returning strlit3150 (depth = 12)
  int op_slot_right_3149 = gc_frame_newslot(strlit3150);
// starting to compile index node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextLine (depth = 13)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3152 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3152 (depth = 12)
  int op_slot_left_3149 = gc_frame_newslot(idxres3152);
  params[0] = strlit3150;
  partcv[0] = 1;
  Object opresult3153 = callmethod(idxres3152, "==", 1, partcv, params);
// compiled op node returning opresult3153 (depth = 11)
  Object if3148 = done;
  if (istrue(opresult3153)) {
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3155 = alloc_Float64(1);
// compiled num node returning num3155 (depth = 13)
  int op_slot_right_3154 = gc_frame_newslot(num3155);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_count (depth = 13)
  int op_slot_left_3154 = gc_frame_newslot(*var_count);
  params[0] = num3155;
  partcv[0] = 1;
  Object sum3157 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum3157 (depth = 12)
  *var_count = sum3157;
  if (sum3157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3148 = done;
  } else {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3161 == NULL) {
    strlit3161 = alloc_String("\\");
    gc_root(strlit3161);
  }
// compiled string node returning strlit3161 (depth = 13)
  int op_slot_right_3160 = gc_frame_newslot(strlit3161);
// starting to compile index node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextLine (depth = 14)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3163 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3163 (depth = 13)
  int op_slot_left_3160 = gc_frame_newslot(idxres3163);
  params[0] = strlit3161;
  partcv[0] = 1;
  Object opresult3164 = callmethod(idxres3163, "==", 1, partcv, params);
// compiled op node returning opresult3164 (depth = 12)
  Object if3159 = done;
  if (istrue(opresult3164)) {
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num3166 = alloc_Float64(1);
// compiled num node returning num3166 (depth = 14)
  int op_slot_right_3165 = gc_frame_newslot(num3166);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  int op_slot_left_3165 = gc_frame_newslot(*var_i);
  params[0] = num3166;
  partcv[0] = 1;
  Object sum3168 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3168 (depth = 13)
  *var_i = sum3168;
  if (sum3168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3159 = done;
  } else {
  }
// compiled if node returning if3159 (depth = 11)
    gc_frame_newslot(if3159);
    if3148 = if3159;
  }
// compiled if node returning if3148 (depth = 10)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3171 = alloc_Float64(1);
// compiled num node returning num3171 (depth = 12)
  int op_slot_right_3170 = gc_frame_newslot(num3171);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_3170 = gc_frame_newslot(*var_i);
  params[0] = num3171;
  partcv[0] = 1;
  Object sum3173 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3173 (depth = 11)
  *var_i = sum3173;
  if (sum3173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply2231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(20, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_mode = getfromclosure(closure, 0);
  Object *var_badSeparator = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_linePosition = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object *var_inStr = getfromclosure(closure, 5);
  Object *var_unicode = getfromclosure(closure, 6);
  Object *var_badControl = getfromclosure(closure, 7);
  Object *var_atStart = getfromclosure(closure, 8);
  Object *var_newmode = getfromclosure(closure, 9);
  Object *var_stringStart = getfromclosure(closure, 10);
  Object *var_startLine = getfromclosure(closure, 11);
  Object *var_identifierChar = getfromclosure(closure, 12);
  Object *var_digit = getfromclosure(closure, 13);
  Object *var_iGTLT = getfromclosure(closure, 14);
  Object *var_tokens = getfromclosure(closure, 15);
  Object *var_accum = getfromclosure(closure, 16);
  Object *var_operatorChar = getfromclosure(closure, 17);
  Object *var_selfModes = getfromclosure(closure, 18);
  Object *var_util = getfromclosure(closure, 19);
  Object *var_escaped = getfromclosure(closure, 20);
  Object *var_interpString = getfromclosure(closure, 21);
  Object *var_interpdepth = getfromclosure(closure, 22);
  Object *var_brackets = getfromclosure(closure, 23);
  Object *var_unichars = getfromclosure(closure, 24);
  Object *var_codepoint = getfromclosure(closure, 25);
  Object *var_newlineFound = getfromclosure(closure, 26);
  Object *var_startPosition = getfromclosure(closure, 27);
  Object self = *(getfromclosure(closure, 28));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ct = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ct");
  Object *var_ordval = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ordval");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_i = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "i");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_errorLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "errorLine");
  Object *var_nextLine = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "nextLine");
  Object *var_count = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "count");
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2232 == NULL) {
    strlit2232 = alloc_String("");
    gc_root(strlit2232);
  }
// compiled string node returning strlit2232 (depth = 5)
  *var_ct = strlit2232;
  if (strlit2232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2233 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  partcv[0] = 0;
  Object call2234 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe2233);
// compiled call node returning call2234 (depth = 6)
// compiled member node returning call2234 (depth = 5)
  *var_ordval = call2234;
  if (call2234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2236 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2237 = alloc_Block(NULL, NULL, "lexer", 679);
  gc_frame_newslot(block2237);
// method _apply
  block_savedest(block2237);
  Object closure2238 = createclosure(2, "_apply");
  setclosureframe(closure2238, stackframe);
  addtoclosure(closure2238, var_mode);
  addtoclosure(closure2238, selfslot);
  struct UserObject *uo2238 = (struct UserObject*)block2237;
  uo2238->data[0] = (Object)closure2238;
  Method *meth_meth_lexer__apply2238 = addmethod2pos(block2237, "_apply", &meth_lexer__apply2238, 0);
  int argcv_meth_lexer__apply2238[] = {0};
  meth_meth_lexer__apply2238->type = alloc_MethodType(1, argcv_meth_lexer__apply2238);
  meth_meth_lexer__apply2238->definitionModule = modulename;
  meth_meth_lexer__apply2238->definitionLine = 678;
// compiled block node returning block2237 (depth = 6)
  gc_frame_newslot(block2237);
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe2244 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ordval (depth = 7)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_badSeparator (depth = 7)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2245 = callmethod(*var_badSeparator, "match",
    1, partcv, params);
  gc_frame_end(callframe2244);
// compiled call node returning call2245 (depth = 6)
  params[0] = block2237;
  partcv[0] = 1;
  Object call2246 = callmethod(call2245, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2236);
// compiled call node returning call2246 (depth = 5)
  Object if2235 = done;
  if (istrue(call2246)) {
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2247 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2248 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2249 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2248);
// compiled call node returning call2249 (depth = 9)
// compiled member node returning call2249 (depth = 8)
  partcv[0] = 0;
  Object call2250 = callmethod(call2249, "new",
    1, partcv, params);
  gc_frame_end(callframe2247);
// compiled call node returning call2250 (depth = 7)
// compiled member node returning call2250 (depth = 6)
  *var_suggestion = call2250;
  if (call2250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2251 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 6)
  if (strlit2252 == NULL) {
    strlit2252 = alloc_String(" ");
    gc_root(strlit2252);
  }
// compiled string node returning strlit2252 (depth = 6)
  gc_frame_newslot(strlit2252);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_linePosition;
  params[1] = strlit2252;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2253 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2251);
// compiled call node returning call2253 (depth = 5)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2256 = alloc_Float64(9);
// compiled num node returning num2256 (depth = 7)
  int op_slot_right_2255 = gc_frame_newslot(num2256);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ordval (depth = 7)
  int op_slot_left_2255 = gc_frame_newslot(*var_ordval);
  params[0] = num2256;
  partcv[0] = 1;
  Object opresult2258 = callmethod(*var_ordval, "==", 1, partcv, params);
// compiled op node returning opresult2258 (depth = 6)
  Object if2254 = done;
  if (istrue(opresult2258)) {
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inStr (depth = 7)
  Object if2259 = done;
  if (istrue(*var_inStr)) {
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2260 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2262 == NULL) {
    strlit2262 = alloc_String("");
    gc_root(strlit2262);
  }
// compiled string node returning strlit2262 (depth = 9)
  int op_slot_right_2261 = gc_frame_newslot(strlit2262);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2265 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2266 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2267 = alloc_Float64(16);
// compiled num node returning num2267 (depth = 12)
  gc_frame_newslot(num2267);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2267;
  partcv[0] = 1;
  Object call2268 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2266);
// compiled call node returning call2268 (depth = 11)
  gc_frame_newslot(call2268);
// starting to compile num node (depth = 11)
  Object num2269 = alloc_Float64(4);
// compiled num node returning num2269 (depth = 11)
  gc_frame_newslot(num2269);
// starting to compile string node (depth = 11)
  if (strlit2270 == NULL) {
    strlit2270 = alloc_String("0");
    gc_root(strlit2270);
  }
// compiled string node returning strlit2270 (depth = 11)
  gc_frame_newslot(strlit2270);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2271 = gc_frame_new();
// call case 3: self.outer request
  Object call2272 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2271);
// compiled call node returning call2272 (depth = 12)
// compiled member node returning call2272 (depth = 11)
  params[0] = call2268;
  params[1] = num2269;
  params[2] = strlit2270;
  partcv[0] = 3;
  Object call2273 = callmethodflags(call2272, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2265);
// compiled call node returning call2273 (depth = 10)
  int op_slot_right_2264 = gc_frame_newslot(call2273);
// starting to compile string node (depth = 10)
  if (strlit2275 == NULL) {
    strlit2275 = alloc_String("\\u");
    gc_root(strlit2275);
  }
// compiled string node returning strlit2275 (depth = 10)
  int op_slot_left_2264 = gc_frame_newslot(strlit2275);
  params[0] = call2273;
  partcv[0] = 1;
  Object opresult2276 = callmethod(strlit2275, "++", 1, partcv, params);
// compiled op node returning opresult2276 (depth = 9)
  int op_slot_left_2261 = gc_frame_newslot(opresult2276);
  params[0] = strlit2262;
  partcv[0] = 1;
  Object opresult2277 = callmethod(opresult2276, "++", 1, partcv, params);
// compiled op node returning opresult2277 (depth = 8)
  gc_frame_newslot(opresult2277);
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2277;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2278 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2260);
// compiled call node returning call2278 (depth = 7)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2279 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2281 == NULL) {
    strlit2281 = alloc_String(" instead");
    gc_root(strlit2281);
  }
// compiled string node returning strlit2281 (depth = 9)
  int op_slot_right_2280 = gc_frame_newslot(strlit2281);
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2284 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2285 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2286 = alloc_Float64(16);
// compiled num node returning num2286 (depth = 12)
  gc_frame_newslot(num2286);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2286;
  partcv[0] = 1;
  Object call2287 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2285);
// compiled call node returning call2287 (depth = 11)
  gc_frame_newslot(call2287);
// starting to compile num node (depth = 11)
  Object num2288 = alloc_Float64(4);
// compiled num node returning num2288 (depth = 11)
  gc_frame_newslot(num2288);
// starting to compile string node (depth = 11)
  if (strlit2289 == NULL) {
    strlit2289 = alloc_String("0");
    gc_root(strlit2289);
  }
// compiled string node returning strlit2289 (depth = 11)
  gc_frame_newslot(strlit2289);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2290 = gc_frame_new();
// call case 3: self.outer request
  Object call2291 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2290);
// compiled call node returning call2291 (depth = 12)
// compiled member node returning call2291 (depth = 11)
  params[0] = call2287;
  params[1] = num2288;
  params[2] = strlit2289;
  partcv[0] = 3;
  Object call2292 = callmethodflags(call2291, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2284);
// compiled call node returning call2292 (depth = 10)
  int op_slot_right_2283 = gc_frame_newslot(call2292);
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2295 == NULL) {
    strlit2295 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2295);
  }
// compiled string node returning strlit2295 (depth = 11)
  int op_slot_right_2294 = gc_frame_newslot(strlit2295);
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2298 == NULL) {
    strlit2298 = alloc_String("written in the source code; ");
    gc_root(strlit2298);
  }
// compiled string node returning strlit2298 (depth = 12)
  int op_slot_right_2297 = gc_frame_newslot(strlit2298);
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2300 == NULL) {
    strlit2300 = alloc_String("tabs cannot be ");
    gc_root(strlit2300);
  }
// compiled string node returning strlit2300 (depth = 12)
  int op_slot_left_2297 = gc_frame_newslot(strlit2300);
  params[0] = strlit2298;
  partcv[0] = 1;
  Object opresult2301 = callmethod(strlit2300, "++", 1, partcv, params);
// compiled op node returning opresult2301 (depth = 11)
  int op_slot_left_2294 = gc_frame_newslot(opresult2301);
  params[0] = strlit2295;
  partcv[0] = 1;
  Object opresult2302 = callmethod(opresult2301, "++", 1, partcv, params);
// compiled op node returning opresult2302 (depth = 10)
  int op_slot_left_2283 = gc_frame_newslot(opresult2302);
  params[0] = call2292;
  partcv[0] = 1;
  Object opresult2303 = callmethod(opresult2302, "++", 1, partcv, params);
// compiled op node returning opresult2303 (depth = 9)
  int op_slot_left_2280 = gc_frame_newslot(opresult2303);
  params[0] = strlit2281;
  partcv[0] = 1;
  Object opresult2304 = callmethod(opresult2303, "++", 1, partcv, params);
// compiled op node returning opresult2304 (depth = 8)
  gc_frame_newslot(opresult2304);
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2304;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2305 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2279);
// compiled call node returning call2305 (depth = 7)
    gc_frame_newslot(call2305);
    if2259 = call2305;
  } else {
  }
// compiled if node returning if2259 (depth = 6)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2306 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2307 == NULL) {
    strlit2307 = alloc_String("Tabs are not allowed; use spaces instead.");
    gc_root(strlit2307);
  }
// compiled string node returning strlit2307 (depth = 7)
  gc_frame_newslot(strlit2307);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2307;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2308 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2306);
// compiled call node returning call2308 (depth = 6)
    gc_frame_newslot(call2308);
    if2254 = call2308;
  } else {
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2311 == NULL) {
    strlit2311 = alloc_String("""\x22""");
    gc_root(strlit2311);
  }
// compiled string node returning strlit2311 (depth = 8)
  int op_slot_right_2310 = gc_frame_newslot(strlit2311);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2310 = gc_frame_newslot(*var_mode);
  params[0] = strlit2311;
  partcv[0] = 1;
  Object opresult2313 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2313 (depth = 7)
  Object if2309 = done;
  if (istrue(opresult2313)) {
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2314 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2316 == NULL) {
    strlit2316 = alloc_String("");
    gc_root(strlit2316);
  }
// compiled string node returning strlit2316 (depth = 9)
  int op_slot_right_2315 = gc_frame_newslot(strlit2316);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2319 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2320 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2321 = alloc_Float64(16);
// compiled num node returning num2321 (depth = 12)
  gc_frame_newslot(num2321);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2321;
  partcv[0] = 1;
  Object call2322 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2320);
// compiled call node returning call2322 (depth = 11)
  gc_frame_newslot(call2322);
// starting to compile num node (depth = 11)
  Object num2323 = alloc_Float64(4);
// compiled num node returning num2323 (depth = 11)
  gc_frame_newslot(num2323);
// starting to compile string node (depth = 11)
  if (strlit2324 == NULL) {
    strlit2324 = alloc_String("0");
    gc_root(strlit2324);
  }
// compiled string node returning strlit2324 (depth = 11)
  gc_frame_newslot(strlit2324);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2325 = gc_frame_new();
// call case 3: self.outer request
  Object call2326 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2325);
// compiled call node returning call2326 (depth = 12)
// compiled member node returning call2326 (depth = 11)
  params[0] = call2322;
  params[1] = num2323;
  params[2] = strlit2324;
  partcv[0] = 3;
  Object call2327 = callmethodflags(call2326, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2319);
// compiled call node returning call2327 (depth = 10)
  int op_slot_right_2318 = gc_frame_newslot(call2327);
// starting to compile string node (depth = 10)
  if (strlit2329 == NULL) {
    strlit2329 = alloc_String("\\u");
    gc_root(strlit2329);
  }
// compiled string node returning strlit2329 (depth = 10)
  int op_slot_left_2318 = gc_frame_newslot(strlit2329);
  params[0] = call2327;
  partcv[0] = 1;
  Object opresult2330 = callmethod(strlit2329, "++", 1, partcv, params);
// compiled op node returning opresult2330 (depth = 9)
  int op_slot_left_2315 = gc_frame_newslot(opresult2330);
  params[0] = strlit2316;
  partcv[0] = 1;
  Object opresult2331 = callmethod(opresult2330, "++", 1, partcv, params);
// compiled op node returning opresult2331 (depth = 8)
  gc_frame_newslot(opresult2331);
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2331;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2332 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2314);
// compiled call node returning call2332 (depth = 7)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2333 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2335 == NULL) {
    strlit2335 = alloc_String(" instead");
    gc_root(strlit2335);
  }
// compiled string node returning strlit2335 (depth = 9)
  int op_slot_right_2334 = gc_frame_newslot(strlit2335);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2338 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2339 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2340 = alloc_Float64(16);
// compiled num node returning num2340 (depth = 12)
  gc_frame_newslot(num2340);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2340;
  partcv[0] = 1;
  Object call2341 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2339);
// compiled call node returning call2341 (depth = 11)
  gc_frame_newslot(call2341);
// starting to compile num node (depth = 11)
  Object num2342 = alloc_Float64(4);
// compiled num node returning num2342 (depth = 11)
  gc_frame_newslot(num2342);
// starting to compile string node (depth = 11)
  if (strlit2343 == NULL) {
    strlit2343 = alloc_String("0");
    gc_root(strlit2343);
  }
// compiled string node returning strlit2343 (depth = 11)
  gc_frame_newslot(strlit2343);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2344 = gc_frame_new();
// call case 3: self.outer request
  Object call2345 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2344);
// compiled call node returning call2345 (depth = 12)
// compiled member node returning call2345 (depth = 11)
  params[0] = call2341;
  params[1] = num2342;
  params[2] = strlit2343;
  partcv[0] = 3;
  Object call2346 = callmethodflags(call2345, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compiled call node returning call2346 (depth = 10)
  int op_slot_right_2337 = gc_frame_newslot(call2346);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2349 == NULL) {
    strlit2349 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2349);
  }
// compiled string node returning strlit2349 (depth = 11)
  int op_slot_right_2348 = gc_frame_newslot(strlit2349);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2352 == NULL) {
    strlit2352 = alloc_String("written in the source code; ");
    gc_root(strlit2352);
  }
// compiled string node returning strlit2352 (depth = 12)
  int op_slot_right_2351 = gc_frame_newslot(strlit2352);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2355 == NULL) {
    strlit2355 = alloc_String(" and cannot be ");
    gc_root(strlit2355);
  }
// compiled string node returning strlit2355 (depth = 13)
  int op_slot_right_2354 = gc_frame_newslot(strlit2355);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit2358 == NULL) {
    strlit2358 = alloc_String("is not a valid whitespace character");
    gc_root(strlit2358);
  }
// compiled string node returning strlit2358 (depth = 14)
  int op_slot_right_2357 = gc_frame_newslot(strlit2358);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2361 == NULL) {
    strlit2361 = alloc_String(") ");
    gc_root(strlit2361);
  }
// compiled string node returning strlit2361 (depth = 15)
  int op_slot_right_2360 = gc_frame_newslot(strlit2361);
// starting to compile op node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2364 = gc_frame_new();
// starting to compile call node (depth = 17)
  int callframe2365 = gc_frame_new();
// starting to compile num node (depth = 18)
  Object num2366 = alloc_Float64(16);
// compiled num node returning num2366 (depth = 18)
  gc_frame_newslot(num2366);
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_ordval (depth = 18)
  params[0] = num2366;
  partcv[0] = 1;
  Object call2367 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2365);
// compiled call node returning call2367 (depth = 17)
  gc_frame_newslot(call2367);
// starting to compile num node (depth = 17)
  Object num2368 = alloc_Float64(4);
// compiled num node returning num2368 (depth = 17)
  gc_frame_newslot(num2368);
// starting to compile string node (depth = 17)
  if (strlit2369 == NULL) {
    strlit2369 = alloc_String("0");
    gc_root(strlit2369);
  }
// compiled string node returning strlit2369 (depth = 17)
  gc_frame_newslot(strlit2369);
// call case 2: outer request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe2370 = gc_frame_new();
// call case 3: self.outer request
  Object call2371 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2370);
// compiled call node returning call2371 (depth = 18)
// compiled member node returning call2371 (depth = 17)
  params[0] = call2367;
  params[1] = num2368;
  params[2] = strlit2369;
  partcv[0] = 3;
  Object call2372 = callmethodflags(call2371, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2364);
// compiled call node returning call2372 (depth = 16)
  int op_slot_right_2363 = gc_frame_newslot(call2372);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2375 == NULL) {
    strlit2375 = alloc_String(" (U+");
    gc_root(strlit2375);
  }
// compiled string node returning strlit2375 (depth = 17)
  int op_slot_right_2374 = gc_frame_newslot(strlit2375);
// starting to compile op node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe2378 = gc_frame_new();
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_unicode (depth = 19)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2379 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2378);
// compiled call node returning call2379 (depth = 18)
  int op_slot_right_2377 = gc_frame_newslot(call2379);
// starting to compile string node (depth = 18)
  if (strlit2381 == NULL) {
    strlit2381 = alloc_String("");
    gc_root(strlit2381);
  }
// compiled string node returning strlit2381 (depth = 18)
  int op_slot_left_2377 = gc_frame_newslot(strlit2381);
  params[0] = call2379;
  partcv[0] = 1;
  Object opresult2382 = callmethod(strlit2381, "++", 1, partcv, params);
// compiled op node returning opresult2382 (depth = 17)
  int op_slot_left_2374 = gc_frame_newslot(opresult2382);
  params[0] = strlit2375;
  partcv[0] = 1;
  Object opresult2383 = callmethod(opresult2382, "++", 1, partcv, params);
// compiled op node returning opresult2383 (depth = 16)
  int op_slot_left_2363 = gc_frame_newslot(opresult2383);
  params[0] = call2372;
  partcv[0] = 1;
  Object opresult2384 = callmethod(opresult2383, "++", 1, partcv, params);
// compiled op node returning opresult2384 (depth = 15)
  int op_slot_left_2360 = gc_frame_newslot(opresult2384);
  params[0] = strlit2361;
  partcv[0] = 1;
  Object opresult2385 = callmethod(opresult2384, "++", 1, partcv, params);
// compiled op node returning opresult2385 (depth = 14)
  int op_slot_left_2357 = gc_frame_newslot(opresult2385);
  params[0] = strlit2358;
  partcv[0] = 1;
  Object opresult2386 = callmethod(opresult2385, "++", 1, partcv, params);
// compiled op node returning opresult2386 (depth = 13)
  int op_slot_left_2354 = gc_frame_newslot(opresult2386);
  params[0] = strlit2355;
  partcv[0] = 1;
  Object opresult2387 = callmethod(opresult2386, "++", 1, partcv, params);
// compiled op node returning opresult2387 (depth = 12)
  int op_slot_left_2351 = gc_frame_newslot(opresult2387);
  params[0] = strlit2352;
  partcv[0] = 1;
  Object opresult2388 = callmethod(opresult2387, "++", 1, partcv, params);
// compiled op node returning opresult2388 (depth = 11)
  int op_slot_left_2348 = gc_frame_newslot(opresult2388);
  params[0] = strlit2349;
  partcv[0] = 1;
  Object opresult2389 = callmethod(opresult2388, "++", 1, partcv, params);
// compiled op node returning opresult2389 (depth = 10)
  int op_slot_left_2337 = gc_frame_newslot(opresult2389);
  params[0] = call2346;
  partcv[0] = 1;
  Object opresult2390 = callmethod(opresult2389, "++", 1, partcv, params);
// compiled op node returning opresult2390 (depth = 9)
  int op_slot_left_2334 = gc_frame_newslot(opresult2390);
  params[0] = strlit2335;
  partcv[0] = 1;
  Object opresult2391 = callmethod(opresult2390, "++", 1, partcv, params);
// compiled op node returning opresult2391 (depth = 8)
  gc_frame_newslot(opresult2391);
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2391;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2392 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2333);
// compiled call node returning call2392 (depth = 7)
    gc_frame_newslot(call2392);
    if2309 = call2392;
  } else {
  }
// compiled if node returning if2309 (depth = 6)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2393 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2395 == NULL) {
    strlit2395 = alloc_String("is not a valid whitespace character; use spaces instead.");
    gc_root(strlit2395);
  }
// compiled string node returning strlit2395 (depth = 8)
  int op_slot_right_2394 = gc_frame_newslot(strlit2395);
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2398 == NULL) {
    strlit2398 = alloc_String(") ");
    gc_root(strlit2398);
  }
// compiled string node returning strlit2398 (depth = 9)
  int op_slot_right_2397 = gc_frame_newslot(strlit2398);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2401 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2402 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2403 = alloc_Float64(16);
// compiled num node returning num2403 (depth = 12)
  gc_frame_newslot(num2403);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2403;
  partcv[0] = 1;
  Object call2404 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2402);
// compiled call node returning call2404 (depth = 11)
  gc_frame_newslot(call2404);
// starting to compile num node (depth = 11)
  Object num2405 = alloc_Float64(4);
// compiled num node returning num2405 (depth = 11)
  gc_frame_newslot(num2405);
// starting to compile string node (depth = 11)
  if (strlit2406 == NULL) {
    strlit2406 = alloc_String("0");
    gc_root(strlit2406);
  }
// compiled string node returning strlit2406 (depth = 11)
  gc_frame_newslot(strlit2406);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2407 = gc_frame_new();
// call case 3: self.outer request
  Object call2408 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2407);
// compiled call node returning call2408 (depth = 12)
// compiled member node returning call2408 (depth = 11)
  params[0] = call2404;
  params[1] = num2405;
  params[2] = strlit2406;
  partcv[0] = 3;
  Object call2409 = callmethodflags(call2408, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2401);
// compiled call node returning call2409 (depth = 10)
  int op_slot_right_2400 = gc_frame_newslot(call2409);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2412 == NULL) {
    strlit2412 = alloc_String(" (U+");
    gc_root(strlit2412);
  }
// compiled string node returning strlit2412 (depth = 11)
  int op_slot_right_2411 = gc_frame_newslot(strlit2412);
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2415 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2416 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2415);
// compiled call node returning call2416 (depth = 12)
  int op_slot_right_2414 = gc_frame_newslot(call2416);
// starting to compile string node (depth = 12)
  if (strlit2418 == NULL) {
    strlit2418 = alloc_String("");
    gc_root(strlit2418);
  }
// compiled string node returning strlit2418 (depth = 12)
  int op_slot_left_2414 = gc_frame_newslot(strlit2418);
  params[0] = call2416;
  partcv[0] = 1;
  Object opresult2419 = callmethod(strlit2418, "++", 1, partcv, params);
// compiled op node returning opresult2419 (depth = 11)
  int op_slot_left_2411 = gc_frame_newslot(opresult2419);
  params[0] = strlit2412;
  partcv[0] = 1;
  Object opresult2420 = callmethod(opresult2419, "++", 1, partcv, params);
// compiled op node returning opresult2420 (depth = 10)
  int op_slot_left_2400 = gc_frame_newslot(opresult2420);
  params[0] = call2409;
  partcv[0] = 1;
  Object opresult2421 = callmethod(opresult2420, "++", 1, partcv, params);
// compiled op node returning opresult2421 (depth = 9)
  int op_slot_left_2397 = gc_frame_newslot(opresult2421);
  params[0] = strlit2398;
  partcv[0] = 1;
  Object opresult2422 = callmethod(opresult2421, "++", 1, partcv, params);
// compiled op node returning opresult2422 (depth = 8)
  int op_slot_left_2394 = gc_frame_newslot(opresult2422);
  params[0] = strlit2395;
  partcv[0] = 1;
  Object opresult2423 = callmethod(opresult2422, "++", 1, partcv, params);
// compiled op node returning opresult2423 (depth = 7)
  gc_frame_newslot(opresult2423);
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2423;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2424 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2393);
// compiled call node returning call2424 (depth = 6)
    gc_frame_newslot(call2424);
    if2254 = call2424;
  }
// compiled if node returning if2254 (depth = 5)
    gc_frame_newslot(if2254);
    if2235 = if2254;
  } else {
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2426 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2427 = alloc_Block(NULL, NULL, "lexer", 718);
  gc_frame_newslot(block2427);
// method _apply
  block_savedest(block2427);
  Object closure2428 = createclosure(2, "_apply");
  setclosureframe(closure2428, stackframe);
  addtoclosure(closure2428, var_mode);
  addtoclosure(closure2428, selfslot);
  struct UserObject *uo2428 = (struct UserObject*)block2427;
  uo2428->data[0] = (Object)closure2428;
  Method *meth_meth_lexer__apply2428 = addmethod2pos(block2427, "_apply", &meth_lexer__apply2428, 0);
  int argcv_meth_lexer__apply2428[] = {0};
  meth_meth_lexer__apply2428->type = alloc_MethodType(1, argcv_meth_lexer__apply2428);
  meth_meth_lexer__apply2428->definitionModule = modulename;
  meth_meth_lexer__apply2428->definitionLine = 714;
// compiled block node returning block2427 (depth = 7)
  gc_frame_newslot(block2427);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe2434 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_badControl (depth = 8)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2435 = callmethod(*var_badControl, "match",
    1, partcv, params);
  gc_frame_end(callframe2434);
// compiled call node returning call2435 (depth = 7)
  params[0] = block2427;
  partcv[0] = 1;
  Object call2436 = callmethod(call2435, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2426);
// compiled call node returning call2436 (depth = 6)
  Object if2425 = done;
  if (istrue(call2436)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2437 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2439 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2438);
// compiled call node returning call2439 (depth = 10)
// compiled member node returning call2439 (depth = 9)
  partcv[0] = 0;
  Object call2440 = callmethod(call2439, "new",
    1, partcv, params);
  gc_frame_end(callframe2437);
// compiled call node returning call2440 (depth = 8)
// compiled member node returning call2440 (depth = 7)
  *var_suggestion = call2440;
  if (call2440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inStr (depth = 7)
  Object if2441 = done;
  if (istrue(*var_inStr)) {
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2442 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2444 == NULL) {
    strlit2444 = alloc_String("");
    gc_root(strlit2444);
  }
// compiled string node returning strlit2444 (depth = 9)
  int op_slot_right_2443 = gc_frame_newslot(strlit2444);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2447 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2448 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2449 = alloc_Float64(16);
// compiled num node returning num2449 (depth = 12)
  gc_frame_newslot(num2449);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2449;
  partcv[0] = 1;
  Object call2450 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2448);
// compiled call node returning call2450 (depth = 11)
  gc_frame_newslot(call2450);
// starting to compile num node (depth = 11)
  Object num2451 = alloc_Float64(4);
// compiled num node returning num2451 (depth = 11)
  gc_frame_newslot(num2451);
// starting to compile string node (depth = 11)
  if (strlit2452 == NULL) {
    strlit2452 = alloc_String("0");
    gc_root(strlit2452);
  }
// compiled string node returning strlit2452 (depth = 11)
  gc_frame_newslot(strlit2452);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2453 = gc_frame_new();
// call case 3: self.outer request
  Object call2454 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2453);
// compiled call node returning call2454 (depth = 12)
// compiled member node returning call2454 (depth = 11)
  params[0] = call2450;
  params[1] = num2451;
  params[2] = strlit2452;
  partcv[0] = 3;
  Object call2455 = callmethodflags(call2454, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2447);
// compiled call node returning call2455 (depth = 10)
  int op_slot_right_2446 = gc_frame_newslot(call2455);
// starting to compile string node (depth = 10)
  if (strlit2457 == NULL) {
    strlit2457 = alloc_String("\\u");
    gc_root(strlit2457);
  }
// compiled string node returning strlit2457 (depth = 10)
  int op_slot_left_2446 = gc_frame_newslot(strlit2457);
  params[0] = call2455;
  partcv[0] = 1;
  Object opresult2458 = callmethod(strlit2457, "++", 1, partcv, params);
// compiled op node returning opresult2458 (depth = 9)
  int op_slot_left_2443 = gc_frame_newslot(opresult2458);
  params[0] = strlit2444;
  partcv[0] = 1;
  Object opresult2459 = callmethod(opresult2458, "++", 1, partcv, params);
// compiled op node returning opresult2459 (depth = 8)
  gc_frame_newslot(opresult2459);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2459;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2460 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2442);
// compiled call node returning call2460 (depth = 7)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2461 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2463 == NULL) {
    strlit2463 = alloc_String(" instead");
    gc_root(strlit2463);
  }
// compiled string node returning strlit2463 (depth = 9)
  int op_slot_right_2462 = gc_frame_newslot(strlit2463);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2466 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2467 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2468 = alloc_Float64(16);
// compiled num node returning num2468 (depth = 12)
  gc_frame_newslot(num2468);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2468;
  partcv[0] = 1;
  Object call2469 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2467);
// compiled call node returning call2469 (depth = 11)
  gc_frame_newslot(call2469);
// starting to compile num node (depth = 11)
  Object num2470 = alloc_Float64(4);
// compiled num node returning num2470 (depth = 11)
  gc_frame_newslot(num2470);
// starting to compile string node (depth = 11)
  if (strlit2471 == NULL) {
    strlit2471 = alloc_String("0");
    gc_root(strlit2471);
  }
// compiled string node returning strlit2471 (depth = 11)
  gc_frame_newslot(strlit2471);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2472 = gc_frame_new();
// call case 3: self.outer request
  Object call2473 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2472);
// compiled call node returning call2473 (depth = 12)
// compiled member node returning call2473 (depth = 11)
  params[0] = call2469;
  params[1] = num2470;
  params[2] = strlit2471;
  partcv[0] = 3;
  Object call2474 = callmethodflags(call2473, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2466);
// compiled call node returning call2474 (depth = 10)
  int op_slot_right_2465 = gc_frame_newslot(call2474);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2477 == NULL) {
    strlit2477 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2477);
  }
// compiled string node returning strlit2477 (depth = 11)
  int op_slot_right_2476 = gc_frame_newslot(strlit2477);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2480 == NULL) {
    strlit2480 = alloc_String("written in the source code; ");
    gc_root(strlit2480);
  }
// compiled string node returning strlit2480 (depth = 12)
  int op_slot_right_2479 = gc_frame_newslot(strlit2480);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2483 == NULL) {
    strlit2483 = alloc_String("is a control character and cannot be ");
    gc_root(strlit2483);
  }
// compiled string node returning strlit2483 (depth = 13)
  int op_slot_right_2482 = gc_frame_newslot(strlit2483);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2486 == NULL) {
    strlit2486 = alloc_String(") ");
    gc_root(strlit2486);
  }
// compiled string node returning strlit2486 (depth = 14)
  int op_slot_right_2485 = gc_frame_newslot(strlit2486);
// starting to compile op node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2489 = gc_frame_new();
// starting to compile call node (depth = 16)
  int callframe2490 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num2491 = alloc_Float64(16);
// compiled num node returning num2491 (depth = 17)
  gc_frame_newslot(num2491);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_ordval (depth = 17)
  params[0] = num2491;
  partcv[0] = 1;
  Object call2492 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2490);
// compiled call node returning call2492 (depth = 16)
  gc_frame_newslot(call2492);
// starting to compile num node (depth = 16)
  Object num2493 = alloc_Float64(4);
// compiled num node returning num2493 (depth = 16)
  gc_frame_newslot(num2493);
// starting to compile string node (depth = 16)
  if (strlit2494 == NULL) {
    strlit2494 = alloc_String("0");
    gc_root(strlit2494);
  }
// compiled string node returning strlit2494 (depth = 16)
  gc_frame_newslot(strlit2494);
// call case 2: outer request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2495 = gc_frame_new();
// call case 3: self.outer request
  Object call2496 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2495);
// compiled call node returning call2496 (depth = 17)
// compiled member node returning call2496 (depth = 16)
  params[0] = call2492;
  params[1] = num2493;
  params[2] = strlit2494;
  partcv[0] = 3;
  Object call2497 = callmethodflags(call2496, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2489);
// compiled call node returning call2497 (depth = 15)
  int op_slot_right_2488 = gc_frame_newslot(call2497);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit2500 == NULL) {
    strlit2500 = alloc_String(" (U+");
    gc_root(strlit2500);
  }
// compiled string node returning strlit2500 (depth = 16)
  int op_slot_right_2499 = gc_frame_newslot(strlit2500);
// starting to compile op node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2503 = gc_frame_new();
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_unicode (depth = 18)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2504 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2503);
// compiled call node returning call2504 (depth = 17)
  int op_slot_right_2502 = gc_frame_newslot(call2504);
// starting to compile string node (depth = 17)
  if (strlit2506 == NULL) {
    strlit2506 = alloc_String("");
    gc_root(strlit2506);
  }
// compiled string node returning strlit2506 (depth = 17)
  int op_slot_left_2502 = gc_frame_newslot(strlit2506);
  params[0] = call2504;
  partcv[0] = 1;
  Object opresult2507 = callmethod(strlit2506, "++", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 16)
  int op_slot_left_2499 = gc_frame_newslot(opresult2507);
  params[0] = strlit2500;
  partcv[0] = 1;
  Object opresult2508 = callmethod(opresult2507, "++", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 15)
  int op_slot_left_2488 = gc_frame_newslot(opresult2508);
  params[0] = call2497;
  partcv[0] = 1;
  Object opresult2509 = callmethod(opresult2508, "++", 1, partcv, params);
// compiled op node returning opresult2509 (depth = 14)
  int op_slot_left_2485 = gc_frame_newslot(opresult2509);
  params[0] = strlit2486;
  partcv[0] = 1;
  Object opresult2510 = callmethod(opresult2509, "++", 1, partcv, params);
// compiled op node returning opresult2510 (depth = 13)
  int op_slot_left_2482 = gc_frame_newslot(opresult2510);
  params[0] = strlit2483;
  partcv[0] = 1;
  Object opresult2511 = callmethod(opresult2510, "++", 1, partcv, params);
// compiled op node returning opresult2511 (depth = 12)
  int op_slot_left_2479 = gc_frame_newslot(opresult2511);
  params[0] = strlit2480;
  partcv[0] = 1;
  Object opresult2512 = callmethod(opresult2511, "++", 1, partcv, params);
// compiled op node returning opresult2512 (depth = 11)
  int op_slot_left_2476 = gc_frame_newslot(opresult2512);
  params[0] = strlit2477;
  partcv[0] = 1;
  Object opresult2513 = callmethod(opresult2512, "++", 1, partcv, params);
// compiled op node returning opresult2513 (depth = 10)
  int op_slot_left_2465 = gc_frame_newslot(opresult2513);
  params[0] = call2474;
  partcv[0] = 1;
  Object opresult2514 = callmethod(opresult2513, "++", 1, partcv, params);
// compiled op node returning opresult2514 (depth = 9)
  int op_slot_left_2462 = gc_frame_newslot(opresult2514);
  params[0] = strlit2463;
  partcv[0] = 1;
  Object opresult2515 = callmethod(opresult2514, "++", 1, partcv, params);
// compiled op node returning opresult2515 (depth = 8)
  gc_frame_newslot(opresult2515);
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2515;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2516 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2461);
// compiled call node returning call2516 (depth = 7)
    gc_frame_newslot(call2516);
    if2441 = call2516;
  } else {
  }
// compiled if node returning if2441 (depth = 6)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2517 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_linePosition;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2518 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe2517);
// compiled call node returning call2518 (depth = 6)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2519 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2521 == NULL) {
    strlit2521 = alloc_String("is a control character and cannot be written in the source code; consider using spaces instead.");
    gc_root(strlit2521);
  }
// compiled string node returning strlit2521 (depth = 8)
  int op_slot_right_2520 = gc_frame_newslot(strlit2521);
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2524 == NULL) {
    strlit2524 = alloc_String(") ");
    gc_root(strlit2524);
  }
// compiled string node returning strlit2524 (depth = 9)
  int op_slot_right_2523 = gc_frame_newslot(strlit2524);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2527 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2528 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2529 = alloc_Float64(16);
// compiled num node returning num2529 (depth = 12)
  gc_frame_newslot(num2529);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2529;
  partcv[0] = 1;
  Object call2530 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2528);
// compiled call node returning call2530 (depth = 11)
  gc_frame_newslot(call2530);
// starting to compile num node (depth = 11)
  Object num2531 = alloc_Float64(4);
// compiled num node returning num2531 (depth = 11)
  gc_frame_newslot(num2531);
// starting to compile string node (depth = 11)
  if (strlit2532 == NULL) {
    strlit2532 = alloc_String("0");
    gc_root(strlit2532);
  }
// compiled string node returning strlit2532 (depth = 11)
  gc_frame_newslot(strlit2532);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2533 = gc_frame_new();
// call case 3: self.outer request
  Object call2534 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2533);
// compiled call node returning call2534 (depth = 12)
// compiled member node returning call2534 (depth = 11)
  params[0] = call2530;
  params[1] = num2531;
  params[2] = strlit2532;
  partcv[0] = 3;
  Object call2535 = callmethodflags(call2534, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled call node returning call2535 (depth = 10)
  int op_slot_right_2526 = gc_frame_newslot(call2535);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2538 == NULL) {
    strlit2538 = alloc_String(" (U+");
    gc_root(strlit2538);
  }
// compiled string node returning strlit2538 (depth = 11)
  int op_slot_right_2537 = gc_frame_newslot(strlit2538);
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2541 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2542 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2541);
// compiled call node returning call2542 (depth = 12)
  int op_slot_right_2540 = gc_frame_newslot(call2542);
// starting to compile string node (depth = 12)
  if (strlit2544 == NULL) {
    strlit2544 = alloc_String("");
    gc_root(strlit2544);
  }
// compiled string node returning strlit2544 (depth = 12)
  int op_slot_left_2540 = gc_frame_newslot(strlit2544);
  params[0] = call2542;
  partcv[0] = 1;
  Object opresult2545 = callmethod(strlit2544, "++", 1, partcv, params);
// compiled op node returning opresult2545 (depth = 11)
  int op_slot_left_2537 = gc_frame_newslot(opresult2545);
  params[0] = strlit2538;
  partcv[0] = 1;
  Object opresult2546 = callmethod(opresult2545, "++", 1, partcv, params);
// compiled op node returning opresult2546 (depth = 10)
  int op_slot_left_2526 = gc_frame_newslot(opresult2546);
  params[0] = call2535;
  partcv[0] = 1;
  Object opresult2547 = callmethod(opresult2546, "++", 1, partcv, params);
// compiled op node returning opresult2547 (depth = 9)
  int op_slot_left_2523 = gc_frame_newslot(opresult2547);
  params[0] = strlit2524;
  partcv[0] = 1;
  Object opresult2548 = callmethod(opresult2547, "++", 1, partcv, params);
// compiled op node returning opresult2548 (depth = 8)
  int op_slot_left_2520 = gc_frame_newslot(opresult2548);
  params[0] = strlit2521;
  partcv[0] = 1;
  Object opresult2549 = callmethod(opresult2548, "++", 1, partcv, params);
// compiled op node returning opresult2549 (depth = 7)
  gc_frame_newslot(opresult2549);
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2549;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2550 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2519);
// compiled call node returning call2550 (depth = 6)
    gc_frame_newslot(call2550);
    if2425 = call2550;
  } else {
  }
// compiled if node returning if2425 (depth = 5)
    gc_frame_newslot(if2425);
    if2235 = if2425;
  }
// compiled if node returning if2235 (depth = 4)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_atStart (depth = 5)
  Object if2551 = done;
  if (istrue(*var_atStart)) {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2554 = alloc_Float64(1);
// compiled num node returning num2554 (depth = 7)
  int op_slot_right_2553 = gc_frame_newslot(num2554);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_2553 = gc_frame_newslot(*var_linePosition);
  params[0] = num2554;
  partcv[0] = 1;
  Object opresult2556 = callmethod(*var_linePosition, "==", 1, partcv, params);
// compiled op node returning opresult2556 (depth = 6)
  Object if2552 = done;
  if (istrue(opresult2556)) {
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2559 == NULL) {
    strlit2559 = alloc_String("#");
    gc_root(strlit2559);
  }
// compiled string node returning strlit2559 (depth = 8)
  int op_slot_right_2558 = gc_frame_newslot(strlit2559);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2558 = gc_frame_newslot(*var_c);
  params[0] = strlit2559;
  partcv[0] = 1;
  Object opresult2561 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2561 (depth = 7)
  Object if2557 = done;
  if (istrue(opresult2561)) {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2562 == NULL) {
    strlit2562 = alloc_String("p");
    gc_root(strlit2562);
  }
// compiled string node returning strlit2562 (depth = 8)
  *var_mode = strlit2562;
  if (strlit2562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2557 = done;
  } else {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2565 = alloc_Boolean(0);
// compiled identifier node returning bool2565 (depth = 8)
  *var_atStart = bool2565;
  if (bool2565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2557 = done;
  }
// compiled if node returning if2557 (depth = 6)
    gc_frame_newslot(if2557);
    if2552 = if2557;
  } else {
  }
// compiled if node returning if2552 (depth = 5)
    gc_frame_newslot(if2552);
    if2551 = if2552;
  } else {
  }
// compiled if node returning if2551 (depth = 4)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inStr (depth = 5)
  Object if2567 = done;
  if (istrue(*var_inStr)) {
    gc_frame_newslot(done);
    if2567 = done;
  } else {
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2571 == NULL) {
    strlit2571 = alloc_String("p");
    gc_root(strlit2571);
  }
// compiled string node returning strlit2571 (depth = 8)
  int op_slot_right_2570 = gc_frame_newslot(strlit2571);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2570 = gc_frame_newslot(*var_mode);
  params[0] = strlit2571;
  partcv[0] = 1;
  Object opresult2573 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2573 (depth = 7)
  int op_slot_right_2569 = gc_frame_newslot(opresult2573);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2576 == NULL) {
    strlit2576 = alloc_String("c");
    gc_root(strlit2576);
  }
// compiled string node returning strlit2576 (depth = 8)
  int op_slot_right_2575 = gc_frame_newslot(strlit2576);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2575 = gc_frame_newslot(*var_mode);
  params[0] = strlit2576;
  partcv[0] = 1;
  Object opresult2578 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2578 (depth = 7)
  int op_slot_left_2569 = gc_frame_newslot(opresult2578);
  params[0] = opresult2573;
  partcv[0] = 1;
  Object opresult2579 = callmethod(opresult2578, "&&", 1, partcv, params);
// compiled op node returning opresult2579 (depth = 6)
  Object if2568 = done;
  if (istrue(opresult2579)) {
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2583 == NULL) {
    strlit2583 = alloc_String("d");
    gc_root(strlit2583);
  }
// compiled string node returning strlit2583 (depth = 9)
  int op_slot_right_2582 = gc_frame_newslot(strlit2583);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2582 = gc_frame_newslot(*var_mode);
  params[0] = strlit2583;
  partcv[0] = 1;
  Object opresult2585 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2585 (depth = 8)
  int op_slot_right_2581 = gc_frame_newslot(opresult2585);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2588 == NULL) {
    strlit2588 = alloc_String(" ");
    gc_root(strlit2588);
  }
// compiled string node returning strlit2588 (depth = 9)
  int op_slot_right_2587 = gc_frame_newslot(strlit2588);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2587 = gc_frame_newslot(*var_c);
  params[0] = strlit2588;
  partcv[0] = 1;
  Object opresult2590 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2590 (depth = 8)
  int op_slot_left_2581 = gc_frame_newslot(opresult2590);
  params[0] = opresult2585;
  partcv[0] = 1;
  Object opresult2591 = callmethod(opresult2590, "&&", 1, partcv, params);
// compiled op node returning opresult2591 (depth = 7)
  Object if2580 = done;
  if (istrue(opresult2591)) {
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2592 == NULL) {
    strlit2592 = alloc_String("n");
    gc_root(strlit2592);
  }
// compiled string node returning strlit2592 (depth = 8)
  *var_newmode = strlit2592;
  if (strlit2592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2580 = done;
  } else {
  }
// compiled if node returning if2580 (depth = 6)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2596 == NULL) {
    strlit2596 = alloc_String("""\x22""");
    gc_root(strlit2596);
  }
// compiled string node returning strlit2596 (depth = 8)
  int op_slot_right_2595 = gc_frame_newslot(strlit2596);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2595 = gc_frame_newslot(*var_c);
  params[0] = strlit2596;
  partcv[0] = 1;
  Object opresult2598 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2598 (depth = 7)
  Object if2594 = done;
  if (istrue(opresult2598)) {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2599 == NULL) {
    strlit2599 = alloc_String("""\x22""");
    gc_root(strlit2599);
  }
// compiled string node returning strlit2599 (depth = 8)
  *var_newmode = strlit2599;
  if (strlit2599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2601 = alloc_Boolean(1);
// compiled identifier node returning bool2601 (depth = 8)
  *var_inStr = bool2601;
  if (bool2601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  *var_stringStart = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2594 = done;
  } else {
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2606 == NULL) {
    strlit2606 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit2606);
  }
// compiled string node returning strlit2606 (depth = 9)
  int op_slot_right_2605 = gc_frame_newslot(strlit2606);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2605 = gc_frame_newslot(*var_c);
  params[0] = strlit2606;
  partcv[0] = 1;
  Object opresult2608 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2608 (depth = 8)
  Object if2604 = done;
  if (istrue(opresult2608)) {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2609 == NULL) {
    strlit2609 = alloc_String("q");
    gc_root(strlit2609);
  }
// compiled string node returning strlit2609 (depth = 9)
  *var_newmode = strlit2609;
  if (strlit2609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2611 = alloc_Boolean(1);
// compiled identifier node returning bool2611 (depth = 9)
  *var_inStr = bool2611;
  if (bool2611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  *var_startLine = *var_lineNumber;
  if (*var_lineNumber == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  *var_stringStart = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2604 = done;
  } else {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2616 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_identifierChar (depth = 10)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2617 = callmethod(*var_identifierChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2616);
// compiled call node returning call2617 (depth = 9)
  Object if2615 = done;
  if (istrue(call2617)) {
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2618 == NULL) {
    strlit2618 = alloc_String("i");
    gc_root(strlit2618);
  }
// compiled string node returning strlit2618 (depth = 10)
  *var_newmode = strlit2618;
  if (strlit2618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2615 = done;
  } else {
  }
// compiled if node returning if2615 (depth = 8)
    gc_frame_newslot(if2615);
    if2604 = if2615;
  }
// compiled if node returning if2604 (depth = 7)
    gc_frame_newslot(if2604);
    if2594 = if2604;
  }
// compiled if node returning if2594 (depth = 6)
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2621 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_digit (depth = 8)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2622 = callmethod(*var_digit, "match",
    1, partcv, params);
  gc_frame_end(callframe2621);
// compiled call node returning call2622 (depth = 7)
  Object if2620 = done;
  if (istrue(call2622)) {
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2625 == NULL) {
    strlit2625 = alloc_String("i");
    gc_root(strlit2625);
  }
// compiled string node returning strlit2625 (depth = 9)
  int op_slot_right_2624 = gc_frame_newslot(strlit2625);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2624 = gc_frame_newslot(*var_mode);
  params[0] = strlit2625;
  partcv[0] = 1;
  Object opresult2627 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2627 (depth = 8)
  Object if2623 = done;
  if (istrue(opresult2627)) {
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2628 == NULL) {
    strlit2628 = alloc_String("m");
    gc_root(strlit2628);
  }
// compiled string node returning strlit2628 (depth = 9)
  *var_newmode = strlit2628;
  if (strlit2628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2623 = done;
  } else {
  }
// compiled if node returning if2623 (depth = 7)
    gc_frame_newslot(if2623);
    if2620 = if2623;
  } else {
  }
// compiled if node returning if2620 (depth = 6)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2632 == NULL) {
    strlit2632 = alloc_String("m");
    gc_root(strlit2632);
  }
// compiled string node returning strlit2632 (depth = 8)
  int op_slot_right_2631 = gc_frame_newslot(strlit2632);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2631 = gc_frame_newslot(*var_mode);
  params[0] = strlit2632;
  partcv[0] = 1;
  Object opresult2634 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2634 (depth = 7)
  Object if2630 = done;
  if (istrue(opresult2634)) {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2638 = alloc_Float64(122);
// compiled num node returning num2638 (depth = 10)
  int op_slot_right_2637 = gc_frame_newslot(num2638);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  int op_slot_left_2637 = gc_frame_newslot(*var_ordval);
  params[0] = num2638;
  partcv[0] = 1;
  Object opresult2640 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2640 (depth = 9)
  int op_slot_right_2636 = gc_frame_newslot(opresult2640);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2643 = alloc_Float64(97);
// compiled num node returning num2643 (depth = 10)
  int op_slot_right_2642 = gc_frame_newslot(num2643);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  int op_slot_left_2642 = gc_frame_newslot(*var_ordval);
  params[0] = num2643;
  partcv[0] = 1;
  Object opresult2645 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2645 (depth = 9)
  int op_slot_left_2636 = gc_frame_newslot(opresult2645);
  params[0] = opresult2640;
  partcv[0] = 1;
  Object opresult2646 = callmethod(opresult2645, "&&", 1, partcv, params);
// compiled op node returning opresult2646 (depth = 8)
  Object if2635 = done;
  if (istrue(opresult2646)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2647 == NULL) {
    strlit2647 = alloc_String("m");
    gc_root(strlit2647);
  }
// compiled string node returning strlit2647 (depth = 9)
  *var_newmode = strlit2647;
  if (strlit2647 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2635 = done;
  } else {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2652 = alloc_Float64(90);
// compiled num node returning num2652 (depth = 11)
  int op_slot_right_2651 = gc_frame_newslot(num2652);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2651 = gc_frame_newslot(*var_ordval);
  params[0] = num2652;
  partcv[0] = 1;
  Object opresult2654 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2654 (depth = 10)
  int op_slot_right_2650 = gc_frame_newslot(opresult2654);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2657 = alloc_Float64(65);
// compiled num node returning num2657 (depth = 11)
  int op_slot_right_2656 = gc_frame_newslot(num2657);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2656 = gc_frame_newslot(*var_ordval);
  params[0] = num2657;
  partcv[0] = 1;
  Object opresult2659 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2659 (depth = 10)
  int op_slot_left_2650 = gc_frame_newslot(opresult2659);
  params[0] = opresult2654;
  partcv[0] = 1;
  Object opresult2660 = callmethod(opresult2659, "&&", 1, partcv, params);
// compiled op node returning opresult2660 (depth = 9)
  Object if2649 = done;
  if (istrue(opresult2660)) {
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2661 == NULL) {
    strlit2661 = alloc_String("m");
    gc_root(strlit2661);
  }
// compiled string node returning strlit2661 (depth = 10)
  *var_newmode = strlit2661;
  if (strlit2661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2649 = done;
  } else {
  }
// compiled if node returning if2649 (depth = 8)
    gc_frame_newslot(if2649);
    if2635 = if2649;
  }
// compiled if node returning if2635 (depth = 7)
    gc_frame_newslot(if2635);
    if2630 = if2635;
  } else {
  }
// compiled if node returning if2630 (depth = 6)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2666 == NULL) {
    strlit2666 = alloc_String("<");
    gc_root(strlit2666);
  }
// compiled string node returning strlit2666 (depth = 9)
  int op_slot_right_2665 = gc_frame_newslot(strlit2666);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2665 = gc_frame_newslot(*var_c);
  params[0] = strlit2666;
  partcv[0] = 1;
  Object opresult2668 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2668 (depth = 8)
  int op_slot_right_2664 = gc_frame_newslot(opresult2668);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2671 == NULL) {
    strlit2671 = alloc_String("i");
    gc_root(strlit2671);
  }
// compiled string node returning strlit2671 (depth = 9)
  int op_slot_right_2670 = gc_frame_newslot(strlit2671);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2670 = gc_frame_newslot(*var_mode);
  params[0] = strlit2671;
  partcv[0] = 1;
  Object opresult2673 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2673 (depth = 8)
  int op_slot_left_2664 = gc_frame_newslot(opresult2673);
  params[0] = opresult2668;
  partcv[0] = 1;
  Object opresult2674 = callmethod(opresult2673, "&&", 1, partcv, params);
// compiled op node returning opresult2674 (depth = 7)
  Object if2663 = done;
  if (istrue(opresult2674)) {
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2675 == NULL) {
    strlit2675 = alloc_String("<");
    gc_root(strlit2675);
  }
// compiled string node returning strlit2675 (depth = 8)
  *var_newmode = strlit2675;
  if (strlit2675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2663 = done;
  } else {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2680 == NULL) {
    strlit2680 = alloc_String(">");
    gc_root(strlit2680);
  }
// compiled string node returning strlit2680 (depth = 10)
  int op_slot_right_2679 = gc_frame_newslot(strlit2680);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2679 = gc_frame_newslot(*var_c);
  params[0] = strlit2680;
  partcv[0] = 1;
  Object opresult2682 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 9)
  int op_slot_right_2678 = gc_frame_newslot(opresult2682);
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2684 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_iGTLT (depth = 10)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2685 = callmethod(*var_iGTLT, "match",
    1, partcv, params);
  gc_frame_end(callframe2684);
// compiled call node returning call2685 (depth = 9)
  int op_slot_left_2678 = gc_frame_newslot(call2685);
  params[0] = opresult2682;
  partcv[0] = 1;
  Object opresult2686 = callmethod(call2685, "&&", 1, partcv, params);
// compiled op node returning opresult2686 (depth = 8)
  Object if2677 = done;
  if (istrue(opresult2686)) {
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2689 == NULL) {
    strlit2689 = alloc_String(">");
    gc_root(strlit2689);
  }
// compiled string node returning strlit2689 (depth = 10)
  int op_slot_right_2688 = gc_frame_newslot(strlit2689);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2688 = gc_frame_newslot(*var_mode);
  params[0] = strlit2689;
  partcv[0] = 1;
  Object opresult2691 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2691 (depth = 9)
  Object if2687 = done;
  if (istrue(opresult2691)) {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2692 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2693 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2692);
// compiled call node returning call2693 (depth = 9)
    gc_frame_newslot(call2693);
    if2687 = call2693;
  } else {
  }
// compiled if node returning if2687 (depth = 8)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2694 == NULL) {
    strlit2694 = alloc_String(">");
    gc_root(strlit2694);
  }
// compiled string node returning strlit2694 (depth = 9)
  *var_newmode = strlit2694;
  if (strlit2694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2677 = done;
  } else {
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2697 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_operatorChar (depth = 10)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2698 = callmethod(*var_operatorChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2697);
// compiled call node returning call2698 (depth = 9)
  Object if2696 = done;
  if (istrue(call2698)) {
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2699 == NULL) {
    strlit2699 = alloc_String("o");
    gc_root(strlit2699);
  }
// compiled string node returning strlit2699 (depth = 10)
  *var_newmode = strlit2699;
  if (strlit2699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2696 = done;
  } else {
  }
// compiled if node returning if2696 (depth = 8)
    gc_frame_newslot(if2696);
    if2677 = if2696;
  }
// compiled if node returning if2677 (depth = 7)
    gc_frame_newslot(if2677);
    if2663 = if2677;
  }
// compiled if node returning if2663 (depth = 6)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2702 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfModes (depth = 8)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2703 = callmethod(*var_selfModes, "match",
    1, partcv, params);
  gc_frame_end(callframe2702);
// compiled call node returning call2703 (depth = 7)
  Object if2701 = done;
  if (istrue(call2703)) {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  *var_newmode = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2701 = done;
  } else {
  }
// compiled if node returning if2701 (depth = 6)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2707 == NULL) {
    strlit2707 = alloc_String("#");
    gc_root(strlit2707);
  }
// compiled string node returning strlit2707 (depth = 8)
  int op_slot_right_2706 = gc_frame_newslot(strlit2707);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2706 = gc_frame_newslot(*var_c);
  params[0] = strlit2707;
  partcv[0] = 1;
  Object opresult2709 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2709 (depth = 7)
  Object if2705 = done;
  if (istrue(opresult2709)) {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2712 == NULL) {
    strlit2712 = alloc_String("p");
    gc_root(strlit2712);
  }
// compiled string node returning strlit2712 (depth = 9)
  int op_slot_right_2711 = gc_frame_newslot(strlit2712);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2711 = gc_frame_newslot(*var_mode);
  params[0] = strlit2712;
  partcv[0] = 1;
  Object opresult2714 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2714 (depth = 8)
  Object if2710 = done;
  if (istrue(opresult2714)) {
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2717 == NULL) {
    strlit2717 = alloc_String("#pragma");
    gc_root(strlit2717);
  }
// compiled string node returning strlit2717 (depth = 10)
  int op_slot_right_2716 = gc_frame_newslot(strlit2717);
// starting to compile call node (depth = 10)
  int callframe2719 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num2720 = alloc_Float64(1);
// compiled num node returning num2720 (depth = 11)
  gc_frame_newslot(num2720);
// starting to compile num node (depth = 11)
  Object num2721 = alloc_Float64(7);
// compiled num node returning num2721 (depth = 11)
  gc_frame_newslot(num2721);
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2722 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2723 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call2724 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2723);
// compiled call node returning call2724 (depth = 13)
// compiled member node returning call2724 (depth = 12)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2725 = callmethod(call2724, "at",
    1, partcv, params);
  gc_frame_end(callframe2722);
// compiled call node returning call2725 (depth = 11)
  params[0] = num2720;
  params[1] = num2721;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2726 = callmethod(call2725, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2719);
// compiled call node returning call2726 (depth = 10)
  int op_slot_left_2716 = gc_frame_newslot(call2726);
  params[0] = strlit2717;
  partcv[0] = 1;
  Object opresult2727 = callmethod(call2726, "==", 1, partcv, params);
// compiled op node returning opresult2727 (depth = 9)
  Object if2715 = done;
  if (istrue(opresult2727)) {
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2730 = alloc_Float64(0);
// compiled num node returning num2730 (depth = 11)
  int op_slot_right_2729 = gc_frame_newslot(num2730);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call2733 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe2732);
// compiled call node returning call2733 (depth = 12)
// compiled member node returning call2733 (depth = 11)
  int op_slot_left_2729 = gc_frame_newslot(call2733);
  params[0] = num2730;
  partcv[0] = 1;
  Object opresult2734 = callmethod(call2733, "==", 1, partcv, params);
// compiled op node returning opresult2734 (depth = 10)
  Object if2728 = done;
  if (istrue(opresult2734)) {
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2735 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call2737 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2736);
// compiled call node returning call2737 (depth = 14)
// compiled member node returning call2737 (depth = 13)
  partcv[0] = 0;
  Object call2738 = callmethod(call2737, "new",
    1, partcv, params);
  gc_frame_end(callframe2735);
// compiled call node returning call2738 (depth = 12)
// compiled member node returning call2738 (depth = 11)
  *var_suggestion = call2738;
  if (call2738 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2739 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num2740 = alloc_Float64(1);
// compiled num node returning num2740 (depth = 11)
  gc_frame_newslot(num2740);
// starting to compile call node (depth = 11)
  int callframe2741 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call2743 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2742);
// compiled call node returning call2743 (depth = 13)
// compiled member node returning call2743 (depth = 12)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2744 = callmethod(call2743, "at",
    1, partcv, params);
  gc_frame_end(callframe2741);
// compiled call node returning call2744 (depth = 11)
  gc_frame_newslot(call2744);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = num2740;
  params[1] = call2744;
  partcv[0] = 2;
  Object call2745 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compiled call node returning call2745 (depth = 10)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2746 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 11)
  if (strlit2747 == NULL) {
    strlit2747 = alloc_String("");
    gc_root(strlit2747);
  }
// compiled string node returning strlit2747 (depth = 11)
  gc_frame_newslot(strlit2747);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = strlit2747;
  partcv[0] = 2;
  Object call2748 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2746);
// compiled call node returning call2748 (depth = 10)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2749 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2750 == NULL) {
    strlit2750 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2750);
  }
// compiled string node returning strlit2750 (depth = 11)
  gc_frame_newslot(strlit2750);
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2750;
  params[1] = *var_lineNumber;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2751 = callmethod(*var_errormessages, "syntaxError()atLine()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2749);
// compiled call node returning call2751 (depth = 10)
    gc_frame_newslot(call2751);
    if2728 = call2751;
  } else {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2752 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2753 == NULL) {
    strlit2753 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2753);
  }
// compiled string node returning strlit2753 (depth = 11)
  gc_frame_newslot(strlit2753);
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2753;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2754 = callmethod(*var_errormessages, "syntaxError()atLine",
    2, partcv, params);
  gc_frame_end(callframe2752);
// compiled call node returning call2754 (depth = 10)
    gc_frame_newslot(call2754);
    if2728 = call2754;
  }
// compiled if node returning if2728 (depth = 9)
    gc_frame_newslot(if2728);
    if2715 = if2728;
  } else {
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2755 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2757 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2756);
// compiled call node returning call2757 (depth = 13)
// compiled member node returning call2757 (depth = 12)
  partcv[0] = 0;
  Object call2758 = callmethod(call2757, "new",
    1, partcv, params);
  gc_frame_end(callframe2755);
// compiled call node returning call2758 (depth = 11)
// compiled member node returning call2758 (depth = 10)
  *var_suggestion = call2758;
  if (call2758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2759 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 10)
  if (strlit2760 == NULL) {
    strlit2760 = alloc_String("//");
    gc_root(strlit2760);
  }
// compiled string node returning strlit2760 (depth = 10)
  gc_frame_newslot(strlit2760);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_linePosition;
  params[1] = strlit2760;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2761 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2759);
// compiled call node returning call2761 (depth = 9)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2762 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2763 == NULL) {
    strlit2763 = alloc_String("'#' is not allowed here. For a comment use '//'.");
    gc_root(strlit2763);
  }
// compiled string node returning strlit2763 (depth = 10)
  gc_frame_newslot(strlit2763);
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2763;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2764 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2762);
// compiled call node returning call2764 (depth = 9)
    gc_frame_newslot(call2764);
    if2715 = call2764;
  }
// compiled if node returning if2715 (depth = 8)
    gc_frame_newslot(if2715);
    if2710 = if2715;
  } else {
  }
// compiled if node returning if2710 (depth = 7)
    gc_frame_newslot(if2710);
    if2705 = if2710;
  } else {
  }
// compiled if node returning if2705 (depth = 6)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2767 == NULL) {
    strlit2767 = alloc_String(".");
    gc_root(strlit2767);
  }
// compiled string node returning strlit2767 (depth = 8)
  int op_slot_right_2766 = gc_frame_newslot(strlit2767);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2766 = gc_frame_newslot(*var_c);
  params[0] = strlit2767;
  partcv[0] = 1;
  Object opresult2769 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2769 (depth = 7)
  Object if2765 = done;
  if (istrue(opresult2769)) {
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String(".");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 9)
  int op_slot_right_2771 = gc_frame_newslot(strlit2772);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_2771 = gc_frame_newslot(*var_accum);
  params[0] = strlit2772;
  partcv[0] = 1;
  Object opresult2774 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2774 (depth = 8)
  Object if2770 = done;
  if (istrue(opresult2774)) {
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2775 == NULL) {
    strlit2775 = alloc_String("o");
    gc_root(strlit2775);
  }
// compiled string node returning strlit2775 (depth = 9)
  *var_mode = strlit2775;
  if (strlit2775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2770 = done;
  } else {
  }
// compiled if node returning if2770 (depth = 7)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2780 == NULL) {
    strlit2780 = alloc_String("..");
    gc_root(strlit2780);
  }
// compiled string node returning strlit2780 (depth = 9)
  int op_slot_right_2779 = gc_frame_newslot(strlit2780);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_2779 = gc_frame_newslot(*var_accum);
  params[0] = strlit2780;
  partcv[0] = 1;
  Object opresult2782 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2782 (depth = 8)
  Object if2778 = done;
  if (istrue(opresult2782)) {
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2783 == NULL) {
    strlit2783 = alloc_String("n");
    gc_root(strlit2783);
  }
// compiled string node returning strlit2783 (depth = 9)
  *var_mode = strlit2783;
  if (strlit2783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2786 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2787 == NULL) {
    strlit2787 = alloc_String("i");
    gc_root(strlit2787);
  }
// compiled string node returning strlit2787 (depth = 9)
  gc_frame_newslot(strlit2787);
// starting to compile string node (depth = 9)
  if (strlit2788 == NULL) {
    strlit2788 = alloc_String("...");
    gc_root(strlit2788);
  }
// compiled string node returning strlit2788 (depth = 9)
  gc_frame_newslot(strlit2788);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2787;
  params[2] = strlit2788;
  partcv[0] = 3;
  Object call2789 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2786);
// compiled call node returning call2789 (depth = 8)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2790 == NULL) {
    strlit2790 = alloc_String("");
    gc_root(strlit2790);
  }
// compiled string node returning strlit2790 (depth = 9)
  *var_accum = strlit2790;
  if (strlit2790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2778 = done;
  } else {
  }
// compiled if node returning if2778 (depth = 7)
    gc_frame_newslot(if2778);
    if2765 = if2778;
  } else {
  }
// compiled if node returning if2765 (depth = 6)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2794 == NULL) {
    strlit2794 = alloc_String("/");
    gc_root(strlit2794);
  }
// compiled string node returning strlit2794 (depth = 8)
  int op_slot_right_2793 = gc_frame_newslot(strlit2794);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2793 = gc_frame_newslot(*var_c);
  params[0] = strlit2794;
  partcv[0] = 1;
  Object opresult2796 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2796 (depth = 7)
  Object if2792 = done;
  if (istrue(opresult2796)) {
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2799 == NULL) {
    strlit2799 = alloc_String("/");
    gc_root(strlit2799);
  }
// compiled string node returning strlit2799 (depth = 9)
  int op_slot_right_2798 = gc_frame_newslot(strlit2799);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_2798 = gc_frame_newslot(*var_accum);
  params[0] = strlit2799;
  partcv[0] = 1;
  Object opresult2801 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2801 (depth = 8)
  Object if2797 = done;
  if (istrue(opresult2801)) {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2802 == NULL) {
    strlit2802 = alloc_String("c");
    gc_root(strlit2802);
  }
// compiled string node returning strlit2802 (depth = 9)
  *var_mode = strlit2802;
  if (strlit2802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2797 = done;
  } else {
  }
// compiled if node returning if2797 (depth = 7)
    gc_frame_newslot(if2797);
    if2792 = if2797;
  } else {
  }
// compiled if node returning if2792 (depth = 6)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2807 == NULL) {
    strlit2807 = alloc_String("n");
    gc_root(strlit2807);
  }
// compiled string node returning strlit2807 (depth = 8)
  int op_slot_right_2806 = gc_frame_newslot(strlit2807);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2806 = gc_frame_newslot(*var_mode);
  params[0] = strlit2807;
  partcv[0] = 1;
  Object opresult2809 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2809 (depth = 7)
  Object if2805 = done;
  if (istrue(opresult2809)) {
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newmode (depth = 9)
  int op_slot_right_2811 = gc_frame_newslot(*var_newmode);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2811 = gc_frame_newslot(*var_mode);
  params[0] = *var_newmode;
  partcv[0] = 1;
  Object opresult2813 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2813 (depth = 8)
  Object if2810 = done;
  if (istrue(opresult2813)) {
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2815 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2816 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unicode (depth = 12)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2817 = callmethod(*var_unicode, "isSeparator",
    1, partcv, params);
  gc_frame_end(callframe2816);
// compiled call node returning call2817 (depth = 11)
  partcv[0] = 0;
  Object call2818 = callmethod(call2817, "not",
    1, partcv, params);
  gc_frame_end(callframe2815);
// compiled call node returning call2818 (depth = 10)
// compiled member node returning call2818 (depth = 9)
  Object if2814 = done;
  if (istrue(call2818)) {
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2820 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2821 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2822 = callmethod(*var_unicode, "isControl",
    1, partcv, params);
  gc_frame_end(callframe2821);
// compiled call node returning call2822 (depth = 12)
  partcv[0] = 0;
  Object call2823 = callmethod(call2822, "not",
    1, partcv, params);
  gc_frame_end(callframe2820);
// compiled call node returning call2823 (depth = 11)
// compiled member node returning call2823 (depth = 10)
  Object if2819 = done;
  if (istrue(call2823)) {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2826 = alloc_Float64(10);
// compiled num node returning num2826 (depth = 12)
  int op_slot_right_2825 = gc_frame_newslot(num2826);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  int op_slot_left_2825 = gc_frame_newslot(*var_ordval);
  params[0] = num2826;
  partcv[0] = 1;
  Object opresult2828 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2828 (depth = 11)
  Object if2824 = done;
  if (istrue(opresult2828)) {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2831 = alloc_Float64(13);
// compiled num node returning num2831 (depth = 13)
  int op_slot_right_2830 = gc_frame_newslot(num2831);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  int op_slot_left_2830 = gc_frame_newslot(*var_ordval);
  params[0] = num2831;
  partcv[0] = 1;
  Object opresult2833 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2833 (depth = 12)
  Object if2829 = done;
  if (istrue(opresult2833)) {
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num2836 = alloc_Float64(32);
// compiled num node returning num2836 (depth = 14)
  int op_slot_right_2835 = gc_frame_newslot(num2836);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  int op_slot_left_2835 = gc_frame_newslot(*var_ordval);
  params[0] = num2836;
  partcv[0] = 1;
  Object opresult2838 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2838 (depth = 13)
  Object if2834 = done;
  if (istrue(opresult2838)) {
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2841 == NULL) {
    strlit2841 = alloc_String(".");
    gc_root(strlit2841);
  }
// compiled string node returning strlit2841 (depth = 15)
  int op_slot_right_2840 = gc_frame_newslot(strlit2841);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_2840 = gc_frame_newslot(*var_c);
  params[0] = strlit2841;
  partcv[0] = 1;
  Object opresult2843 = callmethod(*var_c, "!=", 1, partcv, params);
// compiled op node returning opresult2843 (depth = 14)
  Object if2839 = done;
  if (istrue(opresult2843)) {
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe2844 = gc_frame_new();
// starting to compile op node (depth = 15)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 16)
  if (strlit2846 == NULL) {
    strlit2846 = alloc_String("is not a valid character; use spaces instead.");
    gc_root(strlit2846);
  }
// compiled string node returning strlit2846 (depth = 16)
  int op_slot_right_2845 = gc_frame_newslot(strlit2846);
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2849 == NULL) {
    strlit2849 = alloc_String(") ");
    gc_root(strlit2849);
  }
// compiled string node returning strlit2849 (depth = 17)
  int op_slot_right_2848 = gc_frame_newslot(strlit2849);
// starting to compile op node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe2852 = gc_frame_new();
// starting to compile call node (depth = 19)
  int callframe2853 = gc_frame_new();
// starting to compile num node (depth = 20)
  Object num2854 = alloc_Float64(16);
// compiled num node returning num2854 (depth = 20)
  gc_frame_newslot(num2854);
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_ordval (depth = 20)
  params[0] = num2854;
  partcv[0] = 1;
  Object call2855 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2853);
// compiled call node returning call2855 (depth = 19)
  gc_frame_newslot(call2855);
// starting to compile num node (depth = 19)
  Object num2856 = alloc_Float64(4);
// compiled num node returning num2856 (depth = 19)
  gc_frame_newslot(num2856);
// starting to compile string node (depth = 19)
  if (strlit2857 == NULL) {
    strlit2857 = alloc_String("0");
    gc_root(strlit2857);
  }
// compiled string node returning strlit2857 (depth = 19)
  gc_frame_newslot(strlit2857);
// call case 2: outer request
// starting to compile member node (depth = 19)
// starting to compile call node (depth = 20)
  int callframe2858 = gc_frame_new();
// call case 3: self.outer request
  Object call2859 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2858);
// compiled call node returning call2859 (depth = 20)
// compiled member node returning call2859 (depth = 19)
  params[0] = call2855;
  params[1] = num2856;
  params[2] = strlit2857;
  partcv[0] = 3;
  Object call2860 = callmethodflags(call2859, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2852);
// compiled call node returning call2860 (depth = 18)
  int op_slot_right_2851 = gc_frame_newslot(call2860);
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit2863 == NULL) {
    strlit2863 = alloc_String(" (U+");
    gc_root(strlit2863);
  }
// compiled string node returning strlit2863 (depth = 19)
  int op_slot_right_2862 = gc_frame_newslot(strlit2863);
// starting to compile op node (depth = 19)
// starting to compile call node (depth = 20)
  int callframe2866 = gc_frame_new();
// starting to compile identifier node (depth = 21)
// compiled identifier node returning *var_c (depth = 21)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 21)
// compiled identifier node returning *var_unicode (depth = 21)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2867 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2866);
// compiled call node returning call2867 (depth = 20)
  int op_slot_right_2865 = gc_frame_newslot(call2867);
// starting to compile string node (depth = 20)
  if (strlit2869 == NULL) {
    strlit2869 = alloc_String("");
    gc_root(strlit2869);
  }
// compiled string node returning strlit2869 (depth = 20)
  int op_slot_left_2865 = gc_frame_newslot(strlit2869);
  params[0] = call2867;
  partcv[0] = 1;
  Object opresult2870 = callmethod(strlit2869, "++", 1, partcv, params);
// compiled op node returning opresult2870 (depth = 19)
  int op_slot_left_2862 = gc_frame_newslot(opresult2870);
  params[0] = strlit2863;
  partcv[0] = 1;
  Object opresult2871 = callmethod(opresult2870, "++", 1, partcv, params);
// compiled op node returning opresult2871 (depth = 18)
  int op_slot_left_2851 = gc_frame_newslot(opresult2871);
  params[0] = call2860;
  partcv[0] = 1;
  Object opresult2872 = callmethod(opresult2871, "++", 1, partcv, params);
// compiled op node returning opresult2872 (depth = 17)
  int op_slot_left_2848 = gc_frame_newslot(opresult2872);
  params[0] = strlit2849;
  partcv[0] = 1;
  Object opresult2873 = callmethod(opresult2872, "++", 1, partcv, params);
// compiled op node returning opresult2873 (depth = 16)
  int op_slot_left_2845 = gc_frame_newslot(opresult2873);
  params[0] = strlit2846;
  partcv[0] = 1;
  Object opresult2874 = callmethod(opresult2873, "++", 1, partcv, params);
// compiled op node returning opresult2874 (depth = 15)
  gc_frame_newslot(opresult2874);
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_lineNumber (depth = 15)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = opresult2874;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2875 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe2844);
// compiled call node returning call2875 (depth = 14)
    gc_frame_newslot(call2875);
    if2839 = call2875;
  } else {
  }
// compiled if node returning if2839 (depth = 13)
    gc_frame_newslot(if2839);
    if2834 = if2839;
  } else {
  }
// compiled if node returning if2834 (depth = 12)
    gc_frame_newslot(if2834);
    if2829 = if2834;
  } else {
  }
// compiled if node returning if2829 (depth = 11)
    gc_frame_newslot(if2829);
    if2824 = if2829;
  } else {
  }
// compiled if node returning if2824 (depth = 10)
    gc_frame_newslot(if2824);
    if2819 = if2824;
  } else {
  }
// compiled if node returning if2819 (depth = 9)
    gc_frame_newslot(if2819);
    if2814 = if2819;
  } else {
  }
// compiled if node returning if2814 (depth = 8)
    gc_frame_newslot(if2814);
    if2810 = if2814;
  } else {
  }
// compiled if node returning if2810 (depth = 7)
    gc_frame_newslot(if2810);
    if2805 = if2810;
  } else {
  }
// compiled if node returning if2805 (depth = 6)
    gc_frame_newslot(if2805);
    if2568 = if2805;
  } else {
  }
// compiled if node returning if2568 (depth = 5)
    gc_frame_newslot(if2568);
    if2567 = if2568;
  }
// compiled if node returning if2567 (depth = 4)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2878 == NULL) {
    strlit2878 = alloc_String("""\x22""");
    gc_root(strlit2878);
  }
// compiled string node returning strlit2878 (depth = 6)
  int op_slot_right_2877 = gc_frame_newslot(strlit2878);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_2877 = gc_frame_newslot(*var_mode);
  params[0] = strlit2878;
  partcv[0] = 1;
  Object opresult2880 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2880 (depth = 5)
  Object if2876 = done;
  if (istrue(opresult2880)) {
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2883 == NULL) {
    strlit2883 = alloc_String("""\x22""");
    gc_root(strlit2883);
  }
// compiled string node returning strlit2883 (depth = 7)
  int op_slot_right_2882 = gc_frame_newslot(strlit2883);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_2882 = gc_frame_newslot(*var_c);
  params[0] = strlit2883;
  partcv[0] = 1;
  Object opresult2885 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2885 (depth = 6)
  Object if2881 = done;
  if (istrue(opresult2885)) {
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_escaped (depth = 9)
  partcv[0] = 0;
  Object call2888 = callmethod(*var_escaped, "not",
    1, partcv, params);
  gc_frame_end(callframe2887);
// compiled call node returning call2888 (depth = 8)
// compiled member node returning call2888 (depth = 7)
  Object if2886 = done;
  if (istrue(call2888)) {
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2889 == NULL) {
    strlit2889 = alloc_String("n");
    gc_root(strlit2889);
  }
// compiled string node returning strlit2889 (depth = 8)
  *var_newmode = strlit2889;
  if (strlit2889 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2891 = alloc_Boolean(0);
// compiled identifier node returning bool2891 (depth = 8)
  *var_inStr = bool2891;
  if (bool2891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_interpString (depth = 8)
  Object if2893 = done;
  if (istrue(*var_interpString)) {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2894 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2895 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2894);
// compiled call node returning call2895 (depth = 8)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2896 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2897 == NULL) {
    strlit2897 = alloc_String(")");
    gc_root(strlit2897);
  }
// compiled string node returning strlit2897 (depth = 9)
  gc_frame_newslot(strlit2897);
// starting to compile string node (depth = 9)
  if (strlit2898 == NULL) {
    strlit2898 = alloc_String(")");
    gc_root(strlit2898);
  }
// compiled string node returning strlit2898 (depth = 9)
  gc_frame_newslot(strlit2898);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2897;
  params[2] = strlit2898;
  partcv[0] = 3;
  Object call2899 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2896);
// compiled call node returning call2899 (depth = 8)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newmode (depth = 9)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2901 = alloc_Boolean(0);
// compiled identifier node returning bool2901 (depth = 9)
  *var_interpString = bool2901;
  if (bool2901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2893 = done;
  } else {
  }
// compiled if node returning if2893 (depth = 7)
    gc_frame_newslot(if2893);
    if2886 = if2893;
  } else {
  }
// compiled if node returning if2886 (depth = 6)
    gc_frame_newslot(if2886);
    if2881 = if2886;
  } else {
  }
// compiled if node returning if2881 (depth = 5)
    gc_frame_newslot(if2881);
    if2876 = if2881;
  } else {
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("q");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 7)
  int op_slot_right_2904 = gc_frame_newslot(strlit2905);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_2904 = gc_frame_newslot(*var_mode);
  params[0] = strlit2905;
  partcv[0] = 1;
  Object opresult2907 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2907 (depth = 6)
  Object if2903 = done;
  if (istrue(opresult2907)) {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2910 == NULL) {
    strlit2910 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit2910);
  }
// compiled string node returning strlit2910 (depth = 8)
  int op_slot_right_2909 = gc_frame_newslot(strlit2910);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2909 = gc_frame_newslot(*var_c);
  params[0] = strlit2910;
  partcv[0] = 1;
  Object opresult2912 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2912 (depth = 7)
  Object if2908 = done;
  if (istrue(opresult2912)) {
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2913 == NULL) {
    strlit2913 = alloc_String("n");
    gc_root(strlit2913);
  }
// compiled string node returning strlit2913 (depth = 8)
  *var_newmode = strlit2913;
  if (strlit2913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2915 = alloc_Boolean(0);
// compiled identifier node returning bool2915 (depth = 8)
  *var_inStr = bool2915;
  if (bool2915 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2908 = done;
  } else {
  }
// compiled if node returning if2908 (depth = 6)
    gc_frame_newslot(if2908);
    if2903 = if2908;
  } else {
  }
// compiled if node returning if2903 (depth = 5)
    gc_frame_newslot(if2903);
    if2876 = if2903;
  }
// compiled if node returning if2876 (depth = 4)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_right_2918 = gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newmode (depth = 6)
  int op_slot_left_2918 = gc_frame_newslot(*var_newmode);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult2920 = callmethod(*var_newmode, "!=", 1, partcv, params);
// compiled op node returning opresult2920 (depth = 5)
  Object if2917 = done;
  if (istrue(opresult2920)) {
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2921 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_accum (depth = 6)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2922 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2921);
// compiled call node returning call2922 (depth = 5)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2925 = alloc_Float64(0);
// compiled num node returning num2925 (depth = 7)
  int op_slot_right_2924 = gc_frame_newslot(num2925);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_interpdepth (depth = 7)
  int op_slot_left_2924 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2925;
  partcv[0] = 1;
  Object opresult2927 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult2927 (depth = 6)
  Object if2923 = done;
  if (istrue(opresult2927)) {
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2930 == NULL) {
    strlit2930 = alloc_String("}");
    gc_root(strlit2930);
  }
// compiled string node returning strlit2930 (depth = 8)
  int op_slot_right_2929 = gc_frame_newslot(strlit2930);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newmode (depth = 8)
  int op_slot_left_2929 = gc_frame_newslot(*var_newmode);
  params[0] = strlit2930;
  partcv[0] = 1;
  Object opresult2932 = callmethod(*var_newmode, "==", 1, partcv, params);
// compiled op node returning opresult2932 (depth = 7)
  Object if2928 = done;
  if (istrue(opresult2932)) {
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2935 == NULL) {
    strlit2935 = alloc_String("lbrace");
    gc_root(strlit2935);
  }
// compiled string node returning strlit2935 (depth = 9)
  int op_slot_right_2934 = gc_frame_newslot(strlit2935);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2937 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2938 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call2939 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2938);
// compiled call node returning call2939 (depth = 12)
// compiled member node returning call2939 (depth = 11)
  partcv[0] = 0;
  Object call2940 = callmethod(call2939, "kind",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compiled call node returning call2940 (depth = 10)
// compiled member node returning call2940 (depth = 9)
  int op_slot_left_2934 = gc_frame_newslot(call2940);
  params[0] = strlit2935;
  partcv[0] = 1;
  Object opresult2941 = callmethod(call2940, "==", 1, partcv, params);
// compiled op node returning opresult2941 (depth = 8)
  Object if2933 = done;
  if (istrue(opresult2941)) {
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2942 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call2944 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2943);
// compiled call node returning call2944 (depth = 12)
// compiled member node returning call2944 (depth = 11)
  partcv[0] = 0;
  Object call2945 = callmethod(call2944, "new",
    1, partcv, params);
  gc_frame_end(callframe2942);
// compiled call node returning call2945 (depth = 10)
// compiled member node returning call2945 (depth = 9)
  *var_suggestion = call2945;
  if (call2945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2946 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2948 = alloc_Float64(1);
// compiled num node returning num2948 (depth = 10)
  int op_slot_right_2947 = gc_frame_newslot(num2948);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_2947 = gc_frame_newslot(*var_linePosition);
  params[0] = num2948;
  partcv[0] = 1;
  Object diff2950 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2950 (depth = 9)
  gc_frame_newslot(diff2950);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff2950;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2951 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe2946);
// compiled call node returning call2951 (depth = 8)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2952 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2953 == NULL) {
    strlit2953 = alloc_String("A string interpolation cannot be empty.");
    gc_root(strlit2953);
  }
// compiled string node returning strlit2953 (depth = 9)
  gc_frame_newslot(strlit2953);
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2954 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call2956 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2955);
// compiled call node returning call2956 (depth = 12)
// compiled member node returning call2956 (depth = 11)
  partcv[0] = 0;
  Object call2957 = callmethod(call2956, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2954);
// compiled call node returning call2957 (depth = 10)
// compiled member node returning call2957 (depth = 9)
  gc_frame_newslot(call2957);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2953;
  params[1] = *var_lineNumber;
  params[2] = call2957;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2958 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2952);
// compiled call node returning call2958 (depth = 8)
    gc_frame_newslot(call2958);
    if2933 = call2958;
  } else {
  }
// compiled if node returning if2933 (depth = 7)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2959 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 8)
  if (strlit2960 == NULL) {
    strlit2960 = alloc_String(")");
    gc_root(strlit2960);
  }
// compiled string node returning strlit2960 (depth = 8)
  gc_frame_newslot(strlit2960);
// starting to compile string node (depth = 8)
  if (strlit2961 == NULL) {
    strlit2961 = alloc_String(")");
    gc_root(strlit2961);
  }
// compiled string node returning strlit2961 (depth = 8)
  gc_frame_newslot(strlit2961);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2960;
  params[2] = strlit2961;
  partcv[0] = 3;
  Object call2962 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2959);
// compiled call node returning call2962 (depth = 7)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2963 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 8)
  if (strlit2964 == NULL) {
    strlit2964 = alloc_String("o");
    gc_root(strlit2964);
  }
// compiled string node returning strlit2964 (depth = 8)
  gc_frame_newslot(strlit2964);
// starting to compile string node (depth = 8)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("++");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 8)
  gc_frame_newslot(strlit2965);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2964;
  params[2] = strlit2965;
  partcv[0] = 3;
  Object call2966 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2963);
// compiled call node returning call2966 (depth = 7)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2967 == NULL) {
    strlit2967 = alloc_String("""\x22""");
    gc_root(strlit2967);
  }
// compiled string node returning strlit2967 (depth = 8)
  *var_newmode = strlit2967;
  if (strlit2967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2969 = alloc_Boolean(1);
// compiled identifier node returning bool2969 (depth = 8)
  *var_inStr = bool2969;
  if (bool2969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2972 = alloc_Float64(1);
// compiled num node returning num2972 (depth = 9)
  int op_slot_right_2971 = gc_frame_newslot(num2972);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_interpdepth (depth = 9)
  int op_slot_left_2971 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2972;
  partcv[0] = 1;
  Object diff2974 = callmethod(*var_interpdepth, "-", 1, partcv, params);
// compiled op node returning diff2974 (depth = 8)
  *var_interpdepth = diff2974;
  if (diff2974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2928 = done;
  } else {
  }
// compiled if node returning if2928 (depth = 6)
    gc_frame_newslot(if2928);
    if2923 = if2928;
  } else {
  }
// compiled if node returning if2923 (depth = 5)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newmode (depth = 6)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inStr (depth = 6)
  Object if2977 = done;
  if (istrue(*var_inStr)) {
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2978 == NULL) {
    strlit2978 = alloc_String("");
    gc_root(strlit2978);
  }
// compiled string node returning strlit2978 (depth = 7)
  *var_accum = strlit2978;
  if (strlit2978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2977 = done;
  } else {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  *var_accum = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2977 = done;
  }
// compiled if node returning if2977 (depth = 5)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2982 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_brackets (depth = 7)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2983 = callmethod(*var_brackets, "match",
    1, partcv, params);
  gc_frame_end(callframe2982);
// compiled call node returning call2983 (depth = 6)
  Object if2981 = done;
  if (istrue(call2983)) {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2984 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2985 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2984);
// compiled call node returning call2985 (depth = 6)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2986 == NULL) {
    strlit2986 = alloc_String("n");
    gc_root(strlit2986);
  }
// compiled string node returning strlit2986 (depth = 7)
  *var_mode = strlit2986;
  if (strlit2986 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2988 == NULL) {
    strlit2988 = alloc_String("n");
    gc_root(strlit2988);
  }
// compiled string node returning strlit2988 (depth = 7)
  *var_newmode = strlit2988;
  if (strlit2988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2990 == NULL) {
    strlit2990 = alloc_String("");
    gc_root(strlit2990);
  }
// compiled string node returning strlit2990 (depth = 7)
  *var_accum = strlit2990;
  if (strlit2990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2981 = done;
  } else {
  }
// compiled if node returning if2981 (depth = 5)
    gc_frame_newslot(if2981);
    if2917 = if2981;
  } else {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2994 == NULL) {
    strlit2994 = alloc_String("""\x22""");
    gc_root(strlit2994);
  }
// compiled string node returning strlit2994 (depth = 7)
  int op_slot_right_2993 = gc_frame_newslot(strlit2994);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_2993 = gc_frame_newslot(*var_mode);
  params[0] = strlit2994;
  partcv[0] = 1;
  Object opresult2996 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2996 (depth = 6)
  Object if2992 = done;
  if (istrue(opresult2996)) {
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2999 == NULL) {
    strlit2999 = alloc_String("""\x0a""");
    gc_root(strlit2999);
  }
// compiled string node returning strlit2999 (depth = 8)
  int op_slot_right_2998 = gc_frame_newslot(strlit2999);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2998 = gc_frame_newslot(*var_c);
  params[0] = strlit2999;
  partcv[0] = 1;
  Object opresult3001 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3001 (depth = 7)
  Object if2997 = done;
  if (istrue(opresult3001)) {
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3004 = alloc_Float64(0);
// compiled num node returning num3004 (depth = 9)
  int op_slot_right_3003 = gc_frame_newslot(num3004);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_interpdepth (depth = 9)
  int op_slot_left_3003 = gc_frame_newslot(*var_interpdepth);
  params[0] = num3004;
  partcv[0] = 1;
  Object opresult3006 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult3006 (depth = 8)
  Object if3002 = done;
  if (istrue(opresult3006)) {
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  *var_line = *var_lineNumber;
  if (*var_lineNumber == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3007 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe3008 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call3010 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3009);
// compiled call node returning call3010 (depth = 13)
// compiled member node returning call3010 (depth = 12)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call3011 = callmethod(call3010, "at",
    1, partcv, params);
  gc_frame_end(callframe3008);
// compiled call node returning call3011 (depth = 11)
  partcv[0] = 0;
  Object call3012 = callmethod(call3011, "size",
    1, partcv, params);
  gc_frame_end(callframe3007);
// compiled call node returning call3012 (depth = 10)
// compiled member node returning call3012 (depth = 9)
  *var_i = call3012;
  if (call3012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3013 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3014 = alloc_Block(NULL, NULL, "lexer", 926);
  gc_frame_newslot(block3014);
// method _apply
  block_savedest(block3014);
  Object closure3015 = createclosure(4, "_apply");
  setclosureframe(closure3015, stackframe);
  addtoclosure(closure3015, var_line);
  addtoclosure(closure3015, var_util);
  addtoclosure(closure3015, var_i);
  addtoclosure(closure3015, selfslot);
  struct UserObject *uo3015 = (struct UserObject*)block3014;
  uo3015->data[0] = (Object)closure3015;
  Method *meth_meth_lexer__apply3015 = addmethod2pos(block3014, "_apply", &meth_lexer__apply3015, 0);
  int argcv_meth_lexer__apply3015[] = {0};
  meth_meth_lexer__apply3015->type = alloc_MethodType(1, argcv_meth_lexer__apply3015);
  meth_meth_lexer__apply3015->definitionModule = modulename;
  meth_meth_lexer__apply3015->definitionLine = 925;
// compiled block node returning block3014 (depth = 9)
  gc_frame_newslot(block3014);
// starting to compile block node (depth = 9)
  Object block3026 = alloc_Block(NULL, NULL, "lexer", 926);
  gc_frame_newslot(block3026);
// method _apply
  block_savedest(block3026);
  Object closure3027 = createclosure(5, "_apply");
  setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_i);
  addtoclosure(closure3027, var_line);
  addtoclosure(closure3027, var_lineNumber);
  addtoclosure(closure3027, var_util);
  addtoclosure(closure3027, selfslot);
  struct UserObject *uo3027 = (struct UserObject*)block3026;
  uo3027->data[0] = (Object)closure3027;
  Method *meth_meth_lexer__apply3027 = addmethod2pos(block3026, "_apply", &meth_lexer__apply3027, 0);
  int argcv_meth_lexer__apply3027[] = {0};
  meth_meth_lexer__apply3027->type = alloc_MethodType(1, argcv_meth_lexer__apply3027);
  meth_meth_lexer__apply3027->definitionModule = modulename;
  meth_meth_lexer__apply3027->definitionLine = 926;
// compiled block node returning block3026 (depth = 9)
  gc_frame_newslot(block3026);
// call case 5: prelude request
  params[0] = block3014;
  params[1] = block3026;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3051 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3013);
// compiled call node returning call3051 (depth = 8)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array3052 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3052 (depth = 9)
  *var_suggestions = array3052;
  if (array3052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3053 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3055 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3054);
// compiled call node returning call3055 (depth = 12)
// compiled member node returning call3055 (depth = 11)
  partcv[0] = 0;
  Object call3056 = callmethod(call3055, "new",
    1, partcv, params);
  gc_frame_end(callframe3053);
// compiled call node returning call3056 (depth = 10)
// compiled member node returning call3056 (depth = 9)
  *var_suggestion = call3056;
  if (call3056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3057 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3058 == NULL) {
    strlit3058 = alloc_String("\\");
    gc_root(strlit3058);
  }
// compiled string node returning strlit3058 (depth = 9)
  gc_frame_newslot(strlit3058);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3058;
  params[1] = *var_i;
  params[2] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3059 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe3057);
// compiled call node returning call3059 (depth = 8)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3060 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3061 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3061 (depth = 8)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3066 = alloc_Float64(2);
// compiled num node returning num3066 (depth = 12)
  int op_slot_right_3065 = gc_frame_newslot(num3066);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_linePosition (depth = 12)
  int op_slot_left_3065 = gc_frame_newslot(*var_linePosition);
  params[0] = num3066;
  partcv[0] = 1;
  Object diff3068 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3068 (depth = 11)
  int op_slot_right_3064 = gc_frame_newslot(diff3068);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_3064 = gc_frame_newslot(*var_i);
  params[0] = diff3068;
  partcv[0] = 1;
  Object opresult3070 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult3070 (depth = 10)
  int op_slot_right_3063 = gc_frame_newslot(opresult3070);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  int op_slot_right_3072 = gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_3072 = gc_frame_newslot(*var_line);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult3074 = callmethod(*var_line, "==", 1, partcv, params);
// compiled op node returning opresult3074 (depth = 10)
  int op_slot_left_3063 = gc_frame_newslot(opresult3074);
  params[0] = opresult3070;
  partcv[0] = 1;
  Object opresult3075 = callmethod(opresult3074, "&&", 1, partcv, params);
// compiled op node returning opresult3075 (depth = 9)
  Object if3062 = done;
  if (istrue(opresult3075)) {
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3076 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit3077 == NULL) {
    strlit3077 = alloc_String("For a '{' character in a string use '\\{'.");
    gc_root(strlit3077);
  }
// compiled string node returning strlit3077 (depth = 10)
  gc_frame_newslot(strlit3077);
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit3077;
  params[1] = *var_line;
  params[2] = *var_i;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3078 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3076);
// compiled call node returning call3078 (depth = 9)
    gc_frame_newslot(call3078);
    if3062 = call3078;
  } else {
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3079 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call3081 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3080);
// compiled call node returning call3081 (depth = 13)
// compiled member node returning call3081 (depth = 12)
  partcv[0] = 0;
  Object call3082 = callmethod(call3081, "new",
    1, partcv, params);
  gc_frame_end(callframe3079);
// compiled call node returning call3082 (depth = 11)
// compiled member node returning call3082 (depth = 10)
  *var_suggestion = call3082;
  if (call3082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3084 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit3085 == NULL) {
    strlit3085 = alloc_String("}");
    gc_root(strlit3085);
  }
// compiled string node returning strlit3085 (depth = 10)
  gc_frame_newslot(strlit3085);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3087 = alloc_Float64(1);
// compiled num node returning num3087 (depth = 11)
  int op_slot_right_3086 = gc_frame_newslot(num3087);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  partcv[0] = 0;
  Object call3091 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe3090);
// compiled call node returning call3091 (depth = 13)
// compiled member node returning call3091 (depth = 12)
  int op_slot_right_3089 = gc_frame_newslot(call3091);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_linePosition (depth = 12)
  int op_slot_left_3089 = gc_frame_newslot(*var_linePosition);
  params[0] = call3091;
  partcv[0] = 1;
  Object diff3093 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3093 (depth = 11)
  int op_slot_left_3086 = gc_frame_newslot(diff3093);
  params[0] = num3087;
  partcv[0] = 1;
  Object diff3094 = callmethod(diff3093, "-", 1, partcv, params);
// compiled op node returning diff3094 (depth = 10)
  gc_frame_newslot(diff3094);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit3085;
  params[1] = diff3094;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3095 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe3084);
// compiled call node returning call3095 (depth = 9)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3096 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3097 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3096);
// compiled call node returning call3097 (depth = 9)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3098 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit3099 == NULL) {
    strlit3099 = alloc_String("A string interpolation must end with a '}'. For a '{' character in a string use '\\{'.");
    gc_root(strlit3099);
  }
// compiled string node returning strlit3099 (depth = 10)
  gc_frame_newslot(strlit3099);
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3101 = alloc_Float64(1);
// compiled num node returning num3101 (depth = 11)
  int op_slot_right_3100 = gc_frame_newslot(num3101);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3104 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  partcv[0] = 0;
  Object call3105 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe3104);
// compiled call node returning call3105 (depth = 13)
// compiled member node returning call3105 (depth = 12)
  int op_slot_right_3103 = gc_frame_newslot(call3105);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_linePosition (depth = 12)
  int op_slot_left_3103 = gc_frame_newslot(*var_linePosition);
  params[0] = call3105;
  partcv[0] = 1;
  Object diff3107 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3107 (depth = 11)
  int op_slot_left_3100 = gc_frame_newslot(diff3107);
  params[0] = num3101;
  partcv[0] = 1;
  Object diff3108 = callmethod(diff3107, "-", 1, partcv, params);
// compiled op node returning diff3108 (depth = 10)
  gc_frame_newslot(diff3108);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit3099;
  params[1] = *var_lineNumber;
  params[2] = diff3108;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3109 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3098);
// compiled call node returning call3109 (depth = 9)
    gc_frame_newslot(call3109);
    if3062 = call3109;
  }
// compiled if node returning if3062 (depth = 8)
    gc_frame_newslot(if3062);
    if3002 = if3062;
  } else {
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3110 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call3112 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3111);
// compiled call node returning call3112 (depth = 11)
// compiled member node returning call3112 (depth = 10)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call3113 = callmethod(call3112, "at",
    1, partcv, params);
  gc_frame_end(callframe3110);
// compiled call node returning call3113 (depth = 9)
  *var_errorLine = call3113;
  if (call3113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3117 = alloc_Float64(1);
// compiled num node returning num3117 (depth = 12)
  int op_slot_right_3116 = gc_frame_newslot(num3117);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3116 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3117;
  partcv[0] = 1;
  Object sum3119 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3119 (depth = 11)
  int op_slot_right_3115 = gc_frame_newslot(sum3119);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3121 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call3123 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3122);
// compiled call node returning call3123 (depth = 14)
// compiled member node returning call3123 (depth = 13)
  partcv[0] = 0;
  Object call3124 = callmethod(call3123, "size",
    1, partcv, params);
  gc_frame_end(callframe3121);
// compiled call node returning call3124 (depth = 12)
// compiled member node returning call3124 (depth = 11)
  int op_slot_left_3115 = gc_frame_newslot(call3124);
  params[0] = sum3119;
  partcv[0] = 1;
  Object opresult3125 = callmethod(call3124, ">=", 1, partcv, params);
// compiled op node returning opresult3125 (depth = 10)
  Object if3114 = done;
struct StackFrameObject *iftmpstackframe3114 = stackframe;
  if (istrue(opresult3125)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3114);
gc_frame_newslot((Object)stackframe);
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3126 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3128 = alloc_Float64(1);
// compiled num node returning num3128 (depth = 12)
  int op_slot_right_3127 = gc_frame_newslot(num3128);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3127 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3128;
  partcv[0] = 1;
  Object sum3130 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3130 (depth = 11)
  gc_frame_newslot(sum3130);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_util (depth = 13)
  partcv[0] = 0;
  Object call3132 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3131);
// compiled call node returning call3132 (depth = 12)
// compiled member node returning call3132 (depth = 11)
  params[0] = sum3130;
  partcv[0] = 1;
  Object call3133 = callmethod(call3132, "at",
    1, partcv, params);
  gc_frame_end(callframe3126);
// compiled call node returning call3133 (depth = 10)
    gc_frame_newslot(call3133);
    if3114 = call3133;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe3114);
  gc_frame_newslot((Object)stackframe);
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit3134 == NULL) {
    strlit3134 = alloc_String("");
    gc_root(strlit3134);
  }
// compiled string node returning strlit3134 (depth = 10)
    gc_frame_newslot(strlit3134);
    if3114 = strlit3134;
  }
stackframe = iftmpstackframe3114;
// compiled if node returning if3114 (depth = 9)
  *var_nextLine = if3114;
  if (if3114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3135 = alloc_Float64(1);
// compiled num node returning num3135 (depth = 9)
  *var_i = num3135;
  if (num3135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3136 = alloc_Float64(0);
// compiled num node returning num3136 (depth = 9)
  *var_count = num3136;
  if (num3136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3137 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3138 = alloc_Block(NULL, NULL, "lexer", 957);
  gc_frame_newslot(block3138);
// method _apply
  block_savedest(block3138);
  Object closure3139 = createclosure(3, "_apply");
  setclosureframe(closure3139, stackframe);
  addtoclosure(closure3139, var_nextLine);
  addtoclosure(closure3139, var_i);
  addtoclosure(closure3139, selfslot);
  struct UserObject *uo3139 = (struct UserObject*)block3138;
  uo3139->data[0] = (Object)closure3139;
  Method *meth_meth_lexer__apply3139 = addmethod2pos(block3138, "_apply", &meth_lexer__apply3139, 0);
  int argcv_meth_lexer__apply3139[] = {0};
  meth_meth_lexer__apply3139->type = alloc_MethodType(1, argcv_meth_lexer__apply3139);
  meth_meth_lexer__apply3139->definitionModule = modulename;
  meth_meth_lexer__apply3139->definitionLine = 950;
// compiled block node returning block3138 (depth = 9)
  gc_frame_newslot(block3138);
// starting to compile block node (depth = 9)
  Object block3146 = alloc_Block(NULL, NULL, "lexer", 957);
  gc_frame_newslot(block3146);
// method _apply
  block_savedest(block3146);
  Object closure3147 = createclosure(4, "_apply");
  setclosureframe(closure3147, stackframe);
  addtoclosure(closure3147, var_nextLine);
  addtoclosure(closure3147, var_i);
  addtoclosure(closure3147, var_count);
  addtoclosure(closure3147, selfslot);
  struct UserObject *uo3147 = (struct UserObject*)block3146;
  uo3147->data[0] = (Object)closure3147;
  Method *meth_meth_lexer__apply3147 = addmethod2pos(block3146, "_apply", &meth_lexer__apply3147, 0);
  int argcv_meth_lexer__apply3147[] = {0};
  meth_meth_lexer__apply3147->type = alloc_MethodType(1, argcv_meth_lexer__apply3147);
  meth_meth_lexer__apply3147->definitionModule = modulename;
  meth_meth_lexer__apply3147->definitionLine = 957;
// compiled block node returning block3146 (depth = 9)
  gc_frame_newslot(block3146);
// call case 5: prelude request
  params[0] = block3138;
  params[1] = block3146;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3176 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3137);
// compiled call node returning call3176 (depth = 8)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3179 = alloc_Float64(1);
// compiled num node returning num3179 (depth = 10)
  int op_slot_right_3178 = gc_frame_newslot(num3179);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3182 = alloc_Float64(2);
// compiled num node returning num3182 (depth = 11)
  int op_slot_right_3181 = gc_frame_newslot(num3182);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_count (depth = 11)
  int op_slot_left_3181 = gc_frame_newslot(*var_count);
  params[0] = num3182;
  partcv[0] = 1;
  Object modulus3184 = callmethod(*var_count, "%", 1, partcv, params);
// compiled op node returning modulus3184 (depth = 10)
  int op_slot_left_3178 = gc_frame_newslot(modulus3184);
  params[0] = num3179;
  partcv[0] = 1;
  Object opresult3185 = callmethod(modulus3184, "==", 1, partcv, params);
// compiled op node returning opresult3185 (depth = 9)
  Object if3177 = done;
  if (istrue(opresult3185)) {
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile array node (depth = 10)
  Object array3186 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3186 (depth = 10)
  *var_suggestions = array3186;
  if (array3186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3187 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call3189 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3188);
// compiled call node returning call3189 (depth = 13)
// compiled member node returning call3189 (depth = 12)
  partcv[0] = 0;
  Object call3190 = callmethod(call3189, "new",
    1, partcv, params);
  gc_frame_end(callframe3187);
// compiled call node returning call3190 (depth = 11)
// compiled member node returning call3190 (depth = 10)
  *var_suggestion = call3190;
  if (call3190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3191 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextLine (depth = 11)
  int op_slot_right_3192 = gc_frame_newslot(*var_nextLine);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errorLine (depth = 11)
  int op_slot_left_3192 = gc_frame_newslot(*var_errorLine);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3194 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3194 (depth = 10)
  gc_frame_newslot(opresult3194);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lineNumber;
  params[1] = opresult3194;
  partcv[0] = 2;
  Object call3195 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3191);
// compiled call node returning call3195 (depth = 9)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3196 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3198 = alloc_Float64(1);
// compiled num node returning num3198 (depth = 11)
  int op_slot_right_3197 = gc_frame_newslot(num3198);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  int op_slot_left_3197 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3198;
  partcv[0] = 1;
  Object sum3200 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3200 (depth = 10)
  gc_frame_newslot(sum3200);
// starting to compile string node (depth = 10)
  if (strlit3201 == NULL) {
    strlit3201 = alloc_String("");
    gc_root(strlit3201);
  }
// compiled string node returning strlit3201 (depth = 10)
  gc_frame_newslot(strlit3201);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum3200;
  params[1] = strlit3201;
  partcv[0] = 2;
  Object call3202 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3196);
// compiled call node returning call3202 (depth = 9)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3203 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3204 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3203);
// compiled call node returning call3204 (depth = 9)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3205 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call3207 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compiled call node returning call3207 (depth = 13)
// compiled member node returning call3207 (depth = 12)
  partcv[0] = 0;
  Object call3208 = callmethod(call3207, "new",
    1, partcv, params);
  gc_frame_end(callframe3205);
// compiled call node returning call3208 (depth = 11)
// compiled member node returning call3208 (depth = 10)
  *var_suggestion = call3208;
  if (call3208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3210 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3212 == NULL) {
    strlit3212 = alloc_String("""\x22""");
    gc_root(strlit3212);
  }
// compiled string node returning strlit3212 (depth = 11)
  int op_slot_right_3211 = gc_frame_newslot(strlit3212);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errorLine (depth = 11)
  int op_slot_left_3211 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3212;
  partcv[0] = 1;
  Object opresult3214 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 10)
  gc_frame_newslot(opresult3214);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lineNumber;
  params[1] = opresult3214;
  partcv[0] = 2;
  Object call3215 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3210);
// compiled call node returning call3215 (depth = 9)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3216 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3218 = alloc_Float64(1);
// compiled num node returning num3218 (depth = 11)
  int op_slot_right_3217 = gc_frame_newslot(num3218);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  int op_slot_left_3217 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3218;
  partcv[0] = 1;
  Object sum3220 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3220 (depth = 10)
  gc_frame_newslot(sum3220);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextLine (depth = 11)
  int op_slot_right_3221 = gc_frame_newslot(*var_nextLine);
// starting to compile string node (depth = 11)
  if (strlit3223 == NULL) {
    strlit3223 = alloc_String("    ++ ""\x22""");
    gc_root(strlit3223);
  }
// compiled string node returning strlit3223 (depth = 11)
  int op_slot_left_3221 = gc_frame_newslot(strlit3223);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3224 = callmethod(strlit3223, "++", 1, partcv, params);
// compiled op node returning opresult3224 (depth = 10)
  gc_frame_newslot(opresult3224);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum3220;
  params[1] = opresult3224;
  partcv[0] = 2;
  Object call3225 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3216);
// compiled call node returning call3225 (depth = 9)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3226 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3227 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3226);
// compiled call node returning call3227 (depth = 9)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3228 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call3230 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3229);
// compiled call node returning call3230 (depth = 13)
// compiled member node returning call3230 (depth = 12)
  partcv[0] = 0;
  Object call3231 = callmethod(call3230, "new",
    1, partcv, params);
  gc_frame_end(callframe3228);
// compiled call node returning call3231 (depth = 11)
// compiled member node returning call3231 (depth = 10)
  *var_suggestion = call3231;
  if (call3231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3233 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextLine (depth = 11)
  int op_slot_right_3234 = gc_frame_newslot(*var_nextLine);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("\\n");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 12)
  int op_slot_right_3236 = gc_frame_newslot(strlit3237);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3236 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3237;
  partcv[0] = 1;
  Object opresult3239 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3239 (depth = 11)
  int op_slot_left_3234 = gc_frame_newslot(opresult3239);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3240 = callmethod(opresult3239, "++", 1, partcv, params);
// compiled op node returning opresult3240 (depth = 10)
  gc_frame_newslot(opresult3240);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lineNumber;
  params[1] = opresult3240;
  partcv[0] = 2;
  Object call3241 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3233);
// compiled call node returning call3241 (depth = 9)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3242 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3244 = alloc_Float64(1);
// compiled num node returning num3244 (depth = 11)
  int op_slot_right_3243 = gc_frame_newslot(num3244);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  int op_slot_left_3243 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3244;
  partcv[0] = 1;
  Object sum3246 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3246 (depth = 10)
  gc_frame_newslot(sum3246);
// starting to compile string node (depth = 10)
  if (strlit3247 == NULL) {
    strlit3247 = alloc_String("");
    gc_root(strlit3247);
  }
// compiled string node returning strlit3247 (depth = 10)
  gc_frame_newslot(strlit3247);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum3246;
  params[1] = strlit3247;
  partcv[0] = 2;
  Object call3248 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3242);
// compiled call node returning call3248 (depth = 9)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3249 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3250 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3249);
// compiled call node returning call3250 (depth = 9)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3251 = gc_frame_new();
// starting to compile op node (depth = 10)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3253 == NULL) {
    strlit3253 = alloc_String("To split a string over multiple lines use '++' to join strings together.");
    gc_root(strlit3253);
  }
// compiled string node returning strlit3253 (depth = 11)
  int op_slot_right_3252 = gc_frame_newslot(strlit3253);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3255 == NULL) {
    strlit3255 = alloc_String("A string must end with a '""\x22""'. To insert a newline in a string use '\\n'. ");
    gc_root(strlit3255);
  }
// compiled string node returning strlit3255 (depth = 11)
  int op_slot_left_3252 = gc_frame_newslot(strlit3255);
  params[0] = strlit3253;
  partcv[0] = 1;
  Object opresult3256 = callmethod(strlit3255, "++", 1, partcv, params);
// compiled op node returning opresult3256 (depth = 10)
  gc_frame_newslot(opresult3256);
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = opresult3256;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3257 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3251);
// compiled call node returning call3257 (depth = 9)
    gc_frame_newslot(call3257);
    if3177 = call3257;
  } else {
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3258 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call3260 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3259);
// compiled call node returning call3260 (depth = 13)
// compiled member node returning call3260 (depth = 12)
  partcv[0] = 0;
  Object call3261 = callmethod(call3260, "new",
    1, partcv, params);
  gc_frame_end(callframe3258);
// compiled call node returning call3261 (depth = 11)
// compiled member node returning call3261 (depth = 10)
  *var_suggestion = call3261;
  if (call3261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3262 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3264 == NULL) {
    strlit3264 = alloc_String("""\x22""");
    gc_root(strlit3264);
  }
// compiled string node returning strlit3264 (depth = 11)
  int op_slot_right_3263 = gc_frame_newslot(strlit3264);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errorLine (depth = 11)
  int op_slot_left_3263 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3264;
  partcv[0] = 1;
  Object opresult3266 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3266 (depth = 10)
  gc_frame_newslot(opresult3266);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lineNumber;
  params[1] = opresult3266;
  partcv[0] = 2;
  Object call3267 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3262);
// compiled call node returning call3267 (depth = 9)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3268 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit3269 == NULL) {
    strlit3269 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3269);
  }
// compiled string node returning strlit3269 (depth = 10)
  gc_frame_newslot(strlit3269);
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit3269;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3270 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3268);
// compiled call node returning call3270 (depth = 9)
    gc_frame_newslot(call3270);
    if3177 = call3270;
  }
// compiled if node returning if3177 (depth = 8)
    gc_frame_newslot(if3177);
    if3002 = if3177;
  }
// compiled if node returning if3002 (depth = 7)
    gc_frame_newslot(if3002);
    if2997 = if3002;
  } else {
  }
// compiled if node returning if2997 (depth = 6)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_escaped (depth = 7)
  Object if3271 = done;
  if (istrue(*var_escaped)) {
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3274 == NULL) {
    strlit3274 = alloc_String("n");
    gc_root(strlit3274);
  }
// compiled string node returning strlit3274 (depth = 9)
  int op_slot_right_3273 = gc_frame_newslot(strlit3274);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_3273 = gc_frame_newslot(*var_c);
  params[0] = strlit3274;
  partcv[0] = 1;
  Object opresult3276 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3276 (depth = 8)
  Object if3272 = done;
  if (istrue(opresult3276)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3278 == NULL) {
    strlit3278 = alloc_String("""\x0a""");
    gc_root(strlit3278);
  }
// compiled string node returning strlit3278 (depth = 10)
  int op_slot_right_3277 = gc_frame_newslot(strlit3278);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_3277 = gc_frame_newslot(*var_accum);
  params[0] = strlit3278;
  partcv[0] = 1;
  Object opresult3280 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3280 (depth = 9)
  *var_accum = opresult3280;
  if (opresult3280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3272 = done;
  } else {
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3284 == NULL) {
    strlit3284 = alloc_String("u");
    gc_root(strlit3284);
  }
// compiled string node returning strlit3284 (depth = 10)
  int op_slot_right_3283 = gc_frame_newslot(strlit3284);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3283 = gc_frame_newslot(*var_c);
  params[0] = strlit3284;
  partcv[0] = 1;
  Object opresult3286 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3286 (depth = 9)
  Object if3282 = done;
  if (istrue(opresult3286)) {
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3287 = alloc_Float64(4);
// compiled num node returning num3287 (depth = 10)
  *var_unichars = num3287;
  if (num3287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3289 = alloc_Float64(0);
// compiled num node returning num3289 (depth = 10)
  *var_codepoint = num3289;
  if (num3289 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3282 = done;
  } else {
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3293 == NULL) {
    strlit3293 = alloc_String("U");
    gc_root(strlit3293);
  }
// compiled string node returning strlit3293 (depth = 11)
  int op_slot_right_3292 = gc_frame_newslot(strlit3293);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3292 = gc_frame_newslot(*var_c);
  params[0] = strlit3293;
  partcv[0] = 1;
  Object opresult3295 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3295 (depth = 10)
  Object if3291 = done;
  if (istrue(opresult3295)) {
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3296 = alloc_Float64(6);
// compiled num node returning num3296 (depth = 11)
  *var_unichars = num3296;
  if (num3296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3298 = alloc_Float64(0);
// compiled num node returning num3298 (depth = 11)
  *var_codepoint = num3298;
  if (num3298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3291 = done;
  } else {
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3302 == NULL) {
    strlit3302 = alloc_String("t");
    gc_root(strlit3302);
  }
// compiled string node returning strlit3302 (depth = 12)
  int op_slot_right_3301 = gc_frame_newslot(strlit3302);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3301 = gc_frame_newslot(*var_c);
  params[0] = strlit3302;
  partcv[0] = 1;
  Object opresult3304 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3304 (depth = 11)
  Object if3300 = done;
  if (istrue(opresult3304)) {
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3306 == NULL) {
    strlit3306 = alloc_String("""\x09""");
    gc_root(strlit3306);
  }
// compiled string node returning strlit3306 (depth = 13)
  int op_slot_right_3305 = gc_frame_newslot(strlit3306);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_3305 = gc_frame_newslot(*var_accum);
  params[0] = strlit3306;
  partcv[0] = 1;
  Object opresult3308 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3308 (depth = 12)
  *var_accum = opresult3308;
  if (opresult3308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3300 = done;
  } else {
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3312 == NULL) {
    strlit3312 = alloc_String("r");
    gc_root(strlit3312);
  }
// compiled string node returning strlit3312 (depth = 13)
  int op_slot_right_3311 = gc_frame_newslot(strlit3312);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_3311 = gc_frame_newslot(*var_c);
  params[0] = strlit3312;
  partcv[0] = 1;
  Object opresult3314 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3314 (depth = 12)
  Object if3310 = done;
  if (istrue(opresult3314)) {
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3316 == NULL) {
    strlit3316 = alloc_String("""\x0d""");
    gc_root(strlit3316);
  }
// compiled string node returning strlit3316 (depth = 14)
  int op_slot_right_3315 = gc_frame_newslot(strlit3316);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_3315 = gc_frame_newslot(*var_accum);
  params[0] = strlit3316;
  partcv[0] = 1;
  Object opresult3318 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3318 (depth = 13)
  *var_accum = opresult3318;
  if (opresult3318 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3310 = done;
  } else {
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3322 == NULL) {
    strlit3322 = alloc_String("b");
    gc_root(strlit3322);
  }
// compiled string node returning strlit3322 (depth = 14)
  int op_slot_right_3321 = gc_frame_newslot(strlit3322);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_3321 = gc_frame_newslot(*var_c);
  params[0] = strlit3322;
  partcv[0] = 1;
  Object opresult3324 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3324 (depth = 13)
  Object if3320 = done;
  if (istrue(opresult3324)) {
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit3326 == NULL) {
    strlit3326 = alloc_String("""\x08""");
    gc_root(strlit3326);
  }
// compiled string node returning strlit3326 (depth = 15)
  int op_slot_right_3325 = gc_frame_newslot(strlit3326);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_3325 = gc_frame_newslot(*var_accum);
  params[0] = strlit3326;
  partcv[0] = 1;
  Object opresult3328 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3328 (depth = 14)
  *var_accum = opresult3328;
  if (opresult3328 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if3320 = done;
  } else {
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit3332 == NULL) {
    strlit3332 = alloc_String("l");
    gc_root(strlit3332);
  }
// compiled string node returning strlit3332 (depth = 15)
  int op_slot_right_3331 = gc_frame_newslot(strlit3332);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_3331 = gc_frame_newslot(*var_c);
  params[0] = strlit3332;
  partcv[0] = 1;
  Object opresult3334 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3334 (depth = 14)
  Object if3330 = done;
  if (istrue(opresult3334)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit3336 == NULL) {
    strlit3336 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit3336);
  }
// compiled string node returning strlit3336 (depth = 16)
  int op_slot_right_3335 = gc_frame_newslot(strlit3336);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_3335 = gc_frame_newslot(*var_accum);
  params[0] = strlit3336;
  partcv[0] = 1;
  Object opresult3338 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3338 (depth = 15)
  *var_accum = opresult3338;
  if (opresult3338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if3330 = done;
  } else {
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit3342 == NULL) {
    strlit3342 = alloc_String("f");
    gc_root(strlit3342);
  }
// compiled string node returning strlit3342 (depth = 16)
  int op_slot_right_3341 = gc_frame_newslot(strlit3342);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_3341 = gc_frame_newslot(*var_c);
  params[0] = strlit3342;
  partcv[0] = 1;
  Object opresult3344 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3344 (depth = 15)
  Object if3340 = done;
  if (istrue(opresult3344)) {
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 15)
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit3346 == NULL) {
    strlit3346 = alloc_String("""\x0c""");
    gc_root(strlit3346);
  }
// compiled string node returning strlit3346 (depth = 17)
  int op_slot_right_3345 = gc_frame_newslot(strlit3346);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_3345 = gc_frame_newslot(*var_accum);
  params[0] = strlit3346;
  partcv[0] = 1;
  Object opresult3348 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3348 (depth = 16)
  *var_accum = opresult3348;
  if (opresult3348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 15)
    gc_frame_newslot(done);
    if3340 = done;
  } else {
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 15)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit3352 == NULL) {
    strlit3352 = alloc_String("e");
    gc_root(strlit3352);
  }
// compiled string node returning strlit3352 (depth = 17)
  int op_slot_right_3351 = gc_frame_newslot(strlit3352);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_c (depth = 17)
  int op_slot_left_3351 = gc_frame_newslot(*var_c);
  params[0] = strlit3352;
  partcv[0] = 1;
  Object opresult3354 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3354 (depth = 16)
  Object if3350 = done;
  if (istrue(opresult3354)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 16)
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit3356 == NULL) {
    strlit3356 = alloc_String("""\x1b""");
    gc_root(strlit3356);
  }
// compiled string node returning strlit3356 (depth = 18)
  int op_slot_right_3355 = gc_frame_newslot(strlit3356);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_3355 = gc_frame_newslot(*var_accum);
  params[0] = strlit3356;
  partcv[0] = 1;
  Object opresult3358 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3358 (depth = 17)
  *var_accum = opresult3358;
  if (opresult3358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 16)
    gc_frame_newslot(done);
    if3350 = done;
  } else {
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 16)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit3362 == NULL) {
    strlit3362 = alloc_String("_");
    gc_root(strlit3362);
  }
// compiled string node returning strlit3362 (depth = 18)
  int op_slot_right_3361 = gc_frame_newslot(strlit3362);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  int op_slot_left_3361 = gc_frame_newslot(*var_c);
  params[0] = strlit3362;
  partcv[0] = 1;
  Object opresult3364 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3364 (depth = 17)
  Object if3360 = done;
  if (istrue(opresult3364)) {
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 17)
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit3366 == NULL) {
    strlit3366 = alloc_String("""\xc2""""\xa0""");
    gc_root(strlit3366);
  }
// compiled string node returning strlit3366 (depth = 19)
  int op_slot_right_3365 = gc_frame_newslot(strlit3366);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  int op_slot_left_3365 = gc_frame_newslot(*var_accum);
  params[0] = strlit3366;
  partcv[0] = 1;
  Object opresult3368 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3368 (depth = 18)
  *var_accum = opresult3368;
  if (opresult3368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 17)
    gc_frame_newslot(done);
    if3360 = done;
  } else {
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 17)
// starting to compile op node (depth = 18)
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  int op_slot_right_3370 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  int op_slot_left_3370 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3372 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3372 (depth = 18)
  *var_accum = opresult3372;
  if (opresult3372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 17)
    gc_frame_newslot(done);
    if3360 = done;
  }
// compiled if node returning if3360 (depth = 16)
    gc_frame_newslot(if3360);
    if3350 = if3360;
  }
// compiled if node returning if3350 (depth = 15)
    gc_frame_newslot(if3350);
    if3340 = if3350;
  }
// compiled if node returning if3340 (depth = 14)
    gc_frame_newslot(if3340);
    if3330 = if3340;
  }
// compiled if node returning if3330 (depth = 13)
    gc_frame_newslot(if3330);
    if3320 = if3330;
  }
// compiled if node returning if3320 (depth = 12)
    gc_frame_newslot(if3320);
    if3310 = if3320;
  }
// compiled if node returning if3310 (depth = 11)
    gc_frame_newslot(if3310);
    if3300 = if3310;
  }
// compiled if node returning if3300 (depth = 10)
    gc_frame_newslot(if3300);
    if3291 = if3300;
  }
// compiled if node returning if3291 (depth = 9)
    gc_frame_newslot(if3291);
    if3282 = if3291;
  }
// compiled if node returning if3282 (depth = 8)
    gc_frame_newslot(if3282);
    if3272 = if3282;
  }
// compiled if node returning if3272 (depth = 7)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3374 = alloc_Boolean(0);
// compiled identifier node returning bool3374 (depth = 8)
  *var_escaped = bool3374;
  if (bool3374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3271 = done;
  } else {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3378 == NULL) {
    strlit3378 = alloc_String("\\");
    gc_root(strlit3378);
  }
// compiled string node returning strlit3378 (depth = 9)
  int op_slot_right_3377 = gc_frame_newslot(strlit3378);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_3377 = gc_frame_newslot(*var_c);
  params[0] = strlit3378;
  partcv[0] = 1;
  Object opresult3380 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3380 (depth = 8)
  Object if3376 = done;
  if (istrue(opresult3380)) {
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3381 = alloc_Boolean(1);
// compiled identifier node returning bool3381 (depth = 9)
  *var_escaped = bool3381;
  if (bool3381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3376 = done;
  } else {
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3385 = alloc_Float64(0);
// compiled num node returning num3385 (depth = 10)
  int op_slot_right_3384 = gc_frame_newslot(num3385);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_unichars (depth = 10)
  int op_slot_left_3384 = gc_frame_newslot(*var_unichars);
  params[0] = num3385;
  partcv[0] = 1;
  Object opresult3387 = callmethod(*var_unichars, ">", 1, partcv, params);
// compiled op node returning opresult3387 (depth = 9)
  Object if3383 = done;
  if (istrue(opresult3387)) {
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3389 = alloc_Float64(1);
// compiled num node returning num3389 (depth = 11)
  int op_slot_right_3388 = gc_frame_newslot(num3389);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unichars (depth = 11)
  int op_slot_left_3388 = gc_frame_newslot(*var_unichars);
  params[0] = num3389;
  partcv[0] = 1;
  Object diff3391 = callmethod(*var_unichars, "-", 1, partcv, params);
// compiled op node returning diff3391 (depth = 10)
  *var_unichars = diff3391;
  if (diff3391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3394 = alloc_Float64(16);
// compiled num node returning num3394 (depth = 11)
  int op_slot_right_3393 = gc_frame_newslot(num3394);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_codepoint (depth = 11)
  int op_slot_left_3393 = gc_frame_newslot(*var_codepoint);
  params[0] = num3394;
  partcv[0] = 1;
  Object prod3396 = callmethod(*var_codepoint, "*", 1, partcv, params);
// compiled op node returning prod3396 (depth = 10)
  *var_codepoint = prod3396;
  if (prod3396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3399 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3400 = callmethodflags(self, "hexdecchar", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3399);
// compiled call node returning call3400 (depth = 11)
  int op_slot_right_3398 = gc_frame_newslot(call3400);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_codepoint (depth = 11)
  int op_slot_left_3398 = gc_frame_newslot(*var_codepoint);
  params[0] = call3400;
  partcv[0] = 1;
  Object sum3402 = callmethod(*var_codepoint, "+", 1, partcv, params);
// compiled op node returning sum3402 (depth = 10)
  *var_codepoint = sum3402;
  if (sum3402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3406 = alloc_Float64(0);
// compiled num node returning num3406 (depth = 11)
  int op_slot_right_3405 = gc_frame_newslot(num3406);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unichars (depth = 11)
  int op_slot_left_3405 = gc_frame_newslot(*var_unichars);
  params[0] = num3406;
  partcv[0] = 1;
  Object opresult3408 = callmethod(*var_unichars, "==", 1, partcv, params);
// compiled op node returning opresult3408 (depth = 10)
  Object if3404 = done;
  if (istrue(opresult3408)) {
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3410 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_codepoint (depth = 13)
  gc_frame_newslot(*var_codepoint);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_codepoint;
  partcv[0] = 1;
  Object call3411 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe3410);
// compiled call node returning call3411 (depth = 12)
  int op_slot_right_3409 = gc_frame_newslot(call3411);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_3409 = gc_frame_newslot(*var_accum);
  params[0] = call3411;
  partcv[0] = 1;
  Object opresult3413 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3413 (depth = 11)
  *var_accum = opresult3413;
  if (opresult3413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3404 = done;
  } else {
  }
// compiled if node returning if3404 (depth = 9)
    gc_frame_newslot(if3404);
    if3383 = if3404;
  } else {
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3417 == NULL) {
    strlit3417 = alloc_String("{");
    gc_root(strlit3417);
  }
// compiled string node returning strlit3417 (depth = 11)
  int op_slot_right_3416 = gc_frame_newslot(strlit3417);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3416 = gc_frame_newslot(*var_c);
  params[0] = strlit3417;
  partcv[0] = 1;
  Object opresult3419 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3419 (depth = 10)
  Object if3415 = done;
  if (istrue(opresult3419)) {
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_interpString (depth = 13)
  partcv[0] = 0;
  Object call3422 = callmethod(*var_interpString, "not",
    1, partcv, params);
  gc_frame_end(callframe3421);
// compiled call node returning call3422 (depth = 12)
// compiled member node returning call3422 (depth = 11)
  Object if3420 = done;
  if (istrue(call3422)) {
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3423 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 12)
  if (strlit3424 == NULL) {
    strlit3424 = alloc_String("(");
    gc_root(strlit3424);
  }
// compiled string node returning strlit3424 (depth = 12)
  gc_frame_newslot(strlit3424);
// starting to compile string node (depth = 12)
  if (strlit3425 == NULL) {
    strlit3425 = alloc_String("(");
    gc_root(strlit3425);
  }
// compiled string node returning strlit3425 (depth = 12)
  gc_frame_newslot(strlit3425);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3424;
  params[2] = strlit3425;
  partcv[0] = 3;
  Object call3426 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3423);
// compiled call node returning call3426 (depth = 11)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool3427 = alloc_Boolean(1);
// compiled identifier node returning bool3427 (depth = 12)
  *var_interpString = bool3427;
  if (bool3427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3420 = done;
  } else {
  }
// compiled if node returning if3420 (depth = 10)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3429 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3430 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3429);
// compiled call node returning call3430 (depth = 10)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3431 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 11)
  if (strlit3432 == NULL) {
    strlit3432 = alloc_String("o");
    gc_root(strlit3432);
  }
// compiled string node returning strlit3432 (depth = 11)
  gc_frame_newslot(strlit3432);
// starting to compile string node (depth = 11)
  if (strlit3433 == NULL) {
    strlit3433 = alloc_String("++");
    gc_root(strlit3433);
  }
// compiled string node returning strlit3433 (depth = 11)
  gc_frame_newslot(strlit3433);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3432;
  params[2] = strlit3433;
  partcv[0] = 3;
  Object call3434 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3431);
// compiled call node returning call3434 (depth = 10)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3435 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 11)
  if (strlit3436 == NULL) {
    strlit3436 = alloc_String("(");
    gc_root(strlit3436);
  }
// compiled string node returning strlit3436 (depth = 11)
  gc_frame_newslot(strlit3436);
// starting to compile string node (depth = 11)
  if (strlit3437 == NULL) {
    strlit3437 = alloc_String("(");
    gc_root(strlit3437);
  }
// compiled string node returning strlit3437 (depth = 11)
  gc_frame_newslot(strlit3437);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3436;
  params[2] = strlit3437;
  partcv[0] = 3;
  Object call3438 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled call node returning call3438 (depth = 10)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3439 == NULL) {
    strlit3439 = alloc_String("n");
    gc_root(strlit3439);
  }
// compiled string node returning strlit3439 (depth = 11)
  *var_mode = strlit3439;
  if (strlit3439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3441 == NULL) {
    strlit3441 = alloc_String("n");
    gc_root(strlit3441);
  }
// compiled string node returning strlit3441 (depth = 11)
  *var_newmode = strlit3441;
  if (strlit3441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3443 == NULL) {
    strlit3443 = alloc_String("");
    gc_root(strlit3443);
  }
// compiled string node returning strlit3443 (depth = 11)
  *var_accum = strlit3443;
  if (strlit3443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool3445 = alloc_Boolean(0);
// compiled identifier node returning bool3445 (depth = 11)
  *var_inStr = bool3445;
  if (bool3445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3448 = alloc_Float64(1);
// compiled num node returning num3448 (depth = 12)
  int op_slot_right_3447 = gc_frame_newslot(num3448);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_interpdepth (depth = 12)
  int op_slot_left_3447 = gc_frame_newslot(*var_interpdepth);
  params[0] = num3448;
  partcv[0] = 1;
  Object sum3450 = callmethod(*var_interpdepth, "+", 1, partcv, params);
// compiled op node returning sum3450 (depth = 11)
  *var_interpdepth = sum3450;
  if (sum3450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3415 = done;
  } else {
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_right_3452 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_3452 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3454 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3454 (depth = 11)
  *var_accum = opresult3454;
  if (opresult3454 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3415 = done;
  }
// compiled if node returning if3415 (depth = 9)
    gc_frame_newslot(if3415);
    if3383 = if3415;
  }
// compiled if node returning if3383 (depth = 8)
    gc_frame_newslot(if3383);
    if3376 = if3383;
  }
// compiled if node returning if3376 (depth = 7)
    gc_frame_newslot(if3376);
    if3271 = if3376;
  }
// compiled if node returning if3271 (depth = 6)
    gc_frame_newslot(if3271);
    if2992 = if3271;
  } else {
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3458 == NULL) {
    strlit3458 = alloc_String("""\x0a""");
    gc_root(strlit3458);
  }
// compiled string node returning strlit3458 (depth = 8)
  int op_slot_right_3457 = gc_frame_newslot(strlit3458);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_3457 = gc_frame_newslot(*var_c);
  params[0] = strlit3458;
  partcv[0] = 1;
  Object opresult3460 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3460 (depth = 7)
  Object if3456 = done;
  if (istrue(opresult3460)) {
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3461 = alloc_Boolean(1);
// compiled identifier node returning bool3461 (depth = 8)
  *var_newlineFound = bool3461;
  if (bool3461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3465 == NULL) {
    strlit3465 = alloc_String("q");
    gc_root(strlit3465);
  }
// compiled string node returning strlit3465 (depth = 9)
  int op_slot_right_3464 = gc_frame_newslot(strlit3465);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_3464 = gc_frame_newslot(*var_mode);
  params[0] = strlit3465;
  partcv[0] = 1;
  Object opresult3467 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3467 (depth = 8)
  Object if3463 = done;
  if (istrue(opresult3467)) {
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_right_3468 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_3468 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3470 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3470 (depth = 9)
  *var_accum = opresult3470;
  if (opresult3470 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3463 = done;
  } else {
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3472 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3473 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3472);
// compiled call node returning call3473 (depth = 8)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3474 == NULL) {
    strlit3474 = alloc_String("d");
    gc_root(strlit3474);
  }
// compiled string node returning strlit3474 (depth = 9)
  *var_mode = strlit3474;
  if (strlit3474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3476 == NULL) {
    strlit3476 = alloc_String("d");
    gc_root(strlit3476);
  }
// compiled string node returning strlit3476 (depth = 9)
  *var_newmode = strlit3476;
  if (strlit3476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 9)
  *var_accum = strlit3478;
  if (strlit3478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3463 = done;
  }
// compiled if node returning if3463 (depth = 7)
    gc_frame_newslot(if3463);
    if3456 = if3463;
  } else {
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_right_3480 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_3480 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3482 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3482 (depth = 8)
  *var_accum = opresult3482;
  if (opresult3482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3456 = done;
  }
// compiled if node returning if3456 (depth = 6)
    gc_frame_newslot(if3456);
    if2992 = if3456;
  }
// compiled if node returning if2992 (depth = 5)
    gc_frame_newslot(if2992);
    if2917 = if2992;
  }
// compiled if node returning if2917 (depth = 4)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3486 == NULL) {
    strlit3486 = alloc_String("...");
    gc_root(strlit3486);
  }
// compiled string node returning strlit3486 (depth = 6)
  int op_slot_right_3485 = gc_frame_newslot(strlit3486);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_accum (depth = 6)
  int op_slot_left_3485 = gc_frame_newslot(*var_accum);
  params[0] = strlit3486;
  partcv[0] = 1;
  Object opresult3488 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult3488 (depth = 5)
  Object if3484 = done;
  if (istrue(opresult3488)) {
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3491 == NULL) {
    strlit3491 = alloc_String("o");
    gc_root(strlit3491);
  }
// compiled string node returning strlit3491 (depth = 7)
  int op_slot_right_3490 = gc_frame_newslot(strlit3491);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_3490 = gc_frame_newslot(*var_mode);
  params[0] = strlit3491;
  partcv[0] = 1;
  Object opresult3493 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3493 (depth = 6)
  Object if3489 = done;
  if (istrue(opresult3493)) {
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3494 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 7)
  if (strlit3495 == NULL) {
    strlit3495 = alloc_String("i");
    gc_root(strlit3495);
  }
// compiled string node returning strlit3495 (depth = 7)
  gc_frame_newslot(strlit3495);
// starting to compile string node (depth = 7)
  if (strlit3496 == NULL) {
    strlit3496 = alloc_String("...");
    gc_root(strlit3496);
  }
// compiled string node returning strlit3496 (depth = 7)
  gc_frame_newslot(strlit3496);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3495;
  params[2] = strlit3496;
  partcv[0] = 3;
  Object call3497 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3494);
// compiled call node returning call3497 (depth = 6)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3498 == NULL) {
    strlit3498 = alloc_String("n");
    gc_root(strlit3498);
  }
// compiled string node returning strlit3498 (depth = 7)
  *var_newmode = strlit3498;
  if (strlit3498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newmode (depth = 7)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3501 == NULL) {
    strlit3501 = alloc_String("");
    gc_root(strlit3501);
  }
// compiled string node returning strlit3501 (depth = 7)
  *var_accum = strlit3501;
  if (strlit3501 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3489 = done;
  } else {
  }
// compiled if node returning if3489 (depth = 5)
    gc_frame_newslot(if3489);
    if3484 = if3489;
  } else {
  }
// compiled if node returning if3484 (depth = 4)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newlineFound (depth = 5)
  Object if3503 = done;
  if (istrue(*var_newlineFound)) {
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3504 = alloc_Boolean(0);
// compiled identifier node returning bool3504 (depth = 6)
  *var_newlineFound = bool3504;
  if (bool3504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3507 = alloc_Float64(1);
// compiled num node returning num3507 (depth = 7)
  int op_slot_right_3506 = gc_frame_newslot(num3507);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  int op_slot_left_3506 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3507;
  partcv[0] = 1;
  Object sum3509 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3509 (depth = 6)
  *var_lineNumber = sum3509;
  if (sum3509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3511 = alloc_Float64(0);
// compiled num node returning num3511 (depth = 6)
  *var_linePosition = num3511;
  if (num3511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3513 = alloc_Float64(1);
// compiled num node returning num3513 (depth = 6)
  *var_startPosition = num3513;
  if (num3513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3503 = done;
  } else {
  }
// compiled if node returning if3503 (depth = 4)
  gc_frame_end(frame);
  return if3503;
}
Object meth_lexer__apply3521(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_mode = getfromclosure(closure, 1);
  Object *var_mainBlock = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3523 = alloc_Float64(1);
// compiled num node returning num3523 (depth = 8)
  int op_slot_right_3522 = gc_frame_newslot(num3523);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_3522 = gc_frame_newslot(*var_linePosition);
  params[0] = num3523;
  partcv[0] = 1;
  Object sum3525 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3525 (depth = 7)
  *var_linePosition = sum3525;
  if (sum3525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String(" ");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 8)
  int op_slot_right_3528 = gc_frame_newslot(strlit3529);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ch (depth = 8)
  int op_slot_left_3528 = gc_frame_newslot(*var_ch);
  params[0] = strlit3529;
  partcv[0] = 1;
  Object opresult3531 = callmethod(*var_ch, "==", 1, partcv, params);
// compiled op node returning opresult3531 (depth = 7)
  Object if3527 = done;
  if (istrue(opresult3531)) {
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3534 == NULL) {
    strlit3534 = alloc_String("d");
    gc_root(strlit3534);
  }
// compiled string node returning strlit3534 (depth = 9)
  int op_slot_right_3533 = gc_frame_newslot(strlit3534);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_3533 = gc_frame_newslot(*var_mode);
  params[0] = strlit3534;
  partcv[0] = 1;
  Object opresult3536 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 8)
  Object if3532 = done;
  if (istrue(opresult3536)) {
    gc_frame_newslot(done);
    if3532 = done;
  } else {
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3539 == NULL) {
    strlit3539 = alloc_String("n");
    gc_root(strlit3539);
  }
// compiled string node returning strlit3539 (depth = 10)
  int op_slot_right_3538 = gc_frame_newslot(strlit3539);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_3538 = gc_frame_newslot(*var_mode);
  params[0] = strlit3539;
  partcv[0] = 1;
  Object opresult3541 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult3541 (depth = 9)
  Object if3537 = done;
  if (istrue(opresult3541)) {
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3542 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ch (depth = 10)
  gc_frame_newslot(*var_ch);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mainBlock (depth = 10)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call3543 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3542);
// compiled call node returning call3543 (depth = 9)
    gc_frame_newslot(call3543);
    if3537 = call3543;
  } else {
  }
// compiled if node returning if3537 (depth = 8)
    gc_frame_newslot(if3537);
    if3532 = if3537;
  }
// compiled if node returning if3532 (depth = 7)
    gc_frame_newslot(if3532);
    if3527 = if3532;
  } else {
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3544 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ch (depth = 8)
  gc_frame_newslot(*var_ch);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mainBlock (depth = 8)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call3545 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3544);
// compiled call node returning call3545 (depth = 7)
    gc_frame_newslot(call3545);
    if3527 = call3545;
  }
// compiled if node returning if3527 (depth = 6)
  gc_frame_end(frame);
  return if3527;
}
Object meth_lexer__apply3518(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_mode = getfromclosure(closure, 1);
  Object *var_mainBlock = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_eachLine = &(stackframe->slots[0]);
  *var_eachLine = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3519 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_eachLine (depth = 5)
  gc_frame_newslot(*var_eachLine);
// starting to compile block node (depth = 5)
  Object block3520 = alloc_Block(NULL, NULL, "lexer", 1094);
  gc_frame_newslot(block3520);
// method _apply
  block_savedest(block3520);
  Object closure3521 = createclosure(4, "_apply");
  setclosureframe(closure3521, stackframe);
  addtoclosure(closure3521, var_linePosition);
  addtoclosure(closure3521, var_mode);
  addtoclosure(closure3521, var_mainBlock);
  addtoclosure(closure3521, selfslot);
  struct UserObject *uo3521 = (struct UserObject*)block3520;
  uo3521->data[0] = (Object)closure3521;
  Method *meth_meth_lexer__apply3521 = addmethod2pos(block3520, "_apply", &meth_lexer__apply3521, 0);
  int argcv_meth_lexer__apply3521[] = {1};
  meth_meth_lexer__apply3521->type = alloc_MethodType(1, argcv_meth_lexer__apply3521);
  meth_meth_lexer__apply3521->definitionModule = modulename;
  meth_meth_lexer__apply3521->definitionLine = 1045;
// compiled block node returning block3520 (depth = 5)
  gc_frame_newslot(block3520);
// call case 5: prelude request
  params[0] = *var_eachLine;
  params[1] = block3520;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3547 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3519);
// compiled call node returning call3547 (depth = 4)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3548 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3549 == NULL) {
    strlit3549 = alloc_String("""\x0a""");
    gc_root(strlit3549);
  }
// compiled string node returning strlit3549 (depth = 5)
  gc_frame_newslot(strlit3549);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mainBlock (depth = 5)
  params[0] = strlit3549;
  partcv[0] = 1;
  Object call3550 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3548);
// compiled call node returning call3550 (depth = 4)
  gc_frame_end(frame);
  return call3550;
}
Object meth_lexer_lexinput1915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(26, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexinput");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexinput");
  Object params[14];
  int partcv[3];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object *var_stringStart = getfromclosure(closure, 5);
  Object *var_startLine = getfromclosure(closure, 6);
  Object *var_startPosition = getfromclosure(closure, 7);
  Object *var_eofToken = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexinput (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_inputLines = &(stackframe->slots[0]);
  *var_inputLines = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexinput");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tokens");
  Object *var_mode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "mode");
  Object *var_newmode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newmode");
  Object *var_inStr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "inStr");
  Object *var_inBackticks = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inBackticks");
  Object *var_backtickIdent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "backtickIdent");
  Object *var_accum = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "accum");
  Object *var_escaped = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "escaped");
  Object *var_unichars = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "unichars");
  Object *var_codepoint = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "codepoint");
  Object *var_interpdepth = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "interpdepth");
  Object *var_interpString = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "interpString");
  Object *var_atStart = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "atStart");
  Object *var_newlineFound = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "newlineFound");
  Object *var_badSeparator = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "badSeparator");
  Object *var_badControl = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "badControl");
  Object *var_selfModes = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "selfModes");
  Object *var_brackets = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "brackets");
  Object *var_identifierChar = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "identifierChar");
  Object *var_digit = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "digit");
  Object *var_operatorChar = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "operatorChar");
  Object *var_iGTLT = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "iGTLT");
  Object *var_mainBlock = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "mainBlock");
  Object *var_suggestion = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "suggestion");
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1916 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1916 = alloc_userobj2(13,11, objclass1916);
  gc_frame_newslot(obj1916);
// OBJECT OUTER DEC outer
  adddatum2(obj1916, self, 0);
  addmethodreal(obj1916,"outer", &reader_lexer_outer_1917);
  Object oldself1916 = self;
  struct StackFrameObject *oldstackframe1916 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1916);
  gc_frame_newslot((Object)stackframe);
  self = obj1916;
  Object *oldselfslot1916 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1916 = (*(struct UserObject *)self).data[0], lowerouter1916 = thisouter1916;
  if (inheritingObject1916) {
    struct UserObject *inho1916 = (struct UserObject *)inheritingObject1916;
    while (inho1916->super != GraceDefaultObject) inho1916 = (struct UserObject *)inho1916->super;
    inho1916->super = obj1916;
    self = inheritingObject1916;
    *selfslot = self;
    lowerouter1916 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1916;
  }
if (objclass1916 == NULL) {
  Method *reader1918 = addmethodrealflags(obj1916, "first",&reader_lexer_first_1918, 0);
  Method *writer1918 = addmethodrealflags(obj1916, "first:=",&writer_lexer_first_1918, MFLAG_CONFIDENTIAL);
  reader1918->definitionModule = modulename;
  writer1918->definitionModule = modulename;
  reader1918->definitionLine = 579;
  writer1918->definitionLine = 579;
}
obj1916->flags |= OFLAG_MUTABLE;
adddatum2(obj1916, alloc_Undefined(), 1);
if (objclass1916 == NULL) {
  Method *reader1919 = addmethodrealflags(obj1916, "last",&reader_lexer_last_1919, 0);
  Method *writer1919 = addmethodrealflags(obj1916, "last:=",&writer_lexer_last_1919, MFLAG_CONFIDENTIAL);
  reader1919->definitionModule = modulename;
  writer1919->definitionModule = modulename;
  reader1919->definitionLine = 580;
  writer1919->definitionLine = 580;
}
obj1916->flags |= OFLAG_MUTABLE;
adddatum2(obj1916, alloc_Undefined(), 2);
if (objclass1916 == NULL) {
  Method *reader1920 = addmethodrealflags(obj1916, "size'",&reader_lexer_size_39__1920, MFLAG_CONFIDENTIAL);
  Method *writer1920 = addmethodrealflags(obj1916, "size':=",&writer_lexer_size_39__1920, MFLAG_CONFIDENTIAL);
  reader1920->definitionModule = modulename;
  writer1920->definitionModule = modulename;
  reader1920->definitionLine = 581;
  writer1920->definitionLine = 581;
}
obj1916->flags |= OFLAG_MUTABLE;
adddatum2(obj1916, alloc_Undefined(), 3);
// method push
  struct UserObject *uo1921 = (struct UserObject*)obj1916;
  uo1921->data[4] = emptyclosure;
  Method *meth_meth_lexer_push1921 = addmethod2pos(obj1916, "push", &meth_lexer_push1921, 4);
  int argcv_meth_lexer_push1921[] = {1};
  meth_meth_lexer_push1921->type = alloc_MethodType(1, argcv_meth_lexer_push1921);
  meth_meth_lexer_push1921->definitionModule = modulename;
  meth_meth_lexer_push1921->definitionLine = 583;
// method pop
  struct UserObject *uo1951 = (struct UserObject*)obj1916;
  uo1951->data[5] = emptyclosure;
  Method *meth_meth_lexer_pop1951 = addmethod2pos(obj1916, "pop", &meth_lexer_pop1951, 5);
  int argcv_meth_lexer_pop1951[] = {0};
  meth_meth_lexer_pop1951->type = alloc_MethodType(1, argcv_meth_lexer_pop1951);
  meth_meth_lexer_pop1951->definitionModule = modulename;
  meth_meth_lexer_pop1951->definitionLine = 595;
// method poll
  struct UserObject *uo1985 = (struct UserObject*)obj1916;
  uo1985->data[6] = emptyclosure;
  Method *meth_meth_lexer_poll1985 = addmethod2pos(obj1916, "poll", &meth_lexer_poll1985, 6);
  int argcv_meth_lexer_poll1985[] = {0};
  meth_meth_lexer_poll1985->type = alloc_MethodType(1, argcv_meth_lexer_poll1985);
  meth_meth_lexer_poll1985->definitionModule = modulename;
  meth_meth_lexer_poll1985->definitionLine = 607;
// method size
  struct UserObject *uo2019 = (struct UserObject*)obj1916;
  uo2019->data[7] = emptyclosure;
  Method *meth_meth_lexer_size2019 = addmethod2pos(obj1916, "size", &meth_lexer_size2019, 7);
  int argcv_meth_lexer_size2019[] = {0};
  meth_meth_lexer_size2019->type = alloc_MethodType(1, argcv_meth_lexer_size2019);
  meth_meth_lexer_size2019->definitionModule = modulename;
  meth_meth_lexer_size2019->definitionLine = 619;
// method iter
  struct UserObject *uo2026 = (struct UserObject*)obj1916;
  uo2026->data[8] = emptyclosure;
  Method *meth_meth_lexer_iter2026 = addmethod2pos(obj1916, "iter", &meth_lexer_iter2026, 8);
  int argcv_meth_lexer_iter2026[] = {0};
  meth_meth_lexer_iter2026->type = alloc_MethodType(1, argcv_meth_lexer_iter2026);
  meth_meth_lexer_iter2026->definitionModule = modulename;
  meth_meth_lexer_iter2026->definitionLine = 623;
  Method *meth_meth_lexer_iter2026_object = addmethod2pos(obj1916, "iter()object", &meth_lexer_iter2026_object, 8);
  int argcv_meth_lexer_iter2026_object[] = {0};
  meth_meth_lexer_iter2026_object->type = alloc_MethodType(1, argcv_meth_lexer_iter2026_object);
  meth_meth_lexer_iter2026_object->definitionModule = modulename;
  meth_meth_lexer_iter2026_object->definitionLine = 623;
// method iterator
  struct UserObject *uo2058 = (struct UserObject*)obj1916;
  uo2058->data[9] = emptyclosure;
  Method *meth_meth_lexer_iterator2058 = addmethod2pos(obj1916, "iterator", &meth_lexer_iterator2058, 9);
  int argcv_meth_lexer_iterator2058[] = {0};
  meth_meth_lexer_iterator2058->type = alloc_MethodType(1, argcv_meth_lexer_iterator2058);
  meth_meth_lexer_iterator2058->definitionModule = modulename;
  meth_meth_lexer_iterator2058->definitionLine = 640;
  sourceObject = obj1916;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2061 = alloc_Boolean(0);
// compiled identifier node returning bool2061 (depth = 4)
  adddatum2(obj1916, bool2061, 1);
  sourceObject = obj1916;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2062 = alloc_Boolean(0);
// compiled identifier node returning bool2062 (depth = 4)
  adddatum2(obj1916, bool2062, 2);
  sourceObject = obj1916;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num2063 = alloc_Float64(0);
// compiled num node returning num2063 (depth = 4)
  adddatum2(obj1916, num2063, 3);
  sourceObject = obj1916;
  sourceObject = obj1916;
  sourceObject = obj1916;
  sourceObject = obj1916;
  sourceObject = obj1916;
  sourceObject = obj1916;
  objclass1916 = obj1916->class;
  objclass1916->definitionModule = modulename;
  objclass1916->definitionLine = 578;
  (*(struct UserObject *)self).data[0] = lowerouter1916;
  self = oldself1916;
  selfslot = oldselfslot1916;
  stackframe = oldstackframe1916;
// compiled object node returning obj1916 (depth = 3)
  *var_tokens = obj1916;
  if (obj1916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2064 == NULL) {
    strlit2064 = alloc_String("d");
    gc_root(strlit2064);
  }
// compiled string node returning strlit2064 (depth = 3)
  *var_mode = strlit2064;
  if (strlit2064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_mode (depth = 3)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2065 = alloc_Boolean(0);
// compiled identifier node returning bool2065 (depth = 3)
  *var_inStr = bool2065;
  if (bool2065 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2066 = alloc_Boolean(0);
// compiled identifier node returning bool2066 (depth = 3)
  *var_inBackticks = bool2066;
  if (bool2066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2067 = alloc_Boolean(0);
// compiled identifier node returning bool2067 (depth = 3)
  *var_backtickIdent = bool2067;
  if (bool2067 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2068 == NULL) {
    strlit2068 = alloc_String("");
    gc_root(strlit2068);
  }
// compiled string node returning strlit2068 (depth = 3)
  *var_accum = strlit2068;
  if (strlit2068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2069 = alloc_Boolean(0);
// compiled identifier node returning bool2069 (depth = 3)
  *var_escaped = bool2069;
  if (bool2069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2070 = alloc_Float64(0);
// compiled num node returning num2070 (depth = 3)
  *var_unichars = num2070;
  if (num2070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2071 = alloc_Float64(0);
// compiled num node returning num2071 (depth = 3)
  *var_codepoint = num2071;
  if (num2071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2072 = alloc_Float64(0);
// compiled num node returning num2072 (depth = 3)
  *var_interpdepth = num2072;
  if (num2072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2073 = alloc_Boolean(0);
// compiled identifier node returning bool2073 (depth = 3)
  *var_interpString = bool2073;
  if (bool2073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2074 = alloc_Boolean(1);
// compiled identifier node returning bool2074 (depth = 3)
  *var_atStart = bool2074;
  if (bool2074 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2075 = alloc_Boolean(0);
// compiled identifier node returning bool2075 (depth = 3)
  *var_newlineFound = bool2075;
  if (bool2075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2076 = alloc_Float64(0);
// compiled num node returning num2076 (depth = 3)
  *var_linePosition = num2076;
  if (num2076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2078 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit2079 == NULL) {
    strlit2079 = alloc_String("lexing.");
    gc_root(strlit2079);
  }
// compiled string node returning strlit2079 (depth = 3)
  gc_frame_newslot(strlit2079);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit2079;
  partcv[0] = 1;
  Object call2080 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe2078);
// compiled call node returning call2080 (depth = 2)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2081 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2082 == NULL) {
    strlit2082 = alloc_String("Z");
    gc_root(strlit2082);
  }
// compiled string node returning strlit2082 (depth = 4)
  gc_frame_newslot(strlit2082);
// starting to compile num node (depth = 4)
  Object num2083 = alloc_Float64(9);
// compiled num node returning num2083 (depth = 4)
  gc_frame_newslot(num2083);
// starting to compile num node (depth = 4)
  Object num2084 = alloc_Float64(32);
// compiled num node returning num2084 (depth = 4)
  gc_frame_newslot(num2084);
// starting to compile num node (depth = 4)
  Object num2085 = alloc_Float64(160);
// compiled num node returning num2085 (depth = 4)
  gc_frame_newslot(num2085);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = strlit2082;
  params[1] = num2083;
  params[2] = num2084;
  params[3] = num2085;
  partcv[0] = 2;
  partcv[1] = 2;
  Object call2086 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe2081);
// compiled call node returning call2086 (depth = 3)
  *var_badSeparator = call2086;
  if (call2086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2087 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2088 == NULL) {
    strlit2088 = alloc_String("C");
    gc_root(strlit2088);
  }
// compiled string node returning strlit2088 (depth = 4)
  gc_frame_newslot(strlit2088);
// starting to compile num node (depth = 4)
  Object num2089 = alloc_Float64(10);
// compiled num node returning num2089 (depth = 4)
  gc_frame_newslot(num2089);
// starting to compile num node (depth = 4)
  Object num2090 = alloc_Float64(13);
// compiled num node returning num2090 (depth = 4)
  gc_frame_newslot(num2090);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = strlit2088;
  params[1] = num2089;
  params[2] = num2090;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call2091 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe2087);
// compiled call node returning call2091 (depth = 3)
  *var_badControl = call2091;
  if (call2091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2092 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2093 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2094 == NULL) {
    strlit2094 = alloc_String("(");
    gc_root(strlit2094);
  }
// compiled string node returning strlit2094 (depth = 6)
  partcv[0] = 0;
  Object call2095 = callmethod(strlit2094, "ord",
    1, partcv, params);
  gc_frame_end(callframe2093);
// compiled call node returning call2095 (depth = 5)
// compiled member node returning call2095 (depth = 4)
  gc_frame_newslot(call2095);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2096 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2097 == NULL) {
    strlit2097 = alloc_String(")");
    gc_root(strlit2097);
  }
// compiled string node returning strlit2097 (depth = 6)
  partcv[0] = 0;
  Object call2098 = callmethod(strlit2097, "ord",
    1, partcv, params);
  gc_frame_end(callframe2096);
// compiled call node returning call2098 (depth = 5)
// compiled member node returning call2098 (depth = 4)
  gc_frame_newslot(call2098);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2099 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2100 == NULL) {
    strlit2100 = alloc_String(",");
    gc_root(strlit2100);
  }
// compiled string node returning strlit2100 (depth = 6)
  partcv[0] = 0;
  Object call2101 = callmethod(strlit2100, "ord",
    1, partcv, params);
  gc_frame_end(callframe2099);
// compiled call node returning call2101 (depth = 5)
// compiled member node returning call2101 (depth = 4)
  gc_frame_newslot(call2101);
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2102 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2103 == NULL) {
    strlit2103 = alloc_String(".");
    gc_root(strlit2103);
  }
// compiled string node returning strlit2103 (depth = 6)
  partcv[0] = 0;
  Object call2104 = callmethod(strlit2103, "ord",
    1, partcv, params);
  gc_frame_end(callframe2102);
// compiled call node returning call2104 (depth = 5)
// compiled member node returning call2104 (depth = 4)
  gc_frame_newslot(call2104);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2105 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2106 == NULL) {
    strlit2106 = alloc_String("{");
    gc_root(strlit2106);
  }
// compiled string node returning strlit2106 (depth = 6)
  partcv[0] = 0;
  Object call2107 = callmethod(strlit2106, "ord",
    1, partcv, params);
  gc_frame_end(callframe2105);
// compiled call node returning call2107 (depth = 5)
// compiled member node returning call2107 (depth = 4)
  gc_frame_newslot(call2107);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2108 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2109 == NULL) {
    strlit2109 = alloc_String("}");
    gc_root(strlit2109);
  }
// compiled string node returning strlit2109 (depth = 6)
  partcv[0] = 0;
  Object call2110 = callmethod(strlit2109, "ord",
    1, partcv, params);
  gc_frame_end(callframe2108);
// compiled call node returning call2110 (depth = 5)
// compiled member node returning call2110 (depth = 4)
  gc_frame_newslot(call2110);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2111 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2112 == NULL) {
    strlit2112 = alloc_String("[");
    gc_root(strlit2112);
  }
// compiled string node returning strlit2112 (depth = 6)
  partcv[0] = 0;
  Object call2113 = callmethod(strlit2112, "ord",
    1, partcv, params);
  gc_frame_end(callframe2111);
// compiled call node returning call2113 (depth = 5)
// compiled member node returning call2113 (depth = 4)
  gc_frame_newslot(call2113);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2114 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2115 == NULL) {
    strlit2115 = alloc_String("]");
    gc_root(strlit2115);
  }
// compiled string node returning strlit2115 (depth = 6)
  partcv[0] = 0;
  Object call2116 = callmethod(strlit2115, "ord",
    1, partcv, params);
  gc_frame_end(callframe2114);
// compiled call node returning call2116 (depth = 5)
// compiled member node returning call2116 (depth = 4)
  gc_frame_newslot(call2116);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2117 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2118 == NULL) {
    strlit2118 = alloc_String(";");
    gc_root(strlit2118);
  }
// compiled string node returning strlit2118 (depth = 6)
  partcv[0] = 0;
  Object call2119 = callmethod(strlit2118, "ord",
    1, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2119 (depth = 5)
// compiled member node returning call2119 (depth = 4)
  gc_frame_newslot(call2119);
// call case 6: other member request
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = call2095;
  params[1] = call2098;
  params[2] = call2101;
  params[3] = call2104;
  params[4] = call2107;
  params[5] = call2110;
  params[6] = call2113;
  params[7] = call2116;
  params[8] = call2119;
  partcv[0] = 9;
  Object call2120 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2092);
// compiled call node returning call2120 (depth = 3)
  *var_selfModes = call2120;
  if (call2120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2121 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2122 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2123 == NULL) {
    strlit2123 = alloc_String("(");
    gc_root(strlit2123);
  }
// compiled string node returning strlit2123 (depth = 6)
  partcv[0] = 0;
  Object call2124 = callmethod(strlit2123, "ord",
    1, partcv, params);
  gc_frame_end(callframe2122);
// compiled call node returning call2124 (depth = 5)
// compiled member node returning call2124 (depth = 4)
  gc_frame_newslot(call2124);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2125 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2126 == NULL) {
    strlit2126 = alloc_String(")");
    gc_root(strlit2126);
  }
// compiled string node returning strlit2126 (depth = 6)
  partcv[0] = 0;
  Object call2127 = callmethod(strlit2126, "ord",
    1, partcv, params);
  gc_frame_end(callframe2125);
// compiled call node returning call2127 (depth = 5)
// compiled member node returning call2127 (depth = 4)
  gc_frame_newslot(call2127);
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2128 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2129 == NULL) {
    strlit2129 = alloc_String("{");
    gc_root(strlit2129);
  }
// compiled string node returning strlit2129 (depth = 6)
  partcv[0] = 0;
  Object call2130 = callmethod(strlit2129, "ord",
    1, partcv, params);
  gc_frame_end(callframe2128);
// compiled call node returning call2130 (depth = 5)
// compiled member node returning call2130 (depth = 4)
  gc_frame_newslot(call2130);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2131 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2132 == NULL) {
    strlit2132 = alloc_String("}");
    gc_root(strlit2132);
  }
// compiled string node returning strlit2132 (depth = 6)
  partcv[0] = 0;
  Object call2133 = callmethod(strlit2132, "ord",
    1, partcv, params);
  gc_frame_end(callframe2131);
// compiled call node returning call2133 (depth = 5)
// compiled member node returning call2133 (depth = 4)
  gc_frame_newslot(call2133);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2134 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2135 == NULL) {
    strlit2135 = alloc_String("[");
    gc_root(strlit2135);
  }
// compiled string node returning strlit2135 (depth = 6)
  partcv[0] = 0;
  Object call2136 = callmethod(strlit2135, "ord",
    1, partcv, params);
  gc_frame_end(callframe2134);
// compiled call node returning call2136 (depth = 5)
// compiled member node returning call2136 (depth = 4)
  gc_frame_newslot(call2136);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2137 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2138 == NULL) {
    strlit2138 = alloc_String("]");
    gc_root(strlit2138);
  }
// compiled string node returning strlit2138 (depth = 6)
  partcv[0] = 0;
  Object call2139 = callmethod(strlit2138, "ord",
    1, partcv, params);
  gc_frame_end(callframe2137);
// compiled call node returning call2139 (depth = 5)
// compiled member node returning call2139 (depth = 4)
  gc_frame_newslot(call2139);
// call case 6: other member request
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = call2124;
  params[1] = call2127;
  params[2] = call2130;
  params[3] = call2133;
  params[4] = call2136;
  params[5] = call2139;
  partcv[0] = 6;
  Object call2140 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2121);
// compiled call node returning call2140 (depth = 3)
  *var_brackets = call2140;
  if (call2140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2141 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2142 == NULL) {
    strlit2142 = alloc_String("L");
    gc_root(strlit2142);
  }
// compiled string node returning strlit2142 (depth = 4)
  gc_frame_newslot(strlit2142);
// starting to compile string node (depth = 4)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("N");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 4)
  gc_frame_newslot(strlit2143);
// starting to compile num node (depth = 4)
  Object num2144 = alloc_Float64(95);
// compiled num node returning num2144 (depth = 4)
  gc_frame_newslot(num2144);
// starting to compile num node (depth = 4)
  Object num2145 = alloc_Float64(39);
// compiled num node returning num2145 (depth = 4)
  gc_frame_newslot(num2145);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = strlit2142;
  params[1] = strlit2143;
  params[2] = num2144;
  params[3] = num2145;
  partcv[0] = 4;
  Object call2146 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2141);
// compiled call node returning call2146 (depth = 3)
  *var_identifierChar = call2146;
  if (call2146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2147 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2148 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2149 == NULL) {
    strlit2149 = alloc_String("0");
    gc_root(strlit2149);
  }
// compiled string node returning strlit2149 (depth = 6)
  partcv[0] = 0;
  Object call2150 = callmethod(strlit2149, "ord",
    1, partcv, params);
  gc_frame_end(callframe2148);
// compiled call node returning call2150 (depth = 5)
// compiled member node returning call2150 (depth = 4)
  gc_frame_newslot(call2150);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2151 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2152 == NULL) {
    strlit2152 = alloc_String("1");
    gc_root(strlit2152);
  }
// compiled string node returning strlit2152 (depth = 6)
  partcv[0] = 0;
  Object call2153 = callmethod(strlit2152, "ord",
    1, partcv, params);
  gc_frame_end(callframe2151);
// compiled call node returning call2153 (depth = 5)
// compiled member node returning call2153 (depth = 4)
  gc_frame_newslot(call2153);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2154 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2155 == NULL) {
    strlit2155 = alloc_String("2");
    gc_root(strlit2155);
  }
// compiled string node returning strlit2155 (depth = 6)
  partcv[0] = 0;
  Object call2156 = callmethod(strlit2155, "ord",
    1, partcv, params);
  gc_frame_end(callframe2154);
// compiled call node returning call2156 (depth = 5)
// compiled member node returning call2156 (depth = 4)
  gc_frame_newslot(call2156);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2157 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2158 == NULL) {
    strlit2158 = alloc_String("3");
    gc_root(strlit2158);
  }
// compiled string node returning strlit2158 (depth = 6)
  partcv[0] = 0;
  Object call2159 = callmethod(strlit2158, "ord",
    1, partcv, params);
  gc_frame_end(callframe2157);
// compiled call node returning call2159 (depth = 5)
// compiled member node returning call2159 (depth = 4)
  gc_frame_newslot(call2159);
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2160 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2161 == NULL) {
    strlit2161 = alloc_String("4");
    gc_root(strlit2161);
  }
// compiled string node returning strlit2161 (depth = 6)
  partcv[0] = 0;
  Object call2162 = callmethod(strlit2161, "ord",
    1, partcv, params);
  gc_frame_end(callframe2160);
// compiled call node returning call2162 (depth = 5)
// compiled member node returning call2162 (depth = 4)
  gc_frame_newslot(call2162);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2163 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2164 == NULL) {
    strlit2164 = alloc_String("5");
    gc_root(strlit2164);
  }
// compiled string node returning strlit2164 (depth = 6)
  partcv[0] = 0;
  Object call2165 = callmethod(strlit2164, "ord",
    1, partcv, params);
  gc_frame_end(callframe2163);
// compiled call node returning call2165 (depth = 5)
// compiled member node returning call2165 (depth = 4)
  gc_frame_newslot(call2165);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2166 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2167 == NULL) {
    strlit2167 = alloc_String("6");
    gc_root(strlit2167);
  }
// compiled string node returning strlit2167 (depth = 6)
  partcv[0] = 0;
  Object call2168 = callmethod(strlit2167, "ord",
    1, partcv, params);
  gc_frame_end(callframe2166);
// compiled call node returning call2168 (depth = 5)
// compiled member node returning call2168 (depth = 4)
  gc_frame_newslot(call2168);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2169 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2170 == NULL) {
    strlit2170 = alloc_String("7");
    gc_root(strlit2170);
  }
// compiled string node returning strlit2170 (depth = 6)
  partcv[0] = 0;
  Object call2171 = callmethod(strlit2170, "ord",
    1, partcv, params);
  gc_frame_end(callframe2169);
// compiled call node returning call2171 (depth = 5)
// compiled member node returning call2171 (depth = 4)
  gc_frame_newslot(call2171);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2172 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2173 == NULL) {
    strlit2173 = alloc_String("8");
    gc_root(strlit2173);
  }
// compiled string node returning strlit2173 (depth = 6)
  partcv[0] = 0;
  Object call2174 = callmethod(strlit2173, "ord",
    1, partcv, params);
  gc_frame_end(callframe2172);
// compiled call node returning call2174 (depth = 5)
// compiled member node returning call2174 (depth = 4)
  gc_frame_newslot(call2174);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2175 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2176 == NULL) {
    strlit2176 = alloc_String("9");
    gc_root(strlit2176);
  }
// compiled string node returning strlit2176 (depth = 6)
  partcv[0] = 0;
  Object call2177 = callmethod(strlit2176, "ord",
    1, partcv, params);
  gc_frame_end(callframe2175);
// compiled call node returning call2177 (depth = 5)
// compiled member node returning call2177 (depth = 4)
  gc_frame_newslot(call2177);
// call case 6: other member request
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = call2150;
  params[1] = call2153;
  params[2] = call2156;
  params[3] = call2159;
  params[4] = call2162;
  params[5] = call2165;
  params[6] = call2168;
  params[7] = call2171;
  params[8] = call2174;
  params[9] = call2177;
  partcv[0] = 10;
  Object call2178 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2147);
// compiled call node returning call2178 (depth = 3)
  *var_digit = call2178;
  if (call2178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2179 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2180 == NULL) {
    strlit2180 = alloc_String("Sm");
    gc_root(strlit2180);
  }
// compiled string node returning strlit2180 (depth = 4)
  gc_frame_newslot(strlit2180);
// starting to compile string node (depth = 4)
  if (strlit2181 == NULL) {
    strlit2181 = alloc_String("So");
    gc_root(strlit2181);
  }
// compiled string node returning strlit2181 (depth = 4)
  gc_frame_newslot(strlit2181);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2182 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2183 == NULL) {
    strlit2183 = alloc_String("-");
    gc_root(strlit2183);
  }
// compiled string node returning strlit2183 (depth = 6)
  partcv[0] = 0;
  Object call2184 = callmethod(strlit2183, "ord",
    1, partcv, params);
  gc_frame_end(callframe2182);
// compiled call node returning call2184 (depth = 5)
// compiled member node returning call2184 (depth = 4)
  gc_frame_newslot(call2184);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2185 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2186 == NULL) {
    strlit2186 = alloc_String("&");
    gc_root(strlit2186);
  }
// compiled string node returning strlit2186 (depth = 6)
  partcv[0] = 0;
  Object call2187 = callmethod(strlit2186, "ord",
    1, partcv, params);
  gc_frame_end(callframe2185);
// compiled call node returning call2187 (depth = 5)
// compiled member node returning call2187 (depth = 4)
  gc_frame_newslot(call2187);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2188 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2189 == NULL) {
    strlit2189 = alloc_String("|");
    gc_root(strlit2189);
  }
// compiled string node returning strlit2189 (depth = 6)
  partcv[0] = 0;
  Object call2190 = callmethod(strlit2189, "ord",
    1, partcv, params);
  gc_frame_end(callframe2188);
// compiled call node returning call2190 (depth = 5)
// compiled member node returning call2190 (depth = 4)
  gc_frame_newslot(call2190);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2191 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2192 == NULL) {
    strlit2192 = alloc_String(":");
    gc_root(strlit2192);
  }
// compiled string node returning strlit2192 (depth = 6)
  partcv[0] = 0;
  Object call2193 = callmethod(strlit2192, "ord",
    1, partcv, params);
  gc_frame_end(callframe2191);
// compiled call node returning call2193 (depth = 5)
// compiled member node returning call2193 (depth = 4)
  gc_frame_newslot(call2193);
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2194 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2195 == NULL) {
    strlit2195 = alloc_String("%");
    gc_root(strlit2195);
  }
// compiled string node returning strlit2195 (depth = 6)
  partcv[0] = 0;
  Object call2196 = callmethod(strlit2195, "ord",
    1, partcv, params);
  gc_frame_end(callframe2194);
// compiled call node returning call2196 (depth = 5)
// compiled member node returning call2196 (depth = 4)
  gc_frame_newslot(call2196);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2197 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2198 == NULL) {
    strlit2198 = alloc_String("^");
    gc_root(strlit2198);
  }
// compiled string node returning strlit2198 (depth = 6)
  partcv[0] = 0;
  Object call2199 = callmethod(strlit2198, "ord",
    1, partcv, params);
  gc_frame_end(callframe2197);
// compiled call node returning call2199 (depth = 5)
// compiled member node returning call2199 (depth = 4)
  gc_frame_newslot(call2199);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2200 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2201 == NULL) {
    strlit2201 = alloc_String("@");
    gc_root(strlit2201);
  }
// compiled string node returning strlit2201 (depth = 6)
  partcv[0] = 0;
  Object call2202 = callmethod(strlit2201, "ord",
    1, partcv, params);
  gc_frame_end(callframe2200);
// compiled call node returning call2202 (depth = 5)
// compiled member node returning call2202 (depth = 4)
  gc_frame_newslot(call2202);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2203 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2204 == NULL) {
    strlit2204 = alloc_String("?");
    gc_root(strlit2204);
  }
// compiled string node returning strlit2204 (depth = 6)
  partcv[0] = 0;
  Object call2205 = callmethod(strlit2204, "ord",
    1, partcv, params);
  gc_frame_end(callframe2203);
// compiled call node returning call2205 (depth = 5)
// compiled member node returning call2205 (depth = 4)
  gc_frame_newslot(call2205);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2206 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2207 == NULL) {
    strlit2207 = alloc_String("*");
    gc_root(strlit2207);
  }
// compiled string node returning strlit2207 (depth = 6)
  partcv[0] = 0;
  Object call2208 = callmethod(strlit2207, "ord",
    1, partcv, params);
  gc_frame_end(callframe2206);
// compiled call node returning call2208 (depth = 5)
// compiled member node returning call2208 (depth = 4)
  gc_frame_newslot(call2208);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2209 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2210 == NULL) {
    strlit2210 = alloc_String("/");
    gc_root(strlit2210);
  }
// compiled string node returning strlit2210 (depth = 6)
  partcv[0] = 0;
  Object call2211 = callmethod(strlit2210, "ord",
    1, partcv, params);
  gc_frame_end(callframe2209);
// compiled call node returning call2211 (depth = 5)
// compiled member node returning call2211 (depth = 4)
  gc_frame_newslot(call2211);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2212 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2213 == NULL) {
    strlit2213 = alloc_String("+");
    gc_root(strlit2213);
  }
// compiled string node returning strlit2213 (depth = 6)
  partcv[0] = 0;
  Object call2214 = callmethod(strlit2213, "ord",
    1, partcv, params);
  gc_frame_end(callframe2212);
// compiled call node returning call2214 (depth = 5)
// compiled member node returning call2214 (depth = 4)
  gc_frame_newslot(call2214);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2215 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2216 == NULL) {
    strlit2216 = alloc_String("!");
    gc_root(strlit2216);
  }
// compiled string node returning strlit2216 (depth = 6)
  partcv[0] = 0;
  Object call2217 = callmethod(strlit2216, "ord",
    1, partcv, params);
  gc_frame_end(callframe2215);
// compiled call node returning call2217 (depth = 5)
// compiled member node returning call2217 (depth = 4)
  gc_frame_newslot(call2217);
// call case 6: other member request
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = strlit2180;
  params[1] = strlit2181;
  params[2] = call2184;
  params[3] = call2187;
  params[4] = call2190;
  params[5] = call2193;
  params[6] = call2196;
  params[7] = call2199;
  params[8] = call2202;
  params[9] = call2205;
  params[10] = call2208;
  params[11] = call2211;
  params[12] = call2214;
  params[13] = call2217;
  partcv[0] = 14;
  Object call2218 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2179);
// compiled call node returning call2218 (depth = 3)
  *var_operatorChar = call2218;
  if (call2218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2219 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2220 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2221 == NULL) {
    strlit2221 = alloc_String("i");
    gc_root(strlit2221);
  }
// compiled string node returning strlit2221 (depth = 6)
  partcv[0] = 0;
  Object call2222 = callmethod(strlit2221, "ord",
    1, partcv, params);
  gc_frame_end(callframe2220);
// compiled call node returning call2222 (depth = 5)
// compiled member node returning call2222 (depth = 4)
  gc_frame_newslot(call2222);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2223 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2224 == NULL) {
    strlit2224 = alloc_String("<");
    gc_root(strlit2224);
  }
// compiled string node returning strlit2224 (depth = 6)
  partcv[0] = 0;
  Object call2225 = callmethod(strlit2224, "ord",
    1, partcv, params);
  gc_frame_end(callframe2223);
// compiled call node returning call2225 (depth = 5)
// compiled member node returning call2225 (depth = 4)
  gc_frame_newslot(call2225);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2226 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit2227 == NULL) {
    strlit2227 = alloc_String(">");
    gc_root(strlit2227);
  }
// compiled string node returning strlit2227 (depth = 6)
  partcv[0] = 0;
  Object call2228 = callmethod(strlit2227, "ord",
    1, partcv, params);
  gc_frame_end(callframe2226);
// compiled call node returning call2228 (depth = 5)
// compiled member node returning call2228 (depth = 4)
  gc_frame_newslot(call2228);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = call2222;
  params[1] = call2225;
  params[2] = call2228;
  partcv[0] = 3;
  Object call2229 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2219);
// compiled call node returning call2229 (depth = 3)
  *var_iGTLT = call2229;
  if (call2229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile block node (depth = 3)
  Object block2230 = alloc_Block(NULL, NULL, "lexer", 676);
  gc_frame_newslot(block2230);
// method _apply
  block_savedest(block2230);
  Object closure2231 = createclosure(29, "_apply");
  setclosureframe(closure2231, stackframe);
  addtoclosure(closure2231, var_mode);
  addtoclosure(closure2231, var_badSeparator);
  addtoclosure(closure2231, var_errormessages);
  addtoclosure(closure2231, var_linePosition);
  addtoclosure(closure2231, var_lineNumber);
  addtoclosure(closure2231, var_inStr);
  addtoclosure(closure2231, var_unicode);
  addtoclosure(closure2231, var_badControl);
  addtoclosure(closure2231, var_atStart);
  addtoclosure(closure2231, var_newmode);
  addtoclosure(closure2231, var_stringStart);
  addtoclosure(closure2231, var_startLine);
  addtoclosure(closure2231, var_identifierChar);
  addtoclosure(closure2231, var_digit);
  addtoclosure(closure2231, var_iGTLT);
  addtoclosure(closure2231, var_tokens);
  addtoclosure(closure2231, var_accum);
  addtoclosure(closure2231, var_operatorChar);
  addtoclosure(closure2231, var_selfModes);
  addtoclosure(closure2231, var_util);
  addtoclosure(closure2231, var_escaped);
  addtoclosure(closure2231, var_interpString);
  addtoclosure(closure2231, var_interpdepth);
  addtoclosure(closure2231, var_brackets);
  addtoclosure(closure2231, var_unichars);
  addtoclosure(closure2231, var_codepoint);
  addtoclosure(closure2231, var_newlineFound);
  addtoclosure(closure2231, var_startPosition);
  addtoclosure(closure2231, selfslot);
  struct UserObject *uo2231 = (struct UserObject*)block2230;
  uo2231->data[0] = (Object)closure2231;
  Method *meth_meth_lexer__apply2231 = addmethod2pos(block2230, "_apply", &meth_lexer__apply2231, 0);
  int argcv_meth_lexer__apply2231[] = {1};
  meth_meth_lexer__apply2231->type = alloc_MethodType(1, argcv_meth_lexer__apply2231);
  meth_meth_lexer__apply2231->definitionModule = modulename;
  meth_meth_lexer__apply2231->definitionLine = 675;
// compiled block node returning block2230 (depth = 3)
  *var_mainBlock = block2230;
  if (block2230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3516 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inputLines (depth = 3)
  gc_frame_newslot(*var_inputLines);
// starting to compile block node (depth = 3)
  Object block3517 = alloc_Block(NULL, NULL, "lexer", 1093);
  gc_frame_newslot(block3517);
// method _apply
  block_savedest(block3517);
  Object closure3518 = createclosure(4, "_apply");
  setclosureframe(closure3518, stackframe);
  addtoclosure(closure3518, var_linePosition);
  addtoclosure(closure3518, var_mode);
  addtoclosure(closure3518, var_mainBlock);
  addtoclosure(closure3518, selfslot);
  struct UserObject *uo3518 = (struct UserObject*)block3517;
  uo3518->data[0] = (Object)closure3518;
  Method *meth_meth_lexer__apply3518 = addmethod2pos(block3517, "_apply", &meth_lexer__apply3518, 0);
  int argcv_meth_lexer__apply3518[] = {1};
  meth_meth_lexer__apply3518->type = alloc_MethodType(1, argcv_meth_lexer__apply3518);
  meth_meth_lexer__apply3518->definitionModule = modulename;
  meth_meth_lexer__apply3518->definitionLine = 1045;
// compiled block node returning block3517 (depth = 3)
  gc_frame_newslot(block3517);
// call case 5: prelude request
  params[0] = *var_inputLines;
  params[1] = block3517;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3552 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3516);
// compiled call node returning call3552 (depth = 2)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3554 = alloc_Float64(1);
// compiled num node returning num3554 (depth = 4)
  int op_slot_right_3553 = gc_frame_newslot(num3554);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_linePosition (depth = 4)
  int op_slot_left_3553 = gc_frame_newslot(*var_linePosition);
  params[0] = num3554;
  partcv[0] = 1;
  Object sum3556 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3556 (depth = 3)
  *var_linePosition = sum3556;
  if (sum3556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inStr (depth = 3)
  Object if3558 = done;
  if (istrue(*var_inStr)) {
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3561 == NULL) {
    strlit3561 = alloc_String("""\x22""");
    gc_root(strlit3561);
  }
// compiled string node returning strlit3561 (depth = 5)
  int op_slot_right_3560 = gc_frame_newslot(strlit3561);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mode (depth = 5)
  int op_slot_left_3560 = gc_frame_newslot(*var_mode);
  params[0] = strlit3561;
  partcv[0] = 1;
  Object opresult3563 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3563 (depth = 4)
  Object if3559 = done;
  if (istrue(opresult3563)) {
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3564 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3566 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3565);
// compiled call node returning call3566 (depth = 8)
// compiled member node returning call3566 (depth = 7)
  partcv[0] = 0;
  Object call3567 = callmethod(call3566, "new",
    1, partcv, params);
  gc_frame_end(callframe3564);
// compiled call node returning call3567 (depth = 6)
// compiled member node returning call3567 (depth = 5)
  *var_suggestion = call3567;
  if (call3567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3568 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3570 == NULL) {
    strlit3570 = alloc_String("""\x22""");
    gc_root(strlit3570);
  }
// compiled string node returning strlit3570 (depth = 6)
  int op_slot_right_3569 = gc_frame_newslot(strlit3570);
// starting to compile call node (depth = 6)
  int callframe3572 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call3574 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3573);
// compiled call node returning call3574 (depth = 8)
// compiled member node returning call3574 (depth = 7)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call3575 = callmethod(call3574, "at",
    1, partcv, params);
  gc_frame_end(callframe3572);
// compiled call node returning call3575 (depth = 6)
  int op_slot_left_3569 = gc_frame_newslot(call3575);
  params[0] = strlit3570;
  partcv[0] = 1;
  Object opresult3576 = callmethod(call3575, "++", 1, partcv, params);
// compiled op node returning opresult3576 (depth = 5)
  gc_frame_newslot(opresult3576);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lineNumber;
  params[1] = opresult3576;
  partcv[0] = 2;
  Object call3577 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3568);
// compiled call node returning call3577 (depth = 4)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3578 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3579 == NULL) {
    strlit3579 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3579);
  }
// compiled string node returning strlit3579 (depth = 5)
  gc_frame_newslot(strlit3579);
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3579;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3580 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3578);
// compiled call node returning call3580 (depth = 4)
    gc_frame_newslot(call3580);
    if3559 = call3580;
  } else {
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3583 == NULL) {
    strlit3583 = alloc_String("q");
    gc_root(strlit3583);
  }
// compiled string node returning strlit3583 (depth = 6)
  int op_slot_right_3582 = gc_frame_newslot(strlit3583);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_3582 = gc_frame_newslot(*var_mode);
  params[0] = strlit3583;
  partcv[0] = 1;
  Object opresult3585 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3585 (depth = 5)
  Object if3581 = done;
  if (istrue(opresult3585)) {
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3586 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3589 == NULL) {
    strlit3589 = alloc_String(" and unclosed at end of input.");
    gc_root(strlit3589);
  }
// compiled string node returning strlit3589 (depth = 8)
  int op_slot_right_3588 = gc_frame_newslot(strlit3589);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startLine (depth = 9)
  int op_slot_right_3591 = gc_frame_newslot(*var_startLine);
// starting to compile string node (depth = 9)
  if (strlit3593 == NULL) {
    strlit3593 = alloc_String("String opened on line ");
    gc_root(strlit3593);
  }
// compiled string node returning strlit3593 (depth = 9)
  int op_slot_left_3591 = gc_frame_newslot(strlit3593);
  params[0] = *var_startLine;
  partcv[0] = 1;
  Object opresult3594 = callmethod(strlit3593, "++", 1, partcv, params);
// compiled op node returning opresult3594 (depth = 8)
  int op_slot_left_3588 = gc_frame_newslot(opresult3594);
  params[0] = strlit3589;
  partcv[0] = 1;
  Object opresult3595 = callmethod(opresult3594, "++", 1, partcv, params);
// compiled op node returning opresult3595 (depth = 7)
  int op_slot_right_3587 = gc_frame_newslot(opresult3595);
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3597 == NULL) {
    strlit3597 = alloc_String("A multi-line string must end with a '""\xe2""""\x80""""\xba""'.""\x0a""");
    gc_root(strlit3597);
  }
// compiled string node returning strlit3597 (depth = 7)
  int op_slot_left_3587 = gc_frame_newslot(strlit3597);
  params[0] = opresult3595;
  partcv[0] = 1;
  Object opresult3598 = callmethod(strlit3597, "++", 1, partcv, params);
// compiled op node returning opresult3598 (depth = 6)
  gc_frame_newslot(opresult3598);
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startLine (depth = 6)
  gc_frame_newslot(*var_startLine);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringStart (depth = 6)
  gc_frame_newslot(*var_stringStart);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3599 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3600 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startLine (depth = 9)
  gc_frame_newslot(*var_startLine);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call3602 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3601);
// compiled call node returning call3602 (depth = 10)
// compiled member node returning call3602 (depth = 9)
  params[0] = *var_startLine;
  partcv[0] = 1;
  Object call3603 = callmethod(call3602, "at",
    1, partcv, params);
  gc_frame_end(callframe3600);
// compiled call node returning call3603 (depth = 8)
  partcv[0] = 0;
  Object call3604 = callmethod(call3603, "size",
    1, partcv, params);
  gc_frame_end(callframe3599);
// compiled call node returning call3604 (depth = 7)
// compiled member node returning call3604 (depth = 6)
  gc_frame_newslot(call3604);
// call case 6: other member request
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult3598;
  params[1] = *var_startLine;
  params[2] = *var_stringStart;
  params[3] = call3604;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call3605 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe3586);
// compiled call node returning call3605 (depth = 5)
    gc_frame_newslot(call3605);
    if3581 = call3605;
  } else {
  }
// compiled if node returning if3581 (depth = 4)
    gc_frame_newslot(if3581);
    if3559 = if3581;
  }
// compiled if node returning if3559 (depth = 3)
    gc_frame_newslot(if3559);
    if3558 = if3559;
  } else {
  }
// compiled if node returning if3558 (depth = 2)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3606 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_mode (depth = 3)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_accum (depth = 3)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3607 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3606);
// compiled call node returning call3607 (depth = 2)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3608 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_eofToken (depth = 5)
  partcv[0] = 0;
  Object call3610 = callmethod(*var_eofToken, "new",
    1, partcv, params);
  gc_frame_end(callframe3609);
// compiled call node returning call3610 (depth = 4)
// compiled member node returning call3610 (depth = 3)
  gc_frame_newslot(call3610);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  params[0] = call3610;
  partcv[0] = 1;
  Object call3611 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe3608);
// compiled call node returning call3611 (depth = 2)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_tokens (depth = 2)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_lexer_new24(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(30, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_startLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "startLine");
  Object *var_stringStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "stringStart");
  Object *var_Token = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "StringToken");
  Object *var_MultiLineStringToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "MultiLineStringToken");
  Object *var_CommentToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "CommentToken");
  Object *var_LBraceToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "DotToken");
  Object *var_NumToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "RGenericToken");
  Object *var_eofToken = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "eofToken");
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num25 = alloc_Float64(1);
// compiled num node returning num25 (depth = 3)
  *var_lineNumber = num25;
  if (num25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num26 = alloc_Float64(0);
// compiled num node returning num26 (depth = 3)
  *var_linePosition = num26;
  if (num26 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num27 = alloc_Float64(1);
// compiled num node returning num27 (depth = 3)
  *var_startPosition = num27;
  if (num27 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num28 = alloc_Float64(0);
// compiled num node returning num28 (depth = 3)
  *var_indentLevel = num28;
  if (num28 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num29 = alloc_Float64(1);
// compiled num node returning num29 (depth = 3)
  *var_startLine = num29;
  if (num29 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_stringStart = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject30 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj30 = alloc_userobj2(2,4, objclass30);
  gc_frame_newslot(obj30);
// OBJECT OUTER DEC outer
  adddatum2(obj30, self, 0);
  addmethodreal(obj30,"outer", &reader_lexer_outer_31);
  Object oldself30 = self;
  struct StackFrameObject *oldstackframe30 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe30);
  gc_frame_newslot((Object)stackframe);
  self = obj30;
  Object *oldselfslot30 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter30 = (*(struct UserObject *)self).data[0], lowerouter30 = thisouter30;
  if (inheritingObject30) {
    struct UserObject *inho30 = (struct UserObject *)inheritingObject30;
    while (inho30->super != GraceDefaultObject) inho30 = (struct UserObject *)inho30->super;
    inho30->super = obj30;
    self = inheritingObject30;
    *selfslot = self;
    lowerouter30 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter30;
  }
// method new
  block_savedest(obj30);
  Object closure32 = createclosure(3, "new");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_lineNumber);
  addtoclosure(closure32, var_indentLevel);
  addtoclosure(closure32, var_startPosition);
  struct UserObject *uo32 = (struct UserObject*)obj30;
  uo32->data[1] = (Object)closure32;
  Method *meth_meth_lexer_new32 = addmethod2pos(obj30, "new", &meth_lexer_new32, 1);
  int argcv_meth_lexer_new32[] = {0};
  meth_meth_lexer_new32->type = alloc_MethodType(1, argcv_meth_lexer_new32);
  meth_meth_lexer_new32->definitionModule = modulename;
  meth_meth_lexer_new32->definitionLine = 25;
  block_savedest(obj30);
  Object closure104 = createclosure(3, "new()object");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_lineNumber);
  addtoclosure(closure104, var_indentLevel);
  addtoclosure(closure104, var_startPosition);
  Method *meth_meth_lexer_new32_object = addmethod2pos(obj30, "new()object", &meth_lexer_new32_object, 1);
  meth_meth_lexer_new32_object->definitionModule = modulename;
  meth_meth_lexer_new32_object->definitionLine = 25;
  sourceObject = obj30;
  objclass30 = obj30->class;
  objclass30->definitionModule = modulename;
  objclass30->definitionLine = 25;
  (*(struct UserObject *)self).data[0] = lowerouter30;
  self = oldself30;
  selfslot = oldselfslot30;
  stackframe = oldstackframe30;
// compiled object node returning obj30 (depth = 4)
  *var_Token = obj30;
  if (obj30 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject105 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj105 = alloc_userobj2(2,4, objclass105);
  gc_frame_newslot(obj105);
// OBJECT OUTER DEC outer
  adddatum2(obj105, self, 0);
  addmethodreal(obj105,"outer", &reader_lexer_outer_106);
  Object oldself105 = self;
  struct StackFrameObject *oldstackframe105 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe105);
  gc_frame_newslot((Object)stackframe);
  self = obj105;
  Object *oldselfslot105 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter105 = (*(struct UserObject *)self).data[0], lowerouter105 = thisouter105;
  if (inheritingObject105) {
    struct UserObject *inho105 = (struct UserObject *)inheritingObject105;
    while (inho105->super != GraceDefaultObject) inho105 = (struct UserObject *)inho105->super;
    inho105->super = obj105;
    self = inheritingObject105;
    *selfslot = self;
    lowerouter105 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter105;
  }
// method new
  block_savedest(obj105);
  Object closure107 = createclosure(1, "new");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_Token);
  struct UserObject *uo107 = (struct UserObject*)obj105;
  uo107->data[1] = (Object)closure107;
  Method *meth_meth_lexer_new107 = addmethod2pos(obj105, "new", &meth_lexer_new107, 1);
  int argcv_meth_lexer_new107[] = {1};
  meth_meth_lexer_new107->type = alloc_MethodType(1, argcv_meth_lexer_new107);
  meth_meth_lexer_new107->definitionModule = modulename;
  meth_meth_lexer_new107->definitionLine = 44;
  block_savedest(obj105);
  Object closure118 = createclosure(1, "new()object");
  setclosureframe(closure118, stackframe);
  addtoclosure(closure118, var_Token);
  Method *meth_meth_lexer_new107_object = addmethod2pos(obj105, "new()object", &meth_lexer_new107_object, 1);
  meth_meth_lexer_new107_object->definitionModule = modulename;
  meth_meth_lexer_new107_object->definitionLine = 44;
  sourceObject = obj105;
  objclass105 = obj105->class;
  objclass105->definitionModule = modulename;
  objclass105->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter105;
  self = oldself105;
  selfslot = oldselfslot105;
  stackframe = oldstackframe105;
// compiled object node returning obj105 (depth = 4)
  *var_IdentifierToken = obj105;
  if (obj105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject119 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj119 = alloc_userobj2(2,4, objclass119);
  gc_frame_newslot(obj119);
// OBJECT OUTER DEC outer
  adddatum2(obj119, self, 0);
  addmethodreal(obj119,"outer", &reader_lexer_outer_120);
  Object oldself119 = self;
  struct StackFrameObject *oldstackframe119 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe119);
  gc_frame_newslot((Object)stackframe);
  self = obj119;
  Object *oldselfslot119 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter119 = (*(struct UserObject *)self).data[0], lowerouter119 = thisouter119;
  if (inheritingObject119) {
    struct UserObject *inho119 = (struct UserObject *)inheritingObject119;
    while (inho119->super != GraceDefaultObject) inho119 = (struct UserObject *)inho119->super;
    inho119->super = obj119;
    self = inheritingObject119;
    *selfslot = self;
    lowerouter119 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter119;
  }
// method new
  block_savedest(obj119);
  Object closure121 = createclosure(3, "new");
  setclosureframe(closure121, stackframe);
  addtoclosure(closure121, var_Token);
  addtoclosure(closure121, var_stringStart);
  addtoclosure(closure121, var_linePosition);
  struct UserObject *uo121 = (struct UserObject*)obj119;
  uo121->data[1] = (Object)closure121;
  Method *meth_meth_lexer_new121 = addmethod2pos(obj119, "new", &meth_lexer_new121, 1);
  int argcv_meth_lexer_new121[] = {1};
  meth_meth_lexer_new121->type = alloc_MethodType(1, argcv_meth_lexer_new121);
  meth_meth_lexer_new121->definitionModule = modulename;
  meth_meth_lexer_new121->definitionLine = 50;
  block_savedest(obj119);
  Object closure137 = createclosure(3, "new()object");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_Token);
  addtoclosure(closure137, var_stringStart);
  addtoclosure(closure137, var_linePosition);
  Method *meth_meth_lexer_new121_object = addmethod2pos(obj119, "new()object", &meth_lexer_new121_object, 1);
  meth_meth_lexer_new121_object->definitionModule = modulename;
  meth_meth_lexer_new121_object->definitionLine = 50;
  sourceObject = obj119;
  objclass119 = obj119->class;
  objclass119->definitionModule = modulename;
  objclass119->definitionLine = 50;
  (*(struct UserObject *)self).data[0] = lowerouter119;
  self = oldself119;
  selfslot = oldselfslot119;
  stackframe = oldstackframe119;
// compiled object node returning obj119 (depth = 4)
  *var_StringToken = obj119;
  if (obj119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj138 = alloc_userobj2(2,4, objclass138);
  gc_frame_newslot(obj138);
// OBJECT OUTER DEC outer
  adddatum2(obj138, self, 0);
  addmethodreal(obj138,"outer", &reader_lexer_outer_139);
  Object oldself138 = self;
  struct StackFrameObject *oldstackframe138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe138);
  gc_frame_newslot((Object)stackframe);
  self = obj138;
  Object *oldselfslot138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter138 = (*(struct UserObject *)self).data[0], lowerouter138 = thisouter138;
  if (inheritingObject138) {
    struct UserObject *inho138 = (struct UserObject *)inheritingObject138;
    while (inho138->super != GraceDefaultObject) inho138 = (struct UserObject *)inho138->super;
    inho138->super = obj138;
    self = inheritingObject138;
    *selfslot = self;
    lowerouter138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter138;
  }
// method new
  block_savedest(obj138);
  Object closure140 = createclosure(3, "new");
  setclosureframe(closure140, stackframe);
  addtoclosure(closure140, var_Token);
  addtoclosure(closure140, var_startLine);
  addtoclosure(closure140, var_stringStart);
  struct UserObject *uo140 = (struct UserObject*)obj138;
  uo140->data[1] = (Object)closure140;
  Method *meth_meth_lexer_new140 = addmethod2pos(obj138, "new", &meth_lexer_new140, 1);
  int argcv_meth_lexer_new140[] = {1};
  meth_meth_lexer_new140->type = alloc_MethodType(1, argcv_meth_lexer_new140);
  meth_meth_lexer_new140->definitionModule = modulename;
  meth_meth_lexer_new140->definitionLine = 56;
  block_savedest(obj138);
  Object closure163 = createclosure(3, "new()object");
  setclosureframe(closure163, stackframe);
  addtoclosure(closure163, var_Token);
  addtoclosure(closure163, var_startLine);
  addtoclosure(closure163, var_stringStart);
  Method *meth_meth_lexer_new140_object = addmethod2pos(obj138, "new()object", &meth_lexer_new140_object, 1);
  meth_meth_lexer_new140_object->definitionModule = modulename;
  meth_meth_lexer_new140_object->definitionLine = 56;
  sourceObject = obj138;
  objclass138 = obj138->class;
  objclass138->definitionModule = modulename;
  objclass138->definitionLine = 56;
  (*(struct UserObject *)self).data[0] = lowerouter138;
  self = oldself138;
  selfslot = oldselfslot138;
  stackframe = oldstackframe138;
// compiled object node returning obj138 (depth = 4)
  *var_MultiLineStringToken = obj138;
  if (obj138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject164 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj164 = alloc_userobj2(2,4, objclass164);
  gc_frame_newslot(obj164);
// OBJECT OUTER DEC outer
  adddatum2(obj164, self, 0);
  addmethodreal(obj164,"outer", &reader_lexer_outer_165);
  Object oldself164 = self;
  struct StackFrameObject *oldstackframe164 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe164);
  gc_frame_newslot((Object)stackframe);
  self = obj164;
  Object *oldselfslot164 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter164 = (*(struct UserObject *)self).data[0], lowerouter164 = thisouter164;
  if (inheritingObject164) {
    struct UserObject *inho164 = (struct UserObject *)inheritingObject164;
    while (inho164->super != GraceDefaultObject) inho164 = (struct UserObject *)inho164->super;
    inho164->super = obj164;
    self = inheritingObject164;
    *selfslot = self;
    lowerouter164 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter164;
  }
// method new
  block_savedest(obj164);
  Object closure166 = createclosure(1, "new");
  setclosureframe(closure166, stackframe);
  addtoclosure(closure166, var_Token);
  struct UserObject *uo166 = (struct UserObject*)obj164;
  uo166->data[1] = (Object)closure166;
  Method *meth_meth_lexer_new166 = addmethod2pos(obj164, "new", &meth_lexer_new166, 1);
  int argcv_meth_lexer_new166[] = {1};
  meth_meth_lexer_new166->type = alloc_MethodType(1, argcv_meth_lexer_new166);
  meth_meth_lexer_new166->definitionModule = modulename;
  meth_meth_lexer_new166->definitionLine = 66;
  block_savedest(obj164);
  Object closure181 = createclosure(1, "new()object");
  setclosureframe(closure181, stackframe);
  addtoclosure(closure181, var_Token);
  Method *meth_meth_lexer_new166_object = addmethod2pos(obj164, "new()object", &meth_lexer_new166_object, 1);
  meth_meth_lexer_new166_object->definitionModule = modulename;
  meth_meth_lexer_new166_object->definitionLine = 66;
  sourceObject = obj164;
  objclass164 = obj164->class;
  objclass164->definitionModule = modulename;
  objclass164->definitionLine = 66;
  (*(struct UserObject *)self).data[0] = lowerouter164;
  self = oldself164;
  selfslot = oldselfslot164;
  stackframe = oldstackframe164;
// compiled object node returning obj164 (depth = 4)
  *var_CommentToken = obj164;
  if (obj164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject182 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj182 = alloc_userobj2(2,4, objclass182);
  gc_frame_newslot(obj182);
// OBJECT OUTER DEC outer
  adddatum2(obj182, self, 0);
  addmethodreal(obj182,"outer", &reader_lexer_outer_183);
  Object oldself182 = self;
  struct StackFrameObject *oldstackframe182 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe182);
  gc_frame_newslot((Object)stackframe);
  self = obj182;
  Object *oldselfslot182 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter182 = (*(struct UserObject *)self).data[0], lowerouter182 = thisouter182;
  if (inheritingObject182) {
    struct UserObject *inho182 = (struct UserObject *)inheritingObject182;
    while (inho182->super != GraceDefaultObject) inho182 = (struct UserObject *)inho182->super;
    inho182->super = obj182;
    self = inheritingObject182;
    *selfslot = self;
    lowerouter182 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter182;
  }
// method new
  block_savedest(obj182);
  Object closure184 = createclosure(1, "new");
  setclosureframe(closure184, stackframe);
  addtoclosure(closure184, var_Token);
  struct UserObject *uo184 = (struct UserObject*)obj182;
  uo184->data[1] = (Object)closure184;
  Method *meth_meth_lexer_new184 = addmethod2pos(obj182, "new", &meth_lexer_new184, 1);
  int argcv_meth_lexer_new184[] = {0};
  meth_meth_lexer_new184->type = alloc_MethodType(1, argcv_meth_lexer_new184);
  meth_meth_lexer_new184->definitionModule = modulename;
  meth_meth_lexer_new184->definitionLine = 72;
  block_savedest(obj182);
  Object closure195 = createclosure(1, "new()object");
  setclosureframe(closure195, stackframe);
  addtoclosure(closure195, var_Token);
  Method *meth_meth_lexer_new184_object = addmethod2pos(obj182, "new()object", &meth_lexer_new184_object, 1);
  meth_meth_lexer_new184_object->definitionModule = modulename;
  meth_meth_lexer_new184_object->definitionLine = 72;
  sourceObject = obj182;
  objclass182 = obj182->class;
  objclass182->definitionModule = modulename;
  objclass182->definitionLine = 72;
  (*(struct UserObject *)self).data[0] = lowerouter182;
  self = oldself182;
  selfslot = oldselfslot182;
  stackframe = oldstackframe182;
// compiled object node returning obj182 (depth = 4)
  *var_LBraceToken = obj182;
  if (obj182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject196 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj196 = alloc_userobj2(2,4, objclass196);
  gc_frame_newslot(obj196);
// OBJECT OUTER DEC outer
  adddatum2(obj196, self, 0);
  addmethodreal(obj196,"outer", &reader_lexer_outer_197);
  Object oldself196 = self;
  struct StackFrameObject *oldstackframe196 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe196);
  gc_frame_newslot((Object)stackframe);
  self = obj196;
  Object *oldselfslot196 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter196 = (*(struct UserObject *)self).data[0], lowerouter196 = thisouter196;
  if (inheritingObject196) {
    struct UserObject *inho196 = (struct UserObject *)inheritingObject196;
    while (inho196->super != GraceDefaultObject) inho196 = (struct UserObject *)inho196->super;
    inho196->super = obj196;
    self = inheritingObject196;
    *selfslot = self;
    lowerouter196 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter196;
  }
// method new
  block_savedest(obj196);
  Object closure198 = createclosure(1, "new");
  setclosureframe(closure198, stackframe);
  addtoclosure(closure198, var_Token);
  struct UserObject *uo198 = (struct UserObject*)obj196;
  uo198->data[1] = (Object)closure198;
  Method *meth_meth_lexer_new198 = addmethod2pos(obj196, "new", &meth_lexer_new198, 1);
  int argcv_meth_lexer_new198[] = {0};
  meth_meth_lexer_new198->type = alloc_MethodType(1, argcv_meth_lexer_new198);
  meth_meth_lexer_new198->definitionModule = modulename;
  meth_meth_lexer_new198->definitionLine = 78;
  block_savedest(obj196);
  Object closure209 = createclosure(1, "new()object");
  setclosureframe(closure209, stackframe);
  addtoclosure(closure209, var_Token);
  Method *meth_meth_lexer_new198_object = addmethod2pos(obj196, "new()object", &meth_lexer_new198_object, 1);
  meth_meth_lexer_new198_object->definitionModule = modulename;
  meth_meth_lexer_new198_object->definitionLine = 78;
  sourceObject = obj196;
  objclass196 = obj196->class;
  objclass196->definitionModule = modulename;
  objclass196->definitionLine = 78;
  (*(struct UserObject *)self).data[0] = lowerouter196;
  self = oldself196;
  selfslot = oldselfslot196;
  stackframe = oldstackframe196;
// compiled object node returning obj196 (depth = 4)
  *var_RBraceToken = obj196;
  if (obj196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject210 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj210 = alloc_userobj2(2,4, objclass210);
  gc_frame_newslot(obj210);
// OBJECT OUTER DEC outer
  adddatum2(obj210, self, 0);
  addmethodreal(obj210,"outer", &reader_lexer_outer_211);
  Object oldself210 = self;
  struct StackFrameObject *oldstackframe210 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe210);
  gc_frame_newslot((Object)stackframe);
  self = obj210;
  Object *oldselfslot210 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter210 = (*(struct UserObject *)self).data[0], lowerouter210 = thisouter210;
  if (inheritingObject210) {
    struct UserObject *inho210 = (struct UserObject *)inheritingObject210;
    while (inho210->super != GraceDefaultObject) inho210 = (struct UserObject *)inho210->super;
    inho210->super = obj210;
    self = inheritingObject210;
    *selfslot = self;
    lowerouter210 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter210;
  }
// method new
  block_savedest(obj210);
  Object closure212 = createclosure(1, "new");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_Token);
  struct UserObject *uo212 = (struct UserObject*)obj210;
  uo212->data[1] = (Object)closure212;
  Method *meth_meth_lexer_new212 = addmethod2pos(obj210, "new", &meth_lexer_new212, 1);
  int argcv_meth_lexer_new212[] = {0};
  meth_meth_lexer_new212->type = alloc_MethodType(1, argcv_meth_lexer_new212);
  meth_meth_lexer_new212->definitionModule = modulename;
  meth_meth_lexer_new212->definitionLine = 84;
  block_savedest(obj210);
  Object closure223 = createclosure(1, "new()object");
  setclosureframe(closure223, stackframe);
  addtoclosure(closure223, var_Token);
  Method *meth_meth_lexer_new212_object = addmethod2pos(obj210, "new()object", &meth_lexer_new212_object, 1);
  meth_meth_lexer_new212_object->definitionModule = modulename;
  meth_meth_lexer_new212_object->definitionLine = 84;
  sourceObject = obj210;
  objclass210 = obj210->class;
  objclass210->definitionModule = modulename;
  objclass210->definitionLine = 84;
  (*(struct UserObject *)self).data[0] = lowerouter210;
  self = oldself210;
  selfslot = oldselfslot210;
  stackframe = oldstackframe210;
// compiled object node returning obj210 (depth = 4)
  *var_LParenToken = obj210;
  if (obj210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject224 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj224 = alloc_userobj2(2,4, objclass224);
  gc_frame_newslot(obj224);
// OBJECT OUTER DEC outer
  adddatum2(obj224, self, 0);
  addmethodreal(obj224,"outer", &reader_lexer_outer_225);
  Object oldself224 = self;
  struct StackFrameObject *oldstackframe224 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe224);
  gc_frame_newslot((Object)stackframe);
  self = obj224;
  Object *oldselfslot224 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter224 = (*(struct UserObject *)self).data[0], lowerouter224 = thisouter224;
  if (inheritingObject224) {
    struct UserObject *inho224 = (struct UserObject *)inheritingObject224;
    while (inho224->super != GraceDefaultObject) inho224 = (struct UserObject *)inho224->super;
    inho224->super = obj224;
    self = inheritingObject224;
    *selfslot = self;
    lowerouter224 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter224;
  }
// method new
  block_savedest(obj224);
  Object closure226 = createclosure(1, "new");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_Token);
  struct UserObject *uo226 = (struct UserObject*)obj224;
  uo226->data[1] = (Object)closure226;
  Method *meth_meth_lexer_new226 = addmethod2pos(obj224, "new", &meth_lexer_new226, 1);
  int argcv_meth_lexer_new226[] = {0};
  meth_meth_lexer_new226->type = alloc_MethodType(1, argcv_meth_lexer_new226);
  meth_meth_lexer_new226->definitionModule = modulename;
  meth_meth_lexer_new226->definitionLine = 90;
  block_savedest(obj224);
  Object closure237 = createclosure(1, "new()object");
  setclosureframe(closure237, stackframe);
  addtoclosure(closure237, var_Token);
  Method *meth_meth_lexer_new226_object = addmethod2pos(obj224, "new()object", &meth_lexer_new226_object, 1);
  meth_meth_lexer_new226_object->definitionModule = modulename;
  meth_meth_lexer_new226_object->definitionLine = 90;
  sourceObject = obj224;
  objclass224 = obj224->class;
  objclass224->definitionModule = modulename;
  objclass224->definitionLine = 90;
  (*(struct UserObject *)self).data[0] = lowerouter224;
  self = oldself224;
  selfslot = oldselfslot224;
  stackframe = oldstackframe224;
// compiled object node returning obj224 (depth = 4)
  *var_RParenToken = obj224;
  if (obj224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject238 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj238 = alloc_userobj2(2,4, objclass238);
  gc_frame_newslot(obj238);
// OBJECT OUTER DEC outer
  adddatum2(obj238, self, 0);
  addmethodreal(obj238,"outer", &reader_lexer_outer_239);
  Object oldself238 = self;
  struct StackFrameObject *oldstackframe238 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe238);
  gc_frame_newslot((Object)stackframe);
  self = obj238;
  Object *oldselfslot238 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter238 = (*(struct UserObject *)self).data[0], lowerouter238 = thisouter238;
  if (inheritingObject238) {
    struct UserObject *inho238 = (struct UserObject *)inheritingObject238;
    while (inho238->super != GraceDefaultObject) inho238 = (struct UserObject *)inho238->super;
    inho238->super = obj238;
    self = inheritingObject238;
    *selfslot = self;
    lowerouter238 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter238;
  }
// method new
  block_savedest(obj238);
  Object closure240 = createclosure(1, "new");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_Token);
  struct UserObject *uo240 = (struct UserObject*)obj238;
  uo240->data[1] = (Object)closure240;
  Method *meth_meth_lexer_new240 = addmethod2pos(obj238, "new", &meth_lexer_new240, 1);
  int argcv_meth_lexer_new240[] = {0};
  meth_meth_lexer_new240->type = alloc_MethodType(1, argcv_meth_lexer_new240);
  meth_meth_lexer_new240->definitionModule = modulename;
  meth_meth_lexer_new240->definitionLine = 96;
  block_savedest(obj238);
  Object closure251 = createclosure(1, "new()object");
  setclosureframe(closure251, stackframe);
  addtoclosure(closure251, var_Token);
  Method *meth_meth_lexer_new240_object = addmethod2pos(obj238, "new()object", &meth_lexer_new240_object, 1);
  meth_meth_lexer_new240_object->definitionModule = modulename;
  meth_meth_lexer_new240_object->definitionLine = 96;
  sourceObject = obj238;
  objclass238 = obj238->class;
  objclass238->definitionModule = modulename;
  objclass238->definitionLine = 96;
  (*(struct UserObject *)self).data[0] = lowerouter238;
  self = oldself238;
  selfslot = oldselfslot238;
  stackframe = oldstackframe238;
// compiled object node returning obj238 (depth = 4)
  *var_LSquareToken = obj238;
  if (obj238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject252 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj252 = alloc_userobj2(2,4, objclass252);
  gc_frame_newslot(obj252);
// OBJECT OUTER DEC outer
  adddatum2(obj252, self, 0);
  addmethodreal(obj252,"outer", &reader_lexer_outer_253);
  Object oldself252 = self;
  struct StackFrameObject *oldstackframe252 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe252);
  gc_frame_newslot((Object)stackframe);
  self = obj252;
  Object *oldselfslot252 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter252 = (*(struct UserObject *)self).data[0], lowerouter252 = thisouter252;
  if (inheritingObject252) {
    struct UserObject *inho252 = (struct UserObject *)inheritingObject252;
    while (inho252->super != GraceDefaultObject) inho252 = (struct UserObject *)inho252->super;
    inho252->super = obj252;
    self = inheritingObject252;
    *selfslot = self;
    lowerouter252 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter252;
  }
// method new
  block_savedest(obj252);
  Object closure254 = createclosure(1, "new");
  setclosureframe(closure254, stackframe);
  addtoclosure(closure254, var_Token);
  struct UserObject *uo254 = (struct UserObject*)obj252;
  uo254->data[1] = (Object)closure254;
  Method *meth_meth_lexer_new254 = addmethod2pos(obj252, "new", &meth_lexer_new254, 1);
  int argcv_meth_lexer_new254[] = {0};
  meth_meth_lexer_new254->type = alloc_MethodType(1, argcv_meth_lexer_new254);
  meth_meth_lexer_new254->definitionModule = modulename;
  meth_meth_lexer_new254->definitionLine = 102;
  block_savedest(obj252);
  Object closure265 = createclosure(1, "new()object");
  setclosureframe(closure265, stackframe);
  addtoclosure(closure265, var_Token);
  Method *meth_meth_lexer_new254_object = addmethod2pos(obj252, "new()object", &meth_lexer_new254_object, 1);
  meth_meth_lexer_new254_object->definitionModule = modulename;
  meth_meth_lexer_new254_object->definitionLine = 102;
  sourceObject = obj252;
  objclass252 = obj252->class;
  objclass252->definitionModule = modulename;
  objclass252->definitionLine = 102;
  (*(struct UserObject *)self).data[0] = lowerouter252;
  self = oldself252;
  selfslot = oldselfslot252;
  stackframe = oldstackframe252;
// compiled object node returning obj252 (depth = 4)
  *var_RSquareToken = obj252;
  if (obj252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject266 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj266 = alloc_userobj2(2,4, objclass266);
  gc_frame_newslot(obj266);
// OBJECT OUTER DEC outer
  adddatum2(obj266, self, 0);
  addmethodreal(obj266,"outer", &reader_lexer_outer_267);
  Object oldself266 = self;
  struct StackFrameObject *oldstackframe266 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe266);
  gc_frame_newslot((Object)stackframe);
  self = obj266;
  Object *oldselfslot266 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter266 = (*(struct UserObject *)self).data[0], lowerouter266 = thisouter266;
  if (inheritingObject266) {
    struct UserObject *inho266 = (struct UserObject *)inheritingObject266;
    while (inho266->super != GraceDefaultObject) inho266 = (struct UserObject *)inho266->super;
    inho266->super = obj266;
    self = inheritingObject266;
    *selfslot = self;
    lowerouter266 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter266;
  }
// method new
  block_savedest(obj266);
  Object closure268 = createclosure(1, "new");
  setclosureframe(closure268, stackframe);
  addtoclosure(closure268, var_Token);
  struct UserObject *uo268 = (struct UserObject*)obj266;
  uo268->data[1] = (Object)closure268;
  Method *meth_meth_lexer_new268 = addmethod2pos(obj266, "new", &meth_lexer_new268, 1);
  int argcv_meth_lexer_new268[] = {0};
  meth_meth_lexer_new268->type = alloc_MethodType(1, argcv_meth_lexer_new268);
  meth_meth_lexer_new268->definitionModule = modulename;
  meth_meth_lexer_new268->definitionLine = 108;
  block_savedest(obj266);
  Object closure279 = createclosure(1, "new()object");
  setclosureframe(closure279, stackframe);
  addtoclosure(closure279, var_Token);
  Method *meth_meth_lexer_new268_object = addmethod2pos(obj266, "new()object", &meth_lexer_new268_object, 1);
  meth_meth_lexer_new268_object->definitionModule = modulename;
  meth_meth_lexer_new268_object->definitionLine = 108;
  sourceObject = obj266;
  objclass266 = obj266->class;
  objclass266->definitionModule = modulename;
  objclass266->definitionLine = 108;
  (*(struct UserObject *)self).data[0] = lowerouter266;
  self = oldself266;
  selfslot = oldselfslot266;
  stackframe = oldstackframe266;
// compiled object node returning obj266 (depth = 4)
  *var_CommaToken = obj266;
  if (obj266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject280 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj280 = alloc_userobj2(2,4, objclass280);
  gc_frame_newslot(obj280);
// OBJECT OUTER DEC outer
  adddatum2(obj280, self, 0);
  addmethodreal(obj280,"outer", &reader_lexer_outer_281);
  Object oldself280 = self;
  struct StackFrameObject *oldstackframe280 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe280);
  gc_frame_newslot((Object)stackframe);
  self = obj280;
  Object *oldselfslot280 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter280 = (*(struct UserObject *)self).data[0], lowerouter280 = thisouter280;
  if (inheritingObject280) {
    struct UserObject *inho280 = (struct UserObject *)inheritingObject280;
    while (inho280->super != GraceDefaultObject) inho280 = (struct UserObject *)inho280->super;
    inho280->super = obj280;
    self = inheritingObject280;
    *selfslot = self;
    lowerouter280 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter280;
  }
// method new
  block_savedest(obj280);
  Object closure282 = createclosure(1, "new");
  setclosureframe(closure282, stackframe);
  addtoclosure(closure282, var_Token);
  struct UserObject *uo282 = (struct UserObject*)obj280;
  uo282->data[1] = (Object)closure282;
  Method *meth_meth_lexer_new282 = addmethod2pos(obj280, "new", &meth_lexer_new282, 1);
  int argcv_meth_lexer_new282[] = {0};
  meth_meth_lexer_new282->type = alloc_MethodType(1, argcv_meth_lexer_new282);
  meth_meth_lexer_new282->definitionModule = modulename;
  meth_meth_lexer_new282->definitionLine = 114;
  block_savedest(obj280);
  Object closure293 = createclosure(1, "new()object");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_Token);
  Method *meth_meth_lexer_new282_object = addmethod2pos(obj280, "new()object", &meth_lexer_new282_object, 1);
  meth_meth_lexer_new282_object->definitionModule = modulename;
  meth_meth_lexer_new282_object->definitionLine = 114;
  sourceObject = obj280;
  objclass280 = obj280->class;
  objclass280->definitionModule = modulename;
  objclass280->definitionLine = 114;
  (*(struct UserObject *)self).data[0] = lowerouter280;
  self = oldself280;
  selfslot = oldselfslot280;
  stackframe = oldstackframe280;
// compiled object node returning obj280 (depth = 4)
  *var_ColonToken = obj280;
  if (obj280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject294 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj294 = alloc_userobj2(2,4, objclass294);
  gc_frame_newslot(obj294);
// OBJECT OUTER DEC outer
  adddatum2(obj294, self, 0);
  addmethodreal(obj294,"outer", &reader_lexer_outer_295);
  Object oldself294 = self;
  struct StackFrameObject *oldstackframe294 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe294);
  gc_frame_newslot((Object)stackframe);
  self = obj294;
  Object *oldselfslot294 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter294 = (*(struct UserObject *)self).data[0], lowerouter294 = thisouter294;
  if (inheritingObject294) {
    struct UserObject *inho294 = (struct UserObject *)inheritingObject294;
    while (inho294->super != GraceDefaultObject) inho294 = (struct UserObject *)inho294->super;
    inho294->super = obj294;
    self = inheritingObject294;
    *selfslot = self;
    lowerouter294 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter294;
  }
// method new
  block_savedest(obj294);
  Object closure296 = createclosure(1, "new");
  setclosureframe(closure296, stackframe);
  addtoclosure(closure296, var_Token);
  struct UserObject *uo296 = (struct UserObject*)obj294;
  uo296->data[1] = (Object)closure296;
  Method *meth_meth_lexer_new296 = addmethod2pos(obj294, "new", &meth_lexer_new296, 1);
  int argcv_meth_lexer_new296[] = {0};
  meth_meth_lexer_new296->type = alloc_MethodType(1, argcv_meth_lexer_new296);
  meth_meth_lexer_new296->definitionModule = modulename;
  meth_meth_lexer_new296->definitionLine = 120;
  block_savedest(obj294);
  Object closure307 = createclosure(1, "new()object");
  setclosureframe(closure307, stackframe);
  addtoclosure(closure307, var_Token);
  Method *meth_meth_lexer_new296_object = addmethod2pos(obj294, "new()object", &meth_lexer_new296_object, 1);
  meth_meth_lexer_new296_object->definitionModule = modulename;
  meth_meth_lexer_new296_object->definitionLine = 120;
  sourceObject = obj294;
  objclass294 = obj294->class;
  objclass294->definitionModule = modulename;
  objclass294->definitionLine = 120;
  (*(struct UserObject *)self).data[0] = lowerouter294;
  self = oldself294;
  selfslot = oldselfslot294;
  stackframe = oldstackframe294;
// compiled object node returning obj294 (depth = 4)
  *var_DotToken = obj294;
  if (obj294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj308 = alloc_userobj2(2,4, objclass308);
  gc_frame_newslot(obj308);
// OBJECT OUTER DEC outer
  adddatum2(obj308, self, 0);
  addmethodreal(obj308,"outer", &reader_lexer_outer_309);
  Object oldself308 = self;
  struct StackFrameObject *oldstackframe308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe308);
  gc_frame_newslot((Object)stackframe);
  self = obj308;
  Object *oldselfslot308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter308 = (*(struct UserObject *)self).data[0], lowerouter308 = thisouter308;
  if (inheritingObject308) {
    struct UserObject *inho308 = (struct UserObject *)inheritingObject308;
    while (inho308->super != GraceDefaultObject) inho308 = (struct UserObject *)inho308->super;
    inho308->super = obj308;
    self = inheritingObject308;
    *selfslot = self;
    lowerouter308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter308;
  }
// method new
  block_savedest(obj308);
  Object closure310 = createclosure(3, "new");
  setclosureframe(closure310, stackframe);
  addtoclosure(closure310, var_Token);
  addtoclosure(closure310, var_startPosition);
  addtoclosure(closure310, var_linePosition);
  struct UserObject *uo310 = (struct UserObject*)obj308;
  uo310->data[1] = (Object)closure310;
  Method *meth_meth_lexer_new310 = addmethod2pos(obj308, "new", &meth_lexer_new310, 1);
  int argcv_meth_lexer_new310[] = {2};
  meth_meth_lexer_new310->type = alloc_MethodType(1, argcv_meth_lexer_new310);
  meth_meth_lexer_new310->definitionModule = modulename;
  meth_meth_lexer_new310->definitionLine = 126;
  block_savedest(obj308);
  Object closure323 = createclosure(3, "new()object");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_Token);
  addtoclosure(closure323, var_startPosition);
  addtoclosure(closure323, var_linePosition);
  Method *meth_meth_lexer_new310_object = addmethod2pos(obj308, "new()object", &meth_lexer_new310_object, 1);
  meth_meth_lexer_new310_object->definitionModule = modulename;
  meth_meth_lexer_new310_object->definitionLine = 126;
  sourceObject = obj308;
  objclass308 = obj308->class;
  objclass308->definitionModule = modulename;
  objclass308->definitionLine = 126;
  (*(struct UserObject *)self).data[0] = lowerouter308;
  self = oldself308;
  selfslot = oldselfslot308;
  stackframe = oldstackframe308;
// compiled object node returning obj308 (depth = 4)
  *var_NumToken = obj308;
  if (obj308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(2,4, objclass324);
  gc_frame_newslot(obj324);
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_lexer_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
// method new
  block_savedest(obj324);
  Object closure326 = createclosure(1, "new");
  setclosureframe(closure326, stackframe);
  addtoclosure(closure326, var_Token);
  struct UserObject *uo326 = (struct UserObject*)obj324;
  uo326->data[1] = (Object)closure326;
  Method *meth_meth_lexer_new326 = addmethod2pos(obj324, "new", &meth_lexer_new326, 1);
  int argcv_meth_lexer_new326[] = {1};
  meth_meth_lexer_new326->type = alloc_MethodType(1, argcv_meth_lexer_new326);
  meth_meth_lexer_new326->definitionModule = modulename;
  meth_meth_lexer_new326->definitionLine = 133;
  block_savedest(obj324);
  Object closure337 = createclosure(1, "new()object");
  setclosureframe(closure337, stackframe);
  addtoclosure(closure337, var_Token);
  Method *meth_meth_lexer_new326_object = addmethod2pos(obj324, "new()object", &meth_lexer_new326_object, 1);
  meth_meth_lexer_new326_object->definitionModule = modulename;
  meth_meth_lexer_new326_object->definitionLine = 133;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 133;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
// compiled object node returning obj324 (depth = 4)
  *var_KeywordToken = obj324;
  if (obj324 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject338 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj338 = alloc_userobj2(2,4, objclass338);
  gc_frame_newslot(obj338);
// OBJECT OUTER DEC outer
  adddatum2(obj338, self, 0);
  addmethodreal(obj338,"outer", &reader_lexer_outer_339);
  Object oldself338 = self;
  struct StackFrameObject *oldstackframe338 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe338);
  gc_frame_newslot((Object)stackframe);
  self = obj338;
  Object *oldselfslot338 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter338 = (*(struct UserObject *)self).data[0], lowerouter338 = thisouter338;
  if (inheritingObject338) {
    struct UserObject *inho338 = (struct UserObject *)inheritingObject338;
    while (inho338->super != GraceDefaultObject) inho338 = (struct UserObject *)inho338->super;
    inho338->super = obj338;
    self = inheritingObject338;
    *selfslot = self;
    lowerouter338 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter338;
  }
// method new
  block_savedest(obj338);
  Object closure340 = createclosure(1, "new");
  setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_Token);
  struct UserObject *uo340 = (struct UserObject*)obj338;
  uo340->data[1] = (Object)closure340;
  Method *meth_meth_lexer_new340 = addmethod2pos(obj338, "new", &meth_lexer_new340, 1);
  int argcv_meth_lexer_new340[] = {1};
  meth_meth_lexer_new340->type = alloc_MethodType(1, argcv_meth_lexer_new340);
  meth_meth_lexer_new340->definitionModule = modulename;
  meth_meth_lexer_new340->definitionLine = 139;
  block_savedest(obj338);
  Object closure351 = createclosure(1, "new()object");
  setclosureframe(closure351, stackframe);
  addtoclosure(closure351, var_Token);
  Method *meth_meth_lexer_new340_object = addmethod2pos(obj338, "new()object", &meth_lexer_new340_object, 1);
  meth_meth_lexer_new340_object->definitionModule = modulename;
  meth_meth_lexer_new340_object->definitionLine = 139;
  sourceObject = obj338;
  objclass338 = obj338->class;
  objclass338->definitionModule = modulename;
  objclass338->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter338;
  self = oldself338;
  selfslot = oldselfslot338;
  stackframe = oldstackframe338;
// compiled object node returning obj338 (depth = 4)
  *var_OpToken = obj338;
  if (obj338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject352 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj352 = alloc_userobj2(2,4, objclass352);
  gc_frame_newslot(obj352);
// OBJECT OUTER DEC outer
  adddatum2(obj352, self, 0);
  addmethodreal(obj352,"outer", &reader_lexer_outer_353);
  Object oldself352 = self;
  struct StackFrameObject *oldstackframe352 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe352);
  gc_frame_newslot((Object)stackframe);
  self = obj352;
  Object *oldselfslot352 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter352 = (*(struct UserObject *)self).data[0], lowerouter352 = thisouter352;
  if (inheritingObject352) {
    struct UserObject *inho352 = (struct UserObject *)inheritingObject352;
    while (inho352->super != GraceDefaultObject) inho352 = (struct UserObject *)inho352->super;
    inho352->super = obj352;
    self = inheritingObject352;
    *selfslot = self;
    lowerouter352 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter352;
  }
// method new
  block_savedest(obj352);
  Object closure354 = createclosure(1, "new");
  setclosureframe(closure354, stackframe);
  addtoclosure(closure354, var_Token);
  struct UserObject *uo354 = (struct UserObject*)obj352;
  uo354->data[1] = (Object)closure354;
  Method *meth_meth_lexer_new354 = addmethod2pos(obj352, "new", &meth_lexer_new354, 1);
  int argcv_meth_lexer_new354[] = {0};
  meth_meth_lexer_new354->type = alloc_MethodType(1, argcv_meth_lexer_new354);
  meth_meth_lexer_new354->definitionModule = modulename;
  meth_meth_lexer_new354->definitionLine = 145;
  block_savedest(obj352);
  Object closure365 = createclosure(1, "new()object");
  setclosureframe(closure365, stackframe);
  addtoclosure(closure365, var_Token);
  Method *meth_meth_lexer_new354_object = addmethod2pos(obj352, "new()object", &meth_lexer_new354_object, 1);
  meth_meth_lexer_new354_object->definitionModule = modulename;
  meth_meth_lexer_new354_object->definitionLine = 145;
  sourceObject = obj352;
  objclass352 = obj352->class;
  objclass352->definitionModule = modulename;
  objclass352->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter352;
  self = oldself352;
  selfslot = oldselfslot352;
  stackframe = oldstackframe352;
// compiled object node returning obj352 (depth = 4)
  *var_ArrowToken = obj352;
  if (obj352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject366 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj366 = alloc_userobj2(2,4, objclass366);
  gc_frame_newslot(obj366);
// OBJECT OUTER DEC outer
  adddatum2(obj366, self, 0);
  addmethodreal(obj366,"outer", &reader_lexer_outer_367);
  Object oldself366 = self;
  struct StackFrameObject *oldstackframe366 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe366);
  gc_frame_newslot((Object)stackframe);
  self = obj366;
  Object *oldselfslot366 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter366 = (*(struct UserObject *)self).data[0], lowerouter366 = thisouter366;
  if (inheritingObject366) {
    struct UserObject *inho366 = (struct UserObject *)inheritingObject366;
    while (inho366->super != GraceDefaultObject) inho366 = (struct UserObject *)inho366->super;
    inho366->super = obj366;
    self = inheritingObject366;
    *selfslot = self;
    lowerouter366 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter366;
  }
// method new
  block_savedest(obj366);
  Object closure368 = createclosure(1, "new");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_Token);
  struct UserObject *uo368 = (struct UserObject*)obj366;
  uo368->data[1] = (Object)closure368;
  Method *meth_meth_lexer_new368 = addmethod2pos(obj366, "new", &meth_lexer_new368, 1);
  int argcv_meth_lexer_new368[] = {0};
  meth_meth_lexer_new368->type = alloc_MethodType(1, argcv_meth_lexer_new368);
  meth_meth_lexer_new368->definitionModule = modulename;
  meth_meth_lexer_new368->definitionLine = 151;
  block_savedest(obj366);
  Object closure379 = createclosure(1, "new()object");
  setclosureframe(closure379, stackframe);
  addtoclosure(closure379, var_Token);
  Method *meth_meth_lexer_new368_object = addmethod2pos(obj366, "new()object", &meth_lexer_new368_object, 1);
  meth_meth_lexer_new368_object->definitionModule = modulename;
  meth_meth_lexer_new368_object->definitionLine = 151;
  sourceObject = obj366;
  objclass366 = obj366->class;
  objclass366->definitionModule = modulename;
  objclass366->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter366;
  self = oldself366;
  selfslot = oldselfslot366;
  stackframe = oldstackframe366;
// compiled object node returning obj366 (depth = 4)
  *var_BindToken = obj366;
  if (obj366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject380 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj380 = alloc_userobj2(2,4, objclass380);
  gc_frame_newslot(obj380);
// OBJECT OUTER DEC outer
  adddatum2(obj380, self, 0);
  addmethodreal(obj380,"outer", &reader_lexer_outer_381);
  Object oldself380 = self;
  struct StackFrameObject *oldstackframe380 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe380);
  gc_frame_newslot((Object)stackframe);
  self = obj380;
  Object *oldselfslot380 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter380 = (*(struct UserObject *)self).data[0], lowerouter380 = thisouter380;
  if (inheritingObject380) {
    struct UserObject *inho380 = (struct UserObject *)inheritingObject380;
    while (inho380->super != GraceDefaultObject) inho380 = (struct UserObject *)inho380->super;
    inho380->super = obj380;
    self = inheritingObject380;
    *selfslot = self;
    lowerouter380 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter380;
  }
// method new
  block_savedest(obj380);
  Object closure382 = createclosure(1, "new");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_Token);
  struct UserObject *uo382 = (struct UserObject*)obj380;
  uo382->data[1] = (Object)closure382;
  Method *meth_meth_lexer_new382 = addmethod2pos(obj380, "new", &meth_lexer_new382, 1);
  int argcv_meth_lexer_new382[] = {0};
  meth_meth_lexer_new382->type = alloc_MethodType(1, argcv_meth_lexer_new382);
  meth_meth_lexer_new382->definitionModule = modulename;
  meth_meth_lexer_new382->definitionLine = 157;
  block_savedest(obj380);
  Object closure393 = createclosure(1, "new()object");
  setclosureframe(closure393, stackframe);
  addtoclosure(closure393, var_Token);
  Method *meth_meth_lexer_new382_object = addmethod2pos(obj380, "new()object", &meth_lexer_new382_object, 1);
  meth_meth_lexer_new382_object->definitionModule = modulename;
  meth_meth_lexer_new382_object->definitionLine = 157;
  sourceObject = obj380;
  objclass380 = obj380->class;
  objclass380->definitionModule = modulename;
  objclass380->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter380;
  self = oldself380;
  selfslot = oldselfslot380;
  stackframe = oldstackframe380;
// compiled object node returning obj380 (depth = 4)
  *var_SemicolonToken = obj380;
  if (obj380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject394 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj394 = alloc_userobj2(2,4, objclass394);
  gc_frame_newslot(obj394);
// OBJECT OUTER DEC outer
  adddatum2(obj394, self, 0);
  addmethodreal(obj394,"outer", &reader_lexer_outer_395);
  Object oldself394 = self;
  struct StackFrameObject *oldstackframe394 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe394);
  gc_frame_newslot((Object)stackframe);
  self = obj394;
  Object *oldselfslot394 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter394 = (*(struct UserObject *)self).data[0], lowerouter394 = thisouter394;
  if (inheritingObject394) {
    struct UserObject *inho394 = (struct UserObject *)inheritingObject394;
    while (inho394->super != GraceDefaultObject) inho394 = (struct UserObject *)inho394->super;
    inho394->super = obj394;
    self = inheritingObject394;
    *selfslot = self;
    lowerouter394 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter394;
  }
// method new
  block_savedest(obj394);
  Object closure396 = createclosure(1, "new");
  setclosureframe(closure396, stackframe);
  addtoclosure(closure396, var_Token);
  struct UserObject *uo396 = (struct UserObject*)obj394;
  uo396->data[1] = (Object)closure396;
  Method *meth_meth_lexer_new396 = addmethod2pos(obj394, "new", &meth_lexer_new396, 1);
  int argcv_meth_lexer_new396[] = {0};
  meth_meth_lexer_new396->type = alloc_MethodType(1, argcv_meth_lexer_new396);
  meth_meth_lexer_new396->definitionModule = modulename;
  meth_meth_lexer_new396->definitionLine = 163;
  block_savedest(obj394);
  Object closure407 = createclosure(1, "new()object");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_Token);
  Method *meth_meth_lexer_new396_object = addmethod2pos(obj394, "new()object", &meth_lexer_new396_object, 1);
  meth_meth_lexer_new396_object->definitionModule = modulename;
  meth_meth_lexer_new396_object->definitionLine = 163;
  sourceObject = obj394;
  objclass394 = obj394->class;
  objclass394->definitionModule = modulename;
  objclass394->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter394;
  self = oldself394;
  selfslot = oldselfslot394;
  stackframe = oldstackframe394;
// compiled object node returning obj394 (depth = 4)
  *var_LGenericToken = obj394;
  if (obj394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject408 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj408 = alloc_userobj2(2,4, objclass408);
  gc_frame_newslot(obj408);
// OBJECT OUTER DEC outer
  adddatum2(obj408, self, 0);
  addmethodreal(obj408,"outer", &reader_lexer_outer_409);
  Object oldself408 = self;
  struct StackFrameObject *oldstackframe408 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe408);
  gc_frame_newslot((Object)stackframe);
  self = obj408;
  Object *oldselfslot408 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter408 = (*(struct UserObject *)self).data[0], lowerouter408 = thisouter408;
  if (inheritingObject408) {
    struct UserObject *inho408 = (struct UserObject *)inheritingObject408;
    while (inho408->super != GraceDefaultObject) inho408 = (struct UserObject *)inho408->super;
    inho408->super = obj408;
    self = inheritingObject408;
    *selfslot = self;
    lowerouter408 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter408;
  }
// method new
  block_savedest(obj408);
  Object closure410 = createclosure(1, "new");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_Token);
  struct UserObject *uo410 = (struct UserObject*)obj408;
  uo410->data[1] = (Object)closure410;
  Method *meth_meth_lexer_new410 = addmethod2pos(obj408, "new", &meth_lexer_new410, 1);
  int argcv_meth_lexer_new410[] = {0};
  meth_meth_lexer_new410->type = alloc_MethodType(1, argcv_meth_lexer_new410);
  meth_meth_lexer_new410->definitionModule = modulename;
  meth_meth_lexer_new410->definitionLine = 169;
  block_savedest(obj408);
  Object closure421 = createclosure(1, "new()object");
  setclosureframe(closure421, stackframe);
  addtoclosure(closure421, var_Token);
  Method *meth_meth_lexer_new410_object = addmethod2pos(obj408, "new()object", &meth_lexer_new410_object, 1);
  meth_meth_lexer_new410_object->definitionModule = modulename;
  meth_meth_lexer_new410_object->definitionLine = 169;
  sourceObject = obj408;
  objclass408 = obj408->class;
  objclass408->definitionModule = modulename;
  objclass408->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter408;
  self = oldself408;
  selfslot = oldselfslot408;
  stackframe = oldstackframe408;
// compiled object node returning obj408 (depth = 4)
  *var_RGenericToken = obj408;
  if (obj408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj422 = alloc_userobj2(2,4, objclass422);
  gc_frame_newslot(obj422);
// OBJECT OUTER DEC outer
  adddatum2(obj422, self, 0);
  addmethodreal(obj422,"outer", &reader_lexer_outer_423);
  Object oldself422 = self;
  struct StackFrameObject *oldstackframe422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe422);
  gc_frame_newslot((Object)stackframe);
  self = obj422;
  Object *oldselfslot422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter422 = (*(struct UserObject *)self).data[0], lowerouter422 = thisouter422;
  if (inheritingObject422) {
    struct UserObject *inho422 = (struct UserObject *)inheritingObject422;
    while (inho422->super != GraceDefaultObject) inho422 = (struct UserObject *)inho422->super;
    inho422->super = obj422;
    self = inheritingObject422;
    *selfslot = self;
    lowerouter422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter422;
  }
// method new
  block_savedest(obj422);
  Object closure424 = createclosure(1, "new");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_Token);
  struct UserObject *uo424 = (struct UserObject*)obj422;
  uo424->data[1] = (Object)closure424;
  Method *meth_meth_lexer_new424 = addmethod2pos(obj422, "new", &meth_lexer_new424, 1);
  int argcv_meth_lexer_new424[] = {0};
  meth_meth_lexer_new424->type = alloc_MethodType(1, argcv_meth_lexer_new424);
  meth_meth_lexer_new424->definitionModule = modulename;
  meth_meth_lexer_new424->definitionLine = 175;
  block_savedest(obj422);
  Object closure435 = createclosure(1, "new()object");
  setclosureframe(closure435, stackframe);
  addtoclosure(closure435, var_Token);
  Method *meth_meth_lexer_new424_object = addmethod2pos(obj422, "new()object", &meth_lexer_new424_object, 1);
  meth_meth_lexer_new424_object->definitionModule = modulename;
  meth_meth_lexer_new424_object->definitionLine = 175;
  sourceObject = obj422;
  objclass422 = obj422->class;
  objclass422->definitionModule = modulename;
  objclass422->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter422;
  self = oldself422;
  selfslot = oldselfslot422;
  stackframe = oldstackframe422;
// compiled object node returning obj422 (depth = 4)
  *var_eofToken = obj422;
  if (obj422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject436 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj436 = alloc_userobj2(8,9, objclass436);
  gc_frame_newslot(obj436);
if (objclass436 == NULL) {
  glfree(obj436->class->name);
  obj436->class->name = "self.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj436, self, 0);
  addmethodreal(obj436,"outer", &reader_lexer_outer_437);
  Object oldself436 = self;
  struct StackFrameObject *oldstackframe436 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe436);
  gc_frame_newslot((Object)stackframe);
  self = obj436;
  Object *oldselfslot436 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter436 = (*(struct UserObject *)self).data[0], lowerouter436 = thisouter436;
  if (inheritingObject436) {
    struct UserObject *inho436 = (struct UserObject *)inheritingObject436;
    while (inho436->super != GraceDefaultObject) inho436 = (struct UserObject *)inho436->super;
    inho436->super = obj436;
    self = inheritingObject436;
    *selfslot = self;
    lowerouter436 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter436;
  }
// method modechange
  block_savedest(obj436);
  Object closure438 = createclosure(27, "modechange");
  setclosureframe(closure438, stackframe);
  addtoclosure(closure438, var_IdentifierToken);
  addtoclosure(closure438, var_KeywordToken);
  addtoclosure(closure438, var_StringToken);
  addtoclosure(closure438, var_MultiLineStringToken);
  addtoclosure(closure438, var_CommaToken);
  addtoclosure(closure438, var_DotToken);
  addtoclosure(closure438, var_LBraceToken);
  addtoclosure(closure438, var_RBraceToken);
  addtoclosure(closure438, var_LParenToken);
  addtoclosure(closure438, var_RParenToken);
  addtoclosure(closure438, var_LSquareToken);
  addtoclosure(closure438, var_RSquareToken);
  addtoclosure(closure438, var_LGenericToken);
  addtoclosure(closure438, var_RGenericToken);
  addtoclosure(closure438, var_SemicolonToken);
  addtoclosure(closure438, var_NumToken);
  addtoclosure(closure438, var_errormessages);
  addtoclosure(closure438, var_linePosition);
  addtoclosure(closure438, var_lineNumber);
  addtoclosure(closure438, var_OpToken);
  addtoclosure(closure438, var_ArrowToken);
  addtoclosure(closure438, var_BindToken);
  addtoclosure(closure438, var_ColonToken);
  addtoclosure(closure438, var_indentLevel);
  addtoclosure(closure438, var_CommentToken);
  addtoclosure(closure438, var_util);
  addtoclosure(closure438, var_startPosition);
  struct UserObject *uo438 = (struct UserObject*)obj436;
  uo438->data[1] = (Object)closure438;
  Method *meth_meth_lexer_modechange438 = addmethod2pos(obj436, "modechange", &meth_lexer_modechange438, 1);
  int argcv_meth_lexer_modechange438[] = {3};
  meth_meth_lexer_modechange438->type = alloc_MethodType(1, argcv_meth_lexer_modechange438);
  meth_meth_lexer_modechange438->definitionModule = modulename;
  meth_meth_lexer_modechange438->definitionLine = 200;
// method fromBase
  block_savedest(obj436);
  Object closure1207 = createclosure(4, "fromBase");
  setclosureframe(closure1207, stackframe);
  addtoclosure(closure1207, var_errormessages);
  addtoclosure(closure1207, var_linePosition);
  addtoclosure(closure1207, var_lineNumber);
  addtoclosure(closure1207, var_unicode);
  struct UserObject *uo1207 = (struct UserObject*)obj436;
  uo1207->data[2] = (Object)closure1207;
  Method *meth_meth_lexer_fromBase1207 = addmethod2pos(obj436, "fromBase", &meth_lexer_fromBase1207, 2);
  int argcv_meth_lexer_fromBase1207[] = {2};
  meth_meth_lexer_fromBase1207->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1207);
  meth_meth_lexer_fromBase1207->definitionModule = modulename;
  meth_meth_lexer_fromBase1207->definitionLine = 384;
// method hexdecchar
  block_savedest(obj436);
  Object closure1423 = createclosure(3, "hexdecchar");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_lineNumber);
  addtoclosure(closure1423, var_linePosition);
  addtoclosure(closure1423, var_errormessages);
  struct UserObject *uo1423 = (struct UserObject*)obj436;
  uo1423->data[3] = (Object)closure1423;
  Method *meth_meth_lexer_hexdecchar1423 = addmethod2pos(obj436, "hexdecchar", &meth_lexer_hexdecchar1423, 3);
  int argcv_meth_lexer_hexdecchar1423[] = {1};
  meth_meth_lexer_hexdecchar1423->type = alloc_MethodType(1, argcv_meth_lexer_hexdecchar1423);
  meth_meth_lexer_hexdecchar1423->definitionModule = modulename;
  meth_meth_lexer_hexdecchar1423->definitionLine = 426;
// method makeNumToken
  block_savedest(obj436);
  Object closure1501 = createclosure(4, "makeNumToken");
  setclosureframe(closure1501, stackframe);
  addtoclosure(closure1501, var_errormessages);
  addtoclosure(closure1501, var_linePosition);
  addtoclosure(closure1501, var_lineNumber);
  addtoclosure(closure1501, var_NumToken);
  struct UserObject *uo1501 = (struct UserObject*)obj436;
  uo1501->data[4] = (Object)closure1501;
  Method *meth_meth_lexer_makeNumToken1501 = addmethod2pos(obj436, "makeNumToken", &meth_lexer_makeNumToken1501, 4);
  int argcv_meth_lexer_makeNumToken1501[] = {1};
  meth_meth_lexer_makeNumToken1501->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1501);
  meth_meth_lexer_makeNumToken1501->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1501->definitionLine = 444;
// method isidentifierchar
  block_savedest(obj436);
  Object closure1680 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1680, stackframe);
  addtoclosure(closure1680, var_unicode);
  struct UserObject *uo1680 = (struct UserObject*)obj436;
  uo1680->data[5] = (Object)closure1680;
  Method *meth_meth_lexer_isidentifierchar1680 = addmethod2pos(obj436, "isidentifierchar", &meth_lexer_isidentifierchar1680, 5);
  int argcv_meth_lexer_isidentifierchar1680[] = {1};
  meth_meth_lexer_isidentifierchar1680->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1680);
  meth_meth_lexer_isidentifierchar1680->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1680->definitionLine = 489;
// method isoperatorchar
  block_savedest(obj436);
  Object closure1703 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1703, stackframe);
  addtoclosure(closure1703, var_unicode);
  struct UserObject *uo1703 = (struct UserObject*)obj436;
  uo1703->data[6] = (Object)closure1703;
  Method *meth_meth_lexer_isoperatorchar1703 = addmethod2pos(obj436, "isoperatorchar", &meth_lexer_isoperatorchar1703, 6);
  int argcv_meth_lexer_isoperatorchar1703[] = {2};
  meth_meth_lexer_isoperatorchar1703->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1703);
  meth_meth_lexer_isoperatorchar1703->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1703->definitionLine = 505;
// method lexfile
  block_savedest(obj436);
  Object closure1797 = createclosure(1, "lexfile");
  setclosureframe(closure1797, stackframe);
  addtoclosure(closure1797, var_util);
  struct UserObject *uo1797 = (struct UserObject*)obj436;
  uo1797->data[7] = (Object)closure1797;
  Method *meth_meth_lexer_lexfile1797 = addmethod2pos(obj436, "lexfile", &meth_lexer_lexfile1797, 7);
  int argcv_meth_lexer_lexfile1797[] = {1};
  meth_meth_lexer_lexfile1797->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1797);
  meth_meth_lexer_lexfile1797->definitionModule = modulename;
  meth_meth_lexer_lexfile1797->definitionLine = 522;
// method lexinput
  block_savedest(obj436);
  Object closure1915 = createclosure(9, "lexinput");
  setclosureframe(closure1915, stackframe);
  addtoclosure(closure1915, var_linePosition);
  addtoclosure(closure1915, var_util);
  addtoclosure(closure1915, var_unicode);
  addtoclosure(closure1915, var_errormessages);
  addtoclosure(closure1915, var_lineNumber);
  addtoclosure(closure1915, var_stringStart);
  addtoclosure(closure1915, var_startLine);
  addtoclosure(closure1915, var_startPosition);
  addtoclosure(closure1915, var_eofToken);
  struct UserObject *uo1915 = (struct UserObject*)obj436;
  uo1915->data[8] = (Object)closure1915;
  Method *meth_meth_lexer_lexinput1915 = addmethod2pos(obj436, "lexinput", &meth_lexer_lexinput1915, 8);
  int argcv_meth_lexer_lexinput1915[] = {1};
  meth_meth_lexer_lexinput1915->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1915);
  meth_meth_lexer_lexinput1915->definitionModule = modulename;
  meth_meth_lexer_lexinput1915->definitionLine = 576;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  objclass436 = obj436->class;
  objclass436->definitionModule = modulename;
  objclass436->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter436;
  self = oldself436;
  selfslot = oldselfslot436;
  stackframe = oldstackframe436;
  gc_frame_end(frame);
  return obj436;
}
Object meth_lexer_new24_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(30, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_startLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "startLine");
  Object *var_stringStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "stringStart");
  Object *var_Token = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "StringToken");
  Object *var_MultiLineStringToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "MultiLineStringToken");
  Object *var_CommentToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "CommentToken");
  Object *var_LBraceToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "DotToken");
  Object *var_NumToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "RGenericToken");
  Object *var_eofToken = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "eofToken");
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num25 = alloc_Float64(1);
// compiled num node returning num25 (depth = 3)
  *var_lineNumber = num25;
  if (num25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num26 = alloc_Float64(0);
// compiled num node returning num26 (depth = 3)
  *var_linePosition = num26;
  if (num26 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num27 = alloc_Float64(1);
// compiled num node returning num27 (depth = 3)
  *var_startPosition = num27;
  if (num27 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num28 = alloc_Float64(0);
// compiled num node returning num28 (depth = 3)
  *var_indentLevel = num28;
  if (num28 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num29 = alloc_Float64(1);
// compiled num node returning num29 (depth = 3)
  *var_startLine = num29;
  if (num29 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_stringStart = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject30 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj30 = alloc_userobj2(2,4, objclass30);
  gc_frame_newslot(obj30);
// OBJECT OUTER DEC outer
  adddatum2(obj30, self, 0);
  addmethodreal(obj30,"outer", &reader_lexer_outer_31);
  Object oldself30 = self;
  struct StackFrameObject *oldstackframe30 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe30);
  gc_frame_newslot((Object)stackframe);
  self = obj30;
  Object *oldselfslot30 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter30 = (*(struct UserObject *)self).data[0], lowerouter30 = thisouter30;
  if (inheritingObject30) {
    struct UserObject *inho30 = (struct UserObject *)inheritingObject30;
    while (inho30->super != GraceDefaultObject) inho30 = (struct UserObject *)inho30->super;
    inho30->super = obj30;
    self = inheritingObject30;
    *selfslot = self;
    lowerouter30 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter30;
  }
// method new
  block_savedest(obj30);
  Object closure32 = createclosure(3, "new");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_lineNumber);
  addtoclosure(closure32, var_indentLevel);
  addtoclosure(closure32, var_startPosition);
  struct UserObject *uo32 = (struct UserObject*)obj30;
  uo32->data[1] = (Object)closure32;
  Method *meth_meth_lexer_new32 = addmethod2pos(obj30, "new", &meth_lexer_new32, 1);
  int argcv_meth_lexer_new32[] = {0};
  meth_meth_lexer_new32->type = alloc_MethodType(1, argcv_meth_lexer_new32);
  meth_meth_lexer_new32->definitionModule = modulename;
  meth_meth_lexer_new32->definitionLine = 25;
  block_savedest(obj30);
  Object closure104 = createclosure(3, "new()object");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_lineNumber);
  addtoclosure(closure104, var_indentLevel);
  addtoclosure(closure104, var_startPosition);
  Method *meth_meth_lexer_new32_object = addmethod2pos(obj30, "new()object", &meth_lexer_new32_object, 1);
  meth_meth_lexer_new32_object->definitionModule = modulename;
  meth_meth_lexer_new32_object->definitionLine = 25;
  sourceObject = obj30;
  objclass30 = obj30->class;
  objclass30->definitionModule = modulename;
  objclass30->definitionLine = 25;
  (*(struct UserObject *)self).data[0] = lowerouter30;
  self = oldself30;
  selfslot = oldselfslot30;
  stackframe = oldstackframe30;
// compiled object node returning obj30 (depth = 4)
  *var_Token = obj30;
  if (obj30 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject105 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj105 = alloc_userobj2(2,4, objclass105);
  gc_frame_newslot(obj105);
// OBJECT OUTER DEC outer
  adddatum2(obj105, self, 0);
  addmethodreal(obj105,"outer", &reader_lexer_outer_106);
  Object oldself105 = self;
  struct StackFrameObject *oldstackframe105 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe105);
  gc_frame_newslot((Object)stackframe);
  self = obj105;
  Object *oldselfslot105 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter105 = (*(struct UserObject *)self).data[0], lowerouter105 = thisouter105;
  if (inheritingObject105) {
    struct UserObject *inho105 = (struct UserObject *)inheritingObject105;
    while (inho105->super != GraceDefaultObject) inho105 = (struct UserObject *)inho105->super;
    inho105->super = obj105;
    self = inheritingObject105;
    *selfslot = self;
    lowerouter105 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter105;
  }
// method new
  block_savedest(obj105);
  Object closure107 = createclosure(1, "new");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_Token);
  struct UserObject *uo107 = (struct UserObject*)obj105;
  uo107->data[1] = (Object)closure107;
  Method *meth_meth_lexer_new107 = addmethod2pos(obj105, "new", &meth_lexer_new107, 1);
  int argcv_meth_lexer_new107[] = {1};
  meth_meth_lexer_new107->type = alloc_MethodType(1, argcv_meth_lexer_new107);
  meth_meth_lexer_new107->definitionModule = modulename;
  meth_meth_lexer_new107->definitionLine = 44;
  block_savedest(obj105);
  Object closure118 = createclosure(1, "new()object");
  setclosureframe(closure118, stackframe);
  addtoclosure(closure118, var_Token);
  Method *meth_meth_lexer_new107_object = addmethod2pos(obj105, "new()object", &meth_lexer_new107_object, 1);
  meth_meth_lexer_new107_object->definitionModule = modulename;
  meth_meth_lexer_new107_object->definitionLine = 44;
  sourceObject = obj105;
  objclass105 = obj105->class;
  objclass105->definitionModule = modulename;
  objclass105->definitionLine = 44;
  (*(struct UserObject *)self).data[0] = lowerouter105;
  self = oldself105;
  selfslot = oldselfslot105;
  stackframe = oldstackframe105;
// compiled object node returning obj105 (depth = 4)
  *var_IdentifierToken = obj105;
  if (obj105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject119 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj119 = alloc_userobj2(2,4, objclass119);
  gc_frame_newslot(obj119);
// OBJECT OUTER DEC outer
  adddatum2(obj119, self, 0);
  addmethodreal(obj119,"outer", &reader_lexer_outer_120);
  Object oldself119 = self;
  struct StackFrameObject *oldstackframe119 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe119);
  gc_frame_newslot((Object)stackframe);
  self = obj119;
  Object *oldselfslot119 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter119 = (*(struct UserObject *)self).data[0], lowerouter119 = thisouter119;
  if (inheritingObject119) {
    struct UserObject *inho119 = (struct UserObject *)inheritingObject119;
    while (inho119->super != GraceDefaultObject) inho119 = (struct UserObject *)inho119->super;
    inho119->super = obj119;
    self = inheritingObject119;
    *selfslot = self;
    lowerouter119 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter119;
  }
// method new
  block_savedest(obj119);
  Object closure121 = createclosure(3, "new");
  setclosureframe(closure121, stackframe);
  addtoclosure(closure121, var_Token);
  addtoclosure(closure121, var_stringStart);
  addtoclosure(closure121, var_linePosition);
  struct UserObject *uo121 = (struct UserObject*)obj119;
  uo121->data[1] = (Object)closure121;
  Method *meth_meth_lexer_new121 = addmethod2pos(obj119, "new", &meth_lexer_new121, 1);
  int argcv_meth_lexer_new121[] = {1};
  meth_meth_lexer_new121->type = alloc_MethodType(1, argcv_meth_lexer_new121);
  meth_meth_lexer_new121->definitionModule = modulename;
  meth_meth_lexer_new121->definitionLine = 50;
  block_savedest(obj119);
  Object closure137 = createclosure(3, "new()object");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_Token);
  addtoclosure(closure137, var_stringStart);
  addtoclosure(closure137, var_linePosition);
  Method *meth_meth_lexer_new121_object = addmethod2pos(obj119, "new()object", &meth_lexer_new121_object, 1);
  meth_meth_lexer_new121_object->definitionModule = modulename;
  meth_meth_lexer_new121_object->definitionLine = 50;
  sourceObject = obj119;
  objclass119 = obj119->class;
  objclass119->definitionModule = modulename;
  objclass119->definitionLine = 50;
  (*(struct UserObject *)self).data[0] = lowerouter119;
  self = oldself119;
  selfslot = oldselfslot119;
  stackframe = oldstackframe119;
// compiled object node returning obj119 (depth = 4)
  *var_StringToken = obj119;
  if (obj119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj138 = alloc_userobj2(2,4, objclass138);
  gc_frame_newslot(obj138);
// OBJECT OUTER DEC outer
  adddatum2(obj138, self, 0);
  addmethodreal(obj138,"outer", &reader_lexer_outer_139);
  Object oldself138 = self;
  struct StackFrameObject *oldstackframe138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe138);
  gc_frame_newslot((Object)stackframe);
  self = obj138;
  Object *oldselfslot138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter138 = (*(struct UserObject *)self).data[0], lowerouter138 = thisouter138;
  if (inheritingObject138) {
    struct UserObject *inho138 = (struct UserObject *)inheritingObject138;
    while (inho138->super != GraceDefaultObject) inho138 = (struct UserObject *)inho138->super;
    inho138->super = obj138;
    self = inheritingObject138;
    *selfslot = self;
    lowerouter138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter138;
  }
// method new
  block_savedest(obj138);
  Object closure140 = createclosure(3, "new");
  setclosureframe(closure140, stackframe);
  addtoclosure(closure140, var_Token);
  addtoclosure(closure140, var_startLine);
  addtoclosure(closure140, var_stringStart);
  struct UserObject *uo140 = (struct UserObject*)obj138;
  uo140->data[1] = (Object)closure140;
  Method *meth_meth_lexer_new140 = addmethod2pos(obj138, "new", &meth_lexer_new140, 1);
  int argcv_meth_lexer_new140[] = {1};
  meth_meth_lexer_new140->type = alloc_MethodType(1, argcv_meth_lexer_new140);
  meth_meth_lexer_new140->definitionModule = modulename;
  meth_meth_lexer_new140->definitionLine = 56;
  block_savedest(obj138);
  Object closure163 = createclosure(3, "new()object");
  setclosureframe(closure163, stackframe);
  addtoclosure(closure163, var_Token);
  addtoclosure(closure163, var_startLine);
  addtoclosure(closure163, var_stringStart);
  Method *meth_meth_lexer_new140_object = addmethod2pos(obj138, "new()object", &meth_lexer_new140_object, 1);
  meth_meth_lexer_new140_object->definitionModule = modulename;
  meth_meth_lexer_new140_object->definitionLine = 56;
  sourceObject = obj138;
  objclass138 = obj138->class;
  objclass138->definitionModule = modulename;
  objclass138->definitionLine = 56;
  (*(struct UserObject *)self).data[0] = lowerouter138;
  self = oldself138;
  selfslot = oldselfslot138;
  stackframe = oldstackframe138;
// compiled object node returning obj138 (depth = 4)
  *var_MultiLineStringToken = obj138;
  if (obj138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject164 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj164 = alloc_userobj2(2,4, objclass164);
  gc_frame_newslot(obj164);
// OBJECT OUTER DEC outer
  adddatum2(obj164, self, 0);
  addmethodreal(obj164,"outer", &reader_lexer_outer_165);
  Object oldself164 = self;
  struct StackFrameObject *oldstackframe164 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe164);
  gc_frame_newslot((Object)stackframe);
  self = obj164;
  Object *oldselfslot164 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter164 = (*(struct UserObject *)self).data[0], lowerouter164 = thisouter164;
  if (inheritingObject164) {
    struct UserObject *inho164 = (struct UserObject *)inheritingObject164;
    while (inho164->super != GraceDefaultObject) inho164 = (struct UserObject *)inho164->super;
    inho164->super = obj164;
    self = inheritingObject164;
    *selfslot = self;
    lowerouter164 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter164;
  }
// method new
  block_savedest(obj164);
  Object closure166 = createclosure(1, "new");
  setclosureframe(closure166, stackframe);
  addtoclosure(closure166, var_Token);
  struct UserObject *uo166 = (struct UserObject*)obj164;
  uo166->data[1] = (Object)closure166;
  Method *meth_meth_lexer_new166 = addmethod2pos(obj164, "new", &meth_lexer_new166, 1);
  int argcv_meth_lexer_new166[] = {1};
  meth_meth_lexer_new166->type = alloc_MethodType(1, argcv_meth_lexer_new166);
  meth_meth_lexer_new166->definitionModule = modulename;
  meth_meth_lexer_new166->definitionLine = 66;
  block_savedest(obj164);
  Object closure181 = createclosure(1, "new()object");
  setclosureframe(closure181, stackframe);
  addtoclosure(closure181, var_Token);
  Method *meth_meth_lexer_new166_object = addmethod2pos(obj164, "new()object", &meth_lexer_new166_object, 1);
  meth_meth_lexer_new166_object->definitionModule = modulename;
  meth_meth_lexer_new166_object->definitionLine = 66;
  sourceObject = obj164;
  objclass164 = obj164->class;
  objclass164->definitionModule = modulename;
  objclass164->definitionLine = 66;
  (*(struct UserObject *)self).data[0] = lowerouter164;
  self = oldself164;
  selfslot = oldselfslot164;
  stackframe = oldstackframe164;
// compiled object node returning obj164 (depth = 4)
  *var_CommentToken = obj164;
  if (obj164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject182 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj182 = alloc_userobj2(2,4, objclass182);
  gc_frame_newslot(obj182);
// OBJECT OUTER DEC outer
  adddatum2(obj182, self, 0);
  addmethodreal(obj182,"outer", &reader_lexer_outer_183);
  Object oldself182 = self;
  struct StackFrameObject *oldstackframe182 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe182);
  gc_frame_newslot((Object)stackframe);
  self = obj182;
  Object *oldselfslot182 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter182 = (*(struct UserObject *)self).data[0], lowerouter182 = thisouter182;
  if (inheritingObject182) {
    struct UserObject *inho182 = (struct UserObject *)inheritingObject182;
    while (inho182->super != GraceDefaultObject) inho182 = (struct UserObject *)inho182->super;
    inho182->super = obj182;
    self = inheritingObject182;
    *selfslot = self;
    lowerouter182 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter182;
  }
// method new
  block_savedest(obj182);
  Object closure184 = createclosure(1, "new");
  setclosureframe(closure184, stackframe);
  addtoclosure(closure184, var_Token);
  struct UserObject *uo184 = (struct UserObject*)obj182;
  uo184->data[1] = (Object)closure184;
  Method *meth_meth_lexer_new184 = addmethod2pos(obj182, "new", &meth_lexer_new184, 1);
  int argcv_meth_lexer_new184[] = {0};
  meth_meth_lexer_new184->type = alloc_MethodType(1, argcv_meth_lexer_new184);
  meth_meth_lexer_new184->definitionModule = modulename;
  meth_meth_lexer_new184->definitionLine = 72;
  block_savedest(obj182);
  Object closure195 = createclosure(1, "new()object");
  setclosureframe(closure195, stackframe);
  addtoclosure(closure195, var_Token);
  Method *meth_meth_lexer_new184_object = addmethod2pos(obj182, "new()object", &meth_lexer_new184_object, 1);
  meth_meth_lexer_new184_object->definitionModule = modulename;
  meth_meth_lexer_new184_object->definitionLine = 72;
  sourceObject = obj182;
  objclass182 = obj182->class;
  objclass182->definitionModule = modulename;
  objclass182->definitionLine = 72;
  (*(struct UserObject *)self).data[0] = lowerouter182;
  self = oldself182;
  selfslot = oldselfslot182;
  stackframe = oldstackframe182;
// compiled object node returning obj182 (depth = 4)
  *var_LBraceToken = obj182;
  if (obj182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject196 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj196 = alloc_userobj2(2,4, objclass196);
  gc_frame_newslot(obj196);
// OBJECT OUTER DEC outer
  adddatum2(obj196, self, 0);
  addmethodreal(obj196,"outer", &reader_lexer_outer_197);
  Object oldself196 = self;
  struct StackFrameObject *oldstackframe196 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe196);
  gc_frame_newslot((Object)stackframe);
  self = obj196;
  Object *oldselfslot196 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter196 = (*(struct UserObject *)self).data[0], lowerouter196 = thisouter196;
  if (inheritingObject196) {
    struct UserObject *inho196 = (struct UserObject *)inheritingObject196;
    while (inho196->super != GraceDefaultObject) inho196 = (struct UserObject *)inho196->super;
    inho196->super = obj196;
    self = inheritingObject196;
    *selfslot = self;
    lowerouter196 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter196;
  }
// method new
  block_savedest(obj196);
  Object closure198 = createclosure(1, "new");
  setclosureframe(closure198, stackframe);
  addtoclosure(closure198, var_Token);
  struct UserObject *uo198 = (struct UserObject*)obj196;
  uo198->data[1] = (Object)closure198;
  Method *meth_meth_lexer_new198 = addmethod2pos(obj196, "new", &meth_lexer_new198, 1);
  int argcv_meth_lexer_new198[] = {0};
  meth_meth_lexer_new198->type = alloc_MethodType(1, argcv_meth_lexer_new198);
  meth_meth_lexer_new198->definitionModule = modulename;
  meth_meth_lexer_new198->definitionLine = 78;
  block_savedest(obj196);
  Object closure209 = createclosure(1, "new()object");
  setclosureframe(closure209, stackframe);
  addtoclosure(closure209, var_Token);
  Method *meth_meth_lexer_new198_object = addmethod2pos(obj196, "new()object", &meth_lexer_new198_object, 1);
  meth_meth_lexer_new198_object->definitionModule = modulename;
  meth_meth_lexer_new198_object->definitionLine = 78;
  sourceObject = obj196;
  objclass196 = obj196->class;
  objclass196->definitionModule = modulename;
  objclass196->definitionLine = 78;
  (*(struct UserObject *)self).data[0] = lowerouter196;
  self = oldself196;
  selfslot = oldselfslot196;
  stackframe = oldstackframe196;
// compiled object node returning obj196 (depth = 4)
  *var_RBraceToken = obj196;
  if (obj196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject210 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj210 = alloc_userobj2(2,4, objclass210);
  gc_frame_newslot(obj210);
// OBJECT OUTER DEC outer
  adddatum2(obj210, self, 0);
  addmethodreal(obj210,"outer", &reader_lexer_outer_211);
  Object oldself210 = self;
  struct StackFrameObject *oldstackframe210 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe210);
  gc_frame_newslot((Object)stackframe);
  self = obj210;
  Object *oldselfslot210 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter210 = (*(struct UserObject *)self).data[0], lowerouter210 = thisouter210;
  if (inheritingObject210) {
    struct UserObject *inho210 = (struct UserObject *)inheritingObject210;
    while (inho210->super != GraceDefaultObject) inho210 = (struct UserObject *)inho210->super;
    inho210->super = obj210;
    self = inheritingObject210;
    *selfslot = self;
    lowerouter210 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter210;
  }
// method new
  block_savedest(obj210);
  Object closure212 = createclosure(1, "new");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_Token);
  struct UserObject *uo212 = (struct UserObject*)obj210;
  uo212->data[1] = (Object)closure212;
  Method *meth_meth_lexer_new212 = addmethod2pos(obj210, "new", &meth_lexer_new212, 1);
  int argcv_meth_lexer_new212[] = {0};
  meth_meth_lexer_new212->type = alloc_MethodType(1, argcv_meth_lexer_new212);
  meth_meth_lexer_new212->definitionModule = modulename;
  meth_meth_lexer_new212->definitionLine = 84;
  block_savedest(obj210);
  Object closure223 = createclosure(1, "new()object");
  setclosureframe(closure223, stackframe);
  addtoclosure(closure223, var_Token);
  Method *meth_meth_lexer_new212_object = addmethod2pos(obj210, "new()object", &meth_lexer_new212_object, 1);
  meth_meth_lexer_new212_object->definitionModule = modulename;
  meth_meth_lexer_new212_object->definitionLine = 84;
  sourceObject = obj210;
  objclass210 = obj210->class;
  objclass210->definitionModule = modulename;
  objclass210->definitionLine = 84;
  (*(struct UserObject *)self).data[0] = lowerouter210;
  self = oldself210;
  selfslot = oldselfslot210;
  stackframe = oldstackframe210;
// compiled object node returning obj210 (depth = 4)
  *var_LParenToken = obj210;
  if (obj210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject224 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj224 = alloc_userobj2(2,4, objclass224);
  gc_frame_newslot(obj224);
// OBJECT OUTER DEC outer
  adddatum2(obj224, self, 0);
  addmethodreal(obj224,"outer", &reader_lexer_outer_225);
  Object oldself224 = self;
  struct StackFrameObject *oldstackframe224 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe224);
  gc_frame_newslot((Object)stackframe);
  self = obj224;
  Object *oldselfslot224 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter224 = (*(struct UserObject *)self).data[0], lowerouter224 = thisouter224;
  if (inheritingObject224) {
    struct UserObject *inho224 = (struct UserObject *)inheritingObject224;
    while (inho224->super != GraceDefaultObject) inho224 = (struct UserObject *)inho224->super;
    inho224->super = obj224;
    self = inheritingObject224;
    *selfslot = self;
    lowerouter224 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter224;
  }
// method new
  block_savedest(obj224);
  Object closure226 = createclosure(1, "new");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_Token);
  struct UserObject *uo226 = (struct UserObject*)obj224;
  uo226->data[1] = (Object)closure226;
  Method *meth_meth_lexer_new226 = addmethod2pos(obj224, "new", &meth_lexer_new226, 1);
  int argcv_meth_lexer_new226[] = {0};
  meth_meth_lexer_new226->type = alloc_MethodType(1, argcv_meth_lexer_new226);
  meth_meth_lexer_new226->definitionModule = modulename;
  meth_meth_lexer_new226->definitionLine = 90;
  block_savedest(obj224);
  Object closure237 = createclosure(1, "new()object");
  setclosureframe(closure237, stackframe);
  addtoclosure(closure237, var_Token);
  Method *meth_meth_lexer_new226_object = addmethod2pos(obj224, "new()object", &meth_lexer_new226_object, 1);
  meth_meth_lexer_new226_object->definitionModule = modulename;
  meth_meth_lexer_new226_object->definitionLine = 90;
  sourceObject = obj224;
  objclass224 = obj224->class;
  objclass224->definitionModule = modulename;
  objclass224->definitionLine = 90;
  (*(struct UserObject *)self).data[0] = lowerouter224;
  self = oldself224;
  selfslot = oldselfslot224;
  stackframe = oldstackframe224;
// compiled object node returning obj224 (depth = 4)
  *var_RParenToken = obj224;
  if (obj224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject238 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj238 = alloc_userobj2(2,4, objclass238);
  gc_frame_newslot(obj238);
// OBJECT OUTER DEC outer
  adddatum2(obj238, self, 0);
  addmethodreal(obj238,"outer", &reader_lexer_outer_239);
  Object oldself238 = self;
  struct StackFrameObject *oldstackframe238 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe238);
  gc_frame_newslot((Object)stackframe);
  self = obj238;
  Object *oldselfslot238 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter238 = (*(struct UserObject *)self).data[0], lowerouter238 = thisouter238;
  if (inheritingObject238) {
    struct UserObject *inho238 = (struct UserObject *)inheritingObject238;
    while (inho238->super != GraceDefaultObject) inho238 = (struct UserObject *)inho238->super;
    inho238->super = obj238;
    self = inheritingObject238;
    *selfslot = self;
    lowerouter238 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter238;
  }
// method new
  block_savedest(obj238);
  Object closure240 = createclosure(1, "new");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_Token);
  struct UserObject *uo240 = (struct UserObject*)obj238;
  uo240->data[1] = (Object)closure240;
  Method *meth_meth_lexer_new240 = addmethod2pos(obj238, "new", &meth_lexer_new240, 1);
  int argcv_meth_lexer_new240[] = {0};
  meth_meth_lexer_new240->type = alloc_MethodType(1, argcv_meth_lexer_new240);
  meth_meth_lexer_new240->definitionModule = modulename;
  meth_meth_lexer_new240->definitionLine = 96;
  block_savedest(obj238);
  Object closure251 = createclosure(1, "new()object");
  setclosureframe(closure251, stackframe);
  addtoclosure(closure251, var_Token);
  Method *meth_meth_lexer_new240_object = addmethod2pos(obj238, "new()object", &meth_lexer_new240_object, 1);
  meth_meth_lexer_new240_object->definitionModule = modulename;
  meth_meth_lexer_new240_object->definitionLine = 96;
  sourceObject = obj238;
  objclass238 = obj238->class;
  objclass238->definitionModule = modulename;
  objclass238->definitionLine = 96;
  (*(struct UserObject *)self).data[0] = lowerouter238;
  self = oldself238;
  selfslot = oldselfslot238;
  stackframe = oldstackframe238;
// compiled object node returning obj238 (depth = 4)
  *var_LSquareToken = obj238;
  if (obj238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject252 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj252 = alloc_userobj2(2,4, objclass252);
  gc_frame_newslot(obj252);
// OBJECT OUTER DEC outer
  adddatum2(obj252, self, 0);
  addmethodreal(obj252,"outer", &reader_lexer_outer_253);
  Object oldself252 = self;
  struct StackFrameObject *oldstackframe252 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe252);
  gc_frame_newslot((Object)stackframe);
  self = obj252;
  Object *oldselfslot252 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter252 = (*(struct UserObject *)self).data[0], lowerouter252 = thisouter252;
  if (inheritingObject252) {
    struct UserObject *inho252 = (struct UserObject *)inheritingObject252;
    while (inho252->super != GraceDefaultObject) inho252 = (struct UserObject *)inho252->super;
    inho252->super = obj252;
    self = inheritingObject252;
    *selfslot = self;
    lowerouter252 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter252;
  }
// method new
  block_savedest(obj252);
  Object closure254 = createclosure(1, "new");
  setclosureframe(closure254, stackframe);
  addtoclosure(closure254, var_Token);
  struct UserObject *uo254 = (struct UserObject*)obj252;
  uo254->data[1] = (Object)closure254;
  Method *meth_meth_lexer_new254 = addmethod2pos(obj252, "new", &meth_lexer_new254, 1);
  int argcv_meth_lexer_new254[] = {0};
  meth_meth_lexer_new254->type = alloc_MethodType(1, argcv_meth_lexer_new254);
  meth_meth_lexer_new254->definitionModule = modulename;
  meth_meth_lexer_new254->definitionLine = 102;
  block_savedest(obj252);
  Object closure265 = createclosure(1, "new()object");
  setclosureframe(closure265, stackframe);
  addtoclosure(closure265, var_Token);
  Method *meth_meth_lexer_new254_object = addmethod2pos(obj252, "new()object", &meth_lexer_new254_object, 1);
  meth_meth_lexer_new254_object->definitionModule = modulename;
  meth_meth_lexer_new254_object->definitionLine = 102;
  sourceObject = obj252;
  objclass252 = obj252->class;
  objclass252->definitionModule = modulename;
  objclass252->definitionLine = 102;
  (*(struct UserObject *)self).data[0] = lowerouter252;
  self = oldself252;
  selfslot = oldselfslot252;
  stackframe = oldstackframe252;
// compiled object node returning obj252 (depth = 4)
  *var_RSquareToken = obj252;
  if (obj252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject266 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj266 = alloc_userobj2(2,4, objclass266);
  gc_frame_newslot(obj266);
// OBJECT OUTER DEC outer
  adddatum2(obj266, self, 0);
  addmethodreal(obj266,"outer", &reader_lexer_outer_267);
  Object oldself266 = self;
  struct StackFrameObject *oldstackframe266 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe266);
  gc_frame_newslot((Object)stackframe);
  self = obj266;
  Object *oldselfslot266 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter266 = (*(struct UserObject *)self).data[0], lowerouter266 = thisouter266;
  if (inheritingObject266) {
    struct UserObject *inho266 = (struct UserObject *)inheritingObject266;
    while (inho266->super != GraceDefaultObject) inho266 = (struct UserObject *)inho266->super;
    inho266->super = obj266;
    self = inheritingObject266;
    *selfslot = self;
    lowerouter266 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter266;
  }
// method new
  block_savedest(obj266);
  Object closure268 = createclosure(1, "new");
  setclosureframe(closure268, stackframe);
  addtoclosure(closure268, var_Token);
  struct UserObject *uo268 = (struct UserObject*)obj266;
  uo268->data[1] = (Object)closure268;
  Method *meth_meth_lexer_new268 = addmethod2pos(obj266, "new", &meth_lexer_new268, 1);
  int argcv_meth_lexer_new268[] = {0};
  meth_meth_lexer_new268->type = alloc_MethodType(1, argcv_meth_lexer_new268);
  meth_meth_lexer_new268->definitionModule = modulename;
  meth_meth_lexer_new268->definitionLine = 108;
  block_savedest(obj266);
  Object closure279 = createclosure(1, "new()object");
  setclosureframe(closure279, stackframe);
  addtoclosure(closure279, var_Token);
  Method *meth_meth_lexer_new268_object = addmethod2pos(obj266, "new()object", &meth_lexer_new268_object, 1);
  meth_meth_lexer_new268_object->definitionModule = modulename;
  meth_meth_lexer_new268_object->definitionLine = 108;
  sourceObject = obj266;
  objclass266 = obj266->class;
  objclass266->definitionModule = modulename;
  objclass266->definitionLine = 108;
  (*(struct UserObject *)self).data[0] = lowerouter266;
  self = oldself266;
  selfslot = oldselfslot266;
  stackframe = oldstackframe266;
// compiled object node returning obj266 (depth = 4)
  *var_CommaToken = obj266;
  if (obj266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject280 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj280 = alloc_userobj2(2,4, objclass280);
  gc_frame_newslot(obj280);
// OBJECT OUTER DEC outer
  adddatum2(obj280, self, 0);
  addmethodreal(obj280,"outer", &reader_lexer_outer_281);
  Object oldself280 = self;
  struct StackFrameObject *oldstackframe280 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe280);
  gc_frame_newslot((Object)stackframe);
  self = obj280;
  Object *oldselfslot280 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter280 = (*(struct UserObject *)self).data[0], lowerouter280 = thisouter280;
  if (inheritingObject280) {
    struct UserObject *inho280 = (struct UserObject *)inheritingObject280;
    while (inho280->super != GraceDefaultObject) inho280 = (struct UserObject *)inho280->super;
    inho280->super = obj280;
    self = inheritingObject280;
    *selfslot = self;
    lowerouter280 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter280;
  }
// method new
  block_savedest(obj280);
  Object closure282 = createclosure(1, "new");
  setclosureframe(closure282, stackframe);
  addtoclosure(closure282, var_Token);
  struct UserObject *uo282 = (struct UserObject*)obj280;
  uo282->data[1] = (Object)closure282;
  Method *meth_meth_lexer_new282 = addmethod2pos(obj280, "new", &meth_lexer_new282, 1);
  int argcv_meth_lexer_new282[] = {0};
  meth_meth_lexer_new282->type = alloc_MethodType(1, argcv_meth_lexer_new282);
  meth_meth_lexer_new282->definitionModule = modulename;
  meth_meth_lexer_new282->definitionLine = 114;
  block_savedest(obj280);
  Object closure293 = createclosure(1, "new()object");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_Token);
  Method *meth_meth_lexer_new282_object = addmethod2pos(obj280, "new()object", &meth_lexer_new282_object, 1);
  meth_meth_lexer_new282_object->definitionModule = modulename;
  meth_meth_lexer_new282_object->definitionLine = 114;
  sourceObject = obj280;
  objclass280 = obj280->class;
  objclass280->definitionModule = modulename;
  objclass280->definitionLine = 114;
  (*(struct UserObject *)self).data[0] = lowerouter280;
  self = oldself280;
  selfslot = oldselfslot280;
  stackframe = oldstackframe280;
// compiled object node returning obj280 (depth = 4)
  *var_ColonToken = obj280;
  if (obj280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject294 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj294 = alloc_userobj2(2,4, objclass294);
  gc_frame_newslot(obj294);
// OBJECT OUTER DEC outer
  adddatum2(obj294, self, 0);
  addmethodreal(obj294,"outer", &reader_lexer_outer_295);
  Object oldself294 = self;
  struct StackFrameObject *oldstackframe294 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe294);
  gc_frame_newslot((Object)stackframe);
  self = obj294;
  Object *oldselfslot294 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter294 = (*(struct UserObject *)self).data[0], lowerouter294 = thisouter294;
  if (inheritingObject294) {
    struct UserObject *inho294 = (struct UserObject *)inheritingObject294;
    while (inho294->super != GraceDefaultObject) inho294 = (struct UserObject *)inho294->super;
    inho294->super = obj294;
    self = inheritingObject294;
    *selfslot = self;
    lowerouter294 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter294;
  }
// method new
  block_savedest(obj294);
  Object closure296 = createclosure(1, "new");
  setclosureframe(closure296, stackframe);
  addtoclosure(closure296, var_Token);
  struct UserObject *uo296 = (struct UserObject*)obj294;
  uo296->data[1] = (Object)closure296;
  Method *meth_meth_lexer_new296 = addmethod2pos(obj294, "new", &meth_lexer_new296, 1);
  int argcv_meth_lexer_new296[] = {0};
  meth_meth_lexer_new296->type = alloc_MethodType(1, argcv_meth_lexer_new296);
  meth_meth_lexer_new296->definitionModule = modulename;
  meth_meth_lexer_new296->definitionLine = 120;
  block_savedest(obj294);
  Object closure307 = createclosure(1, "new()object");
  setclosureframe(closure307, stackframe);
  addtoclosure(closure307, var_Token);
  Method *meth_meth_lexer_new296_object = addmethod2pos(obj294, "new()object", &meth_lexer_new296_object, 1);
  meth_meth_lexer_new296_object->definitionModule = modulename;
  meth_meth_lexer_new296_object->definitionLine = 120;
  sourceObject = obj294;
  objclass294 = obj294->class;
  objclass294->definitionModule = modulename;
  objclass294->definitionLine = 120;
  (*(struct UserObject *)self).data[0] = lowerouter294;
  self = oldself294;
  selfslot = oldselfslot294;
  stackframe = oldstackframe294;
// compiled object node returning obj294 (depth = 4)
  *var_DotToken = obj294;
  if (obj294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj308 = alloc_userobj2(2,4, objclass308);
  gc_frame_newslot(obj308);
// OBJECT OUTER DEC outer
  adddatum2(obj308, self, 0);
  addmethodreal(obj308,"outer", &reader_lexer_outer_309);
  Object oldself308 = self;
  struct StackFrameObject *oldstackframe308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe308);
  gc_frame_newslot((Object)stackframe);
  self = obj308;
  Object *oldselfslot308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter308 = (*(struct UserObject *)self).data[0], lowerouter308 = thisouter308;
  if (inheritingObject308) {
    struct UserObject *inho308 = (struct UserObject *)inheritingObject308;
    while (inho308->super != GraceDefaultObject) inho308 = (struct UserObject *)inho308->super;
    inho308->super = obj308;
    self = inheritingObject308;
    *selfslot = self;
    lowerouter308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter308;
  }
// method new
  block_savedest(obj308);
  Object closure310 = createclosure(3, "new");
  setclosureframe(closure310, stackframe);
  addtoclosure(closure310, var_Token);
  addtoclosure(closure310, var_startPosition);
  addtoclosure(closure310, var_linePosition);
  struct UserObject *uo310 = (struct UserObject*)obj308;
  uo310->data[1] = (Object)closure310;
  Method *meth_meth_lexer_new310 = addmethod2pos(obj308, "new", &meth_lexer_new310, 1);
  int argcv_meth_lexer_new310[] = {2};
  meth_meth_lexer_new310->type = alloc_MethodType(1, argcv_meth_lexer_new310);
  meth_meth_lexer_new310->definitionModule = modulename;
  meth_meth_lexer_new310->definitionLine = 126;
  block_savedest(obj308);
  Object closure323 = createclosure(3, "new()object");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_Token);
  addtoclosure(closure323, var_startPosition);
  addtoclosure(closure323, var_linePosition);
  Method *meth_meth_lexer_new310_object = addmethod2pos(obj308, "new()object", &meth_lexer_new310_object, 1);
  meth_meth_lexer_new310_object->definitionModule = modulename;
  meth_meth_lexer_new310_object->definitionLine = 126;
  sourceObject = obj308;
  objclass308 = obj308->class;
  objclass308->definitionModule = modulename;
  objclass308->definitionLine = 126;
  (*(struct UserObject *)self).data[0] = lowerouter308;
  self = oldself308;
  selfslot = oldselfslot308;
  stackframe = oldstackframe308;
// compiled object node returning obj308 (depth = 4)
  *var_NumToken = obj308;
  if (obj308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(2,4, objclass324);
  gc_frame_newslot(obj324);
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_lexer_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
// method new
  block_savedest(obj324);
  Object closure326 = createclosure(1, "new");
  setclosureframe(closure326, stackframe);
  addtoclosure(closure326, var_Token);
  struct UserObject *uo326 = (struct UserObject*)obj324;
  uo326->data[1] = (Object)closure326;
  Method *meth_meth_lexer_new326 = addmethod2pos(obj324, "new", &meth_lexer_new326, 1);
  int argcv_meth_lexer_new326[] = {1};
  meth_meth_lexer_new326->type = alloc_MethodType(1, argcv_meth_lexer_new326);
  meth_meth_lexer_new326->definitionModule = modulename;
  meth_meth_lexer_new326->definitionLine = 133;
  block_savedest(obj324);
  Object closure337 = createclosure(1, "new()object");
  setclosureframe(closure337, stackframe);
  addtoclosure(closure337, var_Token);
  Method *meth_meth_lexer_new326_object = addmethod2pos(obj324, "new()object", &meth_lexer_new326_object, 1);
  meth_meth_lexer_new326_object->definitionModule = modulename;
  meth_meth_lexer_new326_object->definitionLine = 133;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 133;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
// compiled object node returning obj324 (depth = 4)
  *var_KeywordToken = obj324;
  if (obj324 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject338 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj338 = alloc_userobj2(2,4, objclass338);
  gc_frame_newslot(obj338);
// OBJECT OUTER DEC outer
  adddatum2(obj338, self, 0);
  addmethodreal(obj338,"outer", &reader_lexer_outer_339);
  Object oldself338 = self;
  struct StackFrameObject *oldstackframe338 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe338);
  gc_frame_newslot((Object)stackframe);
  self = obj338;
  Object *oldselfslot338 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter338 = (*(struct UserObject *)self).data[0], lowerouter338 = thisouter338;
  if (inheritingObject338) {
    struct UserObject *inho338 = (struct UserObject *)inheritingObject338;
    while (inho338->super != GraceDefaultObject) inho338 = (struct UserObject *)inho338->super;
    inho338->super = obj338;
    self = inheritingObject338;
    *selfslot = self;
    lowerouter338 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter338;
  }
// method new
  block_savedest(obj338);
  Object closure340 = createclosure(1, "new");
  setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_Token);
  struct UserObject *uo340 = (struct UserObject*)obj338;
  uo340->data[1] = (Object)closure340;
  Method *meth_meth_lexer_new340 = addmethod2pos(obj338, "new", &meth_lexer_new340, 1);
  int argcv_meth_lexer_new340[] = {1};
  meth_meth_lexer_new340->type = alloc_MethodType(1, argcv_meth_lexer_new340);
  meth_meth_lexer_new340->definitionModule = modulename;
  meth_meth_lexer_new340->definitionLine = 139;
  block_savedest(obj338);
  Object closure351 = createclosure(1, "new()object");
  setclosureframe(closure351, stackframe);
  addtoclosure(closure351, var_Token);
  Method *meth_meth_lexer_new340_object = addmethod2pos(obj338, "new()object", &meth_lexer_new340_object, 1);
  meth_meth_lexer_new340_object->definitionModule = modulename;
  meth_meth_lexer_new340_object->definitionLine = 139;
  sourceObject = obj338;
  objclass338 = obj338->class;
  objclass338->definitionModule = modulename;
  objclass338->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter338;
  self = oldself338;
  selfslot = oldselfslot338;
  stackframe = oldstackframe338;
// compiled object node returning obj338 (depth = 4)
  *var_OpToken = obj338;
  if (obj338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject352 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj352 = alloc_userobj2(2,4, objclass352);
  gc_frame_newslot(obj352);
// OBJECT OUTER DEC outer
  adddatum2(obj352, self, 0);
  addmethodreal(obj352,"outer", &reader_lexer_outer_353);
  Object oldself352 = self;
  struct StackFrameObject *oldstackframe352 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe352);
  gc_frame_newslot((Object)stackframe);
  self = obj352;
  Object *oldselfslot352 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter352 = (*(struct UserObject *)self).data[0], lowerouter352 = thisouter352;
  if (inheritingObject352) {
    struct UserObject *inho352 = (struct UserObject *)inheritingObject352;
    while (inho352->super != GraceDefaultObject) inho352 = (struct UserObject *)inho352->super;
    inho352->super = obj352;
    self = inheritingObject352;
    *selfslot = self;
    lowerouter352 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter352;
  }
// method new
  block_savedest(obj352);
  Object closure354 = createclosure(1, "new");
  setclosureframe(closure354, stackframe);
  addtoclosure(closure354, var_Token);
  struct UserObject *uo354 = (struct UserObject*)obj352;
  uo354->data[1] = (Object)closure354;
  Method *meth_meth_lexer_new354 = addmethod2pos(obj352, "new", &meth_lexer_new354, 1);
  int argcv_meth_lexer_new354[] = {0};
  meth_meth_lexer_new354->type = alloc_MethodType(1, argcv_meth_lexer_new354);
  meth_meth_lexer_new354->definitionModule = modulename;
  meth_meth_lexer_new354->definitionLine = 145;
  block_savedest(obj352);
  Object closure365 = createclosure(1, "new()object");
  setclosureframe(closure365, stackframe);
  addtoclosure(closure365, var_Token);
  Method *meth_meth_lexer_new354_object = addmethod2pos(obj352, "new()object", &meth_lexer_new354_object, 1);
  meth_meth_lexer_new354_object->definitionModule = modulename;
  meth_meth_lexer_new354_object->definitionLine = 145;
  sourceObject = obj352;
  objclass352 = obj352->class;
  objclass352->definitionModule = modulename;
  objclass352->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter352;
  self = oldself352;
  selfslot = oldselfslot352;
  stackframe = oldstackframe352;
// compiled object node returning obj352 (depth = 4)
  *var_ArrowToken = obj352;
  if (obj352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject366 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj366 = alloc_userobj2(2,4, objclass366);
  gc_frame_newslot(obj366);
// OBJECT OUTER DEC outer
  adddatum2(obj366, self, 0);
  addmethodreal(obj366,"outer", &reader_lexer_outer_367);
  Object oldself366 = self;
  struct StackFrameObject *oldstackframe366 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe366);
  gc_frame_newslot((Object)stackframe);
  self = obj366;
  Object *oldselfslot366 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter366 = (*(struct UserObject *)self).data[0], lowerouter366 = thisouter366;
  if (inheritingObject366) {
    struct UserObject *inho366 = (struct UserObject *)inheritingObject366;
    while (inho366->super != GraceDefaultObject) inho366 = (struct UserObject *)inho366->super;
    inho366->super = obj366;
    self = inheritingObject366;
    *selfslot = self;
    lowerouter366 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter366;
  }
// method new
  block_savedest(obj366);
  Object closure368 = createclosure(1, "new");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_Token);
  struct UserObject *uo368 = (struct UserObject*)obj366;
  uo368->data[1] = (Object)closure368;
  Method *meth_meth_lexer_new368 = addmethod2pos(obj366, "new", &meth_lexer_new368, 1);
  int argcv_meth_lexer_new368[] = {0};
  meth_meth_lexer_new368->type = alloc_MethodType(1, argcv_meth_lexer_new368);
  meth_meth_lexer_new368->definitionModule = modulename;
  meth_meth_lexer_new368->definitionLine = 151;
  block_savedest(obj366);
  Object closure379 = createclosure(1, "new()object");
  setclosureframe(closure379, stackframe);
  addtoclosure(closure379, var_Token);
  Method *meth_meth_lexer_new368_object = addmethod2pos(obj366, "new()object", &meth_lexer_new368_object, 1);
  meth_meth_lexer_new368_object->definitionModule = modulename;
  meth_meth_lexer_new368_object->definitionLine = 151;
  sourceObject = obj366;
  objclass366 = obj366->class;
  objclass366->definitionModule = modulename;
  objclass366->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter366;
  self = oldself366;
  selfslot = oldselfslot366;
  stackframe = oldstackframe366;
// compiled object node returning obj366 (depth = 4)
  *var_BindToken = obj366;
  if (obj366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject380 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj380 = alloc_userobj2(2,4, objclass380);
  gc_frame_newslot(obj380);
// OBJECT OUTER DEC outer
  adddatum2(obj380, self, 0);
  addmethodreal(obj380,"outer", &reader_lexer_outer_381);
  Object oldself380 = self;
  struct StackFrameObject *oldstackframe380 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe380);
  gc_frame_newslot((Object)stackframe);
  self = obj380;
  Object *oldselfslot380 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter380 = (*(struct UserObject *)self).data[0], lowerouter380 = thisouter380;
  if (inheritingObject380) {
    struct UserObject *inho380 = (struct UserObject *)inheritingObject380;
    while (inho380->super != GraceDefaultObject) inho380 = (struct UserObject *)inho380->super;
    inho380->super = obj380;
    self = inheritingObject380;
    *selfslot = self;
    lowerouter380 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter380;
  }
// method new
  block_savedest(obj380);
  Object closure382 = createclosure(1, "new");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_Token);
  struct UserObject *uo382 = (struct UserObject*)obj380;
  uo382->data[1] = (Object)closure382;
  Method *meth_meth_lexer_new382 = addmethod2pos(obj380, "new", &meth_lexer_new382, 1);
  int argcv_meth_lexer_new382[] = {0};
  meth_meth_lexer_new382->type = alloc_MethodType(1, argcv_meth_lexer_new382);
  meth_meth_lexer_new382->definitionModule = modulename;
  meth_meth_lexer_new382->definitionLine = 157;
  block_savedest(obj380);
  Object closure393 = createclosure(1, "new()object");
  setclosureframe(closure393, stackframe);
  addtoclosure(closure393, var_Token);
  Method *meth_meth_lexer_new382_object = addmethod2pos(obj380, "new()object", &meth_lexer_new382_object, 1);
  meth_meth_lexer_new382_object->definitionModule = modulename;
  meth_meth_lexer_new382_object->definitionLine = 157;
  sourceObject = obj380;
  objclass380 = obj380->class;
  objclass380->definitionModule = modulename;
  objclass380->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter380;
  self = oldself380;
  selfslot = oldselfslot380;
  stackframe = oldstackframe380;
// compiled object node returning obj380 (depth = 4)
  *var_SemicolonToken = obj380;
  if (obj380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject394 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj394 = alloc_userobj2(2,4, objclass394);
  gc_frame_newslot(obj394);
// OBJECT OUTER DEC outer
  adddatum2(obj394, self, 0);
  addmethodreal(obj394,"outer", &reader_lexer_outer_395);
  Object oldself394 = self;
  struct StackFrameObject *oldstackframe394 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe394);
  gc_frame_newslot((Object)stackframe);
  self = obj394;
  Object *oldselfslot394 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter394 = (*(struct UserObject *)self).data[0], lowerouter394 = thisouter394;
  if (inheritingObject394) {
    struct UserObject *inho394 = (struct UserObject *)inheritingObject394;
    while (inho394->super != GraceDefaultObject) inho394 = (struct UserObject *)inho394->super;
    inho394->super = obj394;
    self = inheritingObject394;
    *selfslot = self;
    lowerouter394 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter394;
  }
// method new
  block_savedest(obj394);
  Object closure396 = createclosure(1, "new");
  setclosureframe(closure396, stackframe);
  addtoclosure(closure396, var_Token);
  struct UserObject *uo396 = (struct UserObject*)obj394;
  uo396->data[1] = (Object)closure396;
  Method *meth_meth_lexer_new396 = addmethod2pos(obj394, "new", &meth_lexer_new396, 1);
  int argcv_meth_lexer_new396[] = {0};
  meth_meth_lexer_new396->type = alloc_MethodType(1, argcv_meth_lexer_new396);
  meth_meth_lexer_new396->definitionModule = modulename;
  meth_meth_lexer_new396->definitionLine = 163;
  block_savedest(obj394);
  Object closure407 = createclosure(1, "new()object");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_Token);
  Method *meth_meth_lexer_new396_object = addmethod2pos(obj394, "new()object", &meth_lexer_new396_object, 1);
  meth_meth_lexer_new396_object->definitionModule = modulename;
  meth_meth_lexer_new396_object->definitionLine = 163;
  sourceObject = obj394;
  objclass394 = obj394->class;
  objclass394->definitionModule = modulename;
  objclass394->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter394;
  self = oldself394;
  selfslot = oldselfslot394;
  stackframe = oldstackframe394;
// compiled object node returning obj394 (depth = 4)
  *var_LGenericToken = obj394;
  if (obj394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject408 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj408 = alloc_userobj2(2,4, objclass408);
  gc_frame_newslot(obj408);
// OBJECT OUTER DEC outer
  adddatum2(obj408, self, 0);
  addmethodreal(obj408,"outer", &reader_lexer_outer_409);
  Object oldself408 = self;
  struct StackFrameObject *oldstackframe408 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe408);
  gc_frame_newslot((Object)stackframe);
  self = obj408;
  Object *oldselfslot408 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter408 = (*(struct UserObject *)self).data[0], lowerouter408 = thisouter408;
  if (inheritingObject408) {
    struct UserObject *inho408 = (struct UserObject *)inheritingObject408;
    while (inho408->super != GraceDefaultObject) inho408 = (struct UserObject *)inho408->super;
    inho408->super = obj408;
    self = inheritingObject408;
    *selfslot = self;
    lowerouter408 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter408;
  }
// method new
  block_savedest(obj408);
  Object closure410 = createclosure(1, "new");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_Token);
  struct UserObject *uo410 = (struct UserObject*)obj408;
  uo410->data[1] = (Object)closure410;
  Method *meth_meth_lexer_new410 = addmethod2pos(obj408, "new", &meth_lexer_new410, 1);
  int argcv_meth_lexer_new410[] = {0};
  meth_meth_lexer_new410->type = alloc_MethodType(1, argcv_meth_lexer_new410);
  meth_meth_lexer_new410->definitionModule = modulename;
  meth_meth_lexer_new410->definitionLine = 169;
  block_savedest(obj408);
  Object closure421 = createclosure(1, "new()object");
  setclosureframe(closure421, stackframe);
  addtoclosure(closure421, var_Token);
  Method *meth_meth_lexer_new410_object = addmethod2pos(obj408, "new()object", &meth_lexer_new410_object, 1);
  meth_meth_lexer_new410_object->definitionModule = modulename;
  meth_meth_lexer_new410_object->definitionLine = 169;
  sourceObject = obj408;
  objclass408 = obj408->class;
  objclass408->definitionModule = modulename;
  objclass408->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter408;
  self = oldself408;
  selfslot = oldselfslot408;
  stackframe = oldstackframe408;
// compiled object node returning obj408 (depth = 4)
  *var_RGenericToken = obj408;
  if (obj408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 2)
// starting to compile defdec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj422 = alloc_userobj2(2,4, objclass422);
  gc_frame_newslot(obj422);
// OBJECT OUTER DEC outer
  adddatum2(obj422, self, 0);
  addmethodreal(obj422,"outer", &reader_lexer_outer_423);
  Object oldself422 = self;
  struct StackFrameObject *oldstackframe422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe422);
  gc_frame_newslot((Object)stackframe);
  self = obj422;
  Object *oldselfslot422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter422 = (*(struct UserObject *)self).data[0], lowerouter422 = thisouter422;
  if (inheritingObject422) {
    struct UserObject *inho422 = (struct UserObject *)inheritingObject422;
    while (inho422->super != GraceDefaultObject) inho422 = (struct UserObject *)inho422->super;
    inho422->super = obj422;
    self = inheritingObject422;
    *selfslot = self;
    lowerouter422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter422;
  }
// method new
  block_savedest(obj422);
  Object closure424 = createclosure(1, "new");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_Token);
  struct UserObject *uo424 = (struct UserObject*)obj422;
  uo424->data[1] = (Object)closure424;
  Method *meth_meth_lexer_new424 = addmethod2pos(obj422, "new", &meth_lexer_new424, 1);
  int argcv_meth_lexer_new424[] = {0};
  meth_meth_lexer_new424->type = alloc_MethodType(1, argcv_meth_lexer_new424);
  meth_meth_lexer_new424->definitionModule = modulename;
  meth_meth_lexer_new424->definitionLine = 175;
  block_savedest(obj422);
  Object closure435 = createclosure(1, "new()object");
  setclosureframe(closure435, stackframe);
  addtoclosure(closure435, var_Token);
  Method *meth_meth_lexer_new424_object = addmethod2pos(obj422, "new()object", &meth_lexer_new424_object, 1);
  meth_meth_lexer_new424_object->definitionModule = modulename;
  meth_meth_lexer_new424_object->definitionLine = 175;
  sourceObject = obj422;
  objclass422 = obj422->class;
  objclass422->definitionModule = modulename;
  objclass422->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter422;
  self = oldself422;
  selfslot = oldselfslot422;
  stackframe = oldstackframe422;
// compiled object node returning obj422 (depth = 4)
  *var_eofToken = obj422;
  if (obj422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// compiled class node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject436 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj436 = alloc_userobj2(8,9, objclass436);
  gc_frame_newslot(obj436);
if (objclass436 == NULL) {
  glfree(obj436->class->name);
  obj436->class->name = "self.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj436, self, 0);
  addmethodreal(obj436,"outer", &reader_lexer_outer_437);
  Object oldself436 = self;
  struct StackFrameObject *oldstackframe436 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe436);
  gc_frame_newslot((Object)stackframe);
  self = obj436;
  Object *oldselfslot436 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter436 = (*(struct UserObject *)self).data[0], lowerouter436 = thisouter436;
  if (inheritingObject436) {
    struct UserObject *inho436 = (struct UserObject *)inheritingObject436;
    while (inho436->super != GraceDefaultObject) inho436 = (struct UserObject *)inho436->super;
    inho436->super = obj436;
    self = inheritingObject436;
    *selfslot = self;
    lowerouter436 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter436;
  }
// method modechange
  block_savedest(obj436);
  Object closure438 = createclosure(27, "modechange");
  setclosureframe(closure438, stackframe);
  addtoclosure(closure438, var_IdentifierToken);
  addtoclosure(closure438, var_KeywordToken);
  addtoclosure(closure438, var_StringToken);
  addtoclosure(closure438, var_MultiLineStringToken);
  addtoclosure(closure438, var_CommaToken);
  addtoclosure(closure438, var_DotToken);
  addtoclosure(closure438, var_LBraceToken);
  addtoclosure(closure438, var_RBraceToken);
  addtoclosure(closure438, var_LParenToken);
  addtoclosure(closure438, var_RParenToken);
  addtoclosure(closure438, var_LSquareToken);
  addtoclosure(closure438, var_RSquareToken);
  addtoclosure(closure438, var_LGenericToken);
  addtoclosure(closure438, var_RGenericToken);
  addtoclosure(closure438, var_SemicolonToken);
  addtoclosure(closure438, var_NumToken);
  addtoclosure(closure438, var_errormessages);
  addtoclosure(closure438, var_linePosition);
  addtoclosure(closure438, var_lineNumber);
  addtoclosure(closure438, var_OpToken);
  addtoclosure(closure438, var_ArrowToken);
  addtoclosure(closure438, var_BindToken);
  addtoclosure(closure438, var_ColonToken);
  addtoclosure(closure438, var_indentLevel);
  addtoclosure(closure438, var_CommentToken);
  addtoclosure(closure438, var_util);
  addtoclosure(closure438, var_startPosition);
  struct UserObject *uo438 = (struct UserObject*)obj436;
  uo438->data[1] = (Object)closure438;
  Method *meth_meth_lexer_modechange438 = addmethod2pos(obj436, "modechange", &meth_lexer_modechange438, 1);
  int argcv_meth_lexer_modechange438[] = {3};
  meth_meth_lexer_modechange438->type = alloc_MethodType(1, argcv_meth_lexer_modechange438);
  meth_meth_lexer_modechange438->definitionModule = modulename;
  meth_meth_lexer_modechange438->definitionLine = 200;
// method fromBase
  block_savedest(obj436);
  Object closure1207 = createclosure(4, "fromBase");
  setclosureframe(closure1207, stackframe);
  addtoclosure(closure1207, var_errormessages);
  addtoclosure(closure1207, var_linePosition);
  addtoclosure(closure1207, var_lineNumber);
  addtoclosure(closure1207, var_unicode);
  struct UserObject *uo1207 = (struct UserObject*)obj436;
  uo1207->data[2] = (Object)closure1207;
  Method *meth_meth_lexer_fromBase1207 = addmethod2pos(obj436, "fromBase", &meth_lexer_fromBase1207, 2);
  int argcv_meth_lexer_fromBase1207[] = {2};
  meth_meth_lexer_fromBase1207->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1207);
  meth_meth_lexer_fromBase1207->definitionModule = modulename;
  meth_meth_lexer_fromBase1207->definitionLine = 384;
// method hexdecchar
  block_savedest(obj436);
  Object closure1423 = createclosure(3, "hexdecchar");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_lineNumber);
  addtoclosure(closure1423, var_linePosition);
  addtoclosure(closure1423, var_errormessages);
  struct UserObject *uo1423 = (struct UserObject*)obj436;
  uo1423->data[3] = (Object)closure1423;
  Method *meth_meth_lexer_hexdecchar1423 = addmethod2pos(obj436, "hexdecchar", &meth_lexer_hexdecchar1423, 3);
  int argcv_meth_lexer_hexdecchar1423[] = {1};
  meth_meth_lexer_hexdecchar1423->type = alloc_MethodType(1, argcv_meth_lexer_hexdecchar1423);
  meth_meth_lexer_hexdecchar1423->definitionModule = modulename;
  meth_meth_lexer_hexdecchar1423->definitionLine = 426;
// method makeNumToken
  block_savedest(obj436);
  Object closure1501 = createclosure(4, "makeNumToken");
  setclosureframe(closure1501, stackframe);
  addtoclosure(closure1501, var_errormessages);
  addtoclosure(closure1501, var_linePosition);
  addtoclosure(closure1501, var_lineNumber);
  addtoclosure(closure1501, var_NumToken);
  struct UserObject *uo1501 = (struct UserObject*)obj436;
  uo1501->data[4] = (Object)closure1501;
  Method *meth_meth_lexer_makeNumToken1501 = addmethod2pos(obj436, "makeNumToken", &meth_lexer_makeNumToken1501, 4);
  int argcv_meth_lexer_makeNumToken1501[] = {1};
  meth_meth_lexer_makeNumToken1501->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1501);
  meth_meth_lexer_makeNumToken1501->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1501->definitionLine = 444;
// method isidentifierchar
  block_savedest(obj436);
  Object closure1680 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1680, stackframe);
  addtoclosure(closure1680, var_unicode);
  struct UserObject *uo1680 = (struct UserObject*)obj436;
  uo1680->data[5] = (Object)closure1680;
  Method *meth_meth_lexer_isidentifierchar1680 = addmethod2pos(obj436, "isidentifierchar", &meth_lexer_isidentifierchar1680, 5);
  int argcv_meth_lexer_isidentifierchar1680[] = {1};
  meth_meth_lexer_isidentifierchar1680->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1680);
  meth_meth_lexer_isidentifierchar1680->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1680->definitionLine = 489;
// method isoperatorchar
  block_savedest(obj436);
  Object closure1703 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1703, stackframe);
  addtoclosure(closure1703, var_unicode);
  struct UserObject *uo1703 = (struct UserObject*)obj436;
  uo1703->data[6] = (Object)closure1703;
  Method *meth_meth_lexer_isoperatorchar1703 = addmethod2pos(obj436, "isoperatorchar", &meth_lexer_isoperatorchar1703, 6);
  int argcv_meth_lexer_isoperatorchar1703[] = {2};
  meth_meth_lexer_isoperatorchar1703->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1703);
  meth_meth_lexer_isoperatorchar1703->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1703->definitionLine = 505;
// method lexfile
  block_savedest(obj436);
  Object closure1797 = createclosure(1, "lexfile");
  setclosureframe(closure1797, stackframe);
  addtoclosure(closure1797, var_util);
  struct UserObject *uo1797 = (struct UserObject*)obj436;
  uo1797->data[7] = (Object)closure1797;
  Method *meth_meth_lexer_lexfile1797 = addmethod2pos(obj436, "lexfile", &meth_lexer_lexfile1797, 7);
  int argcv_meth_lexer_lexfile1797[] = {1};
  meth_meth_lexer_lexfile1797->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1797);
  meth_meth_lexer_lexfile1797->definitionModule = modulename;
  meth_meth_lexer_lexfile1797->definitionLine = 522;
// method lexinput
  block_savedest(obj436);
  Object closure1915 = createclosure(9, "lexinput");
  setclosureframe(closure1915, stackframe);
  addtoclosure(closure1915, var_linePosition);
  addtoclosure(closure1915, var_util);
  addtoclosure(closure1915, var_unicode);
  addtoclosure(closure1915, var_errormessages);
  addtoclosure(closure1915, var_lineNumber);
  addtoclosure(closure1915, var_stringStart);
  addtoclosure(closure1915, var_startLine);
  addtoclosure(closure1915, var_startPosition);
  addtoclosure(closure1915, var_eofToken);
  struct UserObject *uo1915 = (struct UserObject*)obj436;
  uo1915->data[8] = (Object)closure1915;
  Method *meth_meth_lexer_lexinput1915 = addmethod2pos(obj436, "lexinput", &meth_lexer_lexinput1915, 8);
  int argcv_meth_lexer_lexinput1915[] = {1};
  meth_meth_lexer_lexinput1915->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1915);
  meth_meth_lexer_lexinput1915->definitionModule = modulename;
  meth_meth_lexer_lexinput1915->definitionLine = 576;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  sourceObject = obj436;
  objclass436 = obj436->class;
  objclass436->definitionModule = modulename;
  objclass436->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter436;
  self = oldself436;
  selfslot = oldselfslot436;
  stackframe = oldstackframe436;
  gc_frame_end(frame);
  return obj436;
}
Object module_lexer_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(5, 5);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<lexer>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
  Object *var_util = alloc_var();
  Object *var_unicode = alloc_var();
  Object *var_errormessages = alloc_var();
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method padl
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = emptyclosure;
  Method *meth_meth_lexer_padl0 = addmethod2pos(self, "padl", &meth_lexer_padl0, 1);
  int argcv_meth_lexer_padl0[] = {3};
  meth_meth_lexer_padl0->type = alloc_MethodType(1, argcv_meth_lexer_padl0);
  meth_meth_lexer_padl0->definitionModule = modulename;
  meth_meth_lexer_padl0->definitionLine = 5;
// compiled method node returning  (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method new
  block_savedest(self);
  Object closure24 = createclosure(3, "new");
  setclosureframe(closure24, stackframe);
  addtoclosure(closure24, var_errormessages);
  addtoclosure(closure24, var_util);
  addtoclosure(closure24, var_unicode);
  struct UserObject *uo24 = (struct UserObject*)self;
  uo24->data[2] = (Object)closure24;
  Method *meth_meth_lexer_new24 = addmethod2pos(self, "new", &meth_lexer_new24, 2);
  int argcv_meth_lexer_new24[] = {0};
  meth_meth_lexer_new24->type = alloc_MethodType(1, argcv_meth_lexer_new24);
  meth_meth_lexer_new24->definitionModule = modulename;
  meth_meth_lexer_new24->definitionLine = 17;
  block_savedest(self);
  Object closure3612 = createclosure(3, "new()object");
  setclosureframe(closure3612, stackframe);
  addtoclosure(closure3612, var_errormessages);
  addtoclosure(closure3612, var_util);
  addtoclosure(closure3612, var_unicode);
  Method *meth_meth_lexer_new24_object = addmethod2pos(self, "new()object", &meth_lexer_new24_object, 2);
  meth_meth_lexer_new24_object->definitionModule = modulename;
  meth_meth_lexer_new24_object->definitionLine = 17;
// compiled method node returning  (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of unicode as unicode
  if (module_unicode == NULL)
    module_unicode = dlmodule("unicode");
  *var_unicode = module_unicode;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
